#procedure solveS(Shelp,dx)
repeat;
  *
  * Treat external momentum q:
  *
#do i={|a|b|c|d}
id 'Shelp'(p2?expmom,qmexp'i',??)
= (mexp'i'*gi_('dx')+g_('dx',q)+g_('dx',p2))
         *Dml(mexp'i',q,p2)*'Shelp'(..);
id 'Shelp'(p2?expmom,-qmexp'i',??)
= (mexp'i'*gi_('dx')-g_('dx',q)+g_('dx',p2))
         *Dml(mexp'i',-q,p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,qmexp'i',??)
= (mexp'i'*gi_('dx')+g_('dx',q)-g_('dx',p2))
         *Dml(mexp'i',q,-p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,-qmexp'i',??)
= (mexp'i'*gi_('dx')-g_('dx',q)-g_('dx',p2))
         *Dml(mexp'i',-q,-p2)*'Shelp'(..);
#enddo
id 'Shelp'(p2?expmom,q,??)
=(g_('dx',q)+g_('dx',p2))*Dl(q,p2)*'Shelp'(..);
id 'Shelp'(p2?expmom,-q,??)
=(-g_('dx',q)+g_('dx',p2))*Dl(-q,p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,q,??)
=(g_('dx',q)-g_('dx',p2))*Dl(q,-p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,-q,??)
=(-g_('dx',q)-g_('dx',p2))*Dl(-q,-p2)*'Shelp'(..);
  *
  * Expansion with respect to a momentum and a mass simultaneously.
  *
#do i={|a|b|c|d|2}
id 'Shelp'(p2?expmom,p1?expmass'i'[n],??)
= (mexp'i'*gi_('dx')+g_('dx',malemom[n])+g_('dx',p2))
         *Dml(mexp'i',malemom[n],p2)*'Shelp'(..);
id 'Shelp'(p2?expmom,-p1?expmass'i'[n],??)
= (mexp'i'*gi_('dx')-g_('dx',malemom[n])+g_('dx',p2))  
         *Dml(mexp'i',-malemom[n],p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,p1?expmass'i'[n],??)
= (mexp'i'*gi_('dx')+g_('dx',malemom[n])-g_('dx',p2))
         *Dml(mexp'i',malemom[n],-p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,-p1?expmass'i'[n],??)
= (mexp'i'*gi_('dx')-g_('dx',malemom[n])-g_('dx',p2))
         *Dml(mexp'i',-malemom[n],-p2)*'Shelp'(..);
#enddo 
  *
  * Expansion with respect to a momentum.
  *
id 'Shelp'(p2?expmom,p1?malemom,??) 
= (g_('dx',p1)+g_('dx',p2))*Dl(p1,p2)*'Shelp'(..);
id 'Shelp'(p2?expmom,-p1?malemom,??) 
= (-g_('dx',p1)+g_('dx',p2))*Dl(-p1,p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,p1?malemom,??) 
= (g_('dx',p1)-g_('dx',p2))*Dl(p1,-p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,-p1?malemom,??)
= (-g_('dx',p1)-g_('dx',p2))*Dl(-p1,-p2)*'Shelp'(..);
#do i={|a|b|c|d}
id 'Shelp'(p2?expmom,p1?massmom'i'[n],??) 
= (M'i'*gi_('dx')+g_('dx',malemom[n])+g_('dx',p2))
         *Dh(p1,p2)*'Shelp'(..);
id 'Shelp'(p2?expmom,-p1?massmom'i'[n],??)
= (M'i'*gi_('dx')-g_('dx',malemom[n])+g_('dx',p2))
         *Dh(-p1,p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,p1?massmom'i'[n],??)
= (M'i'*gi_('dx')+g_('dx',malemom[n])-g_('dx',p2))
         *Dh(p1,-p2)*'Shelp'(..);
id 'Shelp'(-p2?expmom,-p1?massmom'i'[n],??)
= (M'i'*gi_('dx')-g_('dx',malemom[n])-g_('dx',p2))
         *Dh(-p1,-p2)*'Shelp'(..);
#enddo
  *
  * Expansion with respect to a mass.
  *
#do i={|a|b|c|d}
id 'Shelp'(qmexp'i',??) 
= (mexp'i'*gi_('dx')+g_('dx',q))*Dma(mexp'i',q)*'Shelp'(..);
id 'Shelp'(-qmexp'i',??) 
= (mexp'i'*gi_('dx')-g_('dx',q))*Dma(mexp'i',-q)*'Shelp'(..);
#enddo
#do i={|a|b|c|d|2}
id 'Shelp'(p1?expmass'i'[n],??)  
= (mexp'i'*gi_('dx')+g_('dx',malemom[n]))
         *Dma(mexp'i',malemom[n])*'Shelp'(..);
id 'Shelp'(-p1?expmass'i'[n],??) 
= (mexp'i'*gi_('dx')-g_('dx',malemom[n]))
         *Dma(mexp'i',-malemom[n])*'Shelp'(..);
#enddo
  *
  * expansion w.r.t. to a small mass (only):
  *
id 'Shelp'(p1?smallmassmom[n],mexp?smallmass[m],??)  
= (smallmass[m]*gi_('dx')+g_('dx',malemom[n]))*
Dma(smallmass[m],malemom[n])*'Shelp'(..);
id 'Shelp'(-p1?smallmassmom[n],mexp?smallmass[m],??)  
= (smallmass[m]*gi_('dx')-g_('dx',malemom[n]))*
Dma(smallmass[m],malemom[n])*'Shelp'(..);
  *
  * 'normal' fermion propagators and vertices
  *
id 'Shelp'(i1?index_,??) = g_('dx',i1)*'Shelp'(..);
id 'Shelp'(q,??) = g_('dx',q)*Ds(q)*'Shelp'(..);
id 'Shelp'(-q,??) = -g_('dx',q)*Ds(q)*'Shelp'(..);
#do i={|a|b|c|d}
id 'Shelp'(p1?expmommass'i'[n],??) 
= (gi_('dx')*M'i'+g_('dx',expmom[n]))*Dmo(M'i',expmom[n])*'Shelp'(..);
id 'Shelp'(-p1?expmommass'i'[n],??) 
= (gi_('dx')*M'i'-g_('dx',expmom[n]))*Dmo(M'i',expmom[n])*'Shelp'(..);
#enddo
id 'Shelp'(p1?malemom,??) = g_('dx',p1)*Ds(p1)*'Shelp'(..);
id 'Shelp'(-p1?malemom,??) = -g_('dx',p1)*Ds(p1)*'Shelp'(..);
#do i={|a|b|c|d}
id 'Shelp'(p1?massmom'i'[n],??) 
= (M'i'*gi_('dx')+g_('dx',malemom[n]))*Dm(p1)*'Shelp'(..);
id 'Shelp'(-p1?massmom'i'[n],??) 
= (M'i'*gi_('dx')-g_('dx',malemom[n]))*Dm(p1)*'Shelp'(..);
#enddo
endrepeat;
id 'Shelp'=1;
#endprocedure
