#procedure treat
multiply replace_(q1,q1exp,q2,q2exp,q3,q3exp);
#message Treat the traces
#include matad.info # time
#call solveS{S|1}
.sort
#call solveS{SS|2}
.sort
#call solveS{SSS|3}
.sort
#call solveS{SSSS|4}
.sort
#include matad.info # time
#ifdef 'PROBLEM0'
#message Include special treat-file 0
#include problems/'PRB'/'FOLDER'.dia # TREAT0
#endif
#include matad.info # time
#message Feynman rules for vertices and propagators:
#message   gluon-ghost-ghost-vertex
id Vgh(i1?,p1?) = -p1(i1);
id Vgh(i1?,q?,p1?) = -(p1(i1)+q(i1));
#message   3-gluon-vertex
id V3g(i1?,p1?,i2?,p2?,i3?,p3?) = -(
+(p1(i3)-p2(i3))*d_(i1,i2)
+(p2(i1)-p3(i1))*d_(i2,i3)
+(p3(i2)-p1(i2))*d_(i3,i1)
);
.sort
id V3g(i1?,0,i2?,p2?,i3?,p3?) = -(
+(-p2(i3))*d_(i1,i2)
+(p2(i1)-p3(i1))*d_(i2,i3)
+(p3(i2))*d_(i3,i1)
);
.sort
id V3g(i1?,p1?,i2?,0,i3?,p3?) = -(
+(p1(i3))*d_(i1,i2)
+(-p3(i1))*d_(i2,i3)
+(p3(i2)-p1(i2))*d_(i3,i1)
);
.sort
id V3g(i1?,p1?,i2?,p2?,i3?,0) = -(
+(p1(i3)-p2(i3))*d_(i1,i2)
+(p2(i1))*d_(i2,i3)
+(-p1(i2))*d_(i3,i1)
);
.sort
#message   gluon propagator
#ifndef 'GAUGE' 
#define 'GAUGE' 0
#endif
id Dg(i1?,i2?,q?expmom,p?) =
(-d_(i1,i2) - ('GAUGE')*(p(i1)+q(i1))*(p(i2)+q(i2))*Dl(p,q))*Dl(p,q);
id Dg(i1?,i2?,-q?expmom,p?) =
(-d_(i1,i2) - ('GAUGE')*(p(i1)-q(i1))*(p(i2)-q(i2))*Dl(p,-q))*Dl(p,-q);
id Dg(i1?,i2?,p?) = (-d_(i1,i2) - ('GAUGE')*p(i1)*p(i2)*Ds(p))*Ds(p);
.sort
#message   ghost propagator
id Dgh(-p1?) = Ds(-p1);
id Dgh(p1?) = Ds(p1);
.sort
#include matad.info # time
.sort
#message expand denominators
#if 'POWER' ==0
id Dh(p1?massmom[n],q?) = massdeno'i'[n];
id Dh(-p1?massmom[n],q?) = massdeno'i'[n];
id Dma(m?,p1?) = Ds(p1);
id Dl(p1?,p2?) = Ds(p1);
id Dml(m?,p1?,p2?) = Ds(p1);
id Dmo(m?,p1?) = 1/m^2;
#endif
#include denoexp
#include matad.info # time
#message Change notation to p1,p2,...
id Dm(p1m?massmom[n]) = massdeno[n];
id 1/p?expmass[n].p?expmass[n] = 1/malemom[n].malemom[n];
id Ds(p1?) =  - 1/p1.p1;
multiply replace_(p1m,p1,p2m,p2,p3m,p3,p4m,p4,p5m,p5,p6m,p6,p7m,p7,p8m,p8);
multiply replace_(p11m,p11,p12m,p12,p13m,p13,p14m,p14,p15m,p15,
p16m,p16,p17m,p17,p18m,p18);
multiply replace_(p21m,p21,p22m,p22,p23m,p23,p24m,p24,p25m,p25,
p26m,p26,p27m,p27,p28m,p28);
#include matad.info # time
.sort
#ifdef 'PROBLEM1'
#message Include special treat-file 1
#include problems/'PRB'/'FOLDER'.dia # TREAT1
#endif
#include matad.info # time
#message Trace 1
tracen,1;
.sort
#call accun{trace1}
#message Trace 2
tracen,2;
.sort
#call accun{trace2}
#message Trace 3
tracen,3;
.sort
#call accun{trace3}
#message Trace 4
tracen,4;
.sort
#call accun{trace4}
#include matad.info # time
#message treat DL(x)
b DL;
.sort
#do i = 1,'POWER'
keep brackets;
id DL(x?) = 1 + poco * x*DL(x);
.sort
b DL;
.sort
#enddo
id DL(x?)=1;
#call accun{DL}
#include matad.info # time
repeat id Dr(p1?,p2?,a?)*Dr(p1?,p2?,b?)=Dr(p1,p2,a+b);
.sort
id Dr(v1?massmom[n],v?,a?) =  Dr(malemom[n],v,a); 
id Dr(p1?malemom[n],p2?,a?) = Dr(p1,p2,a) * massdeno[n];
.sort
#ifdef 'PROBLEM2'
#message Include special treat-file 2
#include problems/'PRB'/'FOLDER'.dia # TREAT2
#endif
#include matad.info # time
multiply replace_(q1exp,q1,q2exp,q2,q3exp,q3);
#message Do Wick-rotation
id p? = i_*p;
id 1/p?.q?=-1/p.q;
#include matad.info # time
.sort
#ifdef 'DALAQN'
#message Apply d Alembertian w.r.t. 'DALAQN'
#ifdef 'EXPAND'
#include redcut
#include expepgam
#call ACCU{dala}
#call dalaqn{'DALAQN'}
#call ACCU{dala}
repeat id acc(x1?)*acc(x2?) = acc(x1*x2);
.sort
#endif
#ifndef 'EXPAND'
#message 'DALAQN' only implemented if 'EXPAND' is defined!
multiply 1/(1-1);
#endif
#endif
#ifdef 'DALA12'
#message Apply derivative w.r.t. q1 and q2
#include TREAT/treat.dala12
#endif
#call accun{dala}
#ifndef 'DALA12' 
#include expandDr
#endif
#if 'POWER' != 0
id poco=1;
#endif
#include matad.info # time
#message q_i -> Q_i
multiply replace_(q,Q,q1,Q1,q2,Q2,q3,Q3);
#include matad.info # time
.sort
#ifndef 'EXPAND'
#call accun{Dr}
#endif
#ifdef 'EXPAND'
#include redcut
#include expepgam
#call ACCU{treat}
#endif
#endprocedure
