(*

l1.m

File prepared for CAPP-2007 by R. Harlander.

Evaluates convolutions of massless 1-loop propagator-type integrals.
The output of

epsexp[t1x11110]  and  epsexp[t1x02011]

has been used in ../AIR/topT1/check_T1.map
to insert the values for the master integrals found by AIR.

*)


<<defs.m;

Int[a_,b_] := Exp[EulerGamma*ep]*( Gamma[a+b-D/2]/Gamma[a]/Gamma[b] 
	       * Gamma[D/2-b]*Gamma[D/2-a]/Gamma[D-a-b] );

t1x11110 = Int[1,1]*Int[1,1];
t1x02011 = Int[1,2]*Int[1,ep+1];

epsexp[expr_] := Collect[Expand[Expand[Normal[
    Series[expr /. D -> 4-2*ep,{ep,0,1}]]] //.  Pi2Zeta],ep];



l1sm = (1/ep+2+Log[mu^2/m^2]+Sqrt[1-4*m^2/q^2]*
    Log[(Sqrt[1-4*m^2/q^2]-1)/(Sqrt[1-4*m^2/q^2]+1)]);

(* End of l1.m *)
