#ifndef `MINCERHFILE'
#define  MINCERHFILE  "1"
*
*	This is the mincer system as adapted to version 3 of FORM.
*	All necessary files are included in the file mincer.h
*	All local variables have names that start with mnc to avoid namespace problems.
*	When needed one should use replace_ to change external names to internal ones.
*	All procedures are included here as well.
*	The only variables that have external names are:
*	S D,ep,z3,z4,z5,z6,zz5;
*	CF acc;
*	V P,Q,p1,p2,p3,p4,p5,p6,p7,p8;
*	I mu,nu,ka,la,ro,si,ga,alfa,beta,MU,NU,KA,RO,SI,mmu,nnu;
*	S cw1,cw2,cw3;
*	S cf,ca,nf,nc,[cf-ca/2],[cf-ca],[dabc^2/n];
*	CF Glonel;
*	S ab,a,[alfas/pi];  * used in total and other renormalizations.
*
*	Conversion by J. Vermaseren 2-may-2000.
*
*--#[ Declarations :
S   D,[D-4],ep(:6),[1-ep/2];
dimension D:[D-4];
AutoDeclare Index mnci,mncj,mu,nu,ka,la,ro,si,ga;
AutoDeclare Vector Q,P,mncp,mncq;
AutoDeclare Symbol mnce,mncx,mncy,mncsgn,mnck,D;
V	[P+Q],[P+p1],[P+p2],[P+p3],[P+p4],[P+p5],[P+p6],[P+p7],[P+p8];
V	[P-Q],[P-p1],[P-p2],[P-p3],[P-p4],[P-p5],[P-p6],[P-p7],[P-p8];
set mncpp18:p1,p2,p3,p4,p5,p6,p7,p8;
set mncpQ18:p1,p2,p3,p4,p5,p6,p7,p8,Q;
set [mncpp18]:[P+p1],[P+p2],[P+p3],[P+p4],[P+p5],[P+p6],[P+p7],[P+p8];
set [-mncpp18]:[P-p1],[P-p2],[P-p3],[P-p4],[P-p5],[P-p6],[P-p7],[P-p8];
set mncee18:mnce1,mnce2,mnce3,mnce4,mnce5,mnce6,mnce7,mnce8;
set [mncPp]:[P+p1],[P+p2],[P+p3],[P+p4],[P+p5],[P+p6],[P+p7],[P+p8],[P+Q],
	[P-p1],[P-p2],[P-p3],[P-p4],[P-p5],[P-p6],[P-p7],[P-p8],[P-Q];
set mncPcenter:[P+p7],[P+p2],[P+p8],[P-p7],[P-p2],[P-p8];
set mncpcenter:p7,p2,p8;
set [mncx18]:mncx1,mncx2,mncx3,mncx4,mncx5,mncx6,mncx7,mncx8;
S	z3,z4,z5,z6,zz5;
S   mncs,mncj;
S   mncexp11,mncexp10,mncexp20,mncG311,mncF321,mncint1,mncint2,mncint3;
S	mncN1,mncN2,mncN3,mncA,mncB,mncm;
I	alfa,beta;
I	MU,NU,KA,RO,SI,mmu,nnu;
S	mncxi;
S	cw1,cw2,cw3;
S	cf,ca,nf,nc,[cf-ca/2],[cf-ca],[dabc^2/n];
S	mncfermi1,mncfermi2,mncfermi3,mncghost1,mncghost2,mncghost3,mncgluon1,mncgluon2,mncgluon3;
F	mncS,mncSS,mncSSS;
S	ab,[(mu^2/Q.Q)^ep],a,[ln(mu^2/Q.Q)],[alfas/pi];
CF	mncv2gi,mncV3G,mncv3g,mncv3gi,mncV4G,mncv4g,mncv4gi,mncDg,mncDs,Glonel,mncVgh,mncDgh,mncDL,mncVv;
CF	mncv2gp,mncv2gc,mncv3gp,mncv3gc,mncv4gp,mncv4gc;
CF  mncG,mncdeno,mncpo,mncpoinv,mncaccm,mncftri;
F   mncdel,mncdd,mncfp;
S	mncproexp;
CF	mncepexp,mncpropxp,mncnaar,mncsumm1,mncsumm2,mncsumm3;
T	mncFQ,mncFFPP;
CF	acc;
#ifndef `SCHEME'
#define SCHEME "1"
#endif
*--#] Declarations : 
*--#[ Procedures :
*--#[ benz :
#procedure benz(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*   Reduction procedure for three loop graphs of the BE or benz type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /    \   P2    /    \ P3
*                   /      \       /      \
*                  /     P6 v     ^ P7     \
*                 /          \   /          \
*          Q --<--            \ /            --<-- Q
*                 \            |            /
*                  \           v P8        / 
*                   \          |          /
*                 P5 \         |         / P4
*                     \---->------->----/
*
*   We start with reducing the dotproducts in the numerator to sums
*   of denominators. Only one dotproduct is irreducible: Q.P2 
*   The easiest reduction (and quite fast) is by writing everything
*   in terms of Q,P1,P2,P3 and use vertex identities and P8 = P3-P1
*   to write the few remaining dotproducts in terms of denominators.
*
*   Routine coded by J.A.M.Vermaseren 8-jul-1990, modified 13-nov-1990.
*
*  id  `P4'.P?!{,`P4'} = `P3'.P-'Q'.P;
*  id  `P5'.P?!{,`P5'} = `P1'.P-'Q'.P;

*#call ACCU(Benz momenta 1)

*  id  `P6'.P?!{,`P6'} = `P2'.P-`P1'.P;

*#call ACCU(Benz momenta 2)

*  id  `P7'.P?!{,`P7'} = `P2'.P-`P3'.P;

*#call ACCU(Benz momenta 3)

*  id  `P8'.P?!{,`P8'} = `P3'.P-`P1'.P;

*#call ACCU(Benz momenta 4)

  id  'Q'.`P1' = `P1'.`P1'/2+'Q'.'Q'/2-`P5'.`P5'/2;

#call ACCU(Benz scalar 1)

  id  'Q'.`P3' = `P3'.`P3'/2+'Q'.'Q'/2-`P4'.`P4'/2;

#call ACCU(Benz scalar 2)

  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;

#call ACCU(Benz scalar 3)

  id  `P2'.`P3' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2;

#call ACCU(Benz scalar 4)

  id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P8'.`P8'/2;

#call ACCU(Benz scalar 5)

  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
              /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
    #call triangle(`P2',`P6',`P7',`P1',`P3')
  endif;
*
#endprocedure
*--#] benz : 
*--#[ benzbar :
#procedure benzbar(P1,P2,P3,P4,P5,P6,P7,Q)
*
*   Reduction procedure for three loop graphs of the BEbar or benz-bar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /     |  P2   |     \ P3
*                   /      \       /      \
*                  /     P6 |     | P7     \
*                 /         \     /         \
*          Q --<--           v   ^           --<-- Q
*                 \          \   /          /
*                  \          | |          / 
*                   \         \ /         /
*                 P5 \         |         / P4
*                     \---->------->----/
*
*
*   Note that from the ladder graphs we can have powers of p7.p8 (P6.P7)
*   Here they can be written as a fake (P6-P7)^2
*   Such a (P6-P7)^2 isn't affected by the transformations here.
*	It is better than writing it as (P3-P1)^2 because then we would
*	generate positive powers of P1.P1 and P3.P3 in the end.
*
*	Coded by J.A.M. Vermaseren, 13-nov-1990.
*
  id  `P6'.`P7' = `P6'.`P6'/2+`P7'.`P7'/2-mncx8/2;

  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
              /`P5'.`P5'/`P6'.`P6'/`P7'.`P7') > 0 );
    #call triangle(`P2',`P6',`P7',`P1',`P3')
  endif;

  id  mncx8 = `P6'.`P6' + `P7'.`P7' - 2*`P6'.`P7';

#endprocedure
*--#] benzbar : 
*--#[ benzbu :
#procedure benzbu(P1,P2,P3,P4,P5,P6,P7,Q)
*
*   Reduction procedure for three loop graphs of the BU or benz-bu type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<-------------<-\
*                 P1 /         |         \ P6
*                   /          ^ P4       \
*                  /           |           \
*                 /     P2     |            \
*          Q --<-- ----->------|             --<-- Q
*                 \            |            /
*                  \           |           / 
*                   \          v P5       /
*                 P3 \         |         / P7
*                     \---->------->----/
*
*   The main complication is to make sure that no loop momentum
*   survives in the numerator (Q.P4 and Q.P5 are independent objects)
*   Because this is a service routine it is best if the calling
*   routine takes care of that.
*   BU is BE with 1 or 3 missing.
*
*   Procedure coded by J.A.M. Vermaseren, 13-nov-1990.
*
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
              /`P5'.`P5'/`P6'.`P6'/`P7'.`P7') > 0 );
    if ( count(`P6'.`P6',1) > count(`P7'.`P7',1) );
      #call triangle(`P4',`P2',`P1',`P5',`P6')
    else;
      #call triangle(`P5',`P2',`P3',`P4',`P7')
    endif;
  endif;
*
#endprocedure
*--#] benzbu : 
*--#[ benzred :
#procedure benzred(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*   Reduction procedure for three loop graphs of the BE or benz type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /    \   P2    /    \ P3
*                   /      \       /      \
*                  /     P6 v     ^ P7     \
*                 /          \   /          \
*          `Q' --<--            \ /            --<-- `Q'
*                 \            |            /
*                  \           v P8        / 
*                   \          |          /
*                 P5 \         |         / P4
*                     \---->------->----/
*
*   We start with reducing the dotproducts in the numerator to sums
*   of denominators. Only one dotproduct is irreducible: `Q'.P2 
*   The easiest reduction (and quite fast) is by writing everything
*   in terms of `Q',P1,P2,P3 and use vertex identities and P8 = P3-P1
*   to write the few remaining dotproducts in terms of denominators.
*
*   Routine coded by J.A.M.Vermaseren 8-jul-1990, modified 13-nov-1990.
*	BEPATH added 21-dec-1994 to improve efficiency.
*
#ifndef `BEPATH'
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P8'.`P8',Benz scalar 0)
  id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P8'.`P8'/2;
#call ACCU2(AB `P2'.`P3' `P2'.`P2' `P3'.`P3' `P7'.`P7',Benz scalar 1)
  id  `P2'.`P3' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P6'.`P6',Benz scalar 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 3)
  id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 4)
  id  `Q'.`P3' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5)
#else
#if `BEPATH' == 0
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P8'.`P8',Benz scalar 0 \(0\))
  id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P8'.`P8'/2;
#call ACCU2(AB `P2'.`P3' `P2'.`P2' `P3'.`P3' `P7'.`P7',Benz scalar 1 \(0\))
  id  `P2'.`P3' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P6'.`P6',Benz scalar 2 \(0\))
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 3 \(0\))
  id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 4 \(0\))
  id  `Q'.`P3' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(0\))
#endif
#if `BEPATH' == 1
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 0 \(1\))
	id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P1'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6',Benz scalar 1 \(1\))
	id	`P1'.`P6' = `P2'.`P2'/2-`P1'.`P1'/2-`P6'.`P6'/2;
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 2 \(1\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `P1'.`P8' `P3'.`P3' `P1'.`P1' `P8'.`P8',Benz scalar 3 \(1\))
	id	`P1'.`P8' = `P3'.`P3'/2-`P1'.`P1'/2-`P8'.`P8'/2;
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(1\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 5 \(1\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',
           `P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',
            `P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',
              `P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(1\))
#endif
#if `BEPATH' == 2
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P6'.`P6',Benz scalar 0 \(2\))
	id	`P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P6'.`P6'/2;
#call ACCU2(AB `P2'.`P7' `P2'.`P2' `P7'.`P7' `P3'.`P3',Benz scalar 1 \(2\))
	id	`P2'.`P7' = `P2'.`P2'/2+`P7'.`P7'/2-`P3'.`P3'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(2\))
	id	`Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P7' `Q'.`P2' `Q'.`Q' `P3'.`P3' `P4'.`P4',Benz scalar 3 \(2\))
	id	`Q'.`P7' = `Q'.`P2'-`Q'.`Q'/2-`P3'.`P3'/2+`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P7' `P2'.`P2' `P6'.`P6' `P3'.`P3' `P8'.`P8',Benz scalar 4 \(2\))
	id	`P1'.`P7' = `P2'.`P2'/2-`P6'.`P6'/2-`P3'.`P3'/2+`P8'.`P8'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(2\))
#endif
#if `BEPATH' == 3
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 0 \(3\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P6' `P2'.`P2' `P6'.`P6' `P1'.`P1',Benz scalar 1 \(3\))
	id	`P2'.`P6' = `P2'.`P2'/2+`P6'.`P6'/2-`P1'.`P1'/2;
#call ACCU2(AB `P2'.`P8' `P3'.`P3' `P1'.`P1' `P7'.`P7' `P6'.`P6',Benz scalar 2 \(3\))
	id	`P2'.`P8' = `P3'.`P3'/2-`P1'.`P1'/2-`P7'.`P7'/2+`P6'.`P6'/2;
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 3 \(3\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(3\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(3\))
#endif
#if `BEPATH' == 4
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 0 \(4\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `P4'.`P8' `P4'.`P4' `P8'.`P8' `P5'.`P5',Benz scalar 1 \(4\))
	id	`P4'.`P8' = `P4'.`P4'/2+`P8'.`P8'/2-`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P4' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 2 \(4\))
	id	`Q'.`P4' = `P3'.`P3'/2-`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 3 \(4\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(4\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `P4'.`P6' `Q'.`P2' `Q'.`Q' `P2'.`P2' `P8'.`P8' `P7'.`P7' `P5'.`P5',Benz scalar 5 \(4\))
	id	`P4'.`P6' = -`Q'.`P2'+`Q'.`Q'/2+`P2'.`P2'/2+`P8'.`P8'/2
	                -`P7'.`P7'/2-`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(4\))
#endif
#if `BEPATH' == 5
#call ACCU2(AB `P1'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6',Benz scalar 0 \(5\))
	id	`P1'.`P6' = `P2'.`P2'/2-`P1'.`P1'/2-`P6'.`P6'/2;
#call ACCU2(AB `P6'.`P7' `P6'.`P6' `P7'.`P7' `P8'.`P8',Benz scalar 1 \(5\))
	id	`P6'.`P7' = `P6'.`P6'/2+`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(5\))
	id	`Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P1'.`P7' `P2'.`P2' `P6'.`P6' `P3'.`P3' `P8'.`P8',Benz scalar 3 \(5\))
	id	`P1'.`P7' = `P2'.`P2'/2-`P6'.`P6'/2-`P3'.`P3'/2+`P8'.`P8'/2;
	if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    	if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
		    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
				multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		endif;
	endif;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(5\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P7' `Q'.`P2' `Q'.`Q' `P3'.`P3' `P4'.`P4',Benz scalar 5 \(5\))
	id	`Q'.`P7' = `Q'.`P2'-`Q'.`Q'/2-`P3'.`P3'/2+`P4'.`P4'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(5\))
#endif
#if `BEPATH' == 6
#call ACCU2(AB `P5'.`P8' `P4'.`P4' `P5'.`P5' `P8'.`P8',Benz scalar 0 \(6\))
	id	`P5'.`P8' = `P4'.`P4'/2-`P5'.`P5'/2-`P8'.`P8'/2;
#call ACCU2(AB `P6'.`P8' `P6'.`P6' `P8'.`P8' `P7'.`P7',Benz scalar 1 \(6\))
	id	`P6'.`P8' = `P6'.`P6'/2+`P8'.`P8'/2-`P7'.`P7'/2;
#call ACCU2(AB `Q'.`P5' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(6\))
	id	`Q'.`P5' = `P1'.`P1'/2-`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P5'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6' `Q'.`P6',Benz scalar 3 \(6\))
	id	`P5'.`P6' = `P2'.`P2'/2-`P1'.`P1'/2-`P6'.`P6'/2-`Q'.`P6';
#call ACCU2(AB `Q'.`P8' `P3'.`P3' `P4'.`P4' `P1'.`P1' `P5'.`P5',Benz scalar 4 \(6\))
	id	`Q'.`P8' = `P3'.`P3'/2-`P4'.`P4'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 5 \(6\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 6 \(6\))
#endif
#if `BEPATH' == 7
#call ACCU2(AB `P4'.`P5' `P4'.`P4' `P5'.`P5' `P8'.`P8',Benz scalar 0 \(7\))
	id	`P4'.`P5' = `P4'.`P4'/2+`P5'.`P5'/2-`P8'.`P8'/2;
#call ACCU2(AB `Q'.`P4' `P3'.`P3' `Q'.`Q' `P4'.`P4',Benz scalar 1 \(7\))
	id	`Q'.`P4' = `P3'.`P3'/2-`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `Q'.`P5' `P1'.`P1' `Q'.`Q' `P5'.`P5',Benz scalar 2 \(7\))
	id	`Q'.`P5' = `P1'.`P1'/2-`Q'.`Q'/2-`P5'.`P5'/2;
#call ACCU2(AB `P2'.`P4' `P2'.`P2' `P3'.`P3' `P7'.`P7' `Q'.`P2',Benz scalar 3 \(7\))
	id	`P2'.`P4' = `P2'.`P2'/2+`P3'.`P3'/2-`P7'.`P7'/2-`Q'.`P2';
#call ACCU2(AB `P2'.`P5' `P2'.`P2' `P1'.`P1' `P6'.`P6' `Q'.`P2',Benz scalar 4 \(7\))
	id	`P2'.`P5' = `P2'.`P2'/2+`P1'.`P1'/2-`P6'.`P6'/2-`Q'.`P2';

if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(7\))
#endif
#if `BEPATH' == 8
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P2'.`P6' `P2'.`P2' `P1'.`P1' `P6'.`P6',Benz scalar 0 \(8\))
	id	`P2'.`P6' = `P2'.`P2'/2+`P6'.`P6'/2-`P1'.`P1'/2;
#call ACCU2(AB `P2'.`P7' `P2'.`P2' `P7'.`P7' `P3'.`P3',Benz scalar 1 \(8\))
	id	`P2'.`P7' = `P2'.`P2'/2+`P7'.`P7'/2-`P3'.`P3'/2;
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU2(AB `P6'.`P7' `P6'.`P6' `P7'.`P7' `P8'.`P8',Benz scalar 2 \(8\))
	id	`P6'.`P7' = `P6'.`P6'/2+`P7'.`P7'/2-`P8'.`P8'/2;
	if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    	if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
		    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
				multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
		endif;
	endif;
#call ACCU2(AB `Q'.`P6' `Q'.`P2' `Q'.`Q' `P1'.`P1' `P5'.`P5',Benz scalar 3 \(8\))
	id	`Q'.`P6' = `Q'.`P2'-`Q'.`Q'/2-`P1'.`P1'/2+`P5'.`P5'/2;
#call ACCU2(AB `Q'.`P7' `Q'.`P2' `Q'.`Q' `P3'.`P3' `P4'.`P4',Benz scalar 4 \(8\))
	id	`Q'.`P7' = `Q'.`P2'-`Q'.`Q'/2-`P3'.`P3'/2+`P4'.`P4'/2;
if ( count(`P6'.`P6',1) < count(`P7'.`P7',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
elseif ( count(`P6'.`P6',1) == count(`P7'.`P7',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P5'.`P5',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P5',`P5',`P4',`P6',`P7',`P7',`P6',`P8',-`P8');
	endif;
endif;
#call ACCU(Benz scalar 5 \(8\))
#endif
#endif
*
#endprocedure
*--#] benzred : 
*--#[ dotwo :
#procedure dotwo()
#define OLDTWO "1"

#ifdef `OLDTWO'
 
if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
    multiply replace_(p1,p6,p6,p1,p3,p4,p4,p3,mnce1,mnce6,mnce6,mnce1,mnce3,mnce4,mnce4,mnce3);
    id  Q.mncq1?{p1,p3,p4,p6,p7} = -Q.mncq1;
endif;
if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
    multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,mnce1,mnce3,mnce3,mnce1,mnce4,mnce6,mnce6,mnce4);
    id  p7.mncq1?{Q,p1,p3,p4,p6} = -p7.mncq1;
endif;

#call ACCU(Presymmetrize)

id  p7.Q = Q.p1-Q.p3;
id  p1.p4 = p1.p3-p1.Q;
id  p3.p6 = p1.p3-p3.Q;
id  p1.p7 = p1.p1/2+p7.p7/2-p3.p3/2;
id  p3.p7 = p1.p1/2-p3.p3/2-p7.p7/2;
id  p4.p7 = p6.p6/2-p4.p4/2-p7.p7/2;
id  p6.p7 = p6.p6/2+p7.p7/2-p4.p4/2;

#call ACCU2(AB p1.Q Q.Q p6.Q p1.p6 p1.p1,Rewrite vectors\(2\))

id  p6.Q = p1.Q-Q.Q;
id  p1.p6 = p1.p1-p1.Q;
 
#call ACCU2(AB  p3.Q Q.Q p4.Q p3.p4 p3.p3,Scalars\(2\) 1)

id  p4.Q = p3.Q-Q.Q;
id  p3.p4 = p3.p3-p3.Q;

#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,Scalars\(2\) 2)

id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;

#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,Scalars\(2\) 3)

id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;

#call ACCU2(AB p1.p3 p1.p1 p3.p3 p7.p7,Scalars\(2\) 4)

id  p1.p3 = p1.p1/2+p3.p3/2-p7.p7/2;

#call ACCU2(AB p4.p6 p4.p4 p6.p6 p7.p7,Scalars\(2\) 5)

id  p4.p6 = p4.p4/2+p6.p6/2-p7.p7/2;

#call ACCU(Scalars\(2\) 6)

*id p1.p6 = p1.p1/2+p6.p6/2-Q.Q/2;
*id p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;

*#call ACCU(Scalars\(2\) 7)

#else
 
if ( count(Q.p6,1,p4.p6,1,Q.p4,1,p4.p7,1,p6.p7,1)
   > count(Q.p1,1,Q.p3,1,p1.p3,1,p1.p7,1,p3.p7,1) );
    multiply replace_(p1,p6,p6,p1,p3,p4,p4,p3,mnce1,mnce6,mnce6,mnce1,mnce3,mnce4,mnce4,mnce3);
    id  Q = -Q;
endif;
if ( count(Q.p3,1,p3.p4,1,Q.p4,1,p3.p7,1,p4.p7,1)
   > count(Q.p1,1,Q.p6,1.p1.p6,1,p1.p7,1,p6.p7,1) );
    multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,mnce1,mnce3,mnce3,mnce1,mnce4,mnce6,mnce6,mnce4);
    id  p7 = -p7;
endif;

#call ACCU(Presymmetrize)

id  p7.mncq1?{Q,p1,p3,p4,p6,p7} = p1.mncq1-p3.mncq1;

#call ACCU(Eliminate p7)

id  p6.mncq1?{Q,p1,p3,p4} = p1.mncq1-Q.mncq1;

#call ACCU(Eliminate p6)

id  p4.mncq1?{Q,p1,p3} = p3.mncq1-Q.mncq1;

#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,Eliminate p4)

id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;

#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,Eliminate Q.p1)

id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;

#call ACCU2(AB p1.p3 p1.p1 p3.p3 p7.p7,Eliminate Q.p3)

id  p1.p3 = p1.p1/2+p3.p3/2-p7.p7/2;

#call ACCU(Eliminate p1.p3)
#endif
*
*   Now relabel the lines so that we get a uniform orientation.
*   This can be done easily because we have only squares of momenta.
*
if ( count(mnce7,1,mnceq,1) > 0 );
label 2;
  if ( ( ( count(p1.p1,1) > count(p3.p3,1) ) &&
         ( count(p6.p6,1) > count(p3.p3,1) ) ) ||
       ( ( count(p1.p1,1) > count(p4.p4,1) ) &&
         ( count(p6.p6,1) > count(p4.p4,1) ) ) );
    multiply replace_(p1,p3,p3,p1,mnce1,mnce3,mnce3,mnce1,p6,p4,p4,p6,mnce6,mnce4,mnce4,mnce6);
  endif;
  if ( ( count(p1.p1,1) > count(p6.p6,1) ) ||
     ( ( count(p1.p1,1) == count(p6.p6,1) ) &&
       ( count(p3.p3,1) > count(p4.p4,1) ) ) );
    multiply replace_(p1,p6,p6,p1,mnce1,mnce6,mnce6,mnce1,p3,p4,p4,p3,mnce3,mnce4,mnce4,mnce3);
  endif;
else;
  if ( ( count(mnce3,1) > 0 ) || ( count(mnce4,1) > 0 ) );
    multiply replace_(p1,p3,p3,p1,mnce1,mnce3,mnce3,mnce1,p6,p4,p4,p6,mnce6,mnce4,mnce4,mnce6);
  endif;
  if ( count(mnce6,1) > 0 );
    multiply replace_(p1,p6,p6,p1,mnce1,mnce6,mnce6,mnce1,p3,p4,p4,p3,mnce3,mnce4,mnce4,mnce3);
  endif;
  if ( count(mnce1,1) == 0 ) goto 2;
endif;

#call ACCU(Use symmetry\(2\))

multiply acc(1/ep);
#call newtwo(p1,mnce1,p3,mnce3,p4,mnce4,p6,mnce6,p7,mnce7,Q,mnceq,0,mncint1*mncint3)
multiply ep;
if ( count(mnce7,1) );
    if ( count(p1.p1,1) < count(p6.p6,1) )
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
        if ( count(p1.p1,1) < count(p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
    elseif ( count(p1.p1,1) < count(p4.p4,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p7,-p7,Q,-Q);
    endif;
endif;
#call ACCU(Two loop reduction)

if ( count(mncint3,1) );
if ( count(mnce7,1) );
    if ( count(p1.p1,1) < count(p6.p6,1) )
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
        if ( count(p1.p1,1) < count(p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
    elseif ( count(p1.p1,1) < count(p4.p4,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p7,-p7,Q,-Q);
    endif;
    id p1.p1 = Q.Q+p6.p6+2*Q.p6;
    id p1 = Q+p6;
    if ( count(p6.p6,1) >= 0 ) discard;
*   Integrate over (6,7)->4
    multiply replace_(p6,-mncp9,p7,-p8,p4,-p1,p3,-p2,mnce7,mnce8);
    multiply mncnaar(p1,mnce1);
elseif ( count(mnce1,1) );
    if ( count(p7.p7,1) >= 0 );
        id  p7.p7 = p6.p6+p4.p4-2*p4.p6;
        id  p7 = p6-p4;
        if ( count(p6.p6,1) >= 0 ) discard;
        if ( count(p3.p3,1) >= 0 ) discard;
        if ( count(p4.p4,1) >= 0 ) discard;
*       Integrate over (6,1)->Q
        multiply replace_(p6,-mncp9,p1,-p8,mnce1,mnce8,p3,p1,p4,p2);
        multiply mncnaar(Q,mnceq);
    elseif ( count(p3.p3,1) >= 0 );
        id  p3.p3 = Q.Q+p4.p4+2*Q.p4;
        id  p3 = p4+Q;
        if ( count(p4.p4,1) >= 0 ) discard;
*       if ( count(p7.p7,1) >= 0 ) discard;
*       Integrate over (4,7)->6
        multiply replace_(p4,-mncp9,p7,p8,p6,-p1,p1,-p2,mnce1,mnce2);
        multiply mncnaar(p1,mnce1);
    elseif ( count(p4.p4,1) >= 0 );
        id  p4.p4 = p3.p3+Q.Q-2*Q.p3;
        id  p4 = p3-Q;
        if ( count(p3.p3,1) >= 0 ) discard;
        if ( count(p6.p6,1) >= 0 ) discard;
*       if ( count(p7.p7,1) >= 0 ) discard;
*       Integrate over (3,7)->1
*       id p7 = -p7;
        multiply replace_(p3,mncp9,p7,-p8,p6,p2);
        multiply mncnaar(p1,mnce1);
    else;
        id  p6.p6 = p4.p4+p7.p7+2*p4.p7;
        id  p6 = p4+p7;
        if ( count(p4.p4,1) >= 0 ) discard;
        if ( count(p7.p7,1) >= 0 ) discard;
*       Integrate over (7,1)->3
        multiply replace_(p1,-p8,p7,-mncp9,p3,p1,p4,p2,mnce1,mnce8);
        multiply mncnaar(p1,mnce1);
    endif;
else;
*   Here we have no internal fractional power.
*   1: order so that p1.p1 has the highest power (or p7.p7).
    if ( count(p1.p1,1) < count(p6.p6,1) )
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
        if ( count(p1.p1,1) < count(p6.p6,1) )
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    elseif ( count(p1.p1,1) < count(p4.p4,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p7,-p7,Q,-Q);
    endif;
    if ( count(p7.p7,1) >= 0 );
        id p7.p7 = p1.p1+p3.p3-2*p1.p3;
        if ( count(p1.p1,1) >= 0 ) discard;
        if ( count(p3.p3,1) >= 0 ) discard;
        if ( count(p1.p1,1) < count(p3.p3,1) )
            multiply replace_(p1,-p3,p3,-p1,p6,-p4,p4,-p6,Q,-Q);
*       Integrate over (1,6)->Q
        multiply replace_(p1,mncp9,p6,p8,p3,p1,p4,p2);
        multiply mncnaar(Q,mnceq);
    else;
*       p1.p1 is missing or positive
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p3.p3,1) >= 0 ) discard;
        id p1.p1 = Q.Q+p6.p6+2*Q.p6;
        if ( count(p6.p6,1) >= 0 ) discard;
*       Integrate over (6,7)->4
        multiply replace_(p6,-mncp9,p7,-p8,p4,-p1,p3,-p2);
        multiply mncnaar(p1,mnce1);
    endif;
endif;
ToTensor,nosquare,mncFQ,mncp9;
endif;

#call ACCU2(B mncnaar p8 mncp9 mnce8 mnce9 mncint3 mncFQ,Prepare second loop)

Keep brackets;
if ( count(mncint3,1) );
if ( count(mncFQ,1) == 0 );
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2? =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3*mncG(mncx1,mncy1,mncx2,mncy2,0,0);
elseif ( match(mncFQ(mnci1?)) );
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2?*mncFQ(mnci1?) =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3*mncG(mncx1,mncy1,mncx2,mncy2,1,0)*mncq1(mnci1);
elseif ( match(mncFQ(mnci1?,mnci2?)) );
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2?*mncFQ(mnci1?,mnci2?) =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3*(
        +mncG(mncx1,mncy1,mncx2,mncy2,2,0)*mncq1(mnci1)*mncq1(mnci2)+mncG(mncx1,mncy1,mncx2,mncy2,2,1)*mncq1.mncq1*d_(mnci1,mnci2)/2);
else;
    id  mncint3/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mnce9^mncy1?*mnce8^mncy2?*mncFQ(?a) =
        mncq1.mncq1^2/mncq1.mncq1^mncx1/mncq1.mncq1^mncx2*mnce3^mncy1*mnce3^mncy2*mnce3
        *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,mncy1,mncx2,mncy2,nargs_(?a),mncj)
        *mncy^mncj*mncq1.mncq1^mncj/2^mncj)*mncFQ(?a);
endif;
#call simplify
if ( count(mncFQ,1) );
    id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
    tovector,mncFQ,mncq1;
    id  mncnaar(mncq2?,mnce4?) = replace_(mncq1,mncq2,mnce3,mnce4);
    id  mncdel(?a) = dd_(?a);
else;
    id  mncnaar(mncq2?,mnce4?) = replace_(mncq1,mncq2,mnce3,mnce4);
endif;
else;
    multiply ep;
endif;

#call ACCU(Second loop)

if ( count(mncint1,1) );
    #call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
endif;

#call ACCU(Third loop)

multiply 1/Q.Q/mnceq^3;
#call simplify

#endprocedure
*--#] dotwo : 
*--#[ dovert1 :
#procedure dovert1(P1,P2,P3)
*
*	P3 = P1+P2
*
id	g_(mnci1?,`P1',`P2',`P3') = g_(mnci1,`P1')*`P3'.`P3'-g_(mnci1,`P3')*`P1'.`P1';
id	g_(mnci1?,`P1',`P3',`P2') = g_(mnci1,`P1')*`P2'.`P2'+g_(mnci1,`P2')*`P1'.`P1';
id	g_(mnci1?,`P2',`P1',`P3') = g_(mnci1,`P2')*`P3'.`P3'-g_(mnci1,`P3')*`P2'.`P2';
id	g_(mnci1?,`P3',`P2',`P1') = g_(mnci1,`P1')*`P3'.`P3'-g_(mnci1,`P3')*`P1'.`P1';
id	g_(mnci1?,`P2',`P3',`P1') = g_(mnci1,`P1')*`P2'.`P2'+g_(mnci1,`P2')*`P1'.`P1';
id	g_(mnci1?,`P3',`P1',`P2') = g_(mnci1,`P2')*`P3'.`P3'-g_(mnci1,`P3')*`P2'.`P2';
*
id	g_(mnci1?,[P+`P1'],`P2',[P+`P3']) =
	g_(mnci1,[P+`P1'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P1'].[P+`P1'];
id	g_(mnci1?,[P+`P1'],[P+`P3'],`P2') =
	g_(mnci1,[P+`P1'])*`P2'.`P2'+g_(mnci1,`P2')*[P+`P1'].[P+`P1'];
id	g_(mnci1?,`P2',[P+`P1'],[P+`P3']) =
	g_(mnci1,`P2')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P2'.`P2';
id	g_(mnci1?,[P+`P3'],`P2',[P+`P1']) =
	g_(mnci1,[P+`P1'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P1'].[P+`P1'];
id	g_(mnci1?,`P2',[P+`P3'],[P+`P1']) =
	g_(mnci1,[P+`P1'])*`P2'.`P2'+g_(mnci1,`P2')*[P+`P1'].[P+`P1'];
id	g_(mnci1?,[P+`P3'],[P+`P1'],`P2') =
	g_(mnci1,`P2')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P2'.`P2';
*
id	g_(mnci1?,`P1',[P+`P2'],[P+`P3']) =
	g_(mnci1,`P1')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P1'.`P1';
id	g_(mnci1?,`P1',[P+`P3'],[P+`P2']) =
	g_(mnci1,`P1')*[P+`P2'].[P+`P2']+g_(mnci1,[P+`P2'])*`P1'.`P1';
id	g_(mnci1?,[P+`P2'],`P1',[P+`P3']) =
	g_(mnci1,[P+`P2'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P2'].[P+`P2'];
id	g_(mnci1?,[P+`P3'],[P+`P2'],`P1') =
	g_(mnci1,`P1')*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*`P1'.`P1';
id	g_(mnci1?,[P+`P2'],[P+`P3'],`P1') =
	g_(mnci1,`P1')*[P+`P2'].[P+`P2']+g_(mnci1,[P+`P2'])*`P1'.`P1';
id	g_(mnci1?,[P+`P3'],`P1',[P+`P2']) =
	g_(mnci1,[P+`P2'])*[P+`P3'].[P+`P3']-g_(mnci1,[P+`P3'])*[P+`P2'].[P+`P2'];
*
id	g_(mnci1?,[P-`P3'],`P2',[P-`P1']) =
	g_(mnci1,[P-`P3'])*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*[P-`P3'].[P-`P3'];
id	g_(mnci1?,[P-`P3'],[P-`P1'],`P2') =
	g_(mnci1,[P-`P3'])*`P2'.`P2'+g_(mnci1,`P2')*[P-`P3'].[P-`P3'];
id	g_(mnci1?,`P2',[P-`P3'],[P-`P1']) =
	g_(mnci1,`P2')*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*`P2'.`P2';
id	g_(mnci1?,[P-`P1'],`P2',[P-`P3']) =
	g_(mnci1,[P-`P3'])*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*[P-`P3'].[P-`P3'];
id	g_(mnci1?,`P2',[P-`P1'],[P-`P3']) =
	g_(mnci1,[P-`P3'])*`P2'.`P2'+g_(mnci1,`P2')*[P-`P3'].[P-`P3'];
id	g_(mnci1?,[P-`P1'],[P-`P3'],`P2') =
	g_(mnci1,`P2')*[P-`P1'].[P-`P1']-g_(mnci1,[P-`P1'])*`P2'.`P2';
*
id	g_(mnci1?,`P1',[P-`P3'],[P-`P2']) =
	g_(mnci1,`P1')*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*`P1'.`P1';
id	g_(mnci1?,`P1',[P-`P2'],[P-`P3']) =
	g_(mnci1,`P1')*[P-`P3'].[P-`P3']+g_(mnci1,[P-`P3'])*`P1'.`P1';
id	g_(mnci1?,[P-`P3'],`P1',[P-`P2']) =
	g_(mnci1,[P-`P3'])*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*[P-`P3'].[P-`P3'];
id	g_(mnci1?,[P-`P2'],[P-`P3'],`P1') =
	g_(mnci1,`P1')*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*`P1'.`P1';
id	g_(mnci1?,[P-`P3'],[P-`P2'],`P1') =
	g_(mnci1,`P1')*[P-`P3'].[P-`P3']+g_(mnci1,[P-`P3'])*`P1'.`P1';
id	g_(mnci1?,[P-`P2'],`P1',[P-`P3']) =
	g_(mnci1,[P-`P3'])*[P-`P2'].[P-`P2']-g_(mnci1,[P-`P2'])*[P-`P3'].[P-`P3'];
*
id	g_(mnci1?,`P3',[P-`P2'],[P+`P1']) =
	g_(mnci1,`P3')*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*`P3'.`P3';
id	g_(mnci1?,`P3',[P+`P1'],[P-`P2']) =
	g_(mnci1,`P3')*[P-`P2'].[P-`P2']+g_(mnci1,[P-`P2'])*`P3'.`P3';
id	g_(mnci1?,[P-`P2'],`P3',[P+`P1']) =
	g_(mnci1,[P-`P2'])*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*[P-`P2'].[P-`P2'];
id	g_(mnci1?,[P+`P1'],[P-`P2'],`P3') =
	g_(mnci1,`P3')*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*`P3'.`P3';
id	g_(mnci1?,[P-`P2'],[P+`P1'],`P3') =
	g_(mnci1,`P3')*[P-`P2'].[P-`P2']+g_(mnci1,[P-`P2'])*`P3'.`P3';
id	g_(mnci1?,[P+`P1'],`P3',[P-`P2']) =
	g_(mnci1,[P-`P2'])*[P+`P1'].[P+`P1']-g_(mnci1,[P+`P1'])*[P-`P2'].[P-`P2'];
*
id	g_(mnci1?,[P-`P1'],`P3',[P+`P2']) =
	g_(mnci1,[P-`P1'])*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*[P-`P1'].[P-`P1'];
id	g_(mnci1?,[P-`P1'],[P+`P2'],`P3') =
	g_(mnci1,[P-`P1'])*`P3'.`P3'+g_(mnci1,`P3')*[P-`P1'].[P-`P1'];
id	g_(mnci1?,`P3',[P-`P1'],[P+`P2']) =
	g_(mnci1,`P3')*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*`P3'.`P3';
id	g_(mnci1?,[P+`P2'],`P3',[P-`P1']) =
	g_(mnci1,[P-`P1'])*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*[P-`P1'].[P-`P1'];
id	g_(mnci1?,`P3',[P+`P2'],[P-`P1']) =
	g_(mnci1,[P-`P1'])*`P3'.`P3'+g_(mnci1,`P3')*[P-`P1'].[P-`P1'];
id	g_(mnci1?,[P+`P2'],[P-`P1'],`P3') =
	g_(mnci1,`P3')*[P+`P2'].[P+`P2']-g_(mnci1,[P+`P2'])*`P3'.`P3';
*
#endprocedure
*--#] dovert1 : 
*--#[ dovert2 :
#procedure dovert2(P1,P2,P3)
*
*	P1 + P2 + P3 = 0
*
id	g_(mnci1?,`P3',`P2',`P1') = -g_(mnci1,`P3')*`P1'.`P1'-g_(mnci1,`P1')*`P3'.`P3';
id	g_(mnci1?,`P3',`P1',`P2') = -g_(mnci1,`P3')*`P2'.`P2'-g_(mnci1,`P2')*`P3'.`P3';
id	g_(mnci1?,`P2',`P3',`P1') = -g_(mnci1,`P2')*`P1'.`P1'-g_(mnci1,`P1')*`P2'.`P2';
id	g_(mnci1?,`P1',`P2',`P3') = -g_(mnci1,`P3')*`P1'.`P1'-g_(mnci1,`P1')*`P3'.`P3';
id	g_(mnci1?,`P2',`P1',`P3') = -g_(mnci1,`P3')*`P2'.`P2'-g_(mnci1,`P2')*`P3'.`P3';
id	g_(mnci1?,`P1',`P3',`P2') = -g_(mnci1,`P2')*`P1'.`P1'-g_(mnci1,`P1')*`P2'.`P2';
*
#endprocedure
*--#] dovert2 : 
*--#[ finish :
#procedure finish(LOOPS,SCHEME)
*
id  ep = 0;
*
*   Substitute the integrals.
*
id  mncexp20*mncexp10 = 1
       + ep * ( 3 )
       + ep^2 * ( 13 )
       + ep^3 * ( 55 - 22*z3 )
       + ep^4 * ( 229 - 66*z3 - 33*z4 )
       + ep^5 * ( 943 - 286*z3 - 99*z4 - 234*z5 )
       + ep^6 * ( 3853 - 1210*z3 + 242*z3^2 - 429*z4 - 702*z5 - 530*z6 );
id  mncexp11 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 22*z3 )
       + ep^4 * ( 128 - 44*z3 - 33*z4 )
       + ep^5 * ( 512 - 176*z3 - 66*z4 - 234*z5 )
       + ep^6 * ( 2048 - 704*z3 + 242*z3^2 - 264*z4 - 468*z5 - 530*z6 );
id  mncexp20 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 16*z3 )
       + ep^4 * ( 128 - 32*z3 - 24*z4 )
       + ep^5 * ( 512 - 128*z3 - 48*z4 - 192*z5 )
       + ep^6 * ( 2048 - 512*z3 + 128*z3^2 - 192*z4 - 384*z5 - 440*z6 );
id  mncexp10 = 1
       + ep * ( 1 )
       + ep^2 * ( 3 )
       + ep^3 * ( 9 - 6*z3 )
       + ep^4 * ( 27 - 6*z3 - 9*z4 )
       + ep^5 * ( 81 - 18*z3 - 9*z4 - 42*z5 )
       + ep^6 * ( 243 - 54*z3 + 18*z3^2 - 27*z4 - 42*z5 - 90*z6 );
*
*   Note that in Gorishny,Larin,Surguladze and Tkachov Comp.Phys.Comm.
*   55(1989)381 the factor (1-2*ep) is erroneously absent in the
*   following integral:
*
id  mncG311 = (1-2*ep)*(6*z3+9*z4*ep+102*z5*ep^2);
*
id  mncF321 = 20*z5;
*
*   Now follow some convenient integrals.
*
*
*	The three loop fermion propagator
*
id	mncfermi3 =ep^3*(
    +cf*ca*nf*(+260075/1296-1/6*ep^-3*mncxi+1/6*ep^-3-13/12*ep^-2*mncxi
        +227/36*ep^-2+2*ep^-1*z3*mncxi-6*ep^-1*z3-155/24*ep^-1*mncxi
        +8267/216*ep^-1+61/6*z3*mncxi-137/6*z3+3*z4*mncxi-9*z4-4483/144*mncxi)
    +cf*ca^2*(-2008997/2592+55/24*ep^-3*mncxi-5/8*ep^-3*mncxi^2+1/12*ep^-3*mncxi^3
        -7/4*ep^-3+623/48*ep^-2*mncxi-49/16*ep^-2*mncxi^2+3/8*ep^-2*mncxi^3
        -1841/72*ep^-2-18*ep^-1*z3*mncxi+11/8*ep^-1*z3*mncxi^2+83/2*ep^-1*z3
        +6869/96*ep^-1*mncxi-497/32*ep^-1*mncxi^2+89/48*ep^-1*mncxi^3
        -66629/432*ep^-1-2917/24*z3*mncxi+23*z3*mncxi^2-29/12*z3*mncxi^3+1015/4*z3
        -27*z4*mncxi+33/16*z4*mncxi^2+249/4*z4+5*z5*mncxi-5/4*z5*mncxi^2-45*z5
        +189061/576*mncxi-4403/64*mncxi^2+49/6*mncxi^3)
    +cf*nf^2*(-1108/81-4/9*ep^-2-68/27*ep^-1)
    +cf^2*ca*(-1199/16+9/4*ep^-3*mncxi-3/2*ep^-3*mncxi^2+1/4*ep^-3*mncxi^3-ep^-3
        +49/4*ep^-2*mncxi-47/8*ep^-2*mncxi^2+7/8*ep^-2*mncxi^3-43/12*ep^-2
        -9*ep^-1*z3*mncxi+3*ep^-1*z3*mncxi^2+2*ep^-1*z3+365/8*ep^-1*mncxi
        -81/4*ep^-1*mncxi^2+11/4*ep^-1*mncxi^3-93/8*ep^-1-101/4*z3*mncxi
        +3/2*z3*mncxi^2+3/4*z3*mncxi^3+23*z3-27/2*z4*mncxi+9/2*z4*mncxi^2+3*z4
        +20*z5*mncxi+2147/16*mncxi-217/4*mncxi^2+27/4*mncxi^3)
    +cf^2*nf*(+163/8-1/2*ep^-2*mncxi-1/6*ep^-2-9/4*ep^-1*mncxi+11/12*ep^-1
        -16*z3-67/8*mncxi)
    +cf^3*(+79/48+1/2*ep^-3*mncxi-1/2*ep^-3*mncxi^2+1/6*ep^-3*mncxi^3-1/6*ep^-3
        +3/4*ep^-2*mncxi-3/2*ep^-2*mncxi^2+1/2*ep^-2*mncxi^3+1/4*ep^-2+13/8*ep^-1*mncxi
        -3*ep^-1*mncxi^2+ep^-1*mncxi^3-1/8*ep^-1-5/2*z3*mncxi-7/2*z3*mncxi^2
        +7/6*z3*mncxi^3+29/6*z3+103/16*mncxi-3*mncxi^2+mncxi^3))
	+2*mncfermi2*mncfermi1-mncfermi1^3;
*
*   The two loop fermion propagator
*
id  mncfermi2 =
    +cf*ca*(-1+5/4*mncxi-1/4*mncxi^2-25/4*ep+15/4*ep*mncxi-5/8*ep*mncxi^2
        -175/8*ep^2+55/4*ep^2*mncxi-17/8*ep^2*mncxi^2+6*ep^2*z3-3*ep^2*z3*mncxi
        -1165/16*ep^3+175/4*ep^3*mncxi-53/8*ep^3*mncxi^2
        +50/3*ep^3*z3-49/3*ep^3*z3*mncxi+8/3*ep^3*z3*mncxi^2
        +9*ep^3*z4-9/2*ep^3*z4*mncxi)
    +cf*nf*(+1/2*ep+7/4*ep^2+53/8*ep^3)
    +cf^2*(+1/2-mncxi+1/2*mncxi^2+7/4*ep-2*ep*mncxi+ep*mncxi^2+29/8*ep^2-6*ep^2*mncxi
        +3*ep^2*mncxi^2+79/16*ep^3-18*ep^3*mncxi+9*ep^3*mncxi^2+2/3*ep^3*z3
        +32/3*ep^3*z3*mncxi-16/3*ep^3*z3*mncxi^2);
*
*   The one loop fermion propagator in QCD (times ep)
*
id  mncfermi1 =
    cf*(mncxi-1)*(1+ep+2*ep^2-7/3*ep^3*z3+4*ep^3);
*
*   The two loop ghost propagator
*
id  mncghost2 =
    +ca*nf*(-1/4-7/8*ep-53/16*ep^2-351/32*ep^3+8/3*ep^3*z3)
    +ca^2*(+5/4+7/16*mncxi-1/32*mncxi^2+83/16*ep+7/32*ep*mncxi
        +599/32*ep^2-9/64*ep^2*mncxi+3/8*ep^2*mncxi^2-3/4*ep^2*z3-3/16*ep^2*z3*mncxi^2
        +3881/64*ep^3-383/128*ep^3*mncxi+17/8*ep^3*mncxi^2
        -40/3*ep^3*z3-85/24*ep^3*z3*mncxi-29/48*ep^3*z3*mncxi^2
        -9/8*ep^3*z4-9/32*ep^3*z4*mncxi^2);
*
*   The one loop ghost propagator (times ep)
*
id  mncghost1 =
    ca*(1/2+1/4*mncxi+ep+2*ep^2-7/12*ep^3*z3*mncxi-7/6*ep^3*z3+4*ep^3);
*
*	The three loop gluon propagator
*
id	mncgluon3 = ep^3*(
  + cf*ca*nf*(-416699/648-1/2*ep^-2*mncxi-131/18*ep^-2+4*ep^-1*z3
    *mncxi+68*ep^-1*z3-49/12*ep^-1*mncxi-9551/108*ep^-1+26/3*z3*mncxi+
    358*z3+6*z4*mncxi+102*z4+40*z5-1309/72*mncxi)
  + cf*nf^2*(11536/81+16/9*ep^-2-16*ep^-1*z3+566/27*ep^-1-256/
    3*z3-24*z4)
  + cf^2*nf*(143/9+1/3*ep^-1+148/3*z3-80*z5)
  + ca*nf^2*(475477/1944+2/9*ep^-3*mncxi+31/9*ep^-3+14/27*ep^-2*mncxi
    +1021/54*ep^-2+8*ep^-1*z3+22/27*ep^-1*mncxi+8003/108*ep^-1-26/
    3*z3*mncxi-5/3*z3+12*z4+586/243*mncxi)
  + ca^2*nf*(-3265189/2592-73/36*ep^-3*mncxi-155/12*ep^-3-947/216
    *ep^-2*mncxi-1/24*ep^-2*mncxi^2-16451/216*ep^-2+2/3*ep^-1*z3*mncxi-89/
    3*ep^-1*z3-2299/432*ep^-1*mncxi-121/144*ep^-1*mncxi^2-144949/432*
    ep^-1+2735/36*z3*mncxi+13/12*z3*mncxi^2+1913/36*z3+z4*mncxi-89/2*z4
    +80/3*z5+14435/7776*mncxi-5503/864*mncxi^2)
  + ca^3*(99584761/46656+665/144*ep^-3*mncxi+3325/216*ep^-3+5455/
    864*ep^-2*mncxi+37/24*ep^-2*mncxi^2-47/96*ep^-2*mncxi^3+1/16*ep^-2*mncxi^4
    +14017/144*ep^-2-379/24*ep^-1*z3*mncxi-1/16*ep^-1*z3*mncxi^2-77/6*
    ep^-1*z3-1519/192*ep^-1*mncxi+281/18*ep^-1*mncxi^2-757/192*ep^-1*mncxi^3
    +15/32*ep^-1*mncxi^4+1266119/2592*ep^-1-23483/144*z3*mncxi-247/24*
    z3*mncxi^2+59/32*z3*mncxi^3-13/96*z3*mncxi^4-73711/216*z3-379/16*z4*mncxi
    -3/32*z4*mncxi^2-77/4*z4+505/24*z5*mncxi-55/24*z5*mncxi^2-15/16*z5*
    mncxi^3+35/192*z5*mncxi^4-655/12*z5-4628509/31104*mncxi+178133/1728*
    mncxi^2-8873/384*mncxi^3+493/192*mncxi^4)
  + nf^3*(-11656/729-8/27*ep^-3-40/27*ep^-2-424/81*ep^-1+56/
    27*z3) );
*
*   The two loop gluon propagator
*
id  mncgluon2 =
    +nf^2*(+4/9+40/27*ep+4*ep^2+2432/243*ep^3-56/27*ep^3*z3)
    +cf*nf*(-ep-55/6*ep^2+8*z3*ep^2-1711/36*ep^3+76/3*ep^3*z3+12*ep^3*z4)
    +ca*nf*(-55/18-1/3*mncxi-1199/108*ep-2/9*ep*mncxi-2371/72*ep^2
        +5/27*ep^2*mncxi-4*ep^2*z3-337315/3888*ep^3+37/81*ep^3*mncxi
        +286/27*ep^3*z3+50/9*ep^3*z3*mncxi-6*ep^3*z4)
    +ca^2*(+175/36+35/24*mncxi+4229/216*ep-97/144*ep*mncxi+5/8*ep*mncxi^2
        -1/8*ep*mncxi^3+9821/144*ep^2-6121/864*ep^2*mncxi+27/8*ep^2*mncxi^2
        -9/16*ep^2*mncxi^3-ep^2*z3-2*ep^2*z3*mncxi+1659373/7776*ep^3
        -165073/5184*ep^3*mncxi+113/8*ep^3*mncxi^2-33/16*ep^3*mncxi^3
        -1184/27*ep^3*z3-134/9*ep^3*z3*mncxi-3/2*ep^3*z3*mncxi^2
        -3/2*ep^3*z4-3*ep^3*z4*mncxi);
*
*   The one loop gluon propagator
*
id  mncgluon1 =
    +ca*(5/3+mncxi/2-ep*mncxi+ep*mncxi^2/4+31/9*ep-2*ep^2*mncxi+ep^2*mncxi^2/2+188/27*ep^2
        -7/6*ep^3*z3*mncxi-35/9*ep^3*z3-4*ep^3*mncxi+ep^3*mncxi^2+1132/81*ep^3)
    +nf*(-2/3-10/9*ep-56/27*ep^2+14/9*ep^3*z3-328/81*ep^3);

id  ep = 0;
*
.sort: Sub integrals;
*
*   The next factor is the conversion to MS-bar. Because there are three
*   loops we need the factor (1/(1-2*ep)-7/3*ep^3*z3+...)^3
*   We have multiplied it out here.
*   Note also that somehow the original Mincer program has a different
*   normalization for mncG311, using effectively only two powers.
*   For the comparison we have corrected that in subint.prc
*   This may have to be changed as it isn't clear to me why this has
*   been done! (But the factor 1-2*ep was needed to get the answer to
*   come out right)
*
#if `SCHEME' == 0
*
*   This is MS-bar
*
#message Answer in MS-bar
#if `LOOPS' == 0
#else
#if `LOOPS' == 1
multiply,1+2*ep+4*ep^2+8*ep^3-7/3*ep^3*z3;
#else
#if `LOOPS' == 2
multiply,1+4*ep+12*ep^2+32*ep^3-14/3*ep^3*z3;
#else
#if `LOOPS' == 3
multiply,1+6*ep+24*ep^2+80*ep^3-7*ep^3*z3;
#else
#message Illegal number of loops specified: 'LOOPS'
#message Answer will be in the G-scheme anyway
#endif
#endif
#endif
#endif
#else
#if ( `SCHEME' != 1 )
#message Invalid value `SCHEME' for output corrected to G-scheme
#else
#message Answer in the G-scheme
#endif
#endif
id  ep = 0;
#endprocedure
*--#] finish : 
*--#[ gtreat :
#procedure gtreat(POWER)
Multiply d_(MU,NU)/Q.Q;
sum mu,mu1,nu,nu1,MU,NU,ga1,ga2,ro,ro1,si,si1,ka,ka1,la,la1;

id	mncVv(mnci1?,p1?,mnci2?,p2?) = p1(11)*p2(mnci2)-p1(mnci2)*p2(mnci1);
print +f +mncs;
.sort
id Glonel(mu?,ro?,Q?,p1?,p2?)  =
   (-1)*nf/2
  *mncSS(mu,p1,ro,-p2)
   +1/2*ca
  *mncV3G(mu,Q,ga4,-p2,ga2,-p1)*mncV3G(ro,-Q,ga3,p1,ga5,p2)
  *mncDg(ga4,ga5,p2)*mncDg(ga2,ga3,p1)
   +(-1)*ca
  *mncVgh(p1,ro)*(-mncVgh(p2,mu))*mncDs(p1)*mncDs(p2);
.sort
repeat;
	id	mncS(mnci1?index_,?a) = g_(1,mnci1)*mncS(?a);
	id	mncS(mncp?,?a)     = g_(1,mncp) *mncS(?a)*mncpropxp(mncp);
endrepeat;
id	mncS = 1;
repeat;
	id	mncSS(mnci1?index_,?a) = g_(2,mnci1)*mncSS(?a);
	id	mncSS(mncp?,?a)     = g_(2,mncp) *mncSS(?a)*mncpropxp(mncp);
endrepeat;
id	mncSS = 1;
repeat;
	id	mncSSS(mnci1?index_,?a) = g_(3,mnci1)*mncSSS(?a);
	id	mncSSS(mncp?,?a)     = g_(3,mncp) *mncSSS(?a)*mncpropxp(mncp);
endrepeat;
id	mncSSS = 1;
id	mncVgh(mncp?,mu?) = mncp(mu);
id	mncDs(mncp?) = mncpropxp(mncp);
id	mncDL(mnci1?,mnci2?,mncp?) = (d_(mnci1,mnci2)-mncp(mnci1)*mncp(mnci2)*mncpropxp(mncp))*mncpropxp(mncp);

#call vertsub
#call ACCU(Vertex substitutions)
id	mncpropxp(mncp?) = 1/mncp.mncp;

*#call reduceto(`TOPO')
*id	g_(1,P,Q,[P+Q]) = [P+Q].[P+Q]*g_(1,P);

#call sym1(`TOPO')
id	P.P = 0;
id D = acc(4-2*ep);

#call ACCU(Vertex identities)

*tracen,3;
*tracen,2;
*tracen,1;
*id	P.P = 0;
*id D = acc(4-2*ep);
*id [D-4] = acc(-2*ep);
*id [1-ep/2] = acc(1-ep/2);

*#call ACCU(Traces)

#do mnci = 1,8
id	[P+p`mnci'] = P+p`mnci';
id	[P-p`mnci'] = P-p`mnci';
#enddo
id	[P+Q] = P+Q;
id	[P-Q] = P-Q;
id	P.P = 0;
#call ACCU(Introduce P)
#call momsubs(`TOPO')
#call ACCU(moms)
id	P = mncproexp*P;
if ( count(mncproexp,1) > `POWER' ) discard;
#do mnci = 1,8
repeat id,once,mncproexp^mncx?/[P+p`mnci'].[P+p`mnci'] =
	sump_(mncj,0,`POWER'-mncx,-2*mncproexp*P.p`mnci'/p`mnci'.p`mnci')*mncproexp^mncx/p`mnci'.p`mnci';
repeat id,once,mncproexp^mncx?/[P-p`mnci'].[P-p`mnci'] =
	sump_(mncj,0,`POWER'-mncx, 2*mncproexp*P.p`mnci'/p`mnci'.p`mnci')*mncproexp^mncx/p`mnci'.p`mnci';
#enddo
repeat id,once,mncproexp^mncx?/[P-Q].[P-Q] =
	sump_(mncj,0,`POWER'-mncx, 2*mncproexp*P.Q/Q.Q)*mncproexp^mncx/Q.Q;
repeat id,once,mncproexp^mncx?/[P+Q].[P+Q] =
	sump_(mncj,0,`POWER'-mncx,-2*mncproexp*P.Q/Q.Q)*mncproexp^mncx/Q.Q;
if ( count(mncproexp,1) != `POWER' ) discard;
id	mncproexp^`POWER' = 1;

#call ACCU(Expand in P)
#call momsubs(`TOPO')
#call sym2(`TOPO')
#call ACCU(moms)
#call harmo(P,Q,mncFFPP)
#call ACCU(Harmonics)
#endprocedure
*--#] gtreat : 
*--#[ harmo :
#procedure harmo(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac is a table to give better speed.
*
id  `P'.`P' = 0;
id  `Q'.`P' = `Q'.`Q';
ToTensor,nosquare,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  `TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to d_'mncs.
*	We used mncdd as an intemediary to have the mnchfac worked out before
*	the dd_ is expanded. At that moment there are fewer terms. 
*
tovector,`TT',`Q';
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
*
#endprocedure
*
*	Table is good up to D12 or P10.
*	We have only terms up to ep^3 as the integrals at this point can have
*	divergences up to ep^-3 only.
*
CTable,relax,mnchfac(0:12,0:12);
Fill mnchfac(0,0) = 1;
Fill mnchfac(1,0) = 1;
Fill mnchfac(2,0) = 4/3 + 2/9*ep + 4/27*ep^2 + 8/81*ep^3;
Fill mnchfac(2,2) = - 1/3 - 2/9*ep - 4/27*ep^2 - 8/81*ep^3;
Fill mnchfac(3,0) = 2 + 2/3*ep + 4/9*ep^2 + 8/27*ep^3;
Fill mnchfac(3,2) = - 1/3 - 2/9*ep - 4/27*ep^2 - 8/81*ep^3;
Fill mnchfac(4,0) = 16/5 + 116/75*ep + 1196/1125*ep^2 + 12176/16875*ep^3;
Fill mnchfac(4,2) = - 2/5 - 22/75*ep - 232/1125*ep^2 - 2392/16875*ep^3;
Fill mnchfac(4,4) = 1/15 + 16/225*ep + 196/3375*ep^2 + 2176/50625*ep^3;
Fill mnchfac(5,0) = 16/3 + 148/45*ep + 1588/675*ep^2 + 16528/10125*ep^3;
Fill mnchfac(5,2) = - 8/15 - 98/225*ep - 1088/3375*ep^2 - 11528/50625*ep^3;
Fill mnchfac(5,4) = 1/15 + 16/225*ep + 196/3375*ep^2 + 2176/50625*ep^3;
Fill mnchfac(6,0) = 64/7 + 1648/245*ep + 129016/25725*ep^2 + 9613672/2701125*ep^3;
Fill mnchfac(6,2) =
       - 16/21 - 1516/2205*ep - 123292/231525*ep^2 - 9367864/24310125*ep^3;
Fill mnchfac(6,4) =
      8/105 + 926/11025*ep + 81092/1157625*ep^2 + 6386864/121550625*ep^3;
Fill mnchfac(6,6) =
       - 1/105 - 142/11025*ep - 13864/1157625*ep^2 - 1162288/121550625*ep^3;
Fill mnchfac(7,0) = 16 + 472/35*ep + 38464/3675*ep^2 + 2929288/385875*ep^3;
Fill mnchfac(7,2) = - 8/7 - 276/245*ep - 23372/25725*ep^2 - 1815224/2701125*ep^3;
Fill mnchfac(7,4) = 2/21 + 242/2205*ep + 21764/231525*ep^2 + 1742288/24310125*ep^3;
Fill mnchfac(7,6) =
       - 1/105 - 142/11025*ep - 13864/1157625*ep^2 - 1162288/121550625*ep^3;
Fill mnchfac(8,0) =
      256/9 + 75808/2835*ep + 19246768/893025*ep^2 + 4489358368/281302875*ep^3;
Fill mnchfac(8,2) =
       - 16/9 - 5368/2835*ep - 1414288/893025*ep^2 - 336272488/281302875*ep^3;
Fill mnchfac(8,4) =
      8/63 + 3044/19845*ep + 844124/6251175*ep^2 + 206121824/1969120125*ep^3;
Fill mnchfac(8,6) =
       - 2/189 - 866/59535*ep - 256496/18753525*ep^2 - 64996496/5907360375*
      ep^3;
Fill mnchfac(8,8) =
      1/945 + 496/297675*ep + 159496/93767625*ep^2 + 42546496/29536801875*ep^3;
Fill mnchfac(9,0) =
      256/5 + 82976/1575*ep + 21820976/496125*ep^2 + 5190442976/156279375*ep^3;
Fill mnchfac(9,2) =
       - 128/45 - 45968/14175*ep - 12519368/4465125*ep^2 - 3033399368/
      1406514375*ep^3;
Fill mnchfac(9,4) =
      8/45 + 3188/14175*ep + 907988/4465125*ep^2 + 225339488/1406514375*ep^3;
Fill mnchfac(9,6) =
       - 4/315 - 1774/99225*ep - 533824/31255875*ep^2 - 136691824/9845600625*
      ep^3;
Fill mnchfac(9,8) =
      1/945 + 496/297675*ep + 159496/93767625*ep^2 + 42546496/29536801875*ep^3;
Fill mnchfac(10,0) =
      1024/11 + 3941248/38115*ep + 11779286528/132068475*ep^2 + 31395360315808/
      457617265875*ep^3;
Fill mnchfac(10,2) =
       - 256/55 - 1074016/190575*ep - 3316968176/660342375*ep^2 - 
      8998169551936/2288086329375*ep^3;
Fill mnchfac(10,4) =
      128/495 + 586288/1715175*ep + 1884204968/5943081375*ep^2 + 5224503688648/
      20592776964375*ep^3;
Fill mnchfac(10,6) =
       - 8/495 - 40108/1715175*ep - 135134588/5943081375*ep^2 - 385061648968/
      20592776964375*ep^3;
Fill mnchfac(10,8) =
      4/3465 + 22034/12006225*ep + 78474124/41601569625*ep^2 + 231375515864/
      144149438750625*ep^3;
Fill mnchfac(10,10) =
       - 1/10395 - 6086/36018675*ep - 23133196/124804708875*ep^2 - 71203299656/
      432448316251875*ep^3;
Fill mnchfac(11,0) =
      512/3 + 2105024/10395*ep + 6484548064/36018675*ep^2 + 17587269036704/
      124804708875*ep^3;
Fill mnchfac(11,2) =
       - 256/33 - 1133152/114345*ep - 3599216912/396205425*ep^2 - 
      9927387845632/1372851797625*ep^3;
Fill mnchfac(11,4) =
      64/165 + 305464/571725*ep + 1005647504/1981027125*ep^2 + 2830303821544/
      6864258988125*ep^3;
Fill mnchfac(11,6) =
       - 32/1485 - 165052/5145525*ep - 566368772/17829244125*ep^2 - 
      1633203887992/61778330893125*ep^3;
Fill mnchfac(11,8) =
      2/1485 + 11182/5145525*ep + 40241252/17829244125*ep^2 + 119504735272/
      61778330893125*ep^3;
Fill mnchfac(11,10) =
       - 1/10395 - 6086/36018675*ep - 23133196/124804708875*ep^2 - 71203299656/
      432448316251875*ep^3;
Fill mnchfac(12,0) =
      4096/13 + 231932416/585585*ep + 9552620306048/26377676325*ep^2 + 
      342403963966857664/1188182430059625*ep^3;
Fill mnchfac(12,2) =
       - 512/39 - 30913472/1756755*ep - 1310118983776/79133028975*ep^2 - 
      47718354631206368/3564547290178875*ep^3;
Fill mnchfac(12,4) =
      256/429 + 16505056/19324305*ep + 722647696208/870463318725*ep^2 + 
      26818419631574944/39210020191967625*ep^3;
Fill mnchfac(12,6) =
       - 64/2145 - 4414552/96621525*ep - 200547273536/4352316593625*ep^2 - 
      7607970101536648/196050100959838125*ep^3;
Fill mnchfac(12,8) =
      32/19305 + 2367436/869593725*ep + 112122653948/39170849342625*ep^2 + 
      4365158933778064/1764450908638543125*ep^3;
Fill mnchfac(12,10) =
       - 2/19305 - 159226/869593725*ep - 7904207768/39170849342625*ep^2 - 
      317328063224824/1764450908638543125*ep^3;
Fill mnchfac(12,12) =
      1/135135 + 86048/6087156075*ep + 4505822764/274195945398375*ep^2 + 
      187659001098752/12351156360469801875*ep^3;

*--#] harmo : 
*--#[ harmo1 :
#procedure harmo1(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac1 is a table to give better speed.
*
id  `P'.`P' = 0;
id  `Q'.`P' = `Q'.`Q';
ToTensor,nosquare,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  `TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac1(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to
*   d_'mncs. We do not expand the mncdd directly to make the multiplication
*   of the acc'mncs much faster.
*
tovector,`TT',`Q';
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
*
#endprocedure

CTable,relax,mnchfac1(0:16,0:16);
Fill mnchfac1(0,0)=
      1;
Fill mnchfac1(1,0)=
      1;
Fill mnchfac1(2,0)=
      4/3+2/9*ep+4/27*ep^2+8/81*ep^3+16/243*ep^4+32/729*ep^5+64/2187*ep^6;
Fill mnchfac1(2,2)=
      -1/3-2/9*ep-4/27*ep^2-8/81*ep^3-16/243*ep^4-32/729*ep^5-64/2187*ep^6;
Fill mnchfac1(3,0)=
      2+2/3*ep+4/9*ep^2+8/27*ep^3+16/81*ep^4+32/243*ep^5+64/729*ep^6;
Fill mnchfac1(3,2)=
      -1/3-2/9*ep-4/27*ep^2-8/81*ep^3-16/243*ep^4-32/729*ep^5-64/2187*ep^6;
Fill mnchfac1(4,0)=
      16/5+116/75*ep+1196/1125*ep^2+12176/16875*ep^3+123056/253125*ep^4+
      1238336/3796875*ep^5+12430016/56953125*ep^6;
Fill mnchfac1(4,2)=
      -2/5-22/75*ep-232/1125*ep^2-2392/16875*ep^3-24352/253125*ep^4-246112/
      3796875*ep^5-2476672/56953125*ep^6;
Fill mnchfac1(4,4)=
      1/15+16/225*ep+196/3375*ep^2+2176/50625*ep^3+23056/759375*ep^4+238336/
      11390625*ep^5+2430016/170859375*ep^6;
Fill mnchfac1(5,0)=
      16/3+148/45*ep+1588/675*ep^2+16528/10125*ep^3+169168/151875*ep^4+
      1715008/2278125*ep^5+17290048/34171875*ep^6;
Fill mnchfac1(5,2)=
      -8/15-98/225*ep-1088/3375*ep^2-11528/50625*ep^3-119168/759375*ep^4-
      1215008/11390625*ep^5-12290048/170859375*ep^6;
Fill mnchfac1(5,4)=
      1/15+16/225*ep+196/3375*ep^2+2176/50625*ep^3+23056/759375*ep^4+238336/
      11390625*ep^5+2430016/170859375*ep^6;
Fill mnchfac1(6,0)=
      64/7+1648/245*ep+129016/25725*ep^2+9613672/2701125*ep^3+697694224/
      283618125*ep^4+49885657408/29779903125*ep^5+3536215611136/3126889828125
      *ep^6;
Fill mnchfac1(6,2)=
      -16/21-1516/2205*ep-123292/231525*ep^2-9367864/24310125*ep^3-687208288/
      2552563125*ep^4-49440388096/268019128125*ep^5-3517368500032/
      28142008453125*ep^6;
Fill mnchfac1(6,4)=
      8/105+926/11025*ep+81092/1157625*ep^2+6386864/121550625*ep^3+477728288/
      12762815625*ep^4+34752488096/1340095640625*ep^5+2488486500032/
      140710042265625*ep^6;
Fill mnchfac1(6,6)=
      -1/105-142/11025*ep-13864/1157625*ep^2-1162288/121550625*ep^3-90226096/
      12762815625*ep^4-6712496032/1340095640625*ep^5-487263833344/
      140710042265625*ep^6;
Fill mnchfac1(7,0)=
      16+472/35*ep+38464/3675*ep^2+2929288/385875*ep^3+215266096/40516875*
      ep^4+15505796032/4254271875*ep^5+1104009833344/446698546875*ep^6;
Fill mnchfac1(7,2)=
      -8/7-276/245*ep-23372/25725*ep^2-1815224/2701125*ep^3-134861408/
      283618125*ep^4-9775819136/29779903125*ep^5-698642203712/3126889828125*
      ep^6;
Fill mnchfac1(7,4)=
      2/21+242/2205*ep+21764/231525*ep^2+1742288/24310125*ep^3+131636096/
      2552563125*ep^4+9635496032/268019128125*ep^5+692602833344/
      28142008453125*ep^6;
Fill mnchfac1(7,6)=
      -1/105-142/11025*ep-13864/1157625*ep^2-1162288/121550625*ep^3-90226096/
      12762815625*ep^4-6712496032/1340095640625*ep^5-487263833344/
      140710042265625*ep^6;
Fill mnchfac1(8,0)=
      256/9+75808/2835*ep+19246768/893025*ep^2+4489358368/281302875*ep^3+
      1001728100368/88610405625*ep^4+218025485306368/27912277771875*ep^5+
      46771949116202368/8792367498140625*ep^6;
Fill mnchfac1(8,2)=
      -16/9-5368/2835*ep-1414288/893025*ep^2-336272488/281302875*ep^3-
      75848735488/88610405625*ep^4-16613136791488/27912277771875*ep^5-
      3577389080927488/8792367498140625*ep^6;
Fill mnchfac1(8,4)=
      8/63+3044/19845*ep+844124/6251175*ep^2+206121824/1969120125*ep^3+
      47199849824/620272839375*ep^4+10430561637824/195385944403125*ep^5+
      2258069814165824/61546572486984375*ep^6;
Fill mnchfac1(8,6)=
      -2/189-866/59535*ep-256496/18753525*ep^2-64996496/5907360375*ep^3-
      15212278496/1860818518125*ep^4-3406285030496/586157833209375*ep^5-
      743347417642496/184639717460953125*ep^6;
Fill mnchfac1(8,8)=
      1/945+496/297675*ep+159496/93767625*ep^2+42546496/29536801875*ep^3+
      10286568496/9304092590625*ep^4+2351196330496/2930789166046875*ep^5+
      519799077642496/923198587304765625*ep^6;
Fill mnchfac1(9,0)=
      256/5+82976/1575*ep+21820976/496125*ep^2+5190442976/156279375*ep^3+
      1171598464976/49228003125*ep^4+256775705086976/15506820984375*ep^5+
      55317926550958976/4884648610078125*ep^6;
Fill mnchfac1(9,2)=
      -128/45-45968/14175*ep-12519368/4465125*ep^2-3033399368/1406514375*ep^3
      -691968210368/443052028125*ep^4-152606739906368/139561388859375*ep^5-
      33000199172202368/43961837490703125*ep^6;
Fill mnchfac1(9,4)=
      8/45+3188/14175*ep+907988/4465125*ep^2+225339488/1406514375*ep^3+
      52120755488/443052028125*ep^4+11590175991488/139561388859375*ep^5+
      2518875627927488/43961837490703125*ep^6;
Fill mnchfac1(9,6)=
      -4/315-1774/99225*ep-533824/31255875*ep^2-136691824/9845600625*ep^3-
      32211509824/3101364196875*ep^4-7244605937824/976929722015625*ep^5-
      1585445081165824/307732862434921875*ep^6;
Fill mnchfac1(9,8)=
      1/945+496/297675*ep+159496/93767625*ep^2+42546496/29536801875*ep^3+
      10286568496/9304092590625*ep^4+2351196330496/2930789166046875*ep^5+
      519799077642496/923198587304765625*ep^6;
Fill mnchfac1(10,0)=
      1024/11+3941248/38115*ep+11779286528/132068475*ep^2+31395360315808/
      457617265875*ep^3+78817416774749888/1585643826256875*ep^4+
      191296333735703644768/5494255857980071875*ep^5+455196393432838909648448/
      19037596547900949046875*ep^6;
Fill mnchfac1(10,2)=
      -256/55-1074016/190575*ep-3316968176/660342375*ep^2-8998169551936/
      2288086329375*ep^3-22822219943433296/7928219131284375*ep^4-
      55731982644325548256/27471279289900359375*ep^5-133110230344468529882816/
      95187982739504745234375*ep^6;
Fill mnchfac1(10,4)=
      128/495+586288/1715175*ep+1884204968/5943081375*ep^2+5224503688648/
      20592776964375*ep^3+13422543891846128/71353972181559375*ep^4+
      33033670720523533408/247241513609103234375*ep^5+79273078399635825303488/
      856691844655542707109375*ep^6;
Fill mnchfac1(10,6)=
      -8/495-40108/1715175*ep-135134588/5943081375*ep^2-385061648968/
      20592776964375*ep^3-1005688819949648/71353972181559375*ep^4-
      2500193390173412128/247241513609103234375*ep^5-6037463662096098209408/
      856691844655542707109375*ep^6;
Fill mnchfac1(10,8)=
      4/3465+22034/12006225*ep+78474124/41601569625*ep^2+231375515864/
      144149438750625*ep^3+617375290327504/499477805270915625*ep^4+
      1555697463798820544/1730690595263722640625*ep^5+3788802075628465273984/
      5996842912588798949765625*ep^6;
Fill mnchfac1(10,10)=
      -1/10395-6086/36018675*ep-23133196/124804708875*ep^2-71203299656/
      432448316251875*ep^3-195463728133216/1498433415812746875*ep^4-
      501804668946637376/5192071785791167921875*ep^5-1236992715223799403136/
      17990528737766396849296875*ep^6;
Fill mnchfac1(11,0)=
      512/3+2105024/10395*ep+6484548064/36018675*ep^2+17587269036704/
      124804708875*ep^3+44620587006331744/432448316251875*ep^4+
      109002812721985297184/1498433415812746875*ep^5+260418148499992639897024/
      5192071785791167921875*ep^6;
Fill mnchfac1(11,2)=
      -256/33-1133152/114345*ep-3599216912/396205425*ep^2-9927387845632/
      1372851797625*ep^3-25437420674539952/4756931478770625*ep^4-
      62514193873472733472/16482767573940215625*ep^5-149901045320140230992192/
      57112789643702847140625*ep^6;
Fill mnchfac1(11,4)=
      64/165+305464/571725*ep+1005647504/1981027125*ep^2+2830303821544/
      6864258988125*ep^3+7340055442799984/23784657393853125*ep^4+
      18171877679298377824/82413837869701078125*ep^5+43771816945911945664064/
      285563948218514235703125*ep^6;
Fill mnchfac1(11,6)=
      -32/1485-165052/5145525*ep-566368772/17829244125*ep^2-1633203887992/
      61778330893125*ep^3-4298811218276912/214061916544678125*ep^4-
      10740981158685800032/741724540827309703125*ep^5-26021186219050005844352/
      2570075533966628121328125*ep^6;
Fill mnchfac1(11,8)=
      2/1485+11182/5145525*ep+40241252/17829244125*ep^2+119504735272/
      61778330893125*ep^3+320436189606992/214061916544678125*ep^4+
      810100247041390912/741724540827309703125*ep^5+1977198808190427804032/
      2570075533966628121328125*ep^6;
Fill mnchfac1(11,10)=
      -1/10395-6086/36018675*ep-23133196/124804708875*ep^2-71203299656/
      432448316251875*ep^3-195463728133216/1498433415812746875*ep^4-
      501804668946637376/5192071785791167921875*ep^5-1236992715223799403136/
      17990528737766396849296875*ep^6;
Fill mnchfac1(12,0)=
      4096/13+231932416/585585*ep+9552620306048/26377676325*ep^2+
      342403963966857664/1188182430059625*ep^3+11407792075081681333952/
      53521677562035808125*ep^4+364561360009988883783267136/
      2410883965781902976990625*ep^5+11366945928654188627099169856448/
      108598268238645819598542703125*ep^6;
Fill mnchfac1(12,2)=
      -512/39-30913472/1756755*ep-1310118983776/79133028975*ep^2-
      47718354631206368/3564547290178875*ep^3-1605096783082101070624/
      160565032686107424375*ep^4-51595302050743047366763232/
      7232651897345708930971875*ep^5-1614544106154750292440383714176/
      325794804715937458795628109375*ep^6;
Fill mnchfac1(12,4)=
      256/429+16505056/19324305*ep+722647696208/870463318725*ep^2+
      26818419631574944/39210020191967625*ep^3+912369819932349930992/
      1766215359547181668125*ep^4+29533805437994496650793856/
      79559170870802798240690625*ep^5+928212986345962610005192697408/
      3583742851875312046751909203125*ep^6;
Fill mnchfac1(12,6)=
      -64/2145-4414552/96621525*ep-200547273536/4352316593625*ep^2-
      7607970101536648/196050100959838125*ep^3-262362556305459313664/
      8831076797735908340625*ep^4-8565263494376565641097952/
      397795854354013991203453125*ep^5-270635475996909892431623899136/
      17918714259376560233759546015625*ep^6;
Fill mnchfac1(12,8)=
      32/19305+2367436/869593725*ep+112122653948/39170849342625*ep^2+
      4365158933778064/1764450908638543125*ep^3+153028898616288867152/
      79479691179623175065625*ep^4+5048541384762808600644736/
      3580162689186125920831078125*ep^5+160585687629192803262038853248/
      161268428334389042103835914140625*ep^6;
Fill mnchfac1(12,10)=
      -2/19305-159226/869593725*ep-7904207768/39170849342625*ep^2-
      317328063224824/1764450908638543125*ep^3-11351061489513328832/
      79479691179623175065625*ep^4-379447407147066524694976/
      3580162689186125920831078125*ep^5-12173131533692001654488077568/
      161268428334389042103835914140625*ep^6;
Fill mnchfac1(12,12)=
      1/135135+86048/6087156075*ep+4505822764/274195945398375*ep^2+
      187659001098752/12351156360469801875*ep^3+6883116416827133536/
      556357838257362225459375*ep^4+234016557715815866651648/
      25061138824302881445817546875*ep^5+7592462315747275929147393664/
      1128878998340723294726851398984375*ep^6;
Fill mnchfac1(13,0)=
      4096/7+244097536/315315*ep+10319742128768/14203364175*ep^2+
      375711675205023424/639790539262875*ep^3+12639066969880845261632/
      28819364841096204375*ep^4+406365756421014097219725376/
      1298168289267178526071875*ep^5+12718704458788802860399082024768/
      58475990590040056706907609375*ep^6;
Fill mnchfac1(13,2)=
      -2048/91-129145088/4099095*ep-5607358794304/184643734275*ep^2-
      207285335824775072/8317277010417375*ep^3-7037777173573268255296/
      374651742934250656875*ep^4-227568776116938423114463328/
      16876187760473320838934375*ep^5-7147878038639593066291156443904/
      760187877670520737189798921875*ep^6;
Fill mnchfac1(13,4)=
      256/273+17104096/12297285*ep+765124349648/553931202825*ep^2+
      28782752505588064/24951831031252125*ep^3+987765403914509727152/
      1123955228802751970625*ep^4+32153921399561393777604736/
      50628563281419962516803125*ep^5+1014182537283552715179078333248/
      2280563633011562211569396765625*ep^6;
Fill mnchfac1(13,6)=
      -128/3003-9076208/135270135*ep-419729246584/6093243231075*ep^2-
      16110167517555512/274470141343773375*ep^3-559853837941644685216/
      12363507516830271676875*ep^4-18369562166151731874761888/
      556914196095619587684834375*ep^5-582314625712167699616689097984/
      25086199963127184327263364421875*ep^6;
Fill mnchfac1(13,8)=
      32/15015+2413196/676350675*ep+115802553028/30466216155375*ep^2+
      4549174479503504/1372350706718866875*ep^3+160455215928334705072/
      61817537584151358384375*ep^4+5315161061687116647687296/
      2784570980478097938424171875*ep^5+169520799430411541843679699328/
      125430999815635921636316822109375*ep^6;
Fill mnchfac1(13,10)=
      -16/135135-1286678/6087156075*ep-64341099904/274195945398375*ep^2-
      2596614444771272/12351156360469801875*ep^3-93223663260247568896/
      556357838257362225459375*ep^4-3124164965461097406168128/
      25061138824302881445817546875*ep^5-100396845367338563439711330304/
      1128878998340723294726851398984375*ep^6;
Fill mnchfac1(13,12)=
      1/135135+86048/6087156075*ep+4505822764/274195945398375*ep^2+
      187659001098752/12351156360469801875*ep^3+6883116416827133536/
      556357838257362225459375*ep^4+234016557715815866651648/
      25061138824302881445817546875*ep^5+7592462315747275929147393664/
      1128878998340723294726851398984375*ep^6;
Fill mnchfac1(14,0)=
      16384/15+1022076928/675675*ep+8855205451264/6087156075*ep^2+
      1635953439324307456/1370979726991875*ep^3+55546394976216520160384/
      61755781802349009375*ep^4+1796409882008846330444963968/
      2781789191286811127296875*ep^5+11286825660272378214206183220352/
      25061138824302881445817546875*ep^6;
Fill mnchfac1(14,2)=
      -4096/105-268698112/4729725*ep-2386708597888/42610092525*ep^2-
      447384534399600064/9596858088943125*ep^3-15326058483484843246016/
      432290472616443065625*ep^4-498414063672824065755297472/
      19472524339007677891078125*ep^5-628487173008311367973015945664/
      35085594354024034024144565625*ep^6;
Fill mnchfac1(14,4)=
      2048/1365+141445376/61486425*ep+1291375944512/553931202825*ep^2+
      246065355438470432/124759155156260625*ep^3+8515645698336721669888/
      5619776144013759853125*ep^4+278713744181148773463810656/
      253142816407099812584015625*ep^5+1764366557238314519942960648768/
      2280563633011562211569396765625*ep^6;
Fill mnchfac1(14,6)=
      -256/4095-18641632/184459275*ep-175417198288/1661793608475*ep^2-
      34050530970176704/374277465468781875*ep^3-1192272892921391011376/
      16859328432041279559375*ep^4-39314712394447268191928992/
      759428449221299437752046875*ep^5-50012267996984120317592154368/
      1368338179806937326941638059375*ep^6;
Fill mnchfac1(14,8)=
      128/45045+9844976/2029052025*ep+95771634488/18279729693225*ep^2+
      18986189701230152/4117052120156600625*ep^3+673884893287232978128/
      185452612752454075153125*ep^4+22416914835234853141398656/
      8353712941434293815272515625*ep^5+143390123242517645516785885184/
      75258599889381552981790093265625*ep^6;
Fill mnchfac1(14,10)=
      -32/225225-2605388/10145260125*ep-131450513356/456993242330625*ep^2-
      1067733252543928/4117052120156600625*ep^3-192519245502228862912/
      927263063762270375765625*ep^4-6471431650173503198336768/
      41768564707171469076362578125*ep^5-208388217921353602052890327936/
      1881464997234538824544752331640625*ep^6;
Fill mnchfac1(14,12)=
      16/2027025+1382774/91307341125*ep+72646040548/4112939180975625*ep^2+
      606585312860512/37053469081409405625*ep^3+111439420205448744256/
      8345367573860433381890625*ep^4+3793470123215022564169664/
      375917082364543221687263203125*ep^5+123180426927367988960114332288/
      16933184975110849420902770984765625*ep^6;
Fill mnchfac1(14,14)=
      -1/2027025-92054/91307341125*ep-5058699088/4112939180975625*ep^2-
      43608309564256/37053469081409405625*ep^3-8192673953041741216/
      8345367573860433381890625*ep^4-283221757477784564394944/
      375917082364543221687263203125*ep^5-9293492191158850022903427328/
      16933184975110849420902770984765625*ep^6;
Fill mnchfac1(15,0)=
      2048+133140992/45045*ep+5900508278272/2029052025*ep^2+
      221097615608542592/91398648466125*ep^3+7574121111626553240832/
      4117052120156600625*ep^4+246347542921060776392076032/
      185452612752454075153125*ep^5+7767029312071063526660719270912/
      8353712941434293815272515625*ep^6;
Fill mnchfac1(15,2)=
      -1024/15-69645568/675675*ep-631879955968/6087156075*ep^2-
      120036485343130816/1370979726991875*ep^3-4147530121298698460864/
      61755781802349009375*ep^4-135628804414790379674012608/
      2781789191286811127296875*ep^5-858161591138629454698283899456/
      25061138824302881445817546875*ep^6;
Fill mnchfac1(15,4)=
      256/105+18235072/4729725*ep+169704257824/42610092525*ep^2+
      32739238583526304/9596858088943125*ep^3+1142221030467170498336/
      432290472616443065625*ep^4+37582297269225715996899232/
      19472524339007677891078125*ep^5+238724606077404111918575630656/
      175427971770120170120722828125*ep^6;
Fill mnchfac1(15,6)=
      -128/1365-9561056/61486425*ep-18295588144/110786240565*ep^2-
      17954474614737152/124759155156260625*ep^3-633322769773649480848/
      5619776144013759853125*ep^4-20985612031878553449587936/
      253142816407099812584015625*ep^5-133905332176793893499852254976/
      2280563633011562211569396765625*ep^6;
Fill mnchfac1(15,8)=
      16/4095+1255192/184459275*ep+12377077984/1661793608475*ep^2+
      2476611609254344/374277465468781875*ep^3+88461927049944678896/
      16859328432041279559375*ep^4+2955265462648549019604352/
      759428449221299437752046875*ep^5+18956832068182634863949499136/
      6841690899034686634708190296875*ep^6;
Fill mnchfac1(15,10)=
      -8/45045-660356/2029052025*ep-6729370556/18279729693225*ep^2-
      1376089666761272/4117052120156600625*ep^3-49866050710359748288/
      185452612752454075153125*ep^4-1681834208983197679041536/
      8353712941434293815272515625*ep^5-10855838251248556331109767552/
      75258599889381552981790093265625*ep^6;
Fill mnchfac1(15,12)=
      2/225225+174098/10145260125*ep+9195937636/456993242330625*ep^2+
      77089103554336/4117052120156600625*ep^3+14202752012392469632/
      927263063762270375765625*ep^4+484434848685621299217728/
      41768564707171469076362578125*ep^5+15751934589965076556213465216/
      1881464997234538824544752331640625*ep^6;
Fill mnchfac1(15,14)=
      -1/2027025-92054/91307341125*ep-5058699088/4112939180975625*ep^2-
      43608309564256/37053469081409405625*ep^3-8192673953041741216/
      8345367573860433381890625*ep^4-283221757477784564394944/
      375917082364543221687263203125*ep^5-9293492191158850022903427328/
      16933184975110849420902770984765625*ep^6;
Fill mnchfac1(16,0)=
      65536/17+75196264448/13018005*ep+57875871822457856/9968732598825*ep^2+
      37362483254848926620672/7633706518539226125*ep^3+
      21945499113835013680434024704/5845625272169190493610625*ep^4+
      12201132004815697250304907827488768/4476375236542640158339740253125*
      ep^5+6562774638413504361334915855526075204096/
      3427851483011074840851031194934265625*ep^6;
Fill mnchfac1(16,2)=
      -2048/17-2447901184/13018005*ep-1925778310087168/9968732598825*ep^2-
      1259745953440522719616/7633706518539226125*ep^3-
      746088682309618045037734912/5845625272169190493610625*ep^4-
      416993412638542080463173436789504/4476375236542640158339740253125*ep^5-
      225044142489744084807083745911634508288/
      3427851483011074840851031194934265625*ep^6;
Fill mnchfac1(16,4)=
      1024/255+1276226816/195270075*ep+41121672409088/5981239559295*ep^2+
      682355539174170147008/114505597778088391875*ep^3+
      407879273785189582693772864/87684379082537857404159375*ep^4+
      229319351125278753617686516874816/67145628548139602375096103796875*ep^5
      +24845810687833729610895677465758697152/
      10283554449033224522553093584802796875*ep^6;
Fill mnchfac1(16,6)=
      -256/1785-333059264/1366890525*ep-55045592329888/209343384575325*ep^2-
      185643166225862781152/801539184446618743125*ep^3-
      112124035530936525145504736/613790653577765001829115625*ep^4-
      63462742214773088988567874516064/470019399836977216625672726578125*ep^5
      -6905703340416942609714357629708156416/
      71984881143232571657871655093619578125*ep^6;
Fill mnchfac1(16,8)=
      128/23205+174069472/17769576825*ep+29573508614576/2721463999479225*ep^2
      +101531720737639386976/10420009397806043660625*ep^3+
      62042743775518910662573648/7979278496510945023778503125*ep^4+
      35385998929483485926862837993472/6110252197880703816133745445515625*
      ep^5+773946824719343250512309981851034368/
      187160690972404686310466303243410903125*ep^6;
Fill mnchfac1(16,10)=
      -16/69615-22779704/53308730475*ep-3987420244048/8164391998437675*ep^2-
      13963726285198013672/31260028193418130981875*ep^3-
      8646420710171918577783296/23937835489532835071335509375*ep^4-
      4975010395779169010000873554304/18330756593642111448401236336546875*
      ep^5-547211579378320120852582387612089856/
      2807410364586070294656994548651163546875*ep^6;
Fill mnchfac1(16,12)=
      8/765765+11946772/586396035225*ep+432009005716/17961662396562885*ep^2+
      7733720815921990336/343860310127599440800625*ep^3+
      4861593329686368646132288/263316190384861185784690603125*ep^4+
      2825945017535701058300936006272/201638322530063225932413599702015625*
      ep^5+312951422168309626261015125821369984/
      30881514010446773241226940035162799015625*ep^6;
Fill mnchfac1(16,14)=
      -2/3828825-3139846/2931980176125*ep-2940494702944/2245207799570360625*
      ep^2-86344119864019552/68772062025519888160125*ep^3-
      1380696594790769492126272/1316580951924305928923453015625*ep^4-
      812215167174920624589041469376/1008191612650316129662067998510078125*
      ep^5-453385872459557342035111641356383744/
      772037850261169331030673500879069975390625*ep^6;
Fill mnchfac1(16,16)=
      1/34459425+1655008/26387821585125*ep+1611063707152/20206870196133245625
      *ep^2+243275770764654464/3094742791148394967205625*ep^3+
      793843892172937871410336/11849228567318753360311077140625*ep^4+
      473651791152994731083469173248/9073724513852845166958611986590703125*
      ep^5+266993598880031227711792795283997952/
      6948340652350523979276061507911629778515625*ep^6;
*--#] harmo1 :
*--#[ harmo2 :
#procedure harmo2(P,Q,TT)
*
*   Routine to generate the harmonic projection for
*   P(mnci1)*P(mnci2)*...*P(in) = TT(mnci1,mnci2,...,in) at P->Q
*   The object mnchfac2 is a table to give better speed.
*
*id  `P'.`P' = 0;
*id  `Q'.`P' = `Q'.`Q';
ToTensor,`TT',`P';
*
*   Next generate the splits between indices that connect to a Q and
*   the indices that go to d_.
*
id  'TT'(?a) = sum_(mncj,0,nargs_(?a),2,`Q'.`Q'^(mncj/2)*
               acc(mnchfac2(nargs_(?a),mncj))*distrib_(1,mncj,mncdd,`TT',?a));
*
*   The indices in TT contract with Q and the indices in mncdd go to d_'mncs.
*	We used mncdd as an intemediary to have the mnchfac2 worked out before
*	the dd_ is expanded. At that moment there are fewer terms. 
*
tovector,`TT',`Q';
id	mncdd = 1;
id  mncdd(?a) = dd_(?a);
id  D = acc(4-2*ep);
*
#endprocedure
*
*	Table is good up to D12 or P10.
*	We have only terms up to ep^3 as the integrals at this point can have
*	divergences up to ep^-3 only.
*
CTable,relax,mnchfac2(2:12,0:12);
Fill mnchfac2(2,0) =
       - 1/3 - 2/9*ep - 4/27*ep^2 - 8/81*ep^3;
Fill mnchfac2(2,2) =
      1/3 + 2/9*ep + 4/27*ep^2 + 8/81*ep^3;
Fill mnchfac2(3,0) =
       - 1 - 2/3*ep - 4/9*ep^2 - 8/27*ep^3;
Fill mnchfac2(3,2) =
      1/3 + 2/9*ep + 4/27*ep^2 + 8/81*ep^3;
Fill mnchfac2(4,0) =
       - 12/5 - 44/25*ep - 464/375*ep^2 - 4784/5625*ep^3;
Fill mnchfac2(4,2) =
      7/15 + 82/225*ep + 892/3375*ep^2 + 9352/50625*ep^3;
Fill mnchfac2(4,4) =
       - 2/15 - 32/225*ep - 392/3375*ep^2 - 4352/50625*ep^3;
Fill mnchfac2(5,0) =
       - 16/3 - 196/45*ep - 2176/675*ep^2 - 23056/10125*ep^3;
Fill mnchfac2(5,2) =
      11/15 + 146/225*ep + 1676/3375*ep^2 + 18056/50625*ep^3;
Fill mnchfac2(5,4) =
       - 2/15 - 32/225*ep - 392/3375*ep^2 - 4352/50625*ep^3;
Fill mnchfac2(6,0) =
       - 80/7 - 1516/147*ep - 123292/15435*ep^2 - 9367864/1620675*ep^3;
Fill mnchfac2(6,2) =
      128/105 + 13136/11025*ep + 1103012/1157625*ep^2 + 85160504/121550625*
      ep^3;
Fill mnchfac2(6,4) =
       - 17/105 - 1994/11025*ep - 176048/1157625*ep^2 - 13936016/121550625*
      ep^3;
Fill mnchfac2(6,6) =
      1/35 + 142/3675*ep + 13864/385875*ep^2 + 1162288/40516875*ep^3;
Fill mnchfac2(7,0) =
       - 24 - 828/35*ep - 23372/1225*ep^2 - 1815224/128625*ep^3;
Fill mnchfac2(7,2) =
      44/21 + 4904/2205*ep + 427988/231525*ep^2 + 33759896/24310125*ep^3;
Fill mnchfac2(7,4) =
       - 23/105 - 2846/11025*ep - 259232/1157625*ep^2 - 20909744/121550625*
      ep^3;
Fill mnchfac2(7,6) =
      1/35 + 142/3675*ep + 13864/385875*ep^2 + 1162288/40516875*ep^3;
Fill mnchfac2(8,0) =
       - 448/9 - 21472/405*ep - 5657152/127575*ep^2 - 1345089952/40186125*ep^3
      ;
Fill mnchfac2(8,2) =
      232/63 + 83236/19845*ep + 22561876/6251175*ep^2 + 5445734776/1969120125*
      ep^3;
Fill mnchfac2(8,4) =
       - 20/63 - 1564/3969*ep - 440248/1250235*ep^2 - 108447328/393824025*ep^3
      ;
Fill mnchfac2(8,6) =
      31/945 + 13486/297675*ep + 4006936/93767625*ep^2 + 1017493936/
      29536801875*ep^3;
Fill mnchfac2(8,8) =
       - 4/945 - 1984/297675*ep - 637984/93767625*ep^2 - 170185984/29536801875
      *ep^3;
Fill mnchfac2(9,0) =
       - 512/5 - 183872/1575*ep - 50077472/496125*ep^2 - 12133597472/156279375
      *ep^3;
Fill mnchfac2(9,2) =
      296/45 + 112916/14175*ep + 31587116/4465125*ep^2 + 7765528616/1406514375
      *ep^3;
Fill mnchfac2(9,4) =
       - 152/315 - 62372/99225*ep - 18050072/31255875*ep^2 - 4521671072/
      9845600625*ep^3;
Fill mnchfac2(9,6) =
      13/315 + 5818/99225*ep + 1760968/31255875*ep^2 + 452621968/9845600625*
      ep^3;
Fill mnchfac2(9,8) =
       - 4/945 - 1984/297675*ep - 637984/93767625*ep^2 - 170185984/29536801875
      *ep^3;
Fill mnchfac2(10,0) =
       - 2304/11 - 1074016/4235*ep - 3316968176/14674275*ep^2 - 8998169551936/
      50846362875*ep^3;
Fill mnchfac2(10,2) =
      5888/495 + 26082208/1715175*ep + 82610452688/5943081375*ep^2 + 
      227269629249568/20592776964375*ep^3;
Fill mnchfac2(10,4) =
       - 376/495 - 1774196/1715175*ep - 5795428756/5943081375*ep^2 - 
      16224932111816/20592776964375*ep^3;
Fill mnchfac2(10,6) =
      64/1155 + 324824/4002075*ep + 1102890364/13867189875*ep^2 + 
      3158182574504/48049812916875*ep^3;
Fill mnchfac2(10,8) =
       - 7/1485 - 38642/5145525*ep - 137831812/17829244125*ep^2 - 406815641432/
      61778330893125*ep^3;
Fill mnchfac2(10,10) =
      1/2079 + 6086/7203735*ep + 23133196/24960941775*ep^2 + 71203299656/
      86489663250375*ep^3;
Fill mnchfac2(11,0) =
       - 1280/3 - 1133152/2079*ep - 3599216912/7203735*ep^2 - 9927387845632/
      24960941775*ep^3;
Fill mnchfac2(11,2) =
      3584/165 + 2380352/81675*ep + 1106110096/40429125*ep^2 + 3092405649056/
      140086918125*ep^3;
Fill mnchfac2(11,4) =
       - 608/495 - 2988148/1715175*ep - 9998466428/5943081375*ep^2 - 
      28414250145208/20592776964375*ep^3;
Fill mnchfac2(11,6) =
      116/1485 + 606976/5145525*ep + 2101518836/17829244125*ep^2 + 
      6094659016696/61778330893125*ep^3;
Fill mnchfac2(11,8) =
       - 59/10395 - 331354/36018675*ep - 1196154644/124804708875*ep^2 - 
      3559742486584/432448316251875*ep^3;
Fill mnchfac2(11,10) =
      1/2079 + 6086/7203735*ep + 23133196/24960941775*ep^2 + 71203299656/
      86489663250375*ep^3;
Fill mnchfac2(12,0) =
       - 11264/13 - 61826944/53235*ep - 2620237967552/2397970575*ep^2 - 
      95436709262412736/108016584550875*ep^3;
Fill mnchfac2(12,2) =
      17152/429 + 1082775712/19324305*ep + 46930455150896/870463318725*ep^2 + 
      1731730784364142528/39210020191967625*ep^3;
Fill mnchfac2(12,4) =
       - 4352/2145 - 288658016/96621525*ep - 12841800621088/4352316593625*ep^2
       - 481207359158775584/196050100959838125*ep^3;
Fill mnchfac2(12,6) =
      736/6435 + 51568148/289864575*ep + 2365538731564/13056949780875*ep^2 + 
      90297525582720152/588150302879514375*ep^3;
Fill mnchfac2(12,8) =
       - 28/3861 - 59572/4969107*ep - 2833804928/223833424815*ep^2 - 
      110654880654064/10082576620791675*ep^3;
Fill mnchfac2(12,10) =
      71/135135 + 5658958/6087156075*ep + 281153094644/274195945398375*ep^2 + 
      11294141213967592/12351156360469801875*ep^3;
Fill mnchfac2(12,12) =
       - 2/45045 - 172096/2029052025*ep - 9011645528/91398648466125*ep^2 - 
      375318002197504/4117052120156600625*ep^3;

*--#] harmo2 : 
*--#[ integral :
#procedure integral(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
*   Reduction procedure for three loop graphs of the la or ladder type.
*   Notation is from S.mncG.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /    |   P2   |    \ P3
*                   /     |        |     \
*                  /      |        |      \
*                 /       |        |       \
*          Q --<--     P7 ^        v P8     --<-- Q
*                 \       |        |       /
*                  \      |        |      / 
*                   \     |        |     /
*                 P6 \    |   P5   |    / P4
*                     \->------>----->-/
*
#call ladder(p1,p2,p3,p4,p5,p6,p7,p8,Q) 
multiply Q.Q;
#call ACCU(Ladder recursion)
*
*   Now use some symmetry relations to diminish the number of terms.
*   Note that these transformations are sign insensitive, because the
*   only `nonsquare' is p7.p8 and either both change sign or neither.
*
if ( ( count(p2.p2,1) > count(p5.p5,1) )
  || ( ( count(p2.p2,1) == count(p5.p5,1) )
  && ( ( count(p1.p1,1) < count(p6.p6,1) )
  || ( ( count(p1.p1,1) == count(p6.p6,1) )
  && ( count(p3.p3,1) < count(p4.p4,1) ) ) ) ) );
    multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
endif;
if ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p6.p6,1) < count(p4.p4,1) )
  || ( ( count(p6.p6,1) == count(p4.p4,1) )
  && ( count(p7.p7,1) < count(p8.p8,1) ) ) ) ) );
    multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
endif;
if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
*
*   type BEbar or benzbar. Note the introduction of Q.p2. This will
*   need some sign corrections in future transformations.
*
    id  p5.p5 = p2.p2+Q.Q-2*Q.p2;
endif;
if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
    id  p7.p8 = p7.p7/2+p8.p8/2-mncx8/2;
endif;

#call ACCU2(AB Q.Q mncx8,Rearrange)
Keep Brackets;
if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
    multiply acc(1/ep);
    #call triangle(p2,p7,p8,p1,p3)
    multiply ep;
endif;
#call ACCU(Second recursion)

id  mncx8 = p7.p7 + p8.p8 - 2*p7.p8;
#call ACCU(Second recursion B)

*
*   Now bring the integrals to a standard form again. We can make it
*   such that either p1.p1 is missing, or p2.p2 and p5.p5, or p8.p8.
*   `missing' means: not occurring in the denominator.
*
if ( ( count(p7.p7,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) );
  if ( count(p7.p7,1) > count(p8.p8,1) );
    multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
  endif;
  if ( ( count(p1.p1,1) < count(p6.p6,1) )
    || ( ( count(p1.p1,1) == count(p6.p6,1) )
    && ( ( count(p3.p3,1) < count(p4.p4,1) )
    || ( ( count(p3.p3,1) == count(p4.p4,1) )
    && ( count(p2.p2,1) < count(p5.p5,1) ) ) ) ) );
      id  Q.p2 = -Q.p2;
      multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
  endif;
else;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p3.p3,1) >= 0 )
  || ( count(p4.p4,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
      multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
    endif;
    if ( count(p1.p1,1) < count(p6.p6,1) );
      id  Q.p2 = -Q.p2;
      multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
    endif;
    if ( count(p1.p1,1) < count(p4.p4,1) );
      id  Q.p2 = -Q.p2;
     multiply replace_(p1,p4,p4,p1,p2,p5,p5,p2,p6,p3,p3,p6,p7,p8,p8,p7);
    endif;
    if ( count(p1.p1,1) < count(p3.p3,1) );
      multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
    endif;
    if ( ( count(p1.p1,1) == count(p3.p3,1) )
    && ( count(p4.p4,1) > count(p6.p6,1) ) );
      multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
    else;
    if ( ( count(p1.p1,1) == count(p6.p6,1) )
    && ( count(p4.p4,1) > count(p3.p3,1) ) );
      id  Q.p2 = -Q.p2;
      multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
    endif;
    endif;
else;
if ( ( count(p2.p2,1) > count(p5.p5,1) )
  || ( ( count(p2.p2,1) == count(p5.p5,1) )
  && ( ( count(p1.p1,1) < count(p6.p6,1) )
  || ( ( count(p1.p1,1) == count(p6.p6,1) )
  && ( count(p3.p3,1) < count(p4.p4,1) ) ) ) ) );
    id  Q.p2 = -Q.p2;
    multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3);
endif;
if ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p6.p6,1) < count(p4.p4,1) )
  || ( ( count(p6.p6,1) == count(p4.p4,1) )
  && ( count(p7.p7,1) < count(p8.p8,1) ) ) ) ) );
    multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p6,p4,p4,p6);
endif;
endif;
endif;

#call ACCU(Use symmetry)

repeat;
if ( count(p1.p1,1) >= 0 );
    id  p1 = p6+Q;
    if ( count(p6.p6,1) >= 0 ) discard;
elseif ( ( count(p2.p2,1) >= 0 ) && ( count(p5.p5,1) >= 0 ) );
    if ( match(1/p7.p7/p8.p8) == 0 ) discard;
    repeat id p2.p2/p1.p1 = 1-2*p1.p7/p1.p1+p7.p7/p1.p1;
    repeat id p5.p5/p6.p6 = 1+p7.p7/p6.p6-2*p6.p7/p6.p6;
    if ( count(p7.p7,1) >= 0 ) discard;
    if ( ( count(p1.p1,1) < 0 ) && ( count(p6.p6,1) >= 0 ) );
        multiply replace_(p1,p6,p6,p1,p2,p5,p5,p2,p3,p4,p4,p3,Q,-Q);
    endif;
    if ( count(p1.p1,1) < 0 );
        id  p2 = p1-p7;
        id  p5 = p6-p7;
        if ( count(p7.p7,1) >= 0 ) discard;
    endif;
else;
    if ( match(1/p3.p3/p4.p4) == 0 ) discard;
    id  p8 = p3-p2;
    if ( count(p3.p3,1) >= 0 ) discard;
endif;
endrepeat;
if ( count(p1.p1,1) >= 0 );
    id  p6.p7 = p6.p6/2+p7.p7/2-p5.p5/2;
    id  p5.p7 = p6.p6/2-p7.p7/2-p5.p5/2;
    id  p5.p6 = p6.p6/2+p5.p5/2-p7.p7/2;
    if ( match(1/p6.p6/p7.p7) == 0 ) discard;
    if ( count(p7.p2,1,p7.p3,1,p7.p4,1,p7.p8,1,p7.Q,1)
       > count(p6.p2,1,p6.p3,1,p6.p4,1,p6.p8,1,p6.Q,1) );
        multiply replace_(p6,-p7,p7,-p6);
    endif;
    id  p7 = p6-p5;
elseif ( ( count(p2.p2,1) >= 0 ) && ( count(p5.p5,1) >= 0 ) );
    id  p7.p8 = p7.p7/2+p8.p8/2-mncp9.mncp9/2;
    if ( match(1/p7.p7/p8.p8) == 0 ) discard;
    if ( count(p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.Q,1)
       > count(p7.p1,1,p7.p3,1,p7.p4,1,p7.p6,1,p7.Q,1) );
        multiply replace_(p7,-p8,p8,-p7);
    endif;
    id  p8 = p7-mncp9;
else;
    id  p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
    id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p4.Q = p3.p3/2-p4.p4/2-Q.Q/2;
    if ( match(1/p3.p3/p4.p4) == 0 ) discard;
    if ( count(p4.p1,1,p4.p2,1,p4.p5,1,p4.p6,1,p4.p7,1)
       > count(p3.p1,1,p3.p2,1,p3.p5,1,p3.p6,1,p3.p7,1) );
        multiply replace_(p3,-p4,p4,-p3);
    endif;
    id  p4 = p3-Q;
endif;

#call ACCU(Prepare first loop)

multiply mncint1*mncint2*mncint3;
*
*   Now we do the first integral.
*   The order of the selection of the integrals determines the speed only.
*   On atari ST (4 Mbytes, 28msec hard disk):
*       8, 1, 2+5:   426 sec.
*       2+5, 8, 1:   416 sec.
*       2+5, 1, 8:   408 sec.
*       1, 2+5, 8:   408 sec.
*   It seems important to keep the p8.p8 for the last.
*
if ( count(p1.p1,1) >= 0 );
    if ( count(p6.p6,1) >= 0 ) discard;
    if ( count(p7.p7,1) >= 0 ) discard;
    totensor,nosquare,mncFQ,p6;
    if ( count(mncFQ,1) == 0 );
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2? =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5*mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mncFQ(mnci1?) =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5*mncG(mncx1,0,mncx2,0,1,0)*p5(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mncFQ(mnci1?,mnci2?) =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5*(
            +mncG(mncx1,0,mncx2,0,2,0)*p5(mnci1)*p5(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*p5.p5*d_(mnci1,mnci2)/2
            );
    else;
        id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mncFQ(?a) =
            p5.p5^2/p5.p5^mncx1/p5.p5^mncx2*mnce5
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *p5.p5^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
        id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
        tovector,mncFQ,p5;
        id  mncdel(?a) = dd_(?a);
    endif;
*    #call one(p6,p7,p5,mnce6,mnce7,mnce5,mncint2)
    id  1/p8.p8 = 1/p7.p7;
    id  p8 = -p7;
    multiply replace_(p2,p1,mnce2,mnce1,p5,p6,mnce5,mnce6);
elseif ( ( count(p2.p2,1) >= 0 ) && ( count(p5.p5,1) >= 0 ) );
    if ( count(p7.p7,1) >= 0 ) discard;
    if ( count(p8.p8,1) >= 0 ) discard;
    totensor,nosquare,mncFQ,p7;
    if ( count(mncFQ,1) == 0 );
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2? =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9*mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?) =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9*mncG(mncx1,0,mncx2,0,1,0)*mncp9(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?,mnci2?) =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9*(
            +mncG(mncx1,0,mncx2,0,2,0)*mncp9(mnci1)*mncp9(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*mncp9.mncp9*d_(mnci1,mnci2)/2
            );
    else;
        id  mncint2/p7.p7^mncx1?/p8.p8^mncx2?*mncFQ(?a) =
            mncp9.mncp9^2/mncp9.mncp9^mncx1/mncp9.mncp9^mncx2*mnce9
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *mncp9.mncp9^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
        id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
        tovector,mncFQ,mncp9;
        id  mncdel(?a) = dd_(?a);
    endif;
*    #call one(p7,p8,mncp9,mnce7,mnce8,mnce9,mncint2)
    multiply replace_(mncp9,p7,mnce9,mnce7);
elseif ( count(p8.p8,1) >= 0 );
*    #call one(p3,p4,Q,mnce3,mnce4,mnceq,mncint2)
    if ( count(p3.p3,1) >= 0 ) discard;
    if ( count(p4.p4,1) >= 0 ) discard;
    totensor,nosquare,mncFQ,p3;
    if ( count(mncFQ,1) == 0 );
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2? =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq*mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2?*mncFQ(mnci1?) =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq*mncG(mncx1,0,mncx2,0,1,0)*Q(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2?*mncFQ(mnci1?,mnci2?) =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq*(
            +mncG(mncx1,0,mncx2,0,2,0)*Q(mnci1)*Q(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*Q.Q*d_(mnci1,mnci2)/2
            );
    else;
        id  mncint2/p3.p3^mncx1?/p4.p4^mncx2?*mncFQ(?a) =
            Q.Q^2/Q.Q^mncx1/Q.Q^mncx2*mnceq
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *Q.Q^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
        id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
        tovector,mncFQ,Q;
        id  mncdel(?a) = dd_(?a);
    endif;
    multiply replace_(p2,p3,mnce2,mnce3,p5,p4,mnce5,mnce4);
else;
	print "Illegal symmetry in LA";
	setexitflag;
endif;
#call ACCU(First loop integral)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(3,`SCHEME')
*
#break
*--#] la : 
*--#[ bu :
#case bu
*
*   Integral of type BU
*   It may as well be handled by BE
*   We only need renumbering.
*
multiply replace_(p1,p2,p2,p6,p3,p5,p4,p7,p5,p8,p6,p3,p7,p4,p8,p1);
*
*--#] bu : 
*--#[ fa :
#case fa
*
*   Integral of type FA.
*   This may as well be done by BE.
*
*--#] fa : 
*--#[ be :
#case be
*
*   Reduction procedure for three loop graphs of the BE or benz type.
*   Notation is from S.mncG.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<------<-\
*                 P1 /    \   P2    /    \ P3
*                   /      \       /      \
*                  /     P6 v     ^ P7     \
*                 /          \   /          \
*          Q --<--            \ /            --<-- Q
*                 \            |            /
*                  \           v P8        / 
*                   \          |          /
*                 P5 \         |         / P4
*                     \---->------->----/
*
#ifdef `BEPATH'
#call benzred(p1,p2,p3,p4,p5,p6,p7,p8,Q)
#else
if ( count(p6.p6,1) < count(p7.p7,1) );
    multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    elseif ( count(p1.p1,1) == count(p3.p3,1) );
        if ( count(p5.p5,1) < count(p4.p4,1) )
            multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    endif;
endif;
#call ACCU2(AB p1.p3 p1.p1 p3.p3 p8.p8,Benz scalar 0)
  id  p1.p3 = p1.p1/2+p3.p3/2-p8.p8/2;
#call ACCU2(AB p2.p3 p2.p2 p3.p3 p7.p7,Benz scalar 1)
  id  p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz scalar 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz scalar 3)
  id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p3 p3.p3 Q.Q p4.p4,Benz scalar 4)
  id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;

if ( count(p6.p6,1) < count(p7.p7,1) );
    multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
        multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    elseif ( count(p1.p1,1) == count(p3.p3,1) );
        if ( count(p5.p5,1) < count(p4.p4,1) )
            multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
    endif;
endif;
#call ACCU(Benz scalar 5)
#endif
multiply Q.Q;
  if ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7) > 0 );
    multiply acc(1/ep);
    #call triangle(p2,p6,p7,p1,p3)
    multiply ep;
  endif;
*#call ACCU(Benz recursion)
*
*   Use the left-right symmetry relation.
*
if ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p5.p5,1) < count(p4.p4,1) )
  || ( ( count(p5.p5,1) == count(p4.p4,1) )
  && ( count(p6.p6,1) < count(p7.p7,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
endif;
#call ACCU2(AB p1.p1 p5.p5 p3.p3 p4.p4 Q.p8 Q.Q Q.p2 Q.p7,Benz recursion)
*#call ACCU(Rearrange)
*
*   Now we use the second level reduction. We have only BU left
*   because FA was treated already together with BE.
*
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
    id  p1.p1 = p5.p5 + p3.p3 - p4.p4 -2*Q.p8;
endif;
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
    id  Q.p2 = Q.p7 + p3.p3/2 + Q.Q/2 - p4.p4/2;
endif;
*if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
*    if ( ( count(p3.p3,1) > count(p4.p4,1) )
*   || ( ( count(p3.p3,1) == count(p4.p4,1) )
*   && ( ( count(p7.p7,1) > count(p8.p8,1) )
*   || ( ( count(p7.p7,1) == count(p8.p8,1) )
*   && ( ( count(p5.p5,1) > count(p2.p2,1) )
*   || ( ( count(p5.p5,1) == count(p2.p2,1) )
*   && ( count(Q.p7,1) < count(Q.p8,1) ) ) ) ) ) ) );
*       Multiply,replace_(p3,-p4,p4,-p3,p2,-p5,p5,-p2,p7,p8,p8,p7);
*   endif;
*endif;
#call ACCU(Prepare second)
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) > 0 );
    multiply acc(1/ep);
    if ( count(p3.p3,1) > count(p4.p4,1) );
        #call triangle(p7,p2,p6,p3,p8)
    else;
        #call triangle(p8,p5,p6,p4,p7)
    endif;
    multiply ep;
endif;
#call ACCU(Second recursion)
if ( match(1/p6.p6/p7.p7) == 0 );
  if ( ( count(p6.p6,1) < count(p7.p7,1) )
  || ( ( count(p6.p6,1) == count(p7.p7,1) )
  && ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( count(p5.p5,1) < count(p4.p4,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
  endif;
elseif ( ( count(p5.p5,1) >= 0 ) || ( count(p4.p4,1) >= 0 ) );
  if ( ( count(p4.p4,1) < count(p5.p5,1) )
  || ( ( count(p4.p4,1) == count(p5.p5,1) )
  && ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( count(p6.p6,1) < count(p7.p7,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
  endif;
elseif ( ( count(p1.p1,1) < count(p3.p3,1) )
  || ( ( count(p1.p1,1) == count(p3.p3,1) )
  && ( ( count(p5.p5,1) < count(p4.p4,1) )
  || ( ( count(p5.p5,1) == count(p4.p4,1) )
  && ( count(p6.p6,1) < count(p7.p7,1) ) ) ) ) );
    multiply replace_(p1,-p3,p2,-p2,p3,-p1,p4,-p5,p5,-p4,p6,-p7,p7,-p6,Q,-Q);
endif;
#call ACCU(Use Symmetry)
*
#ifdef `POW'
#if `POW' >= 1
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
*    id  p8 = p6-p7;
*    id  p1 = p2-p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
*    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
*    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
*       repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
*       repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
*       if ( count(p2.p2,1) < 0 );
*           id p3 = p2-p7;
*       endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 1";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 1)
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
*    id  p8 = p6-p7;
*    id  p1 = p2-p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
*   id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
*    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
*    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 2";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 2)
#if `POW' >= 4
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
*   id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
*   id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
*   id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
*   id  p8.p8 = p6.p6-2*p6.p7+p7.p7;
*   id  p1.p1 = p2.p2-2*p2.p6+p6.p6;
*   id  p8 = p6-p7;
*   id  p1 = p2-p6;
*   id  Q.p4  = p3.p3/2-Q.Q/2-p4.p4/2;
*   id  Q.p3  = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
    id  Q.p5  = p1.p1/2-Q.Q/2-p5.p5/2;
    id  Q.p4  = p3.p3/2-Q.Q/2-p4.p4/2;
    id  Q.p3  = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
    id  Q.p2  = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 3";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 3)
#if `POW' >= 6
if ( count(p6.p6,1) >= 0 );
*    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
*    id  p6 = p2-p1;
*   id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
*   id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
*   id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
    id  p8.p8 = p6.p6-2*p6.p7+p7.p7;
    id  p1.p1 = p2.p2-2*p2.p6+p6.p6;
    id  p8 = p6-p7;
    id  p1 = p2-p6;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
    id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral Pre-Setup 4";*       Just in case we forgot something
endif;
#call ACCU(Pre-setup 4)
#endif
#endif
#endif
#endif
repeat;
if ( count(p6.p6,1) >= 0 );
    id  p6.p6 = p1.p1+p2.p2-2*p1.p2;
    id  p6 = p2-p1;
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
    id  p8.p8 = p6.p6-2*p6.p7+p7.p7;
    id  p1.p1 = p2.p2-2*p2.p6+p6.p6;
    id  p8 = p6-p7;
    id  p1 = p2-p6;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p5.p5,1) >= 0 ) ) discard;
elseif ( count(p2.p2,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    id Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
    id Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
    id  p2.p2 = p1.p1+p6.p6+2*p1.p6;
*   id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6; Reactivated 13-sep-1994
    id  Q.p2 = Q.Q/2+p1.p1/2-p5.p5/2+Q.p6;
    id  p2 = p1+p6;
    if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
    if ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) ) discard;
elseif ( count(p4.p4,1) >= 0 );
    id Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
    if ( count(p5.p5,1) >= 0 ) discard;
    id  p4.p4 = Q.Q+p3.p3-2*Q.p3;
    id  p4 = p3-Q;
    if ( count(p3.p3,1) >= 0 );
        repeat id p3.p3/p2.p2 = 1+p7.p7/p2.p2-2*p2.p7/p2.p2;
        repeat id p2.p3/p2.p2 = 1-p2.p7/p2.p2;
        if ( count(p7.p7,1) >= 0 ) discard;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p2.p2,1) < 0 );
            id p3 = p2-p7;
        endif;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
    repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
    if ( count(p4.p4,1) < 0 );
        repeat id  p1.p1/p5.p5 = 1+Q.Q/p5.p5+2*Q.p5/p5.p5;
        repeat id  p1.p5/p5.p5 = 1+Q.p5/p5.p5;
        if ( count(p5.p5,1) >= 0 );
            multiply replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6
            ,Q,-Q,p4,-p5,p5,-p4);
        else;
            id  p1 = Q+p5;
            id  p3 = Q+p4;
        endif;
    endif;
else;
    exit "mincer integral setup first loop";*       Just in case we forgot something
endif;
endrepeat;
#call ACCU(setup first loop)
if ( count(p6.p6,1) >= 0 );
    multiply replace_(p2,mncp9,p7,p8,p8,-p7,p5,p6);
    multiply mncnaar(p3,mnce3);
    id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p3.p3/2;
    if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
    if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
    > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
        multiply replace_(p8,-mncp9,mncp9,-p8);
    id  p8.mncq1?!{p8} = mncp9.mncq1 - p3.mncq1;
    totensor,nosquare,mncp9,mncFQ;
elseif ( ( count(p8.p8,1) >= 0 ) && ( count(p1.p1,1) >= 0 ) );
    multiply replace_(p2,p4,p3,p6,p4,p1,p7,-p7,p5,mncp9,p6,-p8,Q,-Q);
    multiply mncnaar(p3,mnce3);
    id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p3.p3/2;
    if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
    if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
    > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
        multiply replace_(p8,-mncp9,mncp9,-p8);
    id  p8.mncq1?!{p8} = mncp9.mncq1 - p3.mncq1;
    totensor,nosquare,mncp9,mncFQ;
elseif ( count(p2.p2,1) >= 0 );
    multiply replace_(p5,p6,p8,-p7,p6,p8,p7,mncp9);
label 2;
    multiply mncnaar(p7,mnce7);
    id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p7.p7/2;
    if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
    if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
    > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
        multiply replace_(p8,-mncp9,mncp9,-p8);
    id  p8.mncq1?!{p8} = mncp9.mncq1 - p7.mncq1;
    totensor,nosquare,mncp9,mncFQ;
elseif ( count(p4.p4,1) >= 0 );
    if ( count(p3.p3,1) >= 0 );
        multiply replace_(p2,p3,p6,-p7,p5,p6,p7,-mncp9);
        goto 2;
    else;
        multiply replace_(p2,p1,p8,p4,p1,mncp9,p5,p8);
        multiply mncnaar(Q,mnceq,1);
        id  Q.p8 = mncp9.mncp9/2-p8.p8/2-Q.Q/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        id  p8 = mncp9-Q;
        id  mncp9.mncq1?{p1,p3,p4,p6,p7} = p1.mncq1-p6.mncq1;
        id  Q.mncp9 = mncp9.mncp9/2+Q.Q/2-p8.p8/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
        if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4);
            id p7 = -p7;
        endif;
        totensor,nosquare,Q,mncFQ;
        id,many,mncq1?{p1,p3,p4,p6,p7}.mncq2?{p1,p3,p4,p6,p7}^D? = mncx^D*mncq1.mncq2^D;
    endif;
elseif ( ( count(p1.p1,1) >= 0 ) && ( count(p3.p3,1) >= 0 ) );
    multiply replace_(p5,-p1,p4,-p3,p7,p4,p8,p7,p2,-p8);
    multiply mncnaar(Q,mnceq,1);
    id  Q.p8 = mncp9.mncp9/2-p8.p8/2-Q.Q/2;
    if ( count(p8.p8,1) >= 0 ) discard;
    id  p8 = mncp9-Q;
    id  mncp9.mncq1?{p1,p3,p4,p6,p7} = p1.mncq1-p6.mncq1;
    id  Q.mncp9 = mncp9.mncp9/2+Q.Q/2-p8.p8/2;
    if ( count(p8.p8,1) >= 0 ) discard;
    if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
        multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
    endif;
    if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4);
        id p7 = -p7;
    endif;
    totensor,nosquare,Q,mncFQ;
    id,many,mncq1?{p1,p3,p4,p6,p7}.mncq2?{p1,p3,p4,p6,p7}^D? = mncx^D*mncq1.mncq2^D;
else;
    Print "Illegal case in BE";
    SetExitFlag;
endif;

#call ACCU2(B p8 mncp9 mncnaar mncFQ mncx mncint3,Prepare first loop)
keep brackets;
*
multiply mncint1*mncint2*mncint3;
if ( match(mncnaar(Q,mnceq,1)) );
  id  mncnaar(Q,mnceq,1) = 1;
  id  mncx^D? = mncp9.mncp9^D/Q.Q^D;
  multiply mncp9.mncp9^4/Q.Q^4;
  if ( count(p8.p8,1) >= 0 ) discard;
  if ( count(mncFQ,1) == 0 );
  id  mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mncG(mncx1,2,mncx2,0,0,0);
  elseif ( match(mncFQ(mnci1?)) );
  id  mncint2*mncFQ(mnci1?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*Q(mnci1)*mncG(mncx1,2,mncx2,0,1,0);
  elseif ( match(mncFQ(mnci1?,mnci2?)) );
  id  mncint2*mncFQ(mnci1?,mnci2?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
        (mncG(mncx1,2,mncx2,0,2,0)*mncFFPP(mnci1,mnci2)
        +mncG(mncx1-1,2,mncx2,0,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*Q.Q/2);
  else;
  id  mncint2*mncFQ(?a)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
        mncFQ(?a)/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
        sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,2,mncx2,0,nargs_(?a)-2*mncs,0)
        *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*Q.Q^mncs
        *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*Q.Q^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
        *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
        ));
  endif;
  #call simplify
  if ( count(mncFQ,1) );
    id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
    tovector,mncFQ,Q;
    id  mncdel(?a) = dd_(?a);
  else;
    id mncFFPP(mnci1?,mnci2?) = Q(mnci1)*Q(mnci2) - d_(mnci1,mnci2)*Q.Q/2*acc(mncpoch(3,1));
  endif;
else;
  id  p8 = mncp9 - mncq9;
  id  mncnaar(mncq1?,mncy?) = mncnaar(mncq1,mncy)*replace_(mncq9,mncq1);
  repeat;
    id mncFQ(mncp9) = mncp9.mncp9;
    id mncFQ(?a,mncp9,?b) = mncFQ(?a,?b)*mncp9.mncp9;
  endrepeat;
  totensor,nosquare,mncFQ,mncp9;
  if ( count(mncFQ,1) == 0 );
    id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
          *mncG(mncx1,0,mncx2,0,0,0);
  elseif ( match(mncFQ(mnci1?)) );
    id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?) =
          mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
          *mncG(mncx1,0,mncx2,0,1,0)*mncq9(mnci1);
  elseif ( match(mncFQ(mnci1?,mnci2?)) );
    id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?,mnci2?) =
          mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy*(
          +mncG(mncx1,0,mncx2,0,2,0)*mncq9(mnci1)*mncq9(mnci2)
          +mncG(mncx1,0,mncx2,0,2,1)*mncq9.mncq9*d_(mnci1,mnci2)/2
      );
  else;
    id  mncnaar(mncq9?,mncx?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(?a) =
          mncnaar(mncq9,mncx)*mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncx
          *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
      *mncq9.mncq9^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
  endif;
  #call simplify
  if ( count(mncFQ,1) );
    id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
    tovector,mncFQ,mncq9;
    id  mncnaar(mncq1?,mncy?) = replace_(mncq9,mncq1);
    id  mncdel(?a) = dd_(?a);
  endif;
endif;

#call ACCU(First loop integral)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id  acc(mncx1?) = mncx1;
id  ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(3,`SCHEME')
*
#break
*--#] be : 
*--#[ no :
#case no
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.mncG.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
multiply mncint3*Q.Q;
#call newplane(p1,p2,p3,p4,p5,p6,p7,p8,Q,mncint3)
#call ACCU(noplane recursion)
repeat id Q.p2/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
    ( p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5 )
        /p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
repeat id Q.p2/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p8.p8 =
    ( Q.p8+p3.p3/2+Q.Q/2-p4.p4/2 )
        /p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p8.p8;
repeat id Q.p2/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7 =
    ( Q.p7+p1.p1/2+Q.Q/2-p6.p6/2 )
        /p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7;

if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
label 1;
    if ( count(p3.p3,1) < count(p4.p4,1) );
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
*    elseif ( ( count(p3.p3,1) == count(p4.p4,1) )
*    && ( count(p5.p5,1) < count(p8.p8,1) ) );
*        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
    endif;
elseif ( match(1/p1.p1/p2.p2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    goto 1;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2,p7,-p7,p8,-p8,Q,-Q);
    goto 1;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p7.p7/p8.p8) );
    multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    goto 1;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p6.p6/p7.p7/p8.p8) );
    if ( count(p7.p7,1) < count(p8.p8,1) );
        multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2,p7,-p7,p8,-p8,Q,-Q);
    else;
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    endif;
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p8.p8) );
    multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
elseif ( match(1/p1.p1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7) );
    multiply replace_(p1,-p6,p6,-p1,p2,-p8,p8,-p2,p5,p7,p7,p5);
    if ( count(p7.p7,1) > count(p8.p8,1) );
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    elseif ( count(p7.p7,1) == count(p8.p8,1) );
        if ( count(p1.p1,1) < count(p3.p3,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        elseif ( count(p1.p1,1) == count(p3.p3,1) );
            if ( count(p6.p6,1) < count(p4.p4,1) )
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
        endif;
    endif;
else;
    repeat;
    if ( count(p2.p2,1) < count(p5.p5,1) )
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    if ( count(p7.p7,1) < count(p8.p8,1) )
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    if ( count(p2.p2,1) < count(p7.p7,1) )
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
    endrepeat;
endif;
#call ACCU(Move Q.p2)
#ifdef `POW'
#if `POW' >= 6
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p1.p1/p6.p6 = 1+mncx/p6.p6;
    id mncx = Q.Q+2*Q.p5+2*Q.p8;
*    repeat id Q.p7/p6.p6/p3.p3/p4.p4 =
*        (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p6.p6/p3.p3/p4.p4;
*    repeat id p7.p8/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5 =
*        (p2.p2/2-p3.p3/2+p5.p5/2-p6.p6/2-Q.p8)/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p2.p2/p5.p5/p7.p7/p8.p8 =
        (mncx-p5.p5+p7.p7+p8.p8)/p5.p5/p7.p7/p8.p8;
    id mncx = 2*p1.p3-2*Q.p5-Q.Q;
    repeat id p2.p5/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2+Q.p5)/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
*    repeat id p7.p8/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
*        (p7.p7+p8.p8-mncy9)/2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
*    if ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
*        repeat id Q.p2/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p7/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p8/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p1.p1/2-Q.Q/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*    endif;
endif;

#call ACCU(Prepare second A)
#if `POW' >= 8
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p1.p1/p6.p6 = 1+mncx/p6.p6;
    id mncx = Q.Q+2*Q.p5+2*Q.p8;
    repeat id Q.p7/p6.p6/p3.p3/p4.p4 =
        (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p6.p6/p3.p3/p4.p4;
*    repeat id p7.p8/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5 =
*        (p2.p2/2-p3.p3/2+p5.p5/2-p6.p6/2-Q.p8)/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p2.p2/p5.p5/p7.p7/p8.p8 =
        (mncx-p5.p5+p7.p7+p8.p8)/p5.p5/p7.p7/p8.p8;
    id mncx = 2*p1.p3-2*Q.p5-Q.Q;
    repeat id p2.p5/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2+Q.p5)/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    repeat id p7.p8/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p7.p7+p8.p8-mncy9)/2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    if ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
        repeat id Q.p2/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p7/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
*        repeat id Q.p8/p1.p1/p3.p3/p4.p4/p6.p6 =
*            (p1.p1/2-Q.Q/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
    endif;
endif;

#call ACCU(Prepare second B)
#endif
#endif
#endif
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p1.p1/p6.p6 = 1+mncx/p6.p6;
    id mncx = Q.Q+2*Q.p5+2*Q.p8;
    repeat id Q.p7/p6.p6/p3.p3/p4.p4 =
        (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p6.p6/p3.p3/p4.p4;
    repeat id p7.p8/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5 =
        (p2.p2/2-p3.p3/2+p5.p5/2-p6.p6/2-Q.p8)/p6.p6/p3.p3/p4.p4/p2.p2/p5.p5;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    repeat id p2.p2/p5.p5/p7.p7/p8.p8 =
        (mncx-p5.p5+p7.p7+p8.p8)/p5.p5/p7.p7/p8.p8;
    id mncx = 2*p1.p3-2*Q.p5-Q.Q;
    repeat id p2.p5/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2+Q.p5)/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    repeat id p7.p8/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8 =
        (p7.p7+p8.p8-mncy9)/2/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8;
    if ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
        repeat id Q.p2/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p1.p1/2+p3.p3/2-p4.p4/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
        repeat id Q.p7/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p3.p3/2-Q.Q/2-p4.p4/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
        repeat id Q.p8/p1.p1/p3.p3/p4.p4/p6.p6 =
            (p1.p1/2-Q.Q/2-p6.p6/2-Q.p5)/p1.p1/p3.p3/p4.p4/p6.p6;
    endif;
endif;
if ( ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) == 0 )
  && ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) == 0 ) );
    repeat;
    if ( count(p2.p2,1) < count(p5.p5,1) )
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    if ( count(p7.p7,1) < count(p8.p8,1) )
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    if ( count(p2.p2,1) < count(p7.p7,1) )
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5,mncy9,mncx9,mncx9,mncy9);
    endrepeat;
endif;

#call ACCU(Prepare second)

if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    id Q.p8 = Q.p2 - p3.p3/2 - Q.Q/2 + p4.p4/2;
    id p2.p5 = Q.p5+p4.p4/2+p6.p6/2-p7.p7/2-p8.p8/2;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    id  mncy9 = p1.p1+p3.p3-2*p1.p3;
endif;
#call ACCU(Minimize second)
if ( match(1/p2.p2/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply acc(1/ep);
    #call triangle(p5,p6,p7,p8,p4)
    multiply ep;
elseif ( match(1/p1.p1/p3.p3/p4.p4/p5.p5/p6.p6/p7.p7/p8.p8) );
    multiply acc(1/ep);
    #call triangle(p5,p8,p7,p6,p4)
    multiply ep;
endif;
id  mncx9 = p2.p2+p5.p5+2*p2.p5;
id  mncy9 = p7.p7+p8.p8-2*p7.p8;
repeat;
    if ( count(p2.p2,1) < count(p5.p5,1) )
        multiply replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7);
    if ( count(p7.p7,1) < count(p8.p8,1) )
        multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
    if ( count(p2.p2,1) < count(p7.p7,1) )
        multiply replace_(p3,-p4,p4,-p3,p2,-p7,p7,-p2,p5,p8,p8,p5);
endrepeat;
#call ACCU(Second recursion)
*
*   Now we try to reduce the number of one loop integrals
*
if ( count(mncint3,1) );
if ( count(p2.p2,1) >= 0 );
    if ( count(p8.p8,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    endif;
elseif ( count(p5.p5,1) >= 0 );
    if ( count(p7.p7,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p8.p8,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    endif;
elseif ( count(p7.p7,1) >= 0 );
    if ( count(p8.p8,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p1.p1,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p3,p4,p4,p3,p5,p8,p8,p5,p2,p7,p7,p2);
            id p3 = -p3;
            id p4 = -p4;
            id p2 = -p2;
            id p7 = -p7;
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,-p6,p6,-p1,p5,p7,p7,p5,p2,-p8,p8,-p2);
    endif;
elseif ( count(p8.p8,1) >= 0 );
    if ( count(p1.p1,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p3.p3,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p4,p4,p1,p3,p6,p6,p3,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,-p6,p6,-p1,p5,p7,p7,p5,p2,-p8,p8,-p2);
    endif;
elseif ( count(p3.p3,1) >= 0 );
    if ( count(p4.p4,1) >= 0 );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
*           Everybody flips sign -> nobody flips sign
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p5,p7,p7,p5,p2,p8,p8,p2);
            id  p1 = -p1;
            id  p6 = -p6;
            id  p2 = -p2;
            id  p8 = -p8;
    endif;
elseif ( count(p4.p4,1) >= 0 );
    if ( count(p1.p1,1) >= 0 );
            multiply replace_(p3,-p4,p4,-p3,p5,p8,p8,p5,p2,-p7,p7,-p2);
    elseif ( count(p6.p6,1) >= 0 );
            multiply replace_(p1,p6,p6,p1,p7,p8,p8,p7,p3,p4,p4,p3
            ,p2,p5,p5,p2);
            id  Q = -Q;
            id  p7 = -p7;
            id  p8 = -p8;
    endif;
endif;
endif;
#call ACCU(Symmetry)
if ( count(mncint3,1) );
  if ( count(p2.p2,1) >= 0 );
      if ( count(p1.p1,1) >= 0 );
*          id  p1.p1 = p6.p6+Q.Q+2*Q.p6;
*          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
*          id  p1 = p6+Q;
*          id  p2 = p3+p8;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
      elseif ( count(p7.p7,1) >= 0 );
          if ( count(p5.p5,1) >= 0 ) discard;
*          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
*          id  p7.p7 = p4.p4+p5.p5-2*p4.p5;
*          id  p2 = p3+p8;
*          id  p7 = p4-p5;
          if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 ) ) discard;
      elseif( count(p5.p5,1) >= 0);
          repeat id  p5.p5/p6.p6 = 1+p8.p8/p6.p6-2*p6.p8/p6.p6;
          if ( count(p8.p8,1) >= 0 ) discard;
          repeat id  p5.p6/p6.p6 = 1-p6.p8/p6.p6;
          if ( count(p6.p6,1) >= 0 );
             multiply replace_(p1,-p6,p6,-p1,p5,-p2,p2,-p5,p3,-p4,p4,-p3
             ,p7,p8,p8,p7);
          else;
             repeat id  p2.p2/p3.p3 = 1+p8.p8/p3.p3+2*p3.p8/p3.p3;
             repeat id  p2.p3/p3.p3 = 1+p3.p8/p3.p3;
             if ( count(p8.p8,1) >= 0 ) discard;
             if ( count(p3.p3,1) >= 0 );
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
             else;
*                id  p5 = p6-p8;
*                id  p2 = p3+p8;
                if ( count(p8.p8,1) >= 0 ) discard;
             endif;
          endif;
      else;
          exit "mincer integral Setup first loop";
      endif;
  elseif ( count(p1.p1,1) >= 0 );
      if ( count(p6.p6,1) >= 0 );
*          id  p1.p1 = p2.p2+p7.p7-2*p2.p7;
          if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
*          id  p6.p6 = p5.p5+p8.p8+2*p5.p8;
          if ( ( count(p5.p5,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
*          id  p1 = p2-p7;
*          id  p6 = p5+p8;
*          if ( ( count(p2.p2,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
*          if ( ( count(p5.p5,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
      elseif ( count(p5.p5,1) >= 0 );
          repeat id  p1.p1/p2.p2/p7.p7 = 1/p7.p7+1/p2.p2-2*p2.p7/p2.p2/p7.p7;
          repeat id  p1.p2/p2.p2 = 1-p2.p7/p2.p2;
          repeat id  p1.p7/p7.p7 = p2.p7/p7.p7-1;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
          if ( count(p2.p2,1) < 0 );
             repeat id  p5.p5/p4.p4 = 1+p7.p7/p4.p4-2*p4.p7/p4.p4;
             id  p5.p7 = p4.p7-p7.p7;
             if ( count(p7.p7,1) >= 0 ) discard;
             repeat id  p4.p5/p4.p4 = 1-p4.p7/p4.p4;
             if ( count(p4.p4,1) >= 0 );
               multiply replace_(Q,-Q,p1,p4,p4,p1,p2,p5,p5,p2,p3,p6,p6,p3
               ,p7,-p7,p8,-p8);
             else;
*               id  p1 = p2-p7;
*               id  p5 = p4-p7;
             endif;
          endif;
      elseif ( count(p3.p3,1) >= 0 );
          repeat id  p1.p1/p6.p6 = 1+Q.Q/p6.p6+2*Q.p6/p6.p6;
          repeat id  p1.p6/p6.p6 = 1+Q.p6/p6.p6;
          if ( count(p6.p6,1) < 0 );
            repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
            repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
            if ( count(p4.p4,1) >= 0 );
              multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p4,p6,p6,p4);
            else;
              id  p1 = Q+p6;
              id  p3 = Q+p4;
            endif;
          endif;
      else;
          exit "mincer integral Setup first loop";
      endif;
  else;
      exit "mincer integral Setup first loop";
  endif;
endif;
#call ACCU(Setup first loop)
if ( count(mncint3,1) );
  repeat;
  if ( count(p2.p2,1) >= 0 );
      if ( count(p1.p1,1) >= 0 );
          id  p1.p1 = p6.p6+Q.Q+2*Q.p6;
          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
          id  p1 = p6+Q;
          id  p2 = p3+p8;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
      elseif ( count(p7.p7,1) >= 0 );
          if ( count(p5.p5,1) >= 0 ) discard;
          id  p2.p2 = p3.p3+p8.p8+2*p3.p8;
          id  p7.p7 = p4.p4+p5.p5-2*p4.p5;
          id  p2 = p3+p8;
          id  p7 = p4-p5;
          if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 ) ) discard;
      elseif( count(p5.p5,1) >= 0);
          repeat id  p5.p5/p6.p6 = 1+p8.p8/p6.p6-2*p6.p8/p6.p6;
          if ( count(p8.p8,1) >= 0 ) discard;
          repeat id  p5.p6/p6.p6 = 1-p6.p8/p6.p6;
          if ( count(p6.p6,1) >= 0 );
             multiply replace_(p1,-p6,p6,-p1,p5,-p2,p2,-p5,p3,-p4,p4,-p3
             ,p7,p8,p8,p7);
          else;
             repeat id  p2.p2/p3.p3 = 1+p8.p8/p3.p3+2*p3.p8/p3.p3;
             repeat id  p2.p3/p3.p3 = 1+p3.p8/p3.p3;
             if ( count(p8.p8,1) >= 0 ) discard;
             if ( count(p3.p3,1) >= 0 );
                multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
             else;
                id  p5 = p6-p8;
                id  p2 = p3+p8;
                if ( count(p8.p8,1) >= 0 ) discard;
             endif;
          endif;
      else;
          exit "mincer integral Prepare first loop";
      endif;
  elseif ( count(p1.p1,1) >= 0 );
      if ( count(p6.p6,1) >= 0 );
          id  p1.p1 = p2.p2+p7.p7-2*p2.p7;
          if ( ( count(p2.p2,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
          id  p6.p6 = p5.p5+p8.p8+2*p5.p8;
          if ( ( count(p5.p5,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
          id  p1 = p2-p7;
          id  p6 = p5+p8;
          if ( ( count(p2.p2,1) >= 0 ) || ( count(p8.p8,1) >= 0 ) ) discard;
          if ( ( count(p5.p5,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
      elseif ( count(p5.p5,1) >= 0 );
          repeat id  p1.p1/p2.p2/p7.p7 = 1/p7.p7+1/p2.p2-2*p2.p7/p2.p2/p7.p7;
          repeat id  p1.p2/p2.p2 = 1-p2.p7/p2.p2;
          repeat id  p1.p7/p7.p7 = p2.p7/p7.p7-1;
          if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
          if ( count(p2.p2,1) < 0 );
             repeat id  p5.p5/p4.p4 = 1+p7.p7/p4.p4-2*p4.p7/p4.p4;
             id  p5.p7 = p4.p7-p7.p7;
             if ( count(p7.p7,1) >= 0 ) discard;
             repeat id  p4.p5/p4.p4 = 1-p4.p7/p4.p4;
             if ( count(p4.p4,1) >= 0 );
               multiply replace_(Q,-Q,p1,p4,p4,p1,p2,p5,p5,p2,p3,p6,p6,p3
               ,p7,-p7,p8,-p8);
             else;
               id  p1 = p2-p7;
               id  p5 = p4-p7;
             endif;
          endif;
      elseif ( count(p3.p3,1) >= 0 );
          repeat id  p1.p1/p6.p6 = 1+Q.Q/p6.p6+2*Q.p6/p6.p6;
          repeat id  p1.p6/p6.p6 = 1+Q.p6/p6.p6;
          if ( count(p6.p6,1) < 0 );
            repeat id  p3.p3/p4.p4 = 1+Q.Q/p4.p4+2*Q.p4/p4.p4;
            repeat id  p3.p4/p4.p4 = 1+Q.p4/p4.p4;
            if ( count(p4.p4,1) >= 0 );
              multiply replace_(p1,p3,p3,p1,p7,p8,p8,p7,p4,p6,p6,p4);
            else;
              id  p1 = Q+p6;
              id  p3 = Q+p4;
            endif;
          endif;
      else;
          exit "mincer integral Prepare first loop";
      endif;
  else;
      exit "mincer integral Prepare first loop";
  endif;
  endrepeat;
  if ( count(p2.p2,1) >= 0 );
      if ( count(p1.p1,1) >= 0 );
        multiply replace_(p5,p6,p6,mncp9,p7,-p7);
        multiply mncnaar(p6,mnce6);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p6.p6/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p6.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      elseif ( count(p7.p7,1) >= 0 );
        multiply replace_(p8,p7,p5,p4,p3,mncp9,p4,p8);
        multiply mncnaar(Q,mnceq);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-Q.Q/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - Q.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      else;   * must be p5
        multiply replace_(p7,-mncp9,p8,-p8);
        multiply mncnaar(p7,mnce7);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p7.p7/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p7.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      endif;
  else;
      if ( count(p6.p6,1) >= 0 );
        multiply replace_(p7,-p8,p8,p7,p2,p1,p5,mncp9);
        multiply mncnaar(p4,mnce4);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p4.p4/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p4.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      elseif ( count(p5.p5,1) >= 0 );
        multiply replace_(p8,p7,p7,-p8,p2,p1,p6,mncp9);
        multiply mncnaar(p6,mnce6);
        id  p8.mncp9 = mncp9.mncp9/2+p8.p8/2-p6.p6/2;
        if ( ( count(p8.p8,1) >= 0 ) || ( count(mncp9.mncp9,1) >= 0 ) ) discard;
        if ( count(p8.Q,1,p8.p1,1,p8.p3,1,p8.p4,1,p8.p6,1,p8.p7,1)
        > count(mncp9.Q,1,mncp9.p1,1,mncp9.p3,1,mncp9.p4,1,mncp9.p6,1,mncp9.p7,1) )
            multiply replace_(p8,-mncp9,mncp9,-p8);
        id  p8.mncq1?!{p8} = mncp9.mncq1 - p6.mncq1;
        totensor,nosquare,mncp9,mncFQ;
      else;
          if ( count(p2.p2,1) >= 0 ) discard;
          multiply replace_(p7,-p1,p4,-p3,p8,p4,p5,p7,p2,-p8);
        multiply mncnaar(Q,mnceq,1);
        id  Q.p8 = mncp9.mncp9/2-p8.p8/2-Q.Q/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        id  p8 = mncp9-Q;
        id  mncp9.mncq1?{p1,p3,p4,p6,p7} = p1.mncq1-p6.mncq1;
        id  Q.mncp9 = mncp9.mncp9/2+Q.Q/2-p8.p8/2;
        if ( count(p8.p8,1) >= 0 ) discard;
        if ( count(p1.p1,1,p3.p3,1) > count(p4.p4,1,p6.p6,1) );
            multiply replace_(p1,-p6,p6,-p1,p3,-p4,p4,-p3,p7,-p7);
        endif;
        if ( count(p1.p1,1,p6.p6,1) > count(p3.p3,1,p4.p4,1) );
            multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4);
            id p7 = -p7;
        endif;
        totensor,nosquare,Q,mncFQ;
        id,many,mncq1?{p1,p3,p4,p6,p7}.mncq2?{p1,p3,p4,p6,p7}^D? = mncx^D*mncq1.mncq2^D;
      endif;
  endif;
endif;
if ( ( count(mncint3,1) > 0 ) && ( count(mncnaar,1) == 0 ) );
    Print "Illegal case in NO";
    SetExitFlag;
endif;

#call ACCU2(B p8 mncp9 mncnaar mncFQ mncx mncint3,Prepare first loop)
keep brackets;
if ( count(mncint3,1) );
  id  mncint3 = mncint1*mncint2*mncint3;
  if ( match(mncnaar(Q,mnceq,1)) );
    id  mncnaar(Q,mnceq,1) = 1;
    id  mncx^D? = mncp9.mncp9^D/Q.Q^D;
    multiply mncp9.mncp9^4/Q.Q^4;
    if ( count(p8.p8,1) >= 0 ) discard;
    if ( count(mncFQ,1) == 0 );
    id  mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
          mncG(mncx1,2,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
    id  mncint2*mncFQ(mnci1?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*Q(mnci1)*
          mncG(mncx1,2,mncx2,0,1,0);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
    id  mncint2*mncFQ(mnci1?,mnci2?)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
        (mncG(mncx1,2,mncx2,0,2,0)*mncFFPP(mnci1,mnci2)
        +mncG(mncx1-1,2,mncx2,0,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*Q.Q/2);
    else;
    id  mncint2*mncFQ(?a)/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
          mncFQ(?a)/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*
          sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,2,mncx2,0,nargs_(?a)-2*mncs,0)
          *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*Q.Q^mncs
          *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*Q.Q^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
          *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
          ));
    endif;
    #call simplify
    if ( count(mncFQ,1) );
      id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
      tovector,mncFQ,Q;
      id  mncdel(?a) = dd_(?a);
    else;
      id mncFFPP(mnci1?,mnci2?) = Q(mnci1)*Q(mnci2) - d_(mnci1,mnci2)*Q.Q/2*acc(mncpoch(3,1));
    endif;
  else;
    id  p8 = mncp9 - mncq9;
    id  mncnaar(mncq1?,mncy?) = mncnaar(mncq1,mncy)*replace_(mncq9,mncq1);
    repeat;
      id mncFQ(mncp9) = mncp9.mncp9;
      id mncFQ(?a,mncp9,?b) = mncFQ(?a,?b)*mncp9.mncp9;
    endrepeat;
    totensor,nosquare,mncFQ,mncp9;
    if ( count(mncFQ,1) == 0 );
      id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2? =
            mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
            *mncG(mncx1,0,mncx2,0,0,0);
    elseif ( match(mncFQ(mnci1?)) );
      id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?) =
            mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy
            *mncG(mncx1,0,mncx2,0,1,0)*mncq9(mnci1);
    elseif ( match(mncFQ(mnci1?,mnci2?)) );
      id  mncnaar(mncq9?,mncy?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(mnci1?,mnci2?) =
            mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncy*(
            +mncG(mncx1,0,mncx2,0,2,0)*mncq9(mnci1)*mncq9(mnci2)
            +mncG(mncx1,0,mncx2,0,2,1)*mncq9.mncq9*d_(mnci1,mnci2)/2
        );
    else;
      id  mncnaar(mncq9?,mncx?)*mncint2/mncp9.mncp9^mncx1?/p8.p8^mncx2?*mncFQ(?a) =
            mncnaar(mncq9,mncx)*mncq9.mncq9^2/mncq9.mncq9^mncx1/mncq9.mncq9^mncx2*mncx
            *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,0,mncx2,0,nargs_(?a),mncj)
            *mncq9.mncq9^mncj/2^mncj*mncy^mncj)*mncFQ(?a);
    endif;
    #call simplify
    if ( count(mncFQ,1) );
      id  mncy^mncj?*mncFQ(?a) = distrib_(1,2*mncj,mncdel,mncFQ,?a);
      tovector,mncFQ,mncq9;
      id  mncnaar(mncq1?,mncy?) = replace_(mncq9,mncq1);
      id  mncdel(?a) = dd_(?a);
    endif;
  endif;
else;
  multiply ep;
endif;

#call ACCU(First loop integral)

#define EXTRARED "1"
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id  acc(mncx1?) = mncx1;
id  ep = 0;
.sort: Expression G scheme;
#call finish(3,`SCHEME')
*
#break
*--#] no : 
*--#[ o1 :
#case o1
*
*   Integral of type O1.
*
id	p6.p7 = p5.p5/2-p6.p6/2-p7.p7/2;
id  p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id  p5.p6 = p5.p5/2+p6.p6/2-p7.p7/2;
if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
#call ACCU(Momenta 1)
multiply mncint1*mncint2*mncint3*Q.Q;
#call one(p6,p7,p5,mnce6,mnce7,mnce5,mncint2)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7,mnce5,mnce7);
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
*   Integral of type O2.
*
*id  p7 = p4-p6;
id  p4.p6 = p4.p4/2+p6.p6/2-p7.p7/2;
if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
#call ACCU(Momenta 1)
multiply mncint1*mncint2*mncint3*Q.Q;
#call one(p6,p7,p4,mnce6,mnce7,mnce4,mncint2)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7,mnce4,mnce6);
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
*   Integral of type O3.
*
id  p7 = Q-p6;
id  Q.p6 = Q.Q/2+p6.p6/2-p7.p7/2;
if ( ( count(p6.p6,1) >= 0 ) || ( count(p7.p7,1) >= 0 ) ) discard;
#call ACCU(Momenta 1)
multiply mncint1*mncint2*mncint3*Q.Q;
#call one(p6,p7,Q,mnce6,mnce7,mnceq,mncint2)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7);
#call dotwo{}
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
*   Integral of type O4
*   Note that this is a hacked up version of BE
*   The multiplicative constant is for the Bjorken sumrule
*
id  p6.p1 = p1.p1/2+p6.p6/2-p4.p4/2;
#call ACCU(scalars 1)
id  p6.p2 = p2.p2/2+p6.p6/2-p3.p3/2;
#call ACCU(scalars 2)
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(scalars 3)
id  Q.p6 = Q.Q/2+p6.p6/2-p7.p7/2;
if ( count(p7.p7,1) >= 0 ) discard;
#call ACCU(scalars 4)
id,many,mncq1?{p1,p2,p3,p4,p5}.mncq2?{p1,p2,p3,p4,p5}^mncx1?
        = mncq1.mncq2^mncx1*p6.p6^mncx1/Q.Q^mncx1;
totensor,nosquare,mncFQ,Q;
#call ACCU2(B p6 p7 mncFQ,Prepare first loop)
keep brackets;
multiply mncint1*mncint2*mncint3*mnce6^2/mnceq^2*p6.p6^4/Q.Q^3;
if ( count(mncFQ,1) == 0 );
   id  mncint2/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*
        mncG(mncx1,mncy1,mncx2,0,0,0);
   #call simplify
elseif ( match(mncFQ(mnci1?)) );
   id  mncint2*mncFQ(mnci1?)/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*Q(mnci1)*
        mncG(mncx1,mncy1,mncx2,0,1,0);
   #call simplify
elseif ( match(mncFQ(mnci1?,mnci2?)) );
   id  mncint2*mncFQ(mnci1?,mnci2?)/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        1/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*
        (mncG(mncx1,mncy1,mncx2,0,2,0)*Q(mnci1)*Q(mnci2)
        -mncG(mncx1,mncy1,mncx2,0,2,0)*d_(mnci1,mnci2)*Q.Q/2*acc(mncpoch(3,1))
        +mncG(mncx1-1,mncy1,mncx2,0,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*Q.Q/2);
   #call simplify
else;
   id  mncint2*mncFQ(?a)/p6.p6^mncx1?/p7.p7^mncx2?*mnce6^mncy1? =
        mncFQ(?a)/Q.Q^mncx1/Q.Q^mncx2*Q.Q^2*mnceq*mnceq^mncy1*
        sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,mncy1,mncx2,0,nargs_(?a)-2*mncs,0)
        *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*Q.Q^mncs
        *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*Q.Q^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
        *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
        ));
   #call simplify
   id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
   tovector,mncFQ,Q;
   id  mncdel(?a) = dd_(?a);
endif;

*#call one4(p6,p7,Q,mnce6,mnce7,mnceq,p1,p2,p3,p4,p5,mncint2)
#call ACCU(First loop integral)
*#call simplify
*#call ACCU(Simplify first mncG)
*
*   The rest is standard. Note that the momenta that still exist
*   have to be called p1,p3,p4,p6,p7.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7);
#call dotwo{}
#call ACCU(Simplify mncG\(3\));
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
*   File inpy1 does 3-loop diagrams of type Y1.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  p2.p5 = p2.p2/2+p5.p5/2-p6.p6/2;
if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint1)
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p5,p6,p2,mnce5,mnce6,mnce2,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
*   File inpy2 does 3-loop diagrams of type Y2.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  p1.p5 = p1.p1/2+p5.p5/2-p6.p6/2;
if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint1)
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p5,p6,p1,mnce5,mnce6,mnce1,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
*   File inpy3 does 3-loop diagrams of type Y3.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p3.mncq1-p5.mncq1;
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  p3.p5 = p3.p3/2+p5.p5/2-p6.p6/2;
if ( ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 )
  || ( count(p4.p4,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p5,p6,p3,mnce5,mnce6,mnce3,mncint1)
#call ACCU2(B mncG,Integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
if ( count(p4.p4,1) >= 0 ) discard;
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,Integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
*   File inpy4 does 3-loop diagrams of type Y4.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  Q.p5 = Q.Q/2+p5.p5/2-p6.p6/2;
if ( ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p5,p6,Q,mnce5,mnce6,mnceq,mncint1)
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( count(p2.p2,1) >= 0 ) discard;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
*   File inpy5 does 3-loop diagrams of type Y5.
*   The algorithm here is designed especially for these diagrams
*   so that things may proceed faster.
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id	p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = Q.mncq1-p5.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
id  Q.p3 = Q.Q/2+p3.p3/2-p4.p4/2;
id  Q.p5 = Q.Q/2+p5.p5/2-p6.p6/2;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p2.p2,1) >= 0 )
  || ( count(p3.p3,1) >= 0 ) || ( count(p4.p4,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU(Momenta substitutions)
multiply mncint1*mncint2*mncint3/mnceq^3;
#call one(p3,p4,Q,mnce3,mnce4,mnceq,mncint1)
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
id  Q.p5 = Q.Q/2+p5.p5/2-p6.p6/2;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p2.p2,1) >= 0 )
  || ( count(p5.p5,1) >= 0 ) || ( count(p6.p6,1) >= 0 ) ) discard;
#call ACCU2(B mncG,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
#call one(p5,p6,Q,mnce5,mnce6,mnceq,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
*id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( ( count(p1.p1,1) >= 0 ) || ( count(p2.p2,1) >= 0 ) ) discard;
#call ACCU(Momenta 3)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint3)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral3)
Keep Brackets;
#call simplify
#call ACCU(Simplify 3)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(3,`SCHEME')
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*   This is inpt1. It does two loop topologies of type T1.
*
multiply replace_(p2,p3,p3,p4,p4,p6,p5,p7,mnce2,mnce3,mnce3,mnce4,mnce4,mnce6,mnce5,mnce7)
     *mncint1*mncint3*Q.Q*mnceq;
#call dotwo{}
;
*#message We are at the print statement
#call ACCU(Simplify mncG\(3\))
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(2,`SCHEME')
multiply ep;
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
*   This is inpt2. It does two loop topologies of type T2.
*
multiply mncint1*mncint2/mnceq^2;
if ( count(mnce3,1) < count(mnce4,1) ) multiply replace_(p3,p4,p4,p3,mnce3,mnce4,mnce4,mnce3);
id  p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
if ( ( count(p3.p3,1) >= 0 ) && ( count(mnce3,1) == 0 ) ) discard;
if ( ( count(p4.p4,1) >= 0 ) && ( count(mnce4,1) == 0 ) ) discard;
#call ACCU(momenta)
#call one(p3,p4,p1,mnce3,mnce4,mnce1,mncint1)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 1)
Keep Brackets;
#call simplify
#call ACCU(simplify 1)
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( ( count(p2.p2,1) >= 0 ) && ( count(mnce2,1) == 0 ) ) discard;
#call ACCU(momenta 2)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(2,`SCHEME')
multiply ep;
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
*   This is inpt3. It does two loop topologies of type T3.
*
multiply mncint1*mncint2/mnceq^2;
id  p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id  p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
if ( ( count(p1.p1,1) >= 0 ) && ( count(mnce1,1) == 0 ) ) discard;
if ( ( count(p2.p2,1) >= 0 ) && ( count(mnce2,1) == 0 ) ) discard;
if ( ( count(p3.p3,1) >= 0 ) && ( count(mnce3,1) == 0 ) ) discard;
if ( ( count(p4.p4,1) >= 0 ) && ( count(mnce4,1) == 0 ) ) discard;
#call ACCU(momenta 1)
#call one(p3,p4,Q,mnce3,mnce4,mnceq,mncint2)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 1)
Keep Brackets;
#call simplify
#call ACCU(Simplify 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
if ( ( count(p1.p1,1) >= 0 ) && ( count(mnce1,1) == 0 ) ) discard;
if ( ( count(p2.p2,1) >= 0 ) && ( count(mnce2,1) == 0 ) ) discard;
#call ACCU(momenta 2)
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
#call ACCU2(B mncG mncexp10 mncexp20 mncexp11,integral 2)
Keep Brackets;
#call simplify
#call ACCU(Simplify 2)
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
#call finish(2,`SCHEME')
multiply ep;
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*   This is inpl1. It does the one loop topology of type L1.
*
multiply mncint1/mnceq;
id  p2 = Q-p1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
id  Q.p2 = Q.Q/2-p1.p1/2+p2.p2/2;
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
#call ACCU(integral 1)
#call simplify
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-6;
id  acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(1,`SCHEME')
multiply ep^2;
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*   This is file inpl2. It does topologies of type L2 which are
*   meant to have an entire expanded gluon propagator in two loops.
*   It is done to avoid enormous problems with the gluon insertion
*   inside the three loop graph.
*
multiply mnce2^2*mncint1/ep^5/mnceq^3;
id  p2 = Q-p1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( count(p1.p1,1) >= 0 ) discard;
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)
#call ACCU(integral 1)
#call simplify
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-1;
id  acc(mncx1?) = mncx1;
.sort
#call finish(1,`SCHEME')
multiply,ep^2;
print +f +mncs;
B   ep;
.sort
multiply,
       + ep^-2*ca*nf * (  - 55/18 - 1/3*mncxi )
       + ep^-2*ca^2 * ( 175/36 + 35/24*mncxi )
       + ep^-2*nf^2 * ( 4/9 )
       + ep^-1*cf*nf * (  - 1 )
       + ep^-1*ca*nf * (  - 1199/108 - 2/9*mncxi )
       + ep^-1*ca^2 * ( 4229/216 - 97/144*mncxi + 5/8*mncxi^2 - 1/8*mncxi^3 )
       + ep^-1*nf^2 * ( 40/27 )
       + ep*cf*nf * (  - 1711/36 + 76/3*z3 + 12*z4 )
       + ep*ca*nf * (  - 337315/3888 + 50/9*z3*mncxi + 286/27*z3 - 6*z4 + 37/81*
         mncxi )
       + ep*ca^2 * ( 1659373/7776 - 134/9*z3*mncxi - 3/2*z3*mncxi^2 - 1184/27*z3 - 3
         *z4*mncxi - 3/2*z4 - 165073/5184*mncxi + 113/8*mncxi^2 - 33/16*mncxi^3 )
       + ep*nf^2 * ( 2432/243 - 56/27*z3 )
       + cf*nf * (  - 55/6 + 8*z3 )
       + ca*nf * (  - 2371/72 - 4*z3 + 5/27*mncxi )
       + ca^2 * ( 9821/144 - 2*z3*mncxi - z3 - 6121/864*mncxi + 27/8*mncxi^2 - 9/16*
         mncxi^3 )
       + nf^2 * ( 4 );
id  ep = 0;
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*   This is file inpl3. It does topologies of type L3 which are
*   meant to have an entire expanded gluon propagator in one loop.
*   It is done to avoid enormous problems with the gluon insertion
*   inside the two loop graph.
*
multiply mnce1*mncint1/ep^5/mnceq^2;
id  p2 = Q-p1;
id  Q.p1 = Q.Q/2+p1.p1/2-p2.p2/2;
if ( count(p2.p2,1) >= 0 ) discard;
#call one(p1,p2,Q,mnce1,mnce2,mnceq,mncint1)

#call ACCU(integral 1)
#call simplify
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
multiply ep^-1;
id  acc(mncx1?) = mncx1;

.sort
#call finish(1,`SCHEME')
multiply,ep;

*B  ep;
.sort
multiply,ep^-1*(
    +ca*(5/3+mncxi/2-ep*mncxi+ep*mncxi^2/4+31/9*ep-2*ep^2*mncxi+ep^2*mncxi^2/2+188/27*ep^2
        -7/6*ep^3*z3*mncxi-35/9*ep^3*z3-4*ep^3*mncxi+ep^3*mncxi^2+1132/81*ep^3)
    +nf*(-2/3-10/9*ep-56/27*ep^2+14/9*ep^3*z3-328/81*ep^3));
id  ep = 0;
multiply ep;
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*   This is inptr. It does the tree level topology tr.
*
multiply 1/ep^6;
id      acc(mncx1?) = mncx1;
id      ep = 0;
.sort: Expression G scheme;
*
*   Now approximate and convert to MSbar.
*
#call finish(0,`SCHEME')
multiply ep^3;
*
#break
*--#] tr : 
#endswitch
*
#endprocedure
*--#] integral : 
*--#[ intpow :
#procedure intpow(TOPO)
#case la
#case be
#case no
#case fa
#case bu
#case o1
#case o2
#case o3
#case o4
#case y1
#case y2
#case y3
#case y4
#case y5
Multiply,i_^3;
#break
#case t1
#case t2
#case t3
Multiply,i_^2;
#break
#case l1
#case l2
#case l3
Multiply,i_;
#break
#endswitch
#endprocedure

*--#] intpow : 
*--#[ ladder :
#procedure ladder(P1,P2,P3,P4,P5,P6,P7,P8,Q)
*
*   Reduction procedure for three loop graphs of the LA or ladder type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /    |   P2   |    \ P3
*                   /     |        |     \
*                  /      |        |      \
*                 /       |        |       \
*          Q --<--     P7 ^        v P8     --<-- Q
*                 \       |        |       /
*                  \      |        |      / 
*                   \     |        |     /
*                 P6 \    |   P5   |    / P4
*                     \->------>----->-/
*
*   We start with reducing the dotproducts in the numerator to sums
*   of denominators. Only one dotproduct is irreducible: P7.P8
*   The easiest reduction (and quite fast) is by writing everything
*   in terms of Q,P1,P2,P3 and then rewriting
*   the few remaining dotproducts in terms of denominators.
*   There are variations to this principle.
*
*   Routine coded and tested by J.A.M.Vermaseren 8-jul-1990.
*   modified 13-nov-1990. Variations added april 1993.
*   Backward reduction added 15-may-1993
*
#ifdef `LATRANS'
#if ( `LATRANS' == 1 )
  #call ACCU2(AB `P3'.`P7' `P2'.`P7' `P7'.`P8',Ladder scalar 0)
    id  `P3'.`P7' = `P2'.`P7'+`P7'.`P8';
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 2)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
  #call ACCU2(AB `P2'.`P7' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P2'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 4)
    id  `P2'.`P3' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `Q'.`P7' `P1'.`P1' `P2'.`P2' `P5'.`P5' `P6'.`P6',Ladder scalar 5)
    id  `Q'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P6'.`P6'/2;
  #call ACCU(Ladder scalar 6)
#else
#if ( `LATRANS' == 2 )
  #call ACCU2(AB `P3'.`P7' `P1'.`P7' `P7'.`P8' `P7'.`P7',Ladder scalar 0)
    id  `P3'.`P7' = `P1'.`P7'-`P7'.`P7'+`P7'.`P8';
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `Q'.`Q' `P4'.`P4',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P1' `P1'.`P1' `Q'.`Q' `P6'.`P6',Ladder scalar 2)
    id  `Q'.`P1' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
  #call ACCU2(AB `P1'.`P7' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P1'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P7'.`P7'/2;
  #call ACCU2(AB `Q'.`P7' `P1'.`P1' `P2'.`P2' `P5'.`P5' `P6'.`P6',Ladder scalar 4)
    id  `Q'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P6'.`P6'/2;
  #call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P7'.`P8',Ladder scalar 5)
    id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2+`P7'.`P8';
  #call ACCU(Ladder scalar 6)
#else
#if ( `LATRANS' == 3 )
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 0)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
  #call ACCU2(AB `P2'.`P7' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 1)
    id  `P2'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P8' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 2)
    id  `P2'.`P8' = `P3'.`P3'/2-`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `Q'.`P7' `P1'.`P1' `P2'.`P2' `P5'.`P5' `P6'.`P6',Ladder scalar 3)
    id  `Q'.`P7' = `P1'.`P1'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P6'.`P6'/2;
  #call ACCU2(AB `Q'.`P8' `P3'.`P3' `P2'.`P2' `P5'.`P5' `P4'.`P4',Ladder scalar 4)
    id  `Q'.`P8' = `P3'.`P3'/2-`P2'.`P2'/2+`P5'.`P5'/2-`P4'.`P4'/2;
  #call ACCU(Ladder scalar 5)
#else
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P1' `P1'.`P1' `P6'.`P6' `Q'.`Q',Ladder scalar 0)
    id  `Q'.`P1' = `P1'.`P1'/2-`P6'.`P6'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `P4'.`P4' `Q'.`Q',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 2)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 4)
    id  `P2'.`P3' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P7'.`P8',Ladder scalar 5)
    id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2+`P7'.`P8';
  #call ACCU(Ladder scalar 6)
#endif
#endif
#endif
#else
if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) > count(`P3'.`P3',1) );
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
    elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
        if ( count(`P6'.`P6',1) > count(`P4'.`P4',1) )
            multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
    endif;
endif;
  #call ACCU2(AB `Q'.`P1' `P1'.`P1' `P6'.`P6' `Q'.`Q',Ladder scalar 0)
    id  `Q'.`P1' = `P1'.`P1'/2-`P6'.`P6'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P3' `P3'.`P3' `P4'.`P4' `Q'.`Q',Ladder scalar 1)
    id  `Q'.`P3' = `P3'.`P3'/2-`P4'.`P4'/2+`Q'.`Q'/2;
  #call ACCU2(AB `Q'.`P2' `P2'.`P2' `Q'.`Q' `P5'.`P5',Ladder scalar 2)
    id  `Q'.`P2' = `P2'.`P2'/2+`Q'.`Q'/2-`P5'.`P5'/2;
  #call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',Ladder scalar 3)
    id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
  #call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',Ladder scalar 4)
    id  `P2'.`P3' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
  #call ACCU2(AB `P1'.`P3' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P7'.`P8',Ladder scalar 5)
    id  `P1'.`P3' = `P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2+`P7'.`P8';
  #call ACCU(Ladder scalar 6)
#endif
  if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) );
    multiply replace_(`P1',`P3',`P3',`P1',`P7',`P8',`P8',`P7',`P6',`P4',`P4',`P6');
  endif;
*
*   The rule of the triangle is applied in the procedure `triangle'
*   We apply it in the triangle at the right side. The above reordering
*   makes it the simplest triangle.
*
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
            /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
    multiply acc(1/ep);
    #call triangle(`P8',`P4',`P3',`P5',`P2')
    multiply ep;
  else;
    repeat;
        if ( match(`P2'.`P2'/`P7'.`P7'/`P1'.`P1'^2) );
            id `P7'.`P8'^mncx9?*`P2'.`P2'/`P1'.`P1'^mncx1?/`P7'.`P7'^mncx7?/`P6'.`P6'^mncx6? =
                `P1'.`P1'*`P7'.`P8'^mncx9/`P1'.`P1'^mncx1/`P7'.`P7'^mncx7/`P6'.`P6'^mncx6 *(
                    +`P7'.`P7'/`P1'.`P1'
                    +mncx6/(mncx1-1)*(`P7'.`P7'-`P5'.`P5')/`P6'.`P6'
                    -acc(5-2*mncx7+mncx9-mncx1-mncx6-2*ep)/(mncx1-1)
                );
        endif;
        if ( match(`P2'.`P2'/`P8'.`P8'/`P3'.`P3'^2) );
            id `P7'.`P8'^mncx9?*`P2'.`P2'/`P3'.`P3'^mncx3?/`P8'.`P8'^mncx8?/`P4'.`P4'^mncx4? =
                `P3'.`P3'*`P7'.`P8'^mncx9/`P3'.`P3'^mncx3/`P8'.`P8'^mncx8/`P4'.`P4'^mncx4 *(
                    +`P8'.`P8'/`P3'.`P3'
                    +mncx4/(mncx3-1)*(`P8'.`P8'-`P5'.`P5')/`P4'.`P4'
                    -acc(5-2*mncx8+mncx9-mncx3-mncx4-2*ep)/(mncx3-1)
                );
        endif;
        if ( match(`P5'.`P5'/`P7'.`P7'/`P6'.`P6'^2/`P2'.`P2') );
            id `P7'.`P8'^mncx9?*`P5'.`P5'/`P1'.`P1'^mncx1?/`P7'.`P7'^mncx7?/`P6'.`P6'^mncx6? =
                `P6'.`P6'*`P7'.`P8'^mncx9/`P1'.`P1'^mncx1/`P7'.`P7'^mncx7/`P6'.`P6'^mncx6 *(
                    +`P7'.`P7'/`P6'.`P6'
                    +mncx1/(mncx6-1)*(`P7'.`P7'-`P2'.`P2')/`P1'.`P1'
                    -acc(5-2*mncx7+mncx9-mncx1-mncx6-2*ep)/(mncx6-1)
                );
        endif;
        if ( match(`P5'.`P5'/`P8'.`P8'/`P4'.`P4'^2/`P2'.`P2') );
            id `P7'.`P8'^mncx9?*`P5'.`P5'/`P3'.`P3'^mncx3?/`P8'.`P8'^mncx8?/`P4'.`P4'^mncx4? =
                `P4'.`P4'*`P7'.`P8'^mncx9/`P3'.`P3'^mncx3/`P8'.`P8'^mncx8/`P4'.`P4'^mncx4 *(
                    +`P8'.`P8'/`P4'.`P4'
                    +mncx3/(mncx4-1)*(`P8'.`P8'-`P2'.`P2')/`P3'.`P3'
                    -acc(5-2*mncx8+mncx9-mncx3-mncx4-2*ep)/(mncx4-1)
                );
        endif;
    endrepeat;
  endif;

*id 1/p1.p1^n1?/p2.p2^n2?/p3.p3^n3?/p4.p4^n4?/p5.p5^n5?/p6.p6^n6?/p7.p7^n7?/p8.p8^n8?
*    = I(n1,n2,n3,n4,n5,n6,n7,n8);

*id acc(n1?) = n1;
*id ep=0;
*print +s;
*.end

*
#endprocedure
*--#] ladder : 
*--#[ momsubs :
#procedure momsubs(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
#if ( `LATRANS' == 1 )
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(1\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2\(1\))
id	p1.mncq1?!{p1} = p2.mncq1+p7.mncq1;
#call ACCU2(AB P Q p7 p2 p3,moms3\(1\))
#else
#if ( `LATRANS' == 2 )
id	p5.mncq1?!{p5} = p6.mncq1-p7.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(2\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2\(2\))
id	p2.mncq1?!{p2} = p1.mncq1-p7.mncq1;
#call ACCU2(AB P Q p1 p7 p3,moms3\(2\))
#else
#if ( `LATRANS' == 3 )
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(3\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1+p8.mncq1;
#call ACCU(moms2\(3\))
id	p1.mncq1?!{p1} = p2.mncq1+p7.mncq1;
#call ACCU2(AB P Q p7 p2 p8,moms3\(3\))
#else
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1\(0\))
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2\(0\))
id	p7.mncq1?!{p7} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3\(0\))
#endif
#endif
#endif
#else
id	p5.mncq1?!{p5} = p2.mncq1-Q.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p2.mncq1;
#call ACCU(moms2)
id	p7.mncq1?!{p7} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3)
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
#ifndef `BEPATH'
id	p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p7.p8 = p6.p6/2-p7.p7/2-p8.p8/2;
*
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;

id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p1.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms2)
#else
#if ( `BEPATH' == 0 )
id	p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p7.p8 = p6.p6/2-p7.p7/2-p8.p8/2;
*
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;

id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p1.mncq1;
#call ACCU(moms1 \(0\))
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms2)
#endif
#if ( `BEPATH' == 1 )
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p4.mncq1?!{p4} = p5.mncq1+p8.mncq1;
id	p3.mncq1?!{p3} = p1.mncq1+p8.mncq1;
id	p2.mncq1?!{p2} = p1.mncq1+p6.mncq1;
#call ACCU(moms1 \(1\))
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
#call ACCU2(AB P Q p1 p6 p8,moms2)
#endif
#if ( `BEPATH' == 2 )
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p8.mncq1?!{p8} = p6.mncq1-p7.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU(moms1 \(2\))
id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
#call ACCU2(AB P Q p1 p2 p7,moms2)
#endif
#if ( `BEPATH' == 3 )
id	p1.p5 = p1.p1/2+p5.p5/2-Q.Q/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
id	p4.mncq1?!{p4} = p8.mncq1+p5.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU(moms1 \(3\))
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
id	p1.mncq1?!{p1} = p2.mncq1-p6.mncq1;
#call ACCU2(AB P Q p2 p6 p8,moms2)
#endif
#if ( `BEPATH' == 4 )
id	p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
id	p1.p5 = p1.p1/2+p5.p5/2-Q.Q/2;
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p1.mncq1?!{p1} = Q.mncq1+p5.mncq1;
id	p2.mncq1?!{p2} = p3.mncq1+p7.mncq1;
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
#call ACCU(moms1 \(4\))
id	p3.mncq1?!{p3} = Q.mncq1+p4.mncq1;
id	p5.mncq1?!{p5} = p4.mncq1-p8.mncq1;
#call ACCU2(AB P Q p4 p6 p8,moms2)
#endif
#if ( `BEPATH' == 5 )
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
id	p4.mncq1?!{p4} = -Q.mncq1+p3.mncq1;
id	p5.mncq1?!{p5} = -Q.mncq1+p1.mncq1;
id	p8.mncq1?!{p8} = p6.mncq1-p7.mncq1;
#call ACCU(moms1 \(5\))
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
id	p2.mncq1?!{p2} = p1.mncq1+p6.mncq1;
#call ACCU2(AB P Q p1 p6 p7,moms2)
#endif
#if ( `BEPATH' == 6 )
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
id	p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
id	p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p3.mncq1?!{p3} = Q.mncq1+p4.mncq1;
id	p2.mncq1?!{p2} = p1.mncq1+p6.mncq1;
id	p7.mncq1?!{p7} = p6.mncq1-p8.mncq1;
#call ACCU(moms1 \(6\))
id	p1.mncq1?!{p1} = Q.mncq1+p5.mncq1;
id	p4.mncq1?!{p4} = p5.mncq1+p8.mncq1;
#call ACCU2(AB P Q p5 p6 p8,moms2)
#endif
#if ( `BEPATH' == 7 )
id	p1.p6 = p2.p2/2-p1.p1/2-p6.p6/2;
id	p3.p7 = p2.p2/2-p3.p3/2-p7.p7/2;
id	p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
id	p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
id	p7.p8 = p6.p6/2-p7.p7/2-p8.p8/2;
id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p4.mncq1-p5.mncq1;
#call ACCU(moms1 \(7\))
id	p1.mncq1?!{p1} = Q.mncq1+p5.mncq1;
id	p3.mncq1?!{p3} = Q.mncq1+p4.mncq1;
#call ACCU2(AB P Q p2 p4 p5,moms2)
#endif
#if ( `BEPATH' == 8 )
id	p1.p5 = p1.p1/2+p5.p5/2-Q.Q/2;
id	p3.p4 = p3.p3/2+p4.p4/2-Q.Q/2;
id	p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
id	p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
id	p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
id	p4.mncq1?!{p4} = -Q.mncq1+p3.mncq1;
id	p5.mncq1?!{p5} = -Q.mncq1+p1.mncq1;
id	p8.mncq1?!{p8} = p6.mncq1-p7.mncq1;
#call ACCU(moms1 \(8\))
id	p3.mncq1?!{p3} = p2.mncq1-p7.mncq1;
id	p1.mncq1?!{p1} = p2.mncq1-p6.mncq1;
#call ACCU2(AB P Q p2 p6 p7,moms2)
#endif
#endif
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifndef `NOSPEC'
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p1.mncq1;
#call ACCU(moms2)
id	p8.mncq1?!{p8} = p2.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3)
#else
#if ( `NOSPEC' == 0 )
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p1.mncq1;
#call ACCU(moms2)
id	p8.mncq1?!{p8} = p2.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p2 p3,moms3)
#endif
#if ( `NOSPEC' == 1 )
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p1.mncq1?!{p1} = p2.mncq1-p7.mncq1;
#call ACCU(moms2)
id	p3.mncq1?!{p3} = p2.mncq1-p8.mncq1;
#call ACCU2(AB P Q p7 p2 p8,moms3)
#endif
#if ( `NOSPEC' == 2 )
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p6.mncq1?!{p6} = p1.mncq1-Q.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p1.mncq1;
#call ACCU(moms2)
id	p3.mncq1?!{p3} = p2.mncq1-p8.mncq1;
#call ACCU2(AB P Q p1 p2 p8,moms3)
#endif
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
id	p6.mncq1?!{p6} = p2.mncq1-p1.mncq1;
id	p7.mncq1?!{p7} = p2.mncq1-p3.mncq1;
id	p8.mncq1?!{p8} = p3.mncq1-p1.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p3.mncq1-Q.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-Q.mncq1;
#call ACCU2(AB	P Q p1 p2 p3,moms2)
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
id	p2.mncq1?!{p2} = p1.mncq1-p8.mncq1;
id	p4.mncq1?!{p4} = p1.mncq1-p6.mncq1;
id	p5.mncq1?!{p5} = p6.mncq1-p8.mncq1;
#call ACCU(moms1)
id	p7.mncq1?!{p7} = p6.mncq1-Q.mncq1;
id	p3.mncq1?!{p3} = p8.mncq1-Q.mncq1;
#call ACCU2(AB	P Q p1 p6 p8,moms2)
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
#ifndef `O1PATH'
id p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms1)
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
id p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
#else
#if ( `O1PATH' == 0 )
id p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms1)
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
id p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
#endif
#if ( `O1PATH' == 1 )
id p3.mncq1?!{p3} = p4.mncq1-p5.mncq1;
id p2.mncq1?!{p2} = p1.mncq1-p5.mncq1;
#call ACCU(moms1)
id p5.mncq1?!{p5} = p6.mncq1+p7.mncq1;
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p6 p7,moms2)
#endif
#if ( `O1PATH' == 2 )
id p7.mncq1?!{p7} = p5.mncq1-p6.mncq1;
id p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms1)
id p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
id p2.mncq1?!{p2} = p1.mncq1-p5.mncq1;
#call ACCU2(AB P Q p1 p5 p6,moms2)
#endif
#endif
*#call ACCU(moms2)
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
id	p7.mncq1?!{p7} = p4.mncq1-p6.mncq1;
id	p2.mncq1?!{p2} = p3.mncq1+Q.mncq1;
#call ACCU(moms1)
id	p1.mncq1?!{p1} = p4.mncq1+Q.mncq1;
id	p5.mncq1?!{p5} = p4.mncq1-p3.mncq1;
#call ACCU2(AB P Q p3 p4 p6,moms2)
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
id	p7.mncq1?!{p7} = Q.mncq1-p6.mncq1;
id	p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
id	p7.mncq1?!{p7} = Q.mncq1-p6.mncq1;
id	p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p1.mncq1-p6.mncq1;
id	p3.mncq1?!{p3} = p2.mncq1-p6.mncq1;
#call ACCU2(AB P Q p1 p2 p6,moms2)
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p2.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p1.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = p3.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = Q.mncq1-p5.mncq1;
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
id	p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
id	p6.mncq1?!{p6} = Q.mncq1-p5.mncq1;
#call ACCU2(AB P Q p1 p3 p5,moms2)
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
id	p4.mncq1?!{p4} = p1.mncq1-Q.mncq1;
#call ACCU(moms1)
id	p3.mncq1?!{p3} = p2.mncq1-Q.mncq1;
#call ACCU(moms2)
id	p5.mncq1?!{p5} = p1.mncq1-p2.mncq1;
#call ACCU2(AB P Q p1 p2,moms3)
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU(moms1)
id	p4.mncq1?!{p4} = p1.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p3,moms2)
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
id	p2.mncq1?!{p2} = Q.mncq1-p1.mncq1;
#call ACCU{moms1}
id	p4.mncq1?!{p4} = Q.mncq1-p3.mncq1;
#call ACCU2(AB P Q p1 p3,moms2)
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#default
#message Unknown case `TOPO' in momsubs.prc
#break
#endswitch
#endprocedure
*--#] momsubs : 
*--#[ newplane :
#procedure newplane(P1,P2,P3,P4,P5,P6,P7,P8,Q,INTS)
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*   For the first part we use the algorithms from Chetyrkin & Tkachov
*   (Nuclear physics B192(1981)159.
*   To reduce powers in the numerator. These algorithms work faster.
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
*   Express everything in powers of pi.pi, Q.Q and Q.p2 or p2.p5;
*	We need p2.p5 only when there are enough denominators.
*   The only difficult relation here is the one for p7.p8
*
*   Note that the system here is optimized for the big and difficult
*   expressions.
*   Note also that the final stages can be improved.
*   At the moment the goto statements are not so good
*
#ifndef `NOSPEC'
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU2(AB `P1'.`Q' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 0)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU2(AB `P3'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4',dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU(dots 4)
    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  repeat  id `P1'.`P3'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
*		(`P2'.`P5'+`P2'.`P2'/2+`P5'.`P5'/2+`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2)
*		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 5)
  repeat id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 6)
*  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
*    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
*                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  endif;
*#call ACCU(dots 7)
#else
#if ( `NOSPEC' == 0 )
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU2(AB `P1'.`Q' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 0)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU2(AB `P3'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4',dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P3' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
#call ACCU(dots 4)
    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  repeat  id `P1'.`P3'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
*		(`P2'.`P5'+`P2'.`P2'/2+`P5'.`P5'/2+`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2)
*		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 5)
  repeat id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 6)
*  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
*    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
*                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  endif;
*#call ACCU(dots 7)
#endif
#if ( `NOSPEC' == 1 )
  id  `P2'.`P7' = `P2'.`P2'/2+`P7'.`P7'/2-`P1'.`P1'/2;
#call ACCU2(AB `P2'.`P8' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 0)
  id  `P2'.`P8' = -`P3'.`P3'/2+`P2'.`P2'/2+`P8'.`P8'/2;
#call ACCU2(AB `P7'.`P8' `P7'.`P7' `P8'.`P8' `P1'.`P1' `P3'.`P3' `P1'.`P3',dots 1)
  id  `P7'.`P8' = `P7'.`P7'/2+`P8'.`P8'/2-`P1'.`P1'/2-`P3'.`P3'/2+`P1'.`P3';
#call ACCU2(AB `P7'.`Q' `Q'.`P2' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 2)
  id  `P7'.`Q' = `Q'.`P2'-`P1'.`P1'/2-`Q'.`Q'/2+`P6'.`P6'/2;
#call ACCU2(AB `P8'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4' `Q'.`P2',dots 3)
  id  `P8'.`Q' = `Q'.`P2'-`P3'.`P3'/2-`Q'.`Q'/2+`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P3' `P2'.`P5' `P2'.`P2' `P5'.`P5' `Q'.`Q' `P4'.`P4' `P6'.`P6',dots 4)
  repeat  id `P1'.`P3'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P2'.`P5'+`P2'.`P2'/2+`P5'.`P5'/2+`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2)
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU2(AB `Q'.`P2' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P2'.`P5',dots 5)
#do ii6 = 1,1
  id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
  if ( match(`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') ) redefine ii6 "0";
#call ACCU2(AB `Q'.`P2' `P1'.`P1' `P3'.`P3' `P7'.`P7' `P8'.`P8' `P2'.`P5',dots 6)
#enddo
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
    id,once,`P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
  endif;
#call ACCU(dots 7)
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
    id,`P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
  endif;
#call ACCU(dots 8)
#endif
#if ( `NOSPEC' == 2 )
#call ACCU2(AB `P1'.`Q' `P1'.`P1' `Q'.`Q' `P6'.`P6',dots 0)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU2(AB `P8'.`Q' `P2'.`Q' `P3'.`P3' `Q'.`Q' `P4'.`P4',dots 1)
  id  `P8'.`Q' = `P2'.`Q'-`P3'.`P3'/2-`Q'.`Q'/2+`P4'.`P4'/2;
#call ACCU2(AB `P1'.`P2' `P1'.`P1' `P2'.`P2' `P7'.`P7',dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU2(AB `P2'.`P8' `P3'.`P3' `P2'.`P2' `P8'.`P8',dots 3)
  id  `P2'.`P8' = `P8'.`P8'/2+`P2'.`P2'/2-`P3'.`P3'/2;
#call ACCU2(AB `P1'.`P8' `P2'.`Q' `P3'.`P3' `P5'.`P5' `Q'.`Q' `P4'.`P4' `P6'.`P6' `P8'.`P8',dots 4)
  id `P1'.`P8' = +`P2'.`Q'-`P3'.`P3'/2-`P5'.`P5'/2
                 -`Q'.`Q'/2+`P4'.`P4'/2+`P6'.`P6'/2+`P8'.`P8'/2;
#call ACCU(dots 5)
  repeat id	`Q'.`P2'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
		(`P1'.`P1'/2+`P3'.`P3'/2-`P7'.`P7'/2-`P8'.`P8'/2-`P2'.`P5')
		/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8';
#call ACCU(dots 6)
*  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
*    	/`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') == 0 );
*    id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
*                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
*  endif;
*#call ACCU(dots 7)
#endif
#endif
if ( count(`P7'.`P7',1) < count(`P8'.`P8',1) );
	multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
       ,`P7',`P8',`P8',`P7');
elseif ( count(`P7'.`P7',1) == count(`P8'.`P8',1) );
    if ( count(`P1'.`P1',1) < count(`P3'.`P3',1) );
		multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
           ,`P7',`P8',`P8',`P7');
	elseif ( count(`P1'.`P1',1) == count(`P3'.`P3',1) );
	    if ( count(`P6'.`P6',1) < count(`P4'.`P4',1) )
			multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4'
               ,`P7',`P8',`P8',`P7');
	endif;
endif;
*
* Now we start a set of iterations to make either
* 1:  the power of `P2'.`P5' equal to zero
* 2:  the power of `P2'.`P2',`P5'.`P5',`P7'.`P7',`P8'.`P8' >= 0
* 3:  the power of `P1'.`P1',`P3'.`P3',`P4'.`P4',`P6'.`P6' >= -1
*
repeat;
  if ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    if ( count(`P6'.`P6',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
         /`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4
         /`P5'.`P5'^mncx5/`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx6-1)*(`P3'.`P3'-`P2'.`P2'-`P8'.`P8')
        +acc(3-2*ep+mncx9-mncx1-mncx8-2*mncx2)*`P6'.`P6'
        +mncx1*`P6'.`P6'/`P1'.`P1'*(`P7'.`P7'-`P2'.`P2')
        +mncx8*`P6'.`P6'/`P8'.`P8'*(`P3'.`P3'-`P2'.`P2')
        )/(mncx6-1)/2/`P2'.`P5';
    elseif ( count(`P1'.`P1',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx1-1)*(`P4'.`P4'-`P5'.`P5'-`P7'.`P7')
        +acc(2-2*ep+mncx9-mncx7-2*mncx5)*`P1'.`P1'
        +`P1'.`P1'/`P6'.`P6'*(`P8'.`P8'-`P5'.`P5')
        +mncx7*`P1'.`P1'/`P7'.`P7'*(`P4'.`P4'-`P5'.`P5')
        )/(mncx1-1)/2/`P2'.`P5';
    elseif ( count(`P4'.`P4',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx4-1)*(`P1'.`P1'-`P2'.`P2'-`P7'.`P7')
        +acc(3-2*ep+mncx9-mncx3-mncx7-2*mncx2)*`P4'.`P4'
        +mncx3*`P4'.`P4'/`P3'.`P3'*(`P8'.`P8'-`P2'.`P2')
        +mncx7*`P4'.`P4'/`P7'.`P7'*(`P1'.`P1'-`P2'.`P2')
        )/(mncx4-1)/2/`P2'.`P5';
    elseif ( count(`P3'.`P3',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
        +acc(mncx3-1)*(`P6'.`P6'-`P5'.`P5'-`P8'.`P8')
        +acc(2-2*ep+mncx9-mncx8-2*mncx5)*`P3'.`P3'
        +`P3'.`P3'/`P4'.`P4'*(`P7'.`P7'-`P5'.`P5')
        +mncx8*`P3'.`P3'/`P8'.`P8'*(`P6'.`P6'-`P5'.`P5')
        )/(mncx3-1)/2/`P2'.`P5';
    endif;
  endif;
endrepeat;
#call ACCU(nonplanar pass 1)
*
* The next set of iterations has two phases.
* The first phase stops when either
* 1:  the power of `P2'.`P5' equal to zero
* 2:  the power of `P1'.`P1',`P3'.`P3',`P4'.`P4',`P6'.`P6',`P7'.`P7',`P8'.`P8' >= 0
* 3:  the power of `P2'.`P2',`P5'.`P5' >= -1
* The second phase stops when
* 1:  the power of `P2'.`P5' equal to zero
* 2:  the power of all others is >= -1
*
#ifdef `LONGINT'
#do i = 1,`LONGINT'
  if ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    if ( count(`P5'.`P5',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(2*mncx2+mncx7+mncx8-mncx9-3+2*ep)
          +acc(mncx9-1)*`P2'.`P2'/`P2'.`P5'
          +mncx7*(`P2'.`P2'-`P1'.`P1')/`P7'.`P7'
          +mncx8*(`P2'.`P2'-`P3'.`P3')/`P8'.`P8'
        )/(mncx5-1)/2/`P2'.`P5'*`P5'.`P5';
    elseif ( count(`P2'.`P2',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx7+mncx8-mncx9-1+2*ep)
          +acc(mncx9-1)*`P5'.`P5'/`P2'.`P5'
          +mncx7*(`P5'.`P5'-`P4'.`P4')/`P7'.`P7'
          +mncx8*(`P5'.`P5'-`P6'.`P6')/`P8'.`P8'
        )/(mncx2-1)/2/`P2'.`P5'*`P2'.`P2';
    elseif ( count(`P8'.`P8',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx8-1)*(2*`P1'.`P1'+2*`P3'.`P3'-2*`P2'.`P2'-`P7'.`P7'-`Q'.`Q')
          +acc(mncx9-1)*`P8'.`P8'*(`P1'.`P1'-`P2'.`P2'-`P7'.`P7')/`P2'.`P5'
          +acc(3-2*ep-2*mncx7-mncx8)*`P8'.`P8'
          +2*`P8'.`P8'/`P2'.`P2'*(`P1'.`P1'-`P7'.`P7')
        )/(mncx8-1)/2/`P2'.`P5';
    elseif ( count(`P7'.`P7',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8' =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8' * (
          +acc(mncx7-1)*(2*`P6'.`P6'+2*`P4'.`P4'-2*`P5'.`P5'-`P8'.`P8'-`Q'.`Q')
          +acc(mncx9-1)*`P7'.`P7'*(`P6'.`P6'-`P5'.`P5'-`P8'.`P8')/`P2'.`P5'
          +acc(1-2*ep-mncx7)*`P7'.`P7'
          +2*`P7'.`P7'/`P5'.`P5'*(`P6'.`P6'-`P8'.`P8')
        )/(mncx7-1)/2/`P2'.`P5';
    endif;
*    id  acc(0) = 0;
  endif;
#call ACCU(nonplanar pass 2\,`i')
#enddo
#endif
repeat;
  if ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    if ( count(`P5'.`P5',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'^mncx5/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(2*mncx2+mncx7+mncx8-mncx9-3+2*ep)
          +acc(mncx9-1)*`P2'.`P2'/`P2'.`P5'
          +mncx7*(`P2'.`P2'-`P1'.`P1')/`P7'.`P7'
          +mncx8*(`P2'.`P2'-`P3'.`P3')/`P8'.`P8'
        )/(mncx5-1)/2/`P2'.`P5'*`P5'.`P5';
    elseif ( count(`P2'.`P2',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'^mncx2/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx7+mncx8-mncx9-1+2*ep)
          +acc(mncx9-1)*`P5'.`P5'/`P2'.`P5'
          +mncx7*(`P5'.`P5'-`P4'.`P4')/`P7'.`P7'
          +mncx8*(`P5'.`P5'-`P6'.`P6')/`P8'.`P8'
        )/(mncx2-1)/2/`P2'.`P5'*`P2'.`P2';
    elseif ( count(`P8'.`P8',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8 * (
          +acc(mncx8-1)*(2*`P1'.`P1'+2*`P3'.`P3'-2*`P2'.`P2'-`P7'.`P7'-`Q'.`Q')
          +acc(mncx9-1)*`P8'.`P8'*(`P1'.`P1'-`P2'.`P2'-`P7'.`P7')/`P2'.`P5'
          +acc(3-2*ep-2*mncx7-mncx8)*`P8'.`P8'
          +2*`P8'.`P8'/`P2'.`P2'*(`P1'.`P1'-`P7'.`P7')
        )/(mncx8-1)/2/`P2'.`P5';
    elseif ( count(`P7'.`P7',1) < -1 );
      id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8' =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^mncx7/`P8'.`P8' * (
          +acc(mncx7-1)*(2*`P6'.`P6'+2*`P4'.`P4'-2*`P5'.`P5'-`P8'.`P8'-`Q'.`Q')
          +acc(mncx9-1)*`P7'.`P7'*(`P6'.`P6'-`P5'.`P5'-`P8'.`P8')/`P2'.`P5'
          +acc(1-2*ep-mncx7)*`P7'.`P7'
          +2*`P7'.`P7'/`P5'.`P5'*(`P6'.`P6'-`P8'.`P8')
        )/(mncx7-1)/2/`P2'.`P5';
    endif;
*    id  acc(0) = 0;
  endif;
endrepeat;
#call ACCU(nonplanar pass 2)
*
*   Note: equation 6.14 is wrong!!! 6.13 is confusing. Use d/dk instead
*
multiply acc(1/ep);
while ( match(`P2'.`P5'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
  /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
    id `P2'.`P5'^mncx9?/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' =
         `P2'.`P5'^mncx9/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
         /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' * (
            +2*`P3'.`P3'-2*`P8'.`P8'
            +acc(1+2*ep-mncx9)*mncdeno(mncx9-1,-4)*`Q'.`Q'
            +2*`Q'.`Q'*mncdeno(mncx9-1,-4)*(`P2'.`P2'-`P8'.`P8')/`P3'.`P3'
        )/2/`P2'.`P5';
*    id  acc(0) = 0;
*	id	acc(2*ep)*mncdeno(0,-4) = -1/2;
    id  1/`P2'.`P5' = 0;
    id  mncdeno(0,-4) = acc(-1/4/ep);
    id  mncdeno(mncx1?,-4)=acc(1+4/mncx1*ep+16/mncx1^2*ep^2+64/mncx1^3*ep^3
        +256/mncx1^4*ep^4+1024/mncx1^5*ep^5+4096/mncx1^6*ep^6)/mncx1;
endwhile;
multiply ep;

#call ACCU(nonplanar pass 3)
*
*   Next are four recursions that reduce the powers of the propagators
*   that connect to `Q' to 1.
*
#ifdef `LONGINT'
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
#call ACCU(Preparation)
#endif
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
*
*   Now we have that in the 'active terms' the powers of `P1'.`P1', `P3'.`P3',
*   `P4'.`P4' and `P6'.`P6' is 1 and the power of `Q'.`P2' is zero.
*   The final recursion is for lines that don't touch the outside.
*
*   Remark: it seems better to combine this recursion more directly
*   with the above recursions.This can give:
*   1: 5 a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1
*   2: 2 mncx5=1 ( a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1 )
*   3: 8 mncx2=mncx5=1
*   4: 7 mncx2=mncx5=mncx8=1
*
if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1) > `INNOTABL' );
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'^2/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P5'.`P5'/`Q'.`Q'
      +acc(mncx5-1)*mncx4*`P7'.`P7'/`P4'.`P4'
      +acc(mncx5-1)*mncx6*`P8'.`P8'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx4*`P5'.`P5'/`P4'.`P4'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx6*`P5'.`P5'/`P6'.`P6'
    )/(mncx5-1)*mncdeno(mncx4+mncx6+2*mncx5-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'^2/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P2'.`P2'/`Q'.`Q'
      +acc(mncx2-1)*mncx3*`P8'.`P8'/`P3'.`P3'
      +acc(mncx2-1)*mncx1*`P7'.`P7'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx3*`P2'.`P2'/`P3'.`P3'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx1*`P2'.`P2'/`P1'.`P1'
    )/(mncx2-1)*mncdeno(mncx3+mncx1+2*mncx2-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'^2) > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P8'.`P8'/`Q'.`Q'
      +acc(mncx8-1)*mncx3*`P2'.`P2'/`P3'.`P3'
      +acc(mncx8-1)*mncx6*`P5'.`P5'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx3*`P8'.`P8'/`P3'.`P3'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx6*`P8'.`P8'/`P6'.`P6'
    )/(mncx8-1)*mncdeno(mncx3+mncx6+2*mncx8-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^2/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P7'.`P7'/`Q'.`Q'
      +acc(mncx7-1)*mncx4*`P5'.`P5'/`P4'.`P4'
      +acc(mncx7-1)*mncx1*`P2'.`P2'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx4*`P7'.`P7'/`P4'.`P4'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx1*`P7'.`P7'/`P1'.`P1'
    )/(mncx7-1)*mncdeno(mncx4+mncx1+2*mncx7-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;
endif;
label 9;
*
*	Here we take those integrals that have been tabulated
*
if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
     /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
	if ( ( count(`P2'.`P2',1) > count(`P7'.`P7',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P7'.`P7',1) )
	  && ( count(`P8'.`P8',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P7',`P7',`P2',`P8',`P5',`P5',`P8');
	if ( ( count(`P2'.`P2',1) > count(`P8'.`P8',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P8'.`P8',1) )
	  && ( count(`P7'.`P7',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P8',`P8',`P2',`P7',`P5',`P5',`P7');
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
  id `INTS'/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
           /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
           mncnoptab(mncx2,mncx7,mncx8,mncx5)*mnceq^3/`Q'.`Q'^(mncx2+mncx5+mncx7+mncx8-2);
endif;
*
*   The value will only be substituted when the routine subint is
*   invoked. This way we can keep an eye on the accuracy of the calculation.
*
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
*
#endprocedure
*--#] newplane : 
*--#[ newtwo :
#procedure newtwo(P1,E1,P2,E2,P3,E3,P4,E4,P5,E5,Q,EQ,REDUCTION,INTS)
*
*   Newer way to do two loop integrals.
*   The case with the ep power on the outside can be done
*   with the resolved triangle and the part with the ep on the
*   inside and all other powers one is done with a table.
*   This leaves only one type of explicit recursion. We deal
*   with them by making powers equal to 1 as quickly as possible
*   so that in the next recursion they may get killed. It isn't
*   clear whether this is the best strategy.
*
#if ( `REDUCTION' > 0 )
  id  `P4'.mncp?!{`P4'} = `P1'.mncp-`Q'.mncp;
  id  `P3'.mncp?!{`P3'} = `P2'.mncp-`Q'.mncp;
  id  `P5'.mncp?!{`P5'} = `P1'.mncp-`P2'.mncp;
  #call ACCU(Two loop momenta)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P4'.`P4'/2;
  id  `P2'.`Q' = `P2'.`P2'/2+`Q'.`Q'/2-`P3'.`P3'/2;
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P5'.`P5'/2;
  #call ACCU(Two loop scalars)
#endif

if ( count(`E5',1) == 1 );
  repeat;
    if ( match(`E5'/`P1'.`P1'^2/`P4'.`P4'^2/`P2'.`P2'/`P3'.`P3') );
      id  1/`P1'.`P1'^mncx1?/`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?*`E5' =
        1/`P1'.`P1'^mncx1/`P4'.`P4'^mncx4/`P5'.`P5'^mncx5*`E5' * (
          +acc(ep+mncx5)*acc(1-2*ep-mncx5)/(mncx1-1)/(mncx4-1)*
                 `P1'.`P1'*`P4'.`P4'/`P5'.`P5'/`Q'.`Q'
          +acc(mncx1+mncx4-3+ep)/(mncx1-1)*`P1'.`P1'/`Q'.`Q'
          +acc(mncx1+mncx4-3+ep)/(mncx4-1)*`P4'.`P4'/`Q'.`Q'
        );
    endif;
  endrepeat;
  repeat;
    if ( match(`E5'/`P1'.`P1'/`P4'.`P4'/`P2'.`P2'^2/`P3'.`P3'^2) );
      id  1/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P5'.`P5'^mncx5?*`E5' =
        1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P5'.`P5'^mncx5*`E5' * (
          +acc(ep+mncx5)*acc(1-2*ep-mncx5)/(mncx2-1)/(mncx3-1)*
                 `P2'.`P2'*`P3'.`P3'/`P5'.`P5'/`Q'.`Q'
          +acc(mncx2+mncx3-3+ep)/(mncx2-1)*`P2'.`P2'/`Q'.`Q'
          +acc(mncx2+mncx3-3+ep)/(mncx3-1)*`P3'.`P3'/`Q'.`Q'
        );
    endif;
  endrepeat;
endif;

#call ACCU(Reduction 2 loops)

if ( count(`E5',1) == 0 );
  if ( count(`E2',1,`E3',1) == 0 );
    if ( ( match(1/`P2'.`P2'/`P3'.`P3'/`P5'.`P5') > 0 )
	&& ( ( count(`E1',1) > 0 ) || ( count(`P1'.`P1',1) < 0 ) )
	&& ( ( count(`E4',1) > 0 ) || ( count(`P4'.`P4',1) < 0 ) ) );
      #call triangl2(`P5',`P1',`P4',`P2',`P3',`E1',`E4')
    endif;
  else;
    if ( ( match(1/`P1'.`P1'/`P4'.`P4'/`P5'.`P5') > 0 )
	&& ( ( count(`E2',1) > 0 ) || ( count(`P2'.`P2',1) < 0 ) )
	&& ( ( count(`E3',1) > 0 ) || ( count(`P3'.`P3',1) < 0 ) ) );
      #call triangl2(`P5',`P2',`P3',`P1',`P4',`E2',`E3')
    endif;
  endif;
else;
  repeat;
    if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4') > 0 );
      if ( count(`P1'.`P1',1) < count(`P4'.`P4',1) );
        multiply replace_(`P1',`P4',`P4',`P1',`P2',`P3',`P3',`P2');
      endif;
      if ( count(`P3'.`P3',1) < count(`P4'.`P4',1) );
        multiply replace_(`P3',`P4',`P4',`P3',`P2',`P1',`P1',`P2');
        if ( count(`P1'.`P1',1) < count(`P4'.`P4',1) );
          multiply replace_(`P1',`P4',`P4',`P1',`P2',`P3',`P3',`P2');
        endif;
      else;
        if ( count(`P2'.`P2',1) < count(`P4'.`P4',1) );
          multiply replace_(`P2',`P4',`P4',`P2',`P3',`P1',`P1',`P3');
        endif;
      endif;
      if ( count(`P4'.`P4',1) < -1 );
        id 1/`P1'.`P1'^mncx1?/`P4'.`P4'^mncx4?*`E5'^mncy5?/`P5'.`P5'^mncx5? =
           1/`P1'.`P1'^mncx1/`P4'.`P4'^mncx4*`E5'^mncy5/`P5'.`P5'^mncx5*(
             +acc((2*mncx1+mncx4+mncx5+mncy5*ep-5+2*ep)/(mncx4-1))*`P4'.`P4'
             +`P1'.`P1'
             +acc((mncx5+mncy5*ep)/(mncx4-1))*`P1'.`P1'*`P4'.`P4'/`P5'.`P5'
             -acc((mncx5+mncy5*ep)/(mncx4-1))*`P2'.`P2'*`P4'.`P4'/`P5'.`P5'
           )/`Q'.`Q';
      endif;
    endif;
  endrepeat;
  if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4') > 0 );
*
*   Here we substitute from the table
*
    id `INTS'/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'*`E5'/`P5'.`P5'^mncx5? =
       mncTabTwo(mncx5)*`EQ'^3/`Q'.`Q'^mncx5;
  endif;
endif;
#endprocedure
*--#] newtwo : 
*--#[ noplane :
#procedure noplane(P1,P2,P3,P4,P5,P6,P7,P8,Q,INTS)
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 P1 /     \  P2   /    \ P3
*                   /       v     /      \
*                  /      P7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      P8 /   \        / 
*                   \       ^     \      /
*                 P6 \     /  P5   \    / P4
*                     \->------>----->-/
*
*   Express everything in powers of pi.pi, Q.Q and p2.Q;
*   The only difficult relation here is the one for p1.p3
*   It is derived by squaring:
*   p1-p3 = p6-p4 = p5+p8-p4
*   and p2-Q = p4+p8
*
*  id  `P5'.P?!{`P5'} = `P6'.P-`P8'.P;
*  id  `P4'.P?!{`P4'} = `P3'.P-Q.P;
*#call ACCU(moms 1)
*  id  `P6'.P?!{`P6'} = `P1'.P-Q.P;
*#call ACCU(moms 2)
*  id  `P7'.P?!{`P7'} = `P2'.P-`P1'.P;
*#call ACCU(moms 3)
*  id  `P8'.P?!{`P8'} = `P2'.P-`P3'.P;
*#call ACCU(moms 4)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU(dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU(dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU(dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
#call ACCU(dots 4)
  id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU(dots 5)
*
*   First step: eliminate the powers of `Q'.`P2'
*   Equation 3.18 hasn't been checked yet.
*   Note how common factors are kept together in acc till the end.
*   This trick allows us to do an 'intermediate sort' in the argument
*   of acc, thereby making in the end only the terms that are necessary.
*
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'*`Q'.`P2') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8?*`Q'.`P2'^mncx9? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*`Q'.`P2'^mncx9*`Q'.`Q'/`Q'.`P2'/2*(
      +acc(3-2*mncx2-mncx1-mncx3+mncx9-2*ep)
      +mncx1*`P7'.`P7'/`P1'.`P1'-mncx1*`P2'.`P2'/`P1'.`P1'
      +mncx3*`P8'.`P8'/`P3'.`P3'-mncx3*`P2'.`P2'/`P3'.`P3'
      +2*acc(mncx9-1)*`P2'.`P2'/`Q'.`P2'/2
    )*mncdeno(7-mncx1-mncx2-mncx3-mncx4-mncx5-mncx6-mncx7-mncx8+mncx9,-4);
#ifdef `LONGINT'
id  mncdeno(0,-4) = -1/4/ep;
id  mncdeno(mncx1?,-4) = mncaccm(1-4*ep/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
#endif
#call ACCU(Eliminate `Q'.`P2')
*
*   Next are four recursions that reduce the powers of the propagators
*   that connect to `Q' to 1.
*
#ifdef `LONGINT'
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
#call ACCU(Preparation)
#endif
label 6;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx1+2*mncx2+mncx5+mncx6+2*mncx7+mncx8-9+4*ep)*`P6'.`P6'
      +acc(mncx6-1)*`P1'.`P1'
      +mncx8*`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
      -mncx8*`P3'.`P3'*`P6'.`P6'/`P8'.`P8'
      +mncx5*`P6'.`P6'*`P7'.`P7'/`P5'.`P5'
      -mncx5*`P4'.`P4'*`P6'.`P6'/`P5'.`P5'
    )/(mncx6-1);
label 1;
while ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx6+2*mncx5+mncx2+mncx1+2*mncx8+mncx7-9+4*ep)*`P1'.`P1'
      +acc(mncx1-1)*`P6'.`P6'
      +mncx7*`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
      -mncx7*`P4'.`P4'*`P1'.`P1'/`P7'.`P7'
      +mncx2*`P1'.`P1'*`P8'.`P8'/`P2'.`P2'
      -mncx2*`P3'.`P3'*`P1'.`P1'/`P2'.`P2'
    )/(mncx1-1);
label 3;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx4+2*mncx5+mncx2+mncx3+2*mncx7+mncx8-9+4*ep)*`P3'.`P3'
      +acc(mncx3-1)*`P4'.`P4'
      +mncx8*`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
      -mncx8*`P6'.`P6'*`P3'.`P3'/`P8'.`P8'
      +mncx2*`P3'.`P3'*`P7'.`P7'/`P2'.`P2'
      -mncx2*`P1'.`P1'*`P3'.`P3'/`P2'.`P2'
    )/(mncx3-1);
label 4;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'^2
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8/`Q'.`Q'*(
      +acc(2*mncx3+2*mncx2+mncx5+mncx4+2*mncx8+mncx7-9+4*ep)*`P4'.`P4'
      +acc(mncx4-1)*`P3'.`P3'
      +mncx7*`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
      -mncx7*`P1'.`P1'*`P4'.`P4'/`P7'.`P7'
      +mncx5*`P4'.`P4'*`P8'.`P8'/`P5'.`P5'
      -mncx5*`P6'.`P6'*`P4'.`P4'/`P5'.`P5'
    )/(mncx4-1);
*
*   Now we have that in the 'active terms' the powers of `P1'.`P1', `P3'.`P3',
*   `P4'.`P4' and `P6'.`P6' is 1 and the power of `Q'.`P2' is zero.
*   The final recursion is for lines that don't touch the outside.
*
*   Remark: it seems better to combine this recursion more directly
*   with the above recursions.This can give:
*   1: 5 a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1
*   2: 2 mncx5=1 ( a: mncx7=mncx8=1 b: mncx7>1,mncx8=1 c: mncx7=1,mncx8>1 d: mncx7>1,mncx8>1 )
*   3: 8 mncx2=mncx5=1
*   4: 7 mncx2=mncx5=mncx8=1
*
if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1) > `INNOTABL' );
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'^2/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P5'.`P5'/`Q'.`Q'
      +acc(mncx5-1)*mncx4*`P7'.`P7'/`P4'.`P4'
      +acc(mncx5-1)*mncx6*`P8'.`P8'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx4*`P5'.`P5'/`P4'.`P4'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx5+mncx6+mncx7+mncx8-9+4*ep)*mncx6*`P5'.`P5'/`P6'.`P6'
    )/(mncx5-1)*mncdeno(mncx4+mncx6+2*mncx5-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'^2/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P2'.`P2'/`Q'.`Q'
      +acc(mncx2-1)*mncx3*`P8'.`P8'/`P3'.`P3'
      +acc(mncx2-1)*mncx1*`P7'.`P7'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx3*`P2'.`P2'/`P3'.`P3'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx2+mncx6+mncx7+mncx8-9+4*ep)*mncx1*`P2'.`P2'/`P1'.`P1'
    )/(mncx2-1)*mncdeno(mncx3+mncx1+2*mncx2-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'^2) > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx1+2*mncx2+2*mncx4+mncx3+2*mncx5+mncx6+2*mncx7+2*mncx8-14+6*ep)
        +mncx3*`P4'.`P4'/`P3'.`P3'+mncx6*`P1'.`P1'/`P6'.`P6'
      )*`P8'.`P8'/`Q'.`Q'
      +acc(mncx8-1)*mncx3*`P2'.`P2'/`P3'.`P3'
      +acc(mncx8-1)*mncx6*`P5'.`P5'/`P6'.`P6'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx3*`P8'.`P8'/`P3'.`P3'
      -acc(mncx1+mncx2+mncx3+mncx4+2*mncx8+mncx6+mncx7+mncx5-9+4*ep)*mncx6*`P8'.`P8'/`P6'.`P6'
    )/(mncx8-1)*mncdeno(mncx3+mncx6+2*mncx8-4,2);
  if ( count(`P3'.`P3',1) < -1 ) goto 3;
  if ( count(`P6'.`P6',1) < -1 ) goto 6;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;

while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
    /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'^2/`P8'.`P8') > 0 );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
      +acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8-8+4*ep)*(
        +acc(2*mncx6+2*mncx2+2*mncx3+mncx4+2*mncx5+mncx1+2*mncx7+2*mncx8-14+6*ep)
        +mncx4*`P3'.`P3'/`P4'.`P4'+mncx1*`P6'.`P6'/`P1'.`P1'
      )*`P7'.`P7'/`Q'.`Q'
      +acc(mncx7-1)*mncx4*`P5'.`P5'/`P4'.`P4'
      +acc(mncx7-1)*mncx1*`P2'.`P2'/`P1'.`P1'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx4*`P7'.`P7'/`P4'.`P4'
      -acc(mncx1+mncx5+mncx3+mncx4+2*mncx7+mncx6+mncx2+mncx8-9+4*ep)*mncx1*`P7'.`P7'/`P1'.`P1'
    )/(mncx7-1)*mncdeno(mncx4+mncx1+2*mncx7-4,2);
  if ( count(`P4'.`P4',1) < -1 ) goto 4;
  if ( count(`P1'.`P1',1) < -1 ) goto 1;
  if ( count(`P2'.`P2',-1,`P5'.`P5',-1,`P7'.`P7',-1,`P8'.`P8',-1)
     <= `INNOTABL' ) goto 9;
endwhile;
*
*   If we ever get here (luckily we have to do this only at the beginning
*   of the program and for rather few terms), the only interesting integral
*   left is the fundamental integral below:
*
endif;
label 9;
*
*	Here we take those integrals that have been tabulated
*
if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
     /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') );
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
	if ( ( count(`P2'.`P2',1) > count(`P7'.`P7',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P7'.`P7',1) )
	  && ( count(`P8'.`P8',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P7',`P7',`P2',`P8',`P5',`P5',`P8');
	if ( ( count(`P2'.`P2',1) > count(`P8'.`P8',1) )
	|| ( ( count(`P2'.`P2',1) == count(`P8'.`P8',1) )
	  && ( count(`P7'.`P7',1) > count(`P5'.`P5',1) ) ) )
		multiply replace_(`P2',`P8',`P8',`P2',`P7',`P5',`P5',`P7');
	if ( count(`P2'.`P2',1) > count(`P5'.`P5',1) )
		multiply replace_(`P2',`P5',`P5',`P2');
	if ( count(`P7'.`P7',1) > count(`P8'.`P8',1) )
		multiply replace_(`P7',`P8',`P8',`P7');
  id `INTS'/`P1'.`P1'/`P2'.`P2'^mncx2?/`P3'.`P3'/`P4'.`P4'
           /`P5'.`P5'^mncx5?/`P6'.`P6'/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
           mncnoptab(mncx2,mncx7,mncx8,mncx5)*mnceq^3/`Q'.`Q'^(mncx2+mncx5+mncx7+mncx8-2);
endif;
*
*   The value will only be substituted when the routine subint is
*   invoked. This way we can keep an eye on the accuracy of the calculation.
*
id  mncdeno(0,mncx1?) = 1/mncx1/ep;
id  mncdeno(mncx1?,mncx2?) = mncaccm(1+ep*mncx2/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
*
#endprocedure
*--#] noplane : 
*--#[ one :
#procedure one(P,PQ,Q,EP,EPQ,EQ,INT)
*
*   Routine for the reducetion of one loop integrals.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*   Method involves a reduction to a standard function mncG.
*   One problem is the presence of loopmomenta in the numerator.
*   The two propagators are P and P-Q (=PQ) in which Q is the external
*   momentum.
*
*   The formula we use is (3.1)
*   This means that we have to find a way to take the d'Alembertian (dal)
*   of a polynomial in dotproducts. Such is done with the help of the
*   noncommuting(!) function mncFQ.
*	The use of the function distrib_ avoids the generation of double
*	terms. They can speed things up very much over the conventional
*	differentiation by commutation. Example:
*	8 FQ, 3 d'Alembertians: commutation: 229.7 sec, distrib_: 13.6 sec
*	The simple cases have dedicated code.
*
*   Recoded by J.A.M.Vermaseren 4-nov-1990
*
*   We start with some trivialities
*
id  `P'.`PQ' = `P'.`P'/2+`PQ'.`PQ'/2-`Q'.`Q'/2;
id  `PQ'.mncp?!{`PQ'} = `P'.mncp-`Q'.mncp;
id	`P'.`Q' = `P'.`P'/2+`Q'.`Q'/2-`PQ'.`PQ'/2;
if ( ( count(`EP',1) == 0 ) && ( count(`P'.`P',1) >= 0 ) ) discard;
if ( ( count(`EPQ',1) == 0 ) && ( count(`PQ'.`PQ',1) >= 0 ) ) discard;
totensor,nosquare,mncFQ,`P';
*
*   Now relation (3.1) after which we don't need mncx anymore
*
if ( count(mncFQ,1) == 0 );
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'
        *mncG(mncx1,mncy1,mncx2,mncy2,0,0);
else;
if ( match(mncFQ(mnci1?)) );
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2?*mncFQ(mnci1?) =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'
        *mncG(mncx1,mncy1,mncx2,mncy2,1,0)*`Q'(mnci1);
else;
if ( match(mncFQ(mnci1?,mnci2?)) );
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2?*mncFQ(mnci1?,mnci2?) =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'*(
        +mncG(mncx1,mncy1,mncx2,mncy2,2,0)*`Q'(mnci1)*`Q'(mnci2)
        +mncG(mncx1,mncy1,mncx2,mncy2,2,1)*`Q'.`Q'*d_(mnci1,mnci2)/2
		);
else;
	id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2?*mncFQ(?a) =
        `Q'.`Q'^2/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`EQ'^mncy1*`EQ'^mncy2*`EQ'
        *sum_(mncj,0,integer_(nargs_(?a)/2),mncG(mncx1,mncy1,mncx2,mncy2,nargs_(?a),mncj)
		*`Q'.`Q'^mncj/2^mncj*distrib_(1,2*mncj,mncdel,mncFQ,?a));
	tovector,mncFQ,`Q';
	id	mncdel(?a) = dd_(?a);
endif;
endif;
endif;
*
id  mncG(mncx1?,mncy1?,0,0,?a) = 0;
id  mncG(0,0,?a) = 0;
id  mncG(2,0,1,0,0,0) = mncG(1,0,2,0,0,0);
*

#endprocedure
*--#] one : 
*--#[ one4 :
#procedure one4(P,PQ,Q,EP,EPQ,EQ,P1,P2,P3,P4,P5,INT)
*
*   The procedure one4 does an integral of type one4 in which
*   P1-P5 are the 5 momenta in the sub two loop part, P is its
*   momentum flow, Q is the overall momentum flow and PQ = P-Q
*
*   Note that the central formula (B6 in ref 9b) is wrong
*   This can be tested by trying A16 on P.p1^2*P.p2^2. This shows
*   that it isn't an identity operator. Also the first two arguments
*   of the mncG function in B6 should be exchanged.
*
*   Recoded from the old one4 by J.A.M.Vermaseren, 25-mar-1993
*
id,many,mncq1?{`P1',`P2',`P3',`P4',`P5'}.mncq2?{`P1',`P2',`P3',`P4',`P5'}^mncx1?
        = mncq1.mncq2^mncx1*`P'.`P'^mncx1/`Q'.`Q'^mncx1;
multiply `EP'^2/`EQ'^2*`P'.`P'^4/`Q'.`Q'^4;
id  `Q'.`P' = `P'.`P'/2+`Q'.`Q'/2-`PQ'.`PQ'/2;
id  `Q'.`PQ' = `P'.`P'/2-`Q'.`Q'/2-`PQ'.`PQ'/2;
if ( ( count(`EPQ',1) == 0 ) && ( count(`PQ'.`PQ',1) >= 0 ) ) discard;
totensor,nosquare,mncFQ,`Q';
if ( count(mncFQ,1) == 0 );
id  `INT'/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        1/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*
        mncG(mncx1,mncy1,mncx2,mncy2,0,0);
elseif ( match(mncFQ(mnci1?)) );
id  `INT'*mncFQ(mnci1?)/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        1/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*`Q'(mnci1)*
        mncG(mncx1,mncy1,mncx2,mncy2,1,0);
elseif ( match(mncFQ(mnci1?,mnci2?)) );
id  `INT'*mncFQ(mnci1?,mnci2?)/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        1/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*
        (mncG(mncx1,mncy1,mncx2,mncy2,2,0)*`Q'(mnci1)*`Q'(mnci2)
        -mncG(mncx1,mncy1,mncx2,mncy2,2,0)*d_(mnci1,mnci2)*`Q'.`Q'/2*acc(mncpoch(3,1))
        +mncG(mncx1-1,mncy1,mncx2,mncy2,0,0)*acc(mncpoch(3,1))*d_(mnci1,mnci2)*`Q'.`Q'/2);
else;
id  `INT'*mncFQ(?a)/`P'.`P'^mncx1?/`PQ'.`PQ'^mncx2?*`EP'^mncy1?*`EPQ'^mncy2? =
        mncFQ(?a)/`Q'.`Q'^mncx1/`Q'.`Q'^mncx2*`Q'.`Q'^2*`EQ'*`EQ'^mncy1*`EQ'^mncy2*
        sum_(mncs,0,integer_(nargs_(?a)/2),mncG(mncx1-mncs,mncy1,mncx2,mncy2,nargs_(?a)-2*mncs,0)
        *acc(mncpoch(nargs_(?a)+2-mncs,mncs))*`Q'.`Q'^mncs
        *sum_(mncj,0,integer_(nargs_(?a)/2)-mncs,sign_(mncj)*`Q'.`Q'^mncj
*   the original mncy/4 becomes mncy/2 when we consider the normalization of 
*   the distrib_ to expand the mncFQ.
        *mncy^mncj*mncy^mncs/2^mncj/2^mncs*acc(mncpoch(nargs_(?a)+1-2*mncs,mncj))
        ));

id  mncy^mncs?*mncFQ(?a) = fac_(mncs)*distrib_(1,2*mncs,mncdel,mncFQ,?a);
tovector,mncFQ,`Q';
id  mncdel(?a) = dd_(?a);
endif;
#endprocedure

*--#] one4 : 
*--#[ pochtabl :
#procedure pochtabl(NN)
*  #[ Declarations :  The tables and their variables. Commentary.
*
*   The variable ep should be declared in the rest of the program.
*   It has a power limitation of 6.
*   Note the funny convention:
*   When the argument of mncPO or mncPOINV is 0 or less we have
*   taken out an overal factor of 1/mncx/ep, cq. x*ep. This is to
*   avoid a temporary anomalous number of powers of ep which could
*   destroy the accuracy.
*
#if ( `NN' > 4 )
#if ( `NN' > 6 )
#if ( `NN' > 8 )
#if ( `NN' > 10 )
#if ( `NN' > 12 )
#if ( `NN' > 14 )
#if ( `NN' > 16 )
#if ( `NN' > 18 )
#if ( `NN' > 20 )
#if ( `NN' > 24 )
#message Value of parameter in pochtabl readjusted to 24
#endif
#define N "24"
#else
#define N "20"
#endif
#else
#define N "18"
#endif
#else
#define N "16"
#endif
#else
#define N "14"
#endif
#else
#define N "12"
#endif
#else
#define N "10"
#endif
#else
#define N "8"
#endif
#else
#define N "6"
#endif
#else
#define N "4"
#endif
*
*   The parameter N indicates how many elements we need on the
*   positive side.
*
CTable,check,strict,mncPO({-`N'+1}:`N',mncx?);
CTable,check,strict,mncPOINV({-`N'+1}:`N',mncx?);
*
*  #] Declarations : 
*  #[ mncPO-neg :  mncPO negative values
*
*   Note that we should divide the zero and negative formulae
*   here by (mncx*ep). The actual value of mncPO(0) is 1/mncx/ep.
*
fill mncPO(0) = 1;
fill mncPO(-1) = - 1 - mncx*ep - mncx^2*ep^2 - mncx^3*ep^3
    - mncx^4*ep^4 - mncx^5*ep^5 - mncx^6*ep^6;
fill mncPO(-2) =
    + 1/2 + 3/4*mncx*ep + 7/8*mncx^2*ep^2 + 15/16*mncx^3*ep^3
    + 31/32*mncx^4*ep^4 + 63/64*mncx^5*ep^5 + 127/128*mncx^6*ep^6;
fill mncPO(-3) =
    - 1/6
    - 11/36*mncx*ep
    - 85/216*mncx^2*ep^2
    - 575/1296*mncx^3*ep^3
    - 3661/7776*mncx^4*ep^4
    - 22631/46656*mncx^5*ep^5
    - 137845/279936*mncx^6*ep^6;
#if ( `N' > 4 )
fill mncPO(-4) =
    + 1/24
    + 25/288*mncx*ep
    + 415/3456*mncx^2*ep^2
    + 5845/41472*mncx^3*ep^3
    + 76111/497664*mncx^4*ep^4
    + 952525/5971968*mncx^5*ep^5
    + 11679655/71663616*mncx^6*ep^6;
fill mncPO(-5) =
    - 1/120
    - 137/7200*mncx*ep
    - 12019/432000*mncx^2*ep^2
    - 874853/25920000*mncx^3*ep^3
    - 58067611/1555200000*mncx^4*ep^4
    - 3673451957/93312000000*mncx^5*ep^5
    - 226576032859/5598720000000*mncx^6*ep^6;
#if ( `N' > 6 )
fill mncPO(-6) =
    + 1/720
    + 49/14400*mncx*ep
    + 13489/2592000*mncx^2*ep^2
    + 336581/51840000*mncx^3*ep^3
    + 68165041/9331200000*mncx^4*ep^4
    + 483900263/62208000000*mncx^5*ep^5
    + 270127056529/33592320000000*mncx^6*ep^6;
fill mncPO(-7) =
    - 1/5040
    - 121/235200*mncx*ep
    - 726301/889056000*mncx^2*ep^2
    - 129973303/124467840000*mncx^3*ep^3
    - 187059457981/156829478400000*mncx^4*ep^4
    - 28139924320343/21956126976000000*mncx^5*ep^5
    - 36845364451242061/27664719989760000000*mncx^6*ep^6;
#if ( `N' > 8 )
fill mncPO(-8) =
    + 1/40320
    + 761/11289600*mncx*ep
    + 3144919/28449792000*mncx^2*ep^2
    + 1149858589/7965941760000*mncx^3*ep^3
    + 3355156783231/20074173235200000*mncx^4*ep^4
    + 339302688554687/1873589501952000000*mncx^5*ep^5
    + 2678744365563671119/14164336634757120000000*mncx^6*ep^6;
fill mncPO(-9) =
    - 1/362880
    - 7129/914457600*mncx*ep
    - 30300391/2304433152000*mncx^2*ep^2
    - 101622655189/5807171543040000*mncx^3*ep^3
    - 300222042894631/14634072288460800000*mncx^4*ep^4
    - 826117151879597149/36877862166921216000000*mncx^5*ep^5
    - 2184117445022203447471/92932212660641464320000000*mncx^6*ep^6;
#if ( `N' > 10 )
fill mncPO(-10) =
    + 1/3628800
    + 7381/9144576000*mncx*ep
    + 32160403/23044331520000*mncx^2*ep^2
    + 21945415349/11614343086080000*mncx^3*ep^3
    + 327873266234371/146340722884608000000*mncx^4*ep^4
    + 908741214970658641/368778621669212160000000*mncx^5*ep^5
    + 2413120231194809425003/929322126606414643200000000*mncx^6*ep^6;
fill mncPO(-11) =
    - 1/39916800
    - 83711/1106493696000*mncx*ep
    - 4102360483/30672005253120000*mncx^2*ep^2
    - 31276937512951/170045597123297280000*mncx^3*ep^3
    - 5194481903600608411/23568319761289003008000000*mncx^4*ep^4
    - 159443775809313077987411/653313823782931163381760000000*mncx^5*ep^5
    - 4676788004935176736296015403/18109859195262851848942387200000000*mncx^6*ep^6;
#if ( `N' > 12 )
fill mncPO(-12) =
    + 1/479001600
    + 86021/13277924352000*mncx*ep
    + 4301068993/368064063037440000*mncx^2*ep^2
    + 33264031387717/2040547165479567360000*mncx^3*ep^3
    + 5578681466128739761/282819837135468036096000000*mncx^4*ep^4
    + 172330529996070466835321/7839765885395173960581120000000*mncx^5*ep^5
    + 5074871529226099514685606913/217318310343154222187308646400000000*mncx^6*ep^6;
fill mncPO(-13) =
    - 1/6227020800
    - 1145993/2243969215488000*mncx*ep
    - 758647585777/808636746493255680000*mncx^2*ep^2
    - 77287019174361937/58280067593261923368960000*mncx^3*ep^3
    - 170044702211669500782121/105009025789539333526192128000000*mncx^4*ep^4
    - 68698758619138470404367234173/
   37841052533518394229498595246080000000*mncx^5*ep^5
    - 26399765160034818571989179349406177/
   13636401690978688544542113782877388800000000*mncx^6*ep^6;
#if ( `N' > 14 )
fill mncPO(-14) =
    + 1/87178291200
    + 1171733/31415569016832000*mncx*ep
    + 112686856171/1617273492986511360000*mncx^2*ep^2
    + 81347802723340093/815920946305666927165440000*mncx^3*ep^3
    + 180514164422163370751221/1470126361053550669366689792000000*mncx^4*ep^4
    + 10477884744480707938214808959/
   75682105067036788458997190492160000000*mncx^5*ep^5
    + 28287670433295352528296723627638797/
   190909623673701639623589592960283443200000000*mncx^6*ep^6;
fill mncPO(-15) =
    - 1/1307674368000
    - 1195757/471233535252480000*mncx*ep
    - 476696711/99016744468561920000*mncx^2*ep^2
    - 17055178843123409/2447762838917000781496320000*mncx^3*ep^3
    - 190757504835343290196621/22051895415803260040500346880000000*mncx^4*ep^4
    - 11132564501075606110169612231/
   1135231576005551826884957857382400000000*mncx^5*ep^5
    - 6031962308062447011326345395460321/
   572728871021104918870768778880850329600000000*mncx^6*ep^6;
#if ( `N' > 16 )
fill mncPO(-16) =
    + 1/20922789888000
    + 2436559/15079473128079360000*mncx*ep
    + 96568406789/310516510653410181120000*mncx^2*ep^2
    + 142531324182321979/313313643381376100031528960000*mncx^3*ep^3
    + 3212628164810309981747311/5645285226445634570368088801280000000*mncx^4*ep^4
    + 376915326274973740257971537677/
   581238566914842535365098422979788800000000*mncx^5*ep^5
    + 81962999787375055541354912877997039/
   117294872785122287384733445914798147502080000000*mncx^6*ep^6;
fill mncPO(-17) =
    - 1/355687428096000
    - 42142223/4357967734014935040000*mncx*ep
    - 28776062218037/1525567616840204219842560000*mncx^2*ep^2
    - 729291672694244960123/26168268808855913250733330268160000*mncx^3*ep^3
    - 281462294311726805677013376031/
   8015497745765419364179123461119016960000000*mncx^4*ep^4
    - 564145222241140781833967990767603949/
   14029686014368128821510003376465837765427200000000*mncx^5*ep^5
    - 10461164856476842638038161189836649078663547/
   240653112241754467740880813276977714544308859699200000000*mncx^6*ep^6;
#if ( `N' > 18 )
fill mncPO(-18) =
    + 1/6402373705728000
    + 14274301/26147806404089610240000*mncx*ep
    + 29608882035581/27460217103123675957166080000*mncx^2*ep^2
    + 50500501069854396349/31401922570627095900879996321792000*mncx^3*ep^3
    + 294352799712312489617077371031/
   144278959423777548555224222300142305280000000*mncx^4*ep^4
    + 65863120942796227591592510480739821/
   28059372028736257643020006752931675530854400000000*mncx^5*ep^5
    + 88208355135479668752967444674123414750223/
   34654048162812643354686837111884790894380475796684800000*mncx^6*ep^6;
fill mncPO(-19) =
    - 1/121645100408832000
    - 275295799/9439358111876349296640000*mncx*ep
    - 1568274265798307/26907089872903613341457448960000*mncx^2*ep^2
    - 1794683268312579709384043/
   20461649756633468824492910003261276160000*mncx^3*ep^3
    - 40009517970859535080774906095604951/
   357248987150256164200042141613160061961502720000000*mncx^4*ep^4
    - 170864658958309558725823727346322640908759/
   1320077877398654557458859718317620008155187930726400000000*mncx^5*ep^5
    - 545107754958038941477256969841397265941063458146891/
   3872034286835386580830089611201274450551405153503756576358400000000*mncx^6*ep^6;
#if ( `N' > 20 )
fill mncPO(-20) =
    + 1/2432902008176640000
    + 11167027/7551486489501079437312000*mncx*ep
    + 11256448518043769/3766992582206505867804042854400000*mncx^2*ep^2
    + 9279131712715653650968723/
   2046164975663346882449291000326127616000000*mncx^3*ep^3
    + 41629602590344731254886672725930611/
   7144979743005123284000842832263201239230054400000000*mncx^4*ep^4
    + 7142239112579651595742062778098987074987/
   1056062301918923645967087774654096006524150344581120000000*mncx^5*ep^5
    + 571294651960644279934630828168658674310905345370231/
   77440685736707731616601792224025489011028103070075131527168000000000*mncx^6*ep^6;
fill mncPO(-21) =
    - 1/51090942171709440000
    - 18858053/264302027132537780305920000*mncx*ep
    - 80676574383943103/553747909584356362567194299596800000*mncx^2*ep^2
    - 9577241336253249489726083/
   42969464488930284531435111006848679936000000*mncx^3*ep^3
    - 6174587158661922297334017385371973/
   21434939229015369852002528496789603717690163200000000*mncx^4*ep^4
    - 111696754789037742399995916535691943099157/
   332659625104460948479632649016040242055107358543052800000000*mncx^5*ep^5
    - 597296825451676635924546421568548733116332437242151/
   1626254400470862363948637636704535269231590164471577762070528000000000*mncx^6*ep^6;
fill mncPO(-22) =
    + 1/1124000727777607680000
    + 6364399/1938214865638610388910080000*mncx*ep
    + 82494882923667143/12182454010855839976478274591129600000*mncx^2*ep^2
    + 9868213987506291289829963/
   945328218756466259691572442150670958592000000*mncx^3*ep^3
    + 6398344963543032449814395864411773/
   471568663038338136744055626929371281789183590400000000*mncx^4*ep^4
    + 116210352073359830867133385439115668950093/
   7318511752298140866551918278352885325212361887947161600000000*mncx^5*ep^5
    + 623120053293078163170149467651030900158655068872591/
   35777596810358972006870028007499775923094983618374710765551616000000000*mncx^6*ep^6;
fill mncPO(-23) =
    - 1/25852016738884976640000
    - 444316699/3075946991768474687200296960000*mncx*ep
    - 44570695662918553607/148223917950083004993811166950273843200000*mncx^2*ep^2
    - 123525135034106281845251414461/
   264541594065028274578349323783885911723343872000000*mncx^3*ep^3
    - 264591239933345908907390540426325365899/
   433596809052309485437949317999638620563548468255129600000000*mncx^4*ep^4
    - 776713959740478684849561077289313689586845388571/
   1083402393408403076227243586991318834832866105871976452482662400000000*mncx^5*ep^5
    - 96041208895558385773482948005826382154738052851832630885359/
   121816472052416261093751730181537943909751715221890351995814993148772352000000000
   *mncx^6*ep^6;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
*
*  #] mncPO-neg : 
*  #[ mncPO-pos :  mncPO positive values
*
fill mncPO(1) = 1;
fill mncPO(2) = + 1 + mncx*ep;
fill mncPO(3) = + 2 + 3*mncx*ep + mncx^2*ep^2;
fill mncPO(4) = + 6 + 11*mncx*ep + 6*mncx^2*ep^2 + mncx^3*ep^3;
#if ( `N' > 4 )
fill mncPO(5) = + 24 + 50*mncx*ep + 35*mncx^2*ep^2 + 10*mncx^3*ep^3 + mncx^4*ep^4;
fill mncPO(6) =
       + 120
       + 274*mncx*ep
       + 225*mncx^2*ep^2
       + 85*mncx^3*ep^3
       + 15*mncx^4*ep^4
       + mncx^5*ep^5;
#if ( `N' > 6 )
fill mncPO(7) =
       + 720
       + 1764*mncx*ep
       + 1624*mncx^2*ep^2
       + 735*mncx^3*ep^3
       + 175*mncx^4*ep^4
       + 21*mncx^5*ep^5
       + mncx^6*ep^6;
fill mncPO(8) =
       + 5040
       + 13068*mncx*ep
       + 13132*mncx^2*ep^2
       + 6769*mncx^3*ep^3
       + 1960*mncx^4*ep^4
       + 322*mncx^5*ep^5
       + 28*mncx^6*ep^6;
#if ( `N' > 8 )
fill mncPO(9) =
       + 40320
       + 109584*mncx*ep
       + 118124*mncx^2*ep^2
       + 67284*mncx^3*ep^3
       + 22449*mncx^4*ep^4
       + 4536*mncx^5*ep^5
       + 546*mncx^6*ep^6;
fill mncPO(10) =
       + 362880
       + 1026576*mncx*ep
       + 1172700*mncx^2*ep^2
       + 723680*mncx^3*ep^3
       + 269325*mncx^4*ep^4
       + 63273*mncx^5*ep^5
       + 9450*mncx^6*ep^6;
#if ( `N' > 10 )
fill mncPO(11) =
       + 3628800
       + 10628640*mncx*ep
       + 12753576*mncx^2*ep^2
       + 8409500*mncx^3*ep^3
       + 3416930*mncx^4*ep^4
       + 902055*mncx^5*ep^5
       + 157773*mncx^6*ep^6;
fill mncPO(12) =
       + 39916800
       + 120543840*mncx*ep
       + 150917976*mncx^2*ep^2
       + 105258076*mncx^3*ep^3
       + 45995730*mncx^4*ep^4
       + 13339535*mncx^5*ep^5
       + 2637558*mncx^6*ep^6;
#if ( `N' > 12 )
fill mncPO(13) =
       + 479001600
       + 1486442880*mncx*ep
       + 1931559552*mncx^2*ep^2
       + 1414014888*mncx^3*ep^3
       + 657206836*mncx^4*ep^4
       + 206070150*mncx^5*ep^5
       + 44990231*mncx^6*ep^6;
fill mncPO(14) =
       + 6227020800
       + 19802759040*mncx*ep
       + 26596717056*mncx^2*ep^2
       + 20313753096*mncx^3*ep^3
       + 9957703756*mncx^4*ep^4
       + 3336118786*mncx^5*ep^5
       + 790943153*mncx^6*ep^6;
#if ( `N' > 14 )
fill mncPO(15) =
       + 87178291200
       + 283465647360*mncx*ep
       + 392156797824*mncx^2*ep^2
       + 310989260400*mncx^3*ep^3
       + 159721605680*mncx^4*ep^4
       + 56663366760*mncx^5*ep^5
       + 14409322928*mncx^6*ep^6;
fill mncPO(16) =
       + 1307674368000
       + 4339163001600*mncx*ep
       + 6165817614720*mncx^2*ep^2
       + 5056995703824*mncx^3*ep^3
       + 2706813345600*mncx^4*ep^4
       + 1009672107080*mncx^5*ep^5
       + 272803210680*mncx^6*ep^6;
#if ( `N' > 16 )
fill mncPO(17) =
       + 20922789888000
       + 70734282393600*mncx*ep
       + 102992244837120*mncx^2*ep^2
       + 87077748875904*mncx^3*ep^3
       + 48366009233424*mncx^4*ep^4
       + 18861567058880*mncx^5*ep^5
       + 5374523477960*mncx^6*ep^6;
fill mncPO(18) =
       + 355687428096000
       + 1223405590579200*mncx*ep
       + 1821602444624640*mncx^2*ep^2
       + 1583313975727488*mncx^3*ep^3
       + 909299905844112*mncx^4*ep^4
       + 369012649234384*mncx^5*ep^5
       + 110228466184200*mncx^6*ep^6;
#if ( `N' > 18 )
fill mncPO(19) =
       + 6402373705728000
       + 22376988058521600*mncx*ep
       + 34012249593822720*mncx^2*ep^2
       + 30321254007719424*mncx^3*ep^3
       + 17950712280921504*mncx^4*ep^4
       + 7551527592063024*mncx^5*ep^5
       + 2353125040549984*mncx^6*ep^6;
fill mncPO(20) =
       + 121645100408832000
       + 431565146817638400*mncx*ep
       + 668609730341153280*mncx^2*ep^2
       + 610116075740491776*mncx^3*ep^3
       + 371384787345228000*mncx^4*ep^4
       + 161429736530118960*mncx^5*ep^5
       + 52260903362512720*mncx^6*ep^6;
#if ( `N' > 20 )
fill mncPO(21) =
       + 2432902008176640000
       + 8752948036761600000*mncx*ep
       + 13803759753640704000*mncx^2*ep^2
       + 12870931245150988800*mncx^3*ep^3
       + 8037811822645051776*mncx^4*ep^4
       + 3599979517947607200*mncx^5*ep^5
       + 1206647803780373360*mncx^6*ep^6;
fill mncPO(22) =
       + 51090942171709440000
       + 186244810780170240000*mncx*ep
       + 298631902863216384000*mncx^2*ep^2
       + 284093315901811468800*mncx^3*ep^3
       + 181664979520697076096*mncx^4*ep^4
       + 83637381699544802976*mncx^5*ep^5
       + 28939583397335447760*mncx^6*ep^6;
fill mncPO(23) =
       + 1124000727777607680000
       + 4148476779335454720000*mncx*ep
       + 6756146673770930688000*mncx^2*ep^2
       + 6548684852703068697600*mncx^3*ep^3
       + 4280722865357147142912*mncx^4*ep^4
       + 2021687376910682741568*mncx^5*ep^5
       + 720308216440924653696*mncx^6*ep^6;
fill mncPO(24) =
       + 25852016738884976640000
       + 96538966652493066240000*mncx*ep
       + 159539850276066860544000*mncx^2*ep^2
       + 157375898285941510732800*mncx^3*ep^3
       + 105005310755917452984576*mncx^4*ep^4
       + 50779532534302850198976*mncx^5*ep^5
       + 18588776355051949776576*mncx^6*ep^6;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
*
*  #] mncPO-pos : 
*  #[ mncPOINV-neg :  mncPOINV negative values
*
*   Note that we should multiply the zero and negative formulae
*   here by (mncx*ep). The actual value of mncPOINV(0) is mncx*ep.
*
fill mncPOINV(0) = 1;
fill mncPOINV(-1) = - 1 + mncx*ep;
fill mncPOINV(-2) = + 2 - 3*mncx*ep + mncx^2*ep^2;
fill mncPOINV(-3) = - 6 + 11*mncx*ep - 6*mncx^2*ep^2 + mncx^3*ep^3;
#if ( `N' > 4 )
fill mncPOINV(-4) = + 24 - 50*mncx*ep + 35*mncx^2*ep^2 - 10*mncx^3*ep^3 + mncx^4*ep^4;
fill mncPOINV(-5) =
       - 120
       + 274*mncx*ep
       - 225*mncx^2*ep^2
       + 85*mncx^3*ep^3
       - 15*mncx^4*ep^4
       + mncx^5*ep^5;
#if ( `N' > 6 )
fill mncPOINV(-6) =
       + 720
       - 1764*mncx*ep
       + 1624*mncx^2*ep^2
       - 735*mncx^3*ep^3
       + 175*mncx^4*ep^4
       - 21*mncx^5*ep^5
       + mncx^6*ep^6;
fill mncPOINV(-7) =
       - 5040
       + 13068*mncx*ep
       - 13132*mncx^2*ep^2
       + 6769*mncx^3*ep^3
       - 1960*mncx^4*ep^4
       + 322*mncx^5*ep^5
       - 28*mncx^6*ep^6;
#if ( `N' > 8 )
fill mncPOINV(-8) =
       + 40320
       - 109584*mncx*ep
       + 118124*mncx^2*ep^2
       - 67284*mncx^3*ep^3
       + 22449*mncx^4*ep^4
       - 4536*mncx^5*ep^5
       + 546*mncx^6*ep^6;
fill mncPOINV(-9) =
       - 362880
       + 1026576*mncx*ep
       - 1172700*mncx^2*ep^2
       + 723680*mncx^3*ep^3
       - 269325*mncx^4*ep^4
       + 63273*mncx^5*ep^5
       - 9450*mncx^6*ep^6;
#if ( `N' > 10 )
fill mncPOINV(-10) =
       + 3628800
       - 10628640*mncx*ep
       + 12753576*mncx^2*ep^2
       - 8409500*mncx^3*ep^3
       + 3416930*mncx^4*ep^4
       - 902055*mncx^5*ep^5
       + 157773*mncx^6*ep^6;
fill mncPOINV(-11) =
       - 39916800
       + 120543840*mncx*ep
       - 150917976*mncx^2*ep^2
       + 105258076*mncx^3*ep^3
       - 45995730*mncx^4*ep^4
       + 13339535*mncx^5*ep^5
       - 2637558*mncx^6*ep^6;
#if ( `N' > 12 )
fill mncPOINV(-12) =
       + 479001600
       - 1486442880*mncx*ep
       + 1931559552*mncx^2*ep^2
       - 1414014888*mncx^3*ep^3
       + 657206836*mncx^4*ep^4
       - 206070150*mncx^5*ep^5
       + 44990231*mncx^6*ep^6;
fill mncPOINV(-13) =
       - 6227020800
       + 19802759040*mncx*ep
       - 26596717056*mncx^2*ep^2
       + 20313753096*mncx^3*ep^3
       - 9957703756*mncx^4*ep^4
       + 3336118786*mncx^5*ep^5
       - 790943153*mncx^6*ep^6;
#if ( `N' > 14 )
fill mncPOINV(-14) =
       + 87178291200
       - 283465647360*mncx*ep
       + 392156797824*mncx^2*ep^2
       - 310989260400*mncx^3*ep^3
       + 159721605680*mncx^4*ep^4
       - 56663366760*mncx^5*ep^5
       + 14409322928*mncx^6*ep^6;
fill mncPOINV(-15) =
       - 1307674368000
       + 4339163001600*mncx*ep
       - 6165817614720*mncx^2*ep^2
       + 5056995703824*mncx^3*ep^3
       - 2706813345600*mncx^4*ep^4
       + 1009672107080*mncx^5*ep^5
       - 272803210680*mncx^6*ep^6;
#if ( `N' > 16 )
fill mncPOINV(-16) =
       + 20922789888000
       - 70734282393600*mncx*ep
       + 102992244837120*mncx^2*ep^2
       - 87077748875904*mncx^3*ep^3
       + 48366009233424*mncx^4*ep^4
       - 18861567058880*mncx^5*ep^5
       + 5374523477960*mncx^6*ep^6;
fill mncPOINV(-17) =
       - 355687428096000
       + 1223405590579200*mncx*ep
       - 1821602444624640*mncx^2*ep^2
       + 1583313975727488*mncx^3*ep^3
       - 909299905844112*mncx^4*ep^4
       + 369012649234384*mncx^5*ep^5
       - 110228466184200*mncx^6*ep^6;
#if ( `N' > 18 )
fill mncPOINV(-18) =
       + 6402373705728000
       - 22376988058521600*mncx*ep
       + 34012249593822720*mncx^2*ep^2
       - 30321254007719424*mncx^3*ep^3
       + 17950712280921504*mncx^4*ep^4
       - 7551527592063024*mncx^5*ep^5
       + 2353125040549984*mncx^6*ep^6;
fill mncPOINV(-19) =
       - 121645100408832000
       + 431565146817638400*mncx*ep
       - 668609730341153280*mncx^2*ep^2
       + 610116075740491776*mncx^3*ep^3
       - 371384787345228000*mncx^4*ep^4
       + 161429736530118960*mncx^5*ep^5
       - 52260903362512720*mncx^6*ep^6;
#if ( `N' > 20 )
fill mncPOINV(-20) =
       + 2432902008176640000
       - 8752948036761600000*mncx*ep
       + 13803759753640704000*mncx^2*ep^2
       - 12870931245150988800*mncx^3*ep^3
       + 8037811822645051776*mncx^4*ep^4
       - 3599979517947607200*mncx^5*ep^5
       + 1206647803780373360*mncx^6*ep^6;
fill mncPOINV(-21) =
       - 51090942171709440000
       + 186244810780170240000*mncx*ep
       - 298631902863216384000*mncx^2*ep^2
       + 284093315901811468800*mncx^3*ep^3
       - 181664979520697076096*mncx^4*ep^4
       + 83637381699544802976*mncx^5*ep^5
       - 28939583397335447760*mncx^6*ep^6;
fill mncPOINV(-22) =
       + 1124000727777607680000
       - 4148476779335454720000*mncx*ep
       + 6756146673770930688000*mncx^2*ep^2
       - 6548684852703068697600*mncx^3*ep^3
       + 4280722865357147142912*mncx^4*ep^4
       - 2021687376910682741568*mncx^5*ep^5
       + 720308216440924653696*mncx^6*ep^6;
fill mncPOINV(-23) =
       - 25852016738884976640000
       + 96538966652493066240000*mncx*ep
       - 159539850276066860544000*mncx^2*ep^2
       + 157375898285941510732800*mncx^3*ep^3
       - 105005310755917452984576*mncx^4*ep^4
       + 50779532534302850198976*mncx^5*ep^5
       - 18588776355051949776576*mncx^6*ep^6;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
*
*  #] mncPOINV-neg : 
*  #[ mncPOINV-pos :  mncPOINV positive values
*
fill mncPOINV(1) = 1;
fill mncPOINV(2) = + 1 - mncx*ep + mncx^2*ep^2 - mncx^3*ep^3
    + mncx^4*ep^4 - mncx^5*ep^5 + mncx^6*ep^6;
fill mncPOINV(3) = + 1/2 - 3/4*mncx*ep + 7/8*mncx^2*ep^2 - 15/16*mncx^3*ep^3
    + 31/32*mncx^4*ep^4 - 63/64*mncx^5*ep^5 + 127/128*mncx^6*ep^6;
fill mncPOINV(4) =
    + 1/6
    - 11/36*mncx*ep
    + 85/216*mncx^2*ep^2
    - 575/1296*mncx^3*ep^3
    + 3661/7776*mncx^4*ep^4
    - 22631/46656*mncx^5*ep^5
    + 137845/279936*mncx^6*ep^6;
#if ( `N' > 4 )
fill mncPOINV(5) =
    + 1/24
    - 25/288*mncx*ep
    + 415/3456*mncx^2*ep^2
    - 5845/41472*mncx^3*ep^3
    + 76111/497664*mncx^4*ep^4
    - 952525/5971968*mncx^5*ep^5
    + 11679655/71663616*mncx^6*ep^6;
fill mncPOINV(6) =
    + 1/120
    - 137/7200*mncx*ep
    + 12019/432000*mncx^2*ep^2
    - 874853/25920000*mncx^3*ep^3
    + 58067611/1555200000*mncx^4*ep^4
    - 3673451957/93312000000*mncx^5*ep^5
    + 226576032859/5598720000000*mncx^6*ep^6;
#if ( `N' > 6 )
fill mncPOINV(7) =
    + 1/720
    - 49/14400*mncx*ep
    + 13489/2592000*mncx^2*ep^2
    - 336581/51840000*mncx^3*ep^3
    + 68165041/9331200000*mncx^4*ep^4
    - 483900263/62208000000*mncx^5*ep^5
    + 270127056529/33592320000000*mncx^6*ep^6;
fill mncPOINV(8) =
    + 1/5040
    - 121/235200*mncx*ep
    + 726301/889056000*mncx^2*ep^2
    - 129973303/124467840000*mncx^3*ep^3
    + 187059457981/156829478400000*mncx^4*ep^4
    - 28139924320343/21956126976000000*mncx^5*ep^5
    + 36845364451242061/27664719989760000000*mncx^6*ep^6;
#if ( `N' > 8 )
fill mncPOINV(9) =
    + 1/40320
    - 761/11289600*mncx*ep
    + 3144919/28449792000*mncx^2*ep^2
    - 1149858589/7965941760000*mncx^3*ep^3
    + 3355156783231/20074173235200000*mncx^4*ep^4
    - 339302688554687/1873589501952000000*mncx^5*ep^5
    + 2678744365563671119/14164336634757120000000*mncx^6*ep^6;
fill mncPOINV(10) =
    + 1/362880
    - 7129/914457600*mncx*ep
    + 30300391/2304433152000*mncx^2*ep^2
    - 101622655189/5807171543040000*mncx^3*ep^3
    + 300222042894631/14634072288460800000*mncx^4*ep^4
    - 826117151879597149/36877862166921216000000*mncx^5*ep^5
    + 2184117445022203447471/92932212660641464320000000*mncx^6*ep^6;
#if ( `N' > 10 )
fill mncPOINV(11) =
    + 1/3628800
    - 7381/9144576000*mncx*ep
    + 32160403/23044331520000*mncx^2*ep^2
    - 21945415349/11614343086080000*mncx^3*ep^3
    + 327873266234371/146340722884608000000*mncx^4*ep^4
    - 908741214970658641/368778621669212160000000*mncx^5*ep^5
    + 2413120231194809425003/929322126606414643200000000*mncx^6*ep^6;
fill mncPOINV(12) =
    + 1/39916800
    - 83711/1106493696000*mncx*ep
    + 4102360483/30672005253120000*mncx^2*ep^2
    - 31276937512951/170045597123297280000*mncx^3*ep^3
    + 5194481903600608411/23568319761289003008000000*mncx^4*ep^4
    - 159443775809313077987411/653313823782931163381760000000*mncx^5*ep^5
    + 4676788004935176736296015403/18109859195262851848942387200000000*mncx^6*ep^6;
#if ( `N' > 12 )
fill mncPOINV(13) =
    + 1/479001600
    - 86021/13277924352000*mncx*ep
    + 4301068993/368064063037440000*mncx^2*ep^2
    - 33264031387717/2040547165479567360000*mncx^3*ep^3
    + 5578681466128739761/282819837135468036096000000*mncx^4*ep^4
    - 172330529996070466835321/7839765885395173960581120000000*mncx^5*ep^5
    + 5074871529226099514685606913/217318310343154222187308646400000000*mncx^6*ep^6;
fill mncPOINV(14) =
    + 1/6227020800
    - 1145993/2243969215488000*mncx*ep
    + 758647585777/808636746493255680000*mncx^2*ep^2
    - 77287019174361937/58280067593261923368960000*mncx^3*ep^3
    + 170044702211669500782121/105009025789539333526192128000000*mncx^4*ep^4
    - 68698758619138470404367234173/
   37841052533518394229498595246080000000*mncx^5*ep^5
    + 26399765160034818571989179349406177/
   13636401690978688544542113782877388800000000*mncx^6*ep^6;
#if ( `N' > 14 )
fill mncPOINV(15) =
    + 1/87178291200
    - 1171733/31415569016832000*mncx*ep
    + 112686856171/1617273492986511360000*mncx^2*ep^2
    - 81347802723340093/815920946305666927165440000*mncx^3*ep^3
    + 180514164422163370751221/1470126361053550669366689792000000*mncx^4*ep^4
    - 10477884744480707938214808959/
   75682105067036788458997190492160000000*mncx^5*ep^5
    + 28287670433295352528296723627638797/
   190909623673701639623589592960283443200000000*mncx^6*ep^6;
fill mncPOINV(16) =
    + 1/1307674368000
    - 1195757/471233535252480000*mncx*ep
    + 476696711/99016744468561920000*mncx^2*ep^2
    - 17055178843123409/2447762838917000781496320000*mncx^3*ep^3
    + 190757504835343290196621/22051895415803260040500346880000000*mncx^4*ep^4
    - 11132564501075606110169612231/
   1135231576005551826884957857382400000000*mncx^5*ep^5
    + 6031962308062447011326345395460321/
   572728871021104918870768778880850329600000000*mncx^6*ep^6;
#if ( `N' > 16 )
fill mncPOINV(17) =
    + 1/20922789888000
    - 2436559/15079473128079360000*mncx*ep
    + 96568406789/310516510653410181120000*mncx^2*ep^2
    - 142531324182321979/313313643381376100031528960000*mncx^3*ep^3
    + 3212628164810309981747311/5645285226445634570368088801280000000*mncx^4*ep^4
    - 376915326274973740257971537677/
   581238566914842535365098422979788800000000*mncx^5*ep^5
    + 81962999787375055541354912877997039/
   117294872785122287384733445914798147502080000000*mncx^6*ep^6;
fill mncPOINV(18) =
    + 1/355687428096000
    - 42142223/4357967734014935040000*mncx*ep
    + 28776062218037/1525567616840204219842560000*mncx^2*ep^2
    - 729291672694244960123/26168268808855913250733330268160000*mncx^3*ep^3
    + 281462294311726805677013376031/
   8015497745765419364179123461119016960000000*mncx^4*ep^4
    - 564145222241140781833967990767603949/
   14029686014368128821510003376465837765427200000000*mncx^5*ep^5
    + 10461164856476842638038161189836649078663547/
   240653112241754467740880813276977714544308859699200000000*mncx^6*ep^6;
#if ( `N' > 18 )
fill mncPOINV(19) =
    + 1/6402373705728000
    - 14274301/26147806404089610240000*mncx*ep
    + 29608882035581/27460217103123675957166080000*mncx^2*ep^2
    - 50500501069854396349/31401922570627095900879996321792000*mncx^3*ep^3
    + 294352799712312489617077371031/
   144278959423777548555224222300142305280000000*mncx^4*ep^4
    - 65863120942796227591592510480739821/
   28059372028736257643020006752931675530854400000000*mncx^5*ep^5
    + 88208355135479668752967444674123414750223/
   34654048162812643354686837111884790894380475796684800000*mncx^6*ep^6;
fill mncPOINV(20) =
    + 1/121645100408832000
    - 275295799/9439358111876349296640000*mncx*ep
    + 1568274265798307/26907089872903613341457448960000*mncx^2*ep^2
    - 1794683268312579709384043/
   20461649756633468824492910003261276160000*mncx^3*ep^3
    + 40009517970859535080774906095604951/
   357248987150256164200042141613160061961502720000000*mncx^4*ep^4
    - 170864658958309558725823727346322640908759/
   1320077877398654557458859718317620008155187930726400000000*mncx^5*ep^5
    + 545107754958038941477256969841397265941063458146891/
   3872034286835386580830089611201274450551405153503756576358400000000*mncx^6*ep^6;
#if ( `N' > 20 )
fill mncPOINV(21) =
    + 1/2432902008176640000
    - 11167027/7551486489501079437312000*mncx*ep
    + 11256448518043769/3766992582206505867804042854400000*mncx^2*ep^2
    - 9279131712715653650968723/
   2046164975663346882449291000326127616000000*mncx^3*ep^3
    + 41629602590344731254886672725930611/
   7144979743005123284000842832263201239230054400000000*mncx^4*ep^4
    - 7142239112579651595742062778098987074987/
   1056062301918923645967087774654096006524150344581120000000*mncx^5*ep^5
    + 571294651960644279934630828168658674310905345370231/
   77440685736707731616601792224025489011028103070075131527168000000000*mncx^6*ep^6;
fill mncPOINV(22) =
    + 1/51090942171709440000
    - 18858053/264302027132537780305920000*mncx*ep
    + 80676574383943103/553747909584356362567194299596800000*mncx^2*ep^2
    - 9577241336253249489726083/
   42969464488930284531435111006848679936000000*mncx^3*ep^3
    + 6174587158661922297334017385371973/
   21434939229015369852002528496789603717690163200000000*mncx^4*ep^4
    - 111696754789037742399995916535691943099157/
   332659625104460948479632649016040242055107358543052800000000*mncx^5*ep^5
    + 597296825451676635924546421568548733116332437242151/
   1626254400470862363948637636704535269231590164471577762070528000000000*mncx^6*ep^6;
fill mncPOINV(23) =
    + 1/1124000727777607680000
    - 6364399/1938214865638610388910080000*mncx*ep
    + 82494882923667143/12182454010855839976478274591129600000*mncx^2*ep^2
    - 9868213987506291289829963/
   945328218756466259691572442150670958592000000*mncx^3*ep^3
    + 6398344963543032449814395864411773/
   471568663038338136744055626929371281789183590400000000*mncx^4*ep^4
    - 116210352073359830867133385439115668950093/
   7318511752298140866551918278352885325212361887947161600000000*mncx^5*ep^5
    + 623120053293078163170149467651030900158655068872591/
   35777596810358972006870028007499775923094983618374710765551616000000000*mncx^6*ep^6;
fill mncPOINV(24) =
    + 1/25852016738884976640000
    - 444316699/3075946991768474687200296960000*mncx*ep
    + 44570695662918553607/148223917950083004993811166950273843200000*mncx^2*ep^2
    - 123525135034106281845251414461/
   264541594065028274578349323783885911723343872000000*mncx^3*ep^3
    + 264591239933345908907390540426325365899/
   433596809052309485437949317999638620563548468255129600000000*mncx^4*ep^4
    - 776713959740478684849561077289313689586845388571/
   1083402393408403076227243586991318834832866105871976452482662400000000*mncx^5*ep^5
    + 96041208895558385773482948005826382154738052851832630885359/
   121816472052416261093751730181537943909751715221890351995814993148772352000000000
   *mncx^6*ep^6;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
*
*  #] mncPOINV-pos : 
#endprocedure
*--#] pochtabl : 
*--#[ projectP :
*
#procedure projectP(topo,power)
*
*	Projects out the P, using harmonic projections.
*
id	1/P.Q = 1/Q.Q/mncproexp;
#do mnci = 1,8
id	1/P.p`mnci' = 1/P.p`mnci'/mncproexp;
#enddo
id  P = mncproexp*P;
if ( count(mncproexp,1) > `power' ) discard;

id	mncepexp(mncp?mncpp18[mncn],mncx?) = mncee18[mncn]^mncx/mnceq^mncx;
id	mncepexp(-mncp?mncpp18[mncn],mncx?) = mncee18[mncn]^mncx/mnceq^mncx;
id	mncepexp(-mncp?[mncPp],mncx?) = mncepexp(mncp,mncx);

id  mncepexp([P+Q],mncx?) = mncepexp( mncproexp*2*P.Q/Q.Q,mncx);
id  mncepexp([P-Q],mncx?) = mncepexp(-mncproexp*2*P.Q/Q.Q,mncx);
id  mncepexp(mncp?[mncpp18][D],mncx?)  = mncee18[D]^mncx/mnceq^mncx
    *mncepexp( 2*mncproexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],mncx);
id  mncepexp(mncp?[-mncpp18][D],mncx?) = mncee18[D]^mncx/mnceq^mncx
    *mncepexp(-2*mncproexp*P.mncpp18[D]/mncpp18[D].mncpp18[D],mncx);

#do mnci = 1,8
if ( count([P+p`mnci'].[P+p`mnci'],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P+p`mnci'].[P+p`mnci'] = (
        sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.p`mnci'^mncj/
			p`mnci'.p`mnci'^mncj*sign_(mncj)))*mncproexp^mncx/p`mnci'.p`mnci';
    endrepeat;
endif;
if ( count([P-p`mnci'].[P-p`mnci'],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P-p`mnci'].[P-p`mnci'] = (
        sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.p`mnci'^mncj/
			p`mnci'.p`mnci'^mncj))*mncproexp^mncx/p`mnci'.p`mnci';
    endrepeat;
endif;
#enddo
if ( count([P+Q].[P+Q],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P+Q].[P+Q] =
        (sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.Q^mncj/
			Q.Q^mncj*sign_(mncj)))*mncproexp^mncx/Q.Q;
	endrepeat;
endif;
if ( count([P-Q].[P-Q],1) < 0 );
    repeat;
      id,once,mncproexp^mncx?/[P-Q].[P-Q] =
        (sum_(mncj,0,`power'-mncx,2^mncj*mncproexp^mncj*P.Q^mncj/Q.Q^mncj))
				*mncproexp^mncx/Q.Q;
    endrepeat;
endif;

repeat;
    id,once,mncproexp^mncx?*mncepexp(y?,D?) =
    sump_(mncj,0,`power'-mncx, y*acc((-D*ep-mncj+1)/mncj))*mncproexp^mncx;
    if ( count(P.P,1) > 0 ) discard;
    if ( count(mncproexp,1) > `power' ) discard;
endrepeat;
if ( count(mncproexp,1) != `power' ) discard;
id  mncproexp^`power' = 1;

#call ACCU(Expand in P)
#call momsubs(`topo')
#call sym2(`topo')
#call ACCU(moms)
#call harmo1(P,Q,mncFFPP)
#call ACCU(Harmonics)
#endprocedure
*
*--#] projectP : 
*--#[ reduceto :
#procedure reduceto(TOPO)
#switch `TOPO'
*--#[ reducela :
#case reducela
*
#call dovert1(p2,p7,p1)
#call dovert1(p2,p8,p3)
#call dovert1(Q,p4,p3)
#call dovert1(p8,p5,p4)
#call dovert1(p5,p7,p6)
#call dovert1(p6,Q,p1)
*
#break
*--#] reducela : 
*--#[ reducebe :
#case reducebe
*
#call dovert1(p1,p6,p2)
#call dovert1(p7,p3,p2)
#call dovert1(Q,p4,p3)
#call dovert1(p8,p5,p4)
#call dovert1(p5,Q,p1)
#call dovert1(p7,p8,p6)
*
#break
*--#] reducebe : 
*--#[ reduceno :
#case reduceno
*
#call dovert1(p1,p7,p2)
#call dovert1(p8,p3,p2)
#call dovert1(Q,p4,p3)
#call dovert1(p7,p5,p4)
#call dovert1(p6,Q,p1)
#call dovert1(p5,p8,p6)
*
#break
*--#] reduceno : 
*--#[ reducefa :
#case reducefa
*
#call dovert1(p1,p6,p2)
#call dovert1(p7,p3,p2)
#call dovert1(Q,p4,p3)
#call dovert1(p5,Q,p1)
*
#break
*--#] reducefa : 
*--#[ reducebu :
#case reducebu
*
#call dovert1(p4,p6,p1)
#call dovert1(p4,p5,p2)
#call dovert1(p3,p5,p7)
#call dovert1(p7,Q,p6)
*
#break
*--#] reducebu : 
*--#[ reduceo1 :
#case reduceo1
*
#call dovert1(p2,p5,p1)
#call dovert1(p3,p5,p4)
#call dovert1(Q,p4,p1)
#call dovert1(p6,p7,p5)
#call dovert1(p3,Q,p2)
*
#break
*--#] reduceo1 : 
*--#[ reduceo2 :
#case reduceo2
*
#call dovert1(p2,p5,p1)
#call dovert1(p3,p5,p4)
#call dovert1(Q,p3,p2)
#call dovert1(p6,p7,p4)
#call dovert1(p4,Q,p1)
*
#break
*--#] reduceo2 : 
*--#[ reduceo3 :
#case reduceo3
*
#call dovert1(p3,p5,p4)
#call dovert1(p2,p5,p1)
#call dovert1(p7,p6,Q)
#call dovert1(p3,Q,p2)
#call dovert1(p4,Q,p1)
*
#break
*--#] reduceo3 : 
*--#[ reduceo4 :
#case reduceo4
*
#call dovert1(p4,p6,p1)
#call dovert1(p2,p5,p1)
#call dovert1(p7,p6,Q)
#call dovert1(p3,p5,p4)
#call dovert1(p3,p6,p2)
*
#break
*--#] reduceo4 : 
*--#[ reducey1 :
#case reducey1
*
#call dovert1(p5,p6,p2)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey1 : 
*--#[ reducey2 :
#case reducey2
*
#call dovert1(p5,p6,p1)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey2 : 
*--#[ reducey3 :
#case reducey3
*
#call dovert1(p5,p6,p3)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey3 : 
*--#[ reducey4 :
#case reducey4
*
#call dovert1(p5,p6,Q)
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey4 : 
*--#[ reducey5 :
#case reducey5
*
#call dovert1(p5,p6,Q)
#call dovert1(p3,p4,Q)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducey5 : 
*--#[ reducet1 :
#case reducet1
*
#call dovert1(p4,Q,p1)
#call dovert1(p2,p5,p1)
#call dovert1(p3,p5,p4)
#call dovert1(p3,Q,p2)
*
#break
*--#] reducet1 : 
*--#[ reducet2 :
#case reducet2
*
#call dovert1(p3,p4,p1)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducet2 : 
*--#[ reducet3 :
#case reducet3
*
#call dovert1(p3,p4,Q)
#call dovert1(p1,p2,Q)
*
#break
*--#] reducet3 : 
*--#[ reducel1 :
#case reducel1
*
*
#break
*--#] reducel1 : 
*--#[ reducel2 :
#case reducel2
*
*
#break
*--#] reducel2 : 
*--#[ reducel3 :
#case reducel3
*
*
#break
*--#] reducel3 : 
*--#[ reducetr :
#case reducetr
*
*
#break
*--#] reducetr : 
#default
#message Illegal case `TOPO' in reduceto.prc
#break
#endswitch
#endprocedure
*--#] reduceto : 
*--#[ rename :
#procedure rename(TOPO)
#switch `TOPO'
*--#[ la :
*
*
*--#] la : 
*--#[ be :
*
*
*--#] be : 
*--#[ no :
*
*
*--#] no : 
*--#[ fa :
*
*
*--#] fa : 
*--#[ bu :
*
*
*--#] bu : 
*--#[ o1 :
#case o1
*
Multiply replace_(p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]);
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
Multiply replace_(p8,p4,[P+p8],[P+p4],[P-p8],[P-p4]);
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
Multiply replace_(p8,Q,[P+p8],[P+Q],[P-p8],[P-Q]);
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
Multiply replace_(p8,p6,[P+p8],[P+p6],[P-p8],[P-p6]);
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
Multiply replace_(p8,p2,[P+p8],[P+p2],[P-p8],[P-p2]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
Multiply replace_(p8,p1,[P+p8],[P+p1],[P-p8],[P-p1]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
Multiply replace_(p8,p3,[P+p8],[P+p3],[P-p8],[P-p3]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
Multiply replace_(p8,Q,[P+p8],[P+Q],[P-p8],[P-Q]);
Multiply replace_(p7,p1,[P+p7],[P+p1],[P-p7],[P-p1]);
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
Multiply replace_(p8,Q,[P+p8],[P+Q],[P-p8],[P-Q]);
Multiply replace_(p7,Q,[P+p7],[P+Q],[P-p7],[P-Q]);
*
#break
*--#] y5 : 
*--#[ t1 :
*
*
*--#] t1 : 
*--#[ t2 :
#case t2
*
Multiply replace_(p5,p1,[P+p5],[P+p1],[P-p5],[P-p1]);
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
Multiply replace_(p5,Q,[P+p5],[P+Q],[P-p5],[P-Q]);
*
#break
*--#] t3 : 
*--#[ l1 :
*
*
*--#] l1 : 
*--#[ l2 :
*
*
*--#] l2 : 
*--#[ l3 :
*
*
*--#] l3 : 
*--#[ tr :
*
*
*--#] tr : 
#endswitch
#endprocedure
*--#] rename : 
*--#[ rplane :
#procedure rplane(P1,P2,P3,P4,P5,P6,P7,P8,Q,INTS)
*
*   Reduction procedure for three loop graphs of the NO or nonplanar type.
*   Notation is from S.G.Gorishny et.al. Comp.Phys.Comm 55(1989)381
*
*                     /-<------<-----<-\
*                 p1 /     \  p2   /    \ p3
*                   /       v     /      \
*                  /      p7 \   /        \
*                 /           \ /          \
*          Q --<--             /            --<-- Q
*                 \           / \          /
*                  \      p8 /   \        / 
*                   \       ^     \      /
*                 p6 \     /  p5   \    / p4
*                     \->------>----->-/
*
*   Routine put together 26-feb-1993 by J.Vermaseren.
*
*   First express everything in powers of pi.pi, Q.Q and p2.Q;
*
*  id  `P5'.P?!{`P5'} = `P6'.P-`P8'.P;
*  id  `P4'.P?!{`P4'} = `P3'.P-`Q'.P;
*#call ACCU(moms 1)
*  id  `P6'.P?!{`P6'} = `P1'.P-`Q'.P;
*#call ACCU(moms 2)
*  id  `P7'.P?!{`P7'} = `P2'.P-`P1'.P;
*#call ACCU(moms 3)
*  id  `P8'.P?!{`P8'} = `P2'.P-`P3'.P;
*#call ACCU(moms 4)
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P6'.`P6'/2;
#call ACCU(dots 1)
  id  `P3'.`Q' = `P3'.`P3'/2+`Q'.`Q'/2-`P4'.`P4'/2;
#call ACCU(dots 2)
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P7'.`P7'/2;
#call ACCU(dots 3)
  id  `P3'.`P2' = `P3'.`P3'/2+`P2'.`P2'/2-`P8'.`P8'/2;
#call ACCU(dots 4)
  id `P1'.`P3' = -`P2'.`Q'+`P1'.`P1'/2+`P2'.`P2'/2+`P3'.`P3'/2+`P5'.`P5'/2
                 +`Q'.`Q'/2-`P4'.`P4'/2-`P6'.`P6'/2-`P7'.`P7'/2-`P8'.`P8'/2;
#call ACCU(dots 5)
*
*   First step: eliminate the powers of `Q'.`P2'
*   Note how common factors are kept together in acc till the end.
*   This trick allows us to do an intermediate sort in the argument
*   of acc, thereby making in the end only the terms that are necessary.
*
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
  /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8'*`Q'.`P2') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?/`P6'.`P6'^mncx6?
    /`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8?*`Q'.`P2'^mncx9? = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'^mncx5/`P6'.`P6'^mncx6
    /`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*`Q'.`P2'^mncx9*`Q'.`Q'/`Q'.`P2'/2*(
      +acc(3-2*mncx2-mncx1-mncx3+mncx9-2*ep)
      +mncx1*`P7'.`P7'/`P1'.`P1'-mncx1*`P2'.`P2'/`P1'.`P1'
      +mncx3*`P8'.`P8'/`P3'.`P3'-mncx3*`P2'.`P2'/`P3'.`P3'
      +2*acc(mncx9-1)*`P2'.`P2'/`Q'.`P2'/2
    )*mncdeno(7-mncx1-mncx2-mncx3-mncx4-mncx5-mncx6-mncx7-mncx8+mncx9,-4);
id  mncdeno(0,-4) = -1/4/ep;
id  mncdeno(mncx1?,-4) = acc(1+4*ep/mncx1+16*ep^2/mncx1^2+64*ep^3/mncx1^3+256*ep^4/mncx1^4
	+1024*ep^5/mncx1^5+4096*ep^6/mncx1^6)/mncx1;
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
#call ACCU(Eliminate `Q'.`P2')
*
*   The essence of the strategy is now to depopulate the inner
*   propagators. This will leave integrals with only excess powers
*   in `P1',`P3',`P4',`P6'. These are tabulated.
*   In case an integral is not in the tables we have to use
*   recursions at the edge to reach the table. The paper has the
*   extra recursion (29) which we combine directly with the
*   recursions below (more general form of (30)) to reach the
*   table automatically.
*
repeat;
repeat;
while ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'^2
               /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?
       /`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'^mncx5
     /`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
        acc(-8+4*ep+mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8)*`P5'.`P5'/`Q'.`Q'*
            (acc(-14+6*ep+2*(mncx1+mncx2+mncx3+mncx5+mncx7+mncx8)+mncx4+mncx6)
                +mncx4*`P3'.`P3'/`P4'.`P4'+mncx6*`P1'.`P1'/`P6'.`P6')/(mncx5-1)
            +mncx4*`P7'.`P7'/`P4'.`P4'+mncx6*`P8'.`P8'/`P6'.`P6'
            -acc(mncx1+mncx2+mncx3+mncx4+mncx5+mncx6+mncx7+mncx8+mncx5-9+4*ep)*`P5'.`P5'
                *(mncx4/`P4'.`P4'+mncx6/`P6'.`P6')/(mncx5-1)
    )*mncdeno(-4+mncx4+mncx6+2*mncx5,2);

while ( match(1/`P1'.`P1'/`P2'.`P2'^2/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
               /`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'
       /`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'
     /`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
        acc(-7+4*ep+mncx1+mncx2+mncx3+mncx4+mncx6+mncx7+mncx8)*`P2'.`P2'/`Q'.`Q'*
            (acc(-12+6*ep+2*(mncx6+mncx2+mncx4+mncx7+mncx8)+mncx1+mncx3)
                +mncx3*`P4'.`P4'/`P3'.`P3'+mncx1*`P6'.`P6'/`P1'.`P1')/(mncx2-1)
            +mncx3*`P8'.`P8'/`P3'.`P3'+mncx1*`P7'.`P7'/`P1'.`P1'
            -acc(mncx1+mncx2+mncx3+mncx4+mncx6+mncx7+mncx8+mncx2-8+4*ep)*`P2'.`P2'
                *(mncx3/`P3'.`P3'+mncx1/`P1'.`P1')/(mncx2-1)
    )*mncdeno(-4+mncx1+mncx3+2*mncx2,2);

if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
               /`P6'.`P6'/`P7'.`P7'^2/`P8'.`P8') > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'
       /`P6'.`P6'^mncx6?/`P7'.`P7'^mncx7?/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'
     /`P6'.`P6'^mncx6/`P7'.`P7'^mncx7/`P8'.`P8'^mncx8*(
        acc(-6+4*ep+mncx1+mncx3+mncx4+mncx6+mncx7+mncx8)*`P7'.`P7'/`Q'.`Q'*
            (acc(-10+6*ep+2*(mncx6+mncx3+mncx7+mncx8)+mncx4+mncx1)
                +mncx4*`P3'.`P3'/`P4'.`P4'+mncx1*`P6'.`P6'/`P1'.`P1')/(mncx7-1)
            +mncx4*`P5'.`P5'/`P4'.`P4'+mncx1*`P2'.`P2'/`P1'.`P1'
            -acc(mncx1+mncx3+mncx4+mncx6+mncx7+mncx8+mncx7-7+4*ep)*`P7'.`P7'
                *(mncx4/`P4'.`P4'+mncx1/`P1'.`P1')/(mncx7-1)
    )*mncdeno(-4+mncx4+mncx1+2*mncx7,2);
endrepeat;

if ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'
               /`P6'.`P6'/`P7'.`P7'/`P8'.`P8'^2) > 0 )
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?/`P5'.`P5'
       /`P6'.`P6'^mncx6?/`P7'.`P7'/`P8'.`P8'^mncx8? =
    1/`P1'.`P1'^mncx1/`P2'.`P2'/`P3'.`P3'^mncx3/`P4'.`P4'^mncx4/`P5'.`P5'
     /`P6'.`P6'^mncx6/`P7'.`P7'/`P8'.`P8'^mncx8*(
        acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6+mncx8)*`P8'.`P8'/`Q'.`Q'*
            (acc(-8+6*ep+2*(mncx1+mncx4+mncx8)+mncx6+mncx3)
                +mncx3*`P4'.`P4'/`P3'.`P3'+mncx6*`P1'.`P1'/`P6'.`P6')/(mncx8-1)
            +mncx3*`P2'.`P2'/`P3'.`P3'+mncx6*`P5'.`P5'/`P6'.`P6'
            -acc(mncx1+mncx3+mncx4+mncx6+mncx8+mncx8-6+4*ep)*`P8'.`P8'
                *(mncx3/`P3'.`P3'+mncx6/`P6'.`P6')/(mncx8-1)
    )*mncdeno(-4+mncx6+mncx3+2*mncx8,2);
endrepeat;

id  mncdeno(0,2) = 1/2/ep;
id  mncdeno(mncx1?,2) = acc(1-2*ep/mncx1+4*ep^2/mncx1^2-8*ep^3/mncx1^3+16*ep^4/mncx1^4
	-32*ep^5/mncx1^5+64*ep^6/mncx1^6)/mncx1;
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
*
*   We arrange the integral so that mncx1 >= mncx3,mncx4,mncx5, mncx3 >= mncx4 etc.
*
if ( match( 1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
             /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' ) > 0 );
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
    if ( ( count(`P1'.`P1',1) > count(`P3'.`P3',1) )
    || ( ( count(`P1'.`P1',1) == count(`P3'.`P3',1) )
      && ( count(`P4'.`P4',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4');
    if ( ( count(`P1'.`P1',1) > count(`P4'.`P4',1) )
    || ( ( count(`P1'.`P1',1) == count(`P4'.`P4',1) )
      && ( count(`P3'.`P3',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P4',`P4',`P1',`P3',`P6',`P6',`P3');
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
endif;

#call ACCU(Inside Reduction)
 
while ( ( match(1/`P1'.`P1'^2/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
               /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
    && ( count(`P1'.`P1',-1,`P3'.`P3',-1,`P4'.`P4',-1,`P6'.`P6',-1)
        > `INRTABL' ) );
  id  1/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'/`P6'.`P6'^mncx6?
    /`P7'.`P7'/`P8'.`P8' = 
    1/`P1'.`P1'^mncx1/`P2'.`P2'/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'/`P6'.`P6'^mncx6
    /`P7'.`P7'/`P8'.`P8'/`Q'.`Q'*(
      +acc((2*mncx6+mncx1-3+4*ep)*(mncx3+mncx1-2+2*ep)*(mncx4+mncx1-2+2*ep)
            +(mncx6+mncx3+mncx4+mncx1-4+4*ep)*((mncx4-1)*(mncx3+mncx1-2+2*ep)
            +(mncx3-1)*(mncx4+mncx1-2+2*ep)))
        *`P1'.`P1'/(mncx1-1)*mncdeno(-2+mncx4+mncx1,2)*mncdeno(-2+mncx1+mncx3,2)
      +`P6'.`P6'
      +`P8'.`P8'*`P1'.`P1'/`P2'.`P2'*acc(1+2*ep/(mncx1-1))*mncdeno(-2+mncx1+mncx3,2)
      +`P5'.`P5'*`P1'.`P1'/`P7'.`P7'*acc(1+2*ep/(mncx1-1))*mncdeno(-2+mncx4+mncx1,2)
      +acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6)*(
          -`P4'.`P4'*acc((-6+6*ep+2*(mncx6+mncx3)+mncx4+mncx1)*(mncx3+mncx1-2+2*ep)
           +(mncx3-1)*(mncx4+mncx1-2+2*ep))
          -`P3'.`P3'*acc((-6+6*ep+2*(mncx6+mncx4)+mncx1+mncx3)*(mncx4+mncx1-2+2*ep)
           +(mncx4-1)*(mncx3+mncx1-2+2*ep))
       )*`P1'.`P1'/`Q'.`Q'/(mncx1-1)*mncdeno(-2+mncx4+mncx1,2)*mncdeno(-2+mncx1+mncx3,2)
      +(-`P6'.`P6'*`P4'.`P4'*acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6)/`Q'.`Q'
        -`P2'.`P2'*`P4'.`P4'/`P7'.`P7'
        +`P4'.`P4'*acc(mncx1+mncx3+mncx4+mncx6-4+4*ep)
      )*mncdeno(-2+mncx4+mncx1,2)
      +(-`P6'.`P6'*`P3'.`P3'*acc(-5+4*ep+mncx1+mncx3+mncx4+mncx6)/`Q'.`Q'
        -`P7'.`P7'*`P3'.`P3'/`P2'.`P2'
        +`P3'.`P3'*acc(mncx1+mncx3+mncx4+mncx6-4+4*ep)
      )*mncdeno(-2+mncx1+mncx3,2)
    );
#ifndef `STRATEGY2'
  if ( match( 1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
             /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' ) > 0 );
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
    if ( ( count(`P1'.`P1',1) > count(`P3'.`P3',1) )
    || ( ( count(`P1'.`P1',1) == count(`P3'.`P3',1) )
      && ( count(`P4'.`P4',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4');
    if ( ( count(`P1'.`P1',1) > count(`P4'.`P4',1) )
    || ( ( count(`P1'.`P1',1) == count(`P4'.`P4',1) )
      && ( count(`P3'.`P3',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P4',`P4',`P1',`P3',`P6',`P6',`P3');
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
  endif;
#endif
endwhile;

#ifdef `STRATEGY2' 
while ( ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^2/`P4'.`P4'
               /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8') > 0 )
    && ( count(`P1'.`P1',-1,`P3'.`P3',-1,`P4'.`P4',-1,`P6'.`P6',-1)
        > `INRTABL' ) )
  id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^mncx3?
    /`P4'.`P4'^mncx4?/`P5'.`P5'/`P6'.`P6'^mncx6?
    /`P7'.`P7'/`P8'.`P8' = 
    1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'^mncx3
    /`P4'.`P4'^mncx4/`P5'.`P5'/`P6'.`P6'^mncx6
    /`P7'.`P7'/`P8'.`P8'/`Q'.`Q'*(
      +acc((2*mncx4+mncx3-3+4*ep)*(mncx6+mncx3-2+2*ep)*(1+mncx3-2+2*ep)
            +(mncx4+mncx6+1+mncx3-4+4*ep)*((1-1)*(mncx6+mncx3-2+2*ep)
            +(mncx6-1)*(1+mncx3-2+2*ep)))
        *`P3'.`P3'/(mncx3-1)*mncdeno(-2+1+mncx3,2)*mncdeno(-2+mncx3+mncx6,2)
      +`P4'.`P4'
      +`P5'.`P5'*`P3'.`P3'/`P8'.`P8'*acc(1+2*ep/(mncx3-1))*mncdeno(-2+mncx3+mncx6,2)
      +`P7'.`P7'*`P3'.`P3'/`P2'.`P2'*acc(1+2*ep/(mncx3-1))*mncdeno(-1+mncx3,2)
      +acc(-4+4*ep+mncx4+mncx6+mncx3)*(
          -`P1'.`P1'*acc((-5+6*ep+2*(mncx4+mncx6)+mncx3)*(mncx6+mncx3-2+2*ep)
           +(mncx6-1)*(mncx3-1+2*ep))*mncdeno(-1+mncx3,2)
          -`P6'.`P6'*acc(-6+6*ep+2*(mncx4+1)+mncx3+mncx6)
       )*`P3'.`P3'/`Q'.`Q'/(mncx3-1)*mncdeno(-2+mncx3+mncx6,2)
      +(-`P4'.`P4'*`P1'.`P1'*acc(-4+4*ep+mncx4+mncx6+mncx3)/`Q'.`Q'
        -`P8'.`P8'*`P1'.`P1'/`P2'.`P2'
        +`P1'.`P1'*acc(mncx4+mncx6+mncx3-3+4*ep)
      )*mncdeno(-1+mncx3,2)
      +(-`P4'.`P4'*`P6'.`P6'*acc(-4+4*ep+mncx4+mncx6+mncx3)/`Q'.`Q'
        -`P2'.`P2'*`P6'.`P6'/`P8'.`P8'
        +`P6'.`P6'*acc(mncx4+mncx6+mncx3-3+4*ep)
      )*mncdeno(-2+mncx3+mncx6,2)
    );

while ( ( match(1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
               /`P5'.`P5'/`P6'.`P6'^2/`P7'.`P7'/`P8'.`P8') > 0 )
    && ( count(`P1'.`P1',-1,`P3'.`P3',-1,`P4'.`P4',-1,`P6'.`P6',-1)
        > `INRTABL' ) )
  id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
    /`P4'.`P4'^mncx4?/`P5'.`P5'/`P6'.`P6'^mncx6?
    /`P7'.`P7'/`P8'.`P8' = 
    1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
    /`P4'.`P4'^mncx4/`P5'.`P5'/`P6'.`P6'^mncx6
    /`P7'.`P7'/`P8'.`P8'/`Q'.`Q'*(
      +acc(mncx6-2+4*ep+mncx4)*acc(mncx4+mncx6-2+2*ep)
        *`P6'.`P6'/(mncx6-1)*mncdeno(-2+mncx4+mncx6,2)
      +`P1'.`P1'
      +`P2'.`P2'*`P6'.`P6'/`P8'.`P8'*acc(1+2*ep/(mncx6-1))*mncdeno(-1+mncx6,2)
      +`P7'.`P7'*`P6'.`P6'/`P5'.`P5'*acc(1+2*ep/(mncx6-1))*mncdeno(-2+mncx4+mncx6,2)
      +acc(-3+4*ep+mncx4+mncx6)*(
          -`P4'.`P4'*acc(-2+6*ep+mncx4+mncx6)
          -`P3'.`P3'*acc((-3+6*ep+2*mncx4+mncx6)*(mncx4+mncx6-2+2*ep)
           +(mncx4-1)*(mncx6-1+2*ep))*mncdeno(-1+mncx6,2)
       )*`P6'.`P6'/`Q'.`Q'/(mncx6-1)*mncdeno(-2+mncx4+mncx6,2)
      +(-`P1'.`P1'*`P4'.`P4'*acc(-3+4*ep+mncx4+mncx6)/`Q'.`Q'
        -`P8'.`P8'*`P4'.`P4'/`P5'.`P5'
        +`P4'.`P4'*acc(mncx4+mncx6-2+4*ep)
      )*mncdeno(-2+mncx4+mncx6,2)
      +(-`P1'.`P1'*`P3'.`P3'*acc(-3+4*ep+mncx4+mncx6)/`Q'.`Q'
        -`P5'.`P5'*`P3'.`P3'/`P8'.`P8'
        +`P3'.`P3'*acc(mncx4+mncx6-2+4*ep)
      )*mncdeno(-1+mncx6,2)
    );

while ( ( match(1/`P1'.`P1'/`P7'.`P7'/`P4'.`P4'^2/`P3'.`P3'
               /`P8'.`P8'/`P6'.`P6'/`P2'.`P2'/`P5'.`P5') > 0 )
    && ( count(`P1'.`P1',-1,`P4'.`P4',-1,`P3'.`P3',-1,`P6'.`P6',-1)
        > `INRTABL' ) )
  id  1/`P1'.`P1'/`P7'.`P7'/`P4'.`P4'^mncx4?
    /`P3'.`P3'/`P8'.`P8'/`P6'.`P6'
    /`P2'.`P2'/`P5'.`P5' = 
    1/`P1'.`P1'/`P7'.`P7'/`P4'.`P4'^mncx4
    /`P3'.`P3'/`P8'.`P8'/`P6'.`P6'
    /`P2'.`P2'/`P5'.`P5'/`Q'.`Q'*(
      +acc(mncx4-1+4*ep)*`P4'.`P4'/(mncx4-1)
      +`P3'.`P3'
      +`P8'.`P8'*`P4'.`P4'/`P5'.`P5'*acc(1+2*ep/(mncx4-1))*mncdeno(-1+mncx4,2)
      +`P2'.`P2'*`P4'.`P4'/`P7'.`P7'*acc(1+2*ep/(mncx4-1))*mncdeno(-1+mncx4,2)
      +acc(-2+4*ep+mncx4)*(
          -`P1'.`P1'*acc(-1+6*ep+mncx4)
          -`P6'.`P6'*acc(-1+6*ep+mncx4)
       )*`P4'.`P4'/`Q'.`Q'/(mncx4-1)*mncdeno(-1+mncx4,2)
      +(-`P3'.`P3'*`P1'.`P1'*acc(-2+4*ep+mncx4)/`Q'.`Q'
        -`P5'.`P5'*`P1'.`P1'/`P7'.`P7'
        +`P1'.`P1'*acc(mncx4-1+4*ep)
      )*mncdeno(-1+mncx4,2)
      +(-`P3'.`P3'*`P6'.`P6'*acc(-2+4*ep+mncx4)/`Q'.`Q'
        -`P7'.`P7'*`P6'.`P6'/`P5'.`P5'
        +`P6'.`P6'*acc(mncx4-1+4*ep)
      )*mncdeno(-1+mncx4,2)
    );
#endif
id  mncdeno(0,2) = 1/2/ep;
id  mncdeno(mncx1?,2) = acc(1-2*ep/mncx1+4*ep^2/mncx1^2-8*ep^3/mncx1^3+16*ep^4/mncx1^4
	-32*ep^5/mncx1^5+64*ep^6/mncx1^6)/mncx1;
repeat id acc(mncx1?)*acc(mncx2?) = acc(mncx1*mncx2);
*
*   Integrals that are left can be looked up in the table.
*   We may have to apply symmetries to map it to an actual
*   element of the table.
*
if ( match( 1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'
             /`P5'.`P5'/`P6'.`P6'/`P7'.`P7'/`P8'.`P8' ) > 0 );
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
    if ( ( count(`P1'.`P1',1) > count(`P3'.`P3',1) )
    || ( ( count(`P1'.`P1',1) == count(`P3'.`P3',1) )
      && ( count(`P4'.`P4',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P3',`P3',`P1',`P4',`P6',`P6',`P4');
    if ( ( count(`P1'.`P1',1) > count(`P4'.`P4',1) )
    || ( ( count(`P1'.`P1',1) == count(`P4'.`P4',1) )
      && ( count(`P3'.`P3',1) > count(`P6'.`P6',1) ) ) )
        multiply replace_(`P1',`P4',`P4',`P1',`P3',`P6',`P6',`P3');
    if ( count(`P1'.`P1',1) > count(`P6'.`P6',1) )
        multiply replace_(`P1',`P6',`P6',`P1');
    if ( count(`P3'.`P3',1) > count(`P4'.`P4',1) )
        multiply replace_(`P3',`P4',`P4',`P3');
  id `INTS'/`P1'.`P1'^mncx1?/`P2'.`P2'/`P3'.`P3'^mncx3?/`P4'.`P4'^mncx4?
           /`P5'.`P5'/`P6'.`P6'^mncx6?/`P7'.`P7'/`P8'.`P8' =
           mncrtab(mncx1,mncx3,mncx4,mncx6)*mnceq^3/`Q'.`Q'^(mncx1+mncx3+mncx4+mncx6-2);
endif;

#endprocedure;
*--#] rplane : 
*--#[ scalars :
#procedure scalars(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
#if ( `LATRANS' == 1 )
  #call ACCU2(AB Q.p3  p3.p3 Q.Q p4.p4,Ladder rewrite 0)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p2  p2.p2 Q.Q p5.p5,Ladder rewrite 1)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p2.p7 p1.p1 p2.p2 p7.p7,Ladder rewrite 2)
    id  p2.p7 = p1.p1/2-p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,Ladder rewrite 3)
    id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
  #call ACCU2(AB Q.p7 p1.p1 p2.p2 p5.p5 p6.p6,Ladder rewrite 4)
    id  Q.p7 = p1.p1/2-p2.p2/2+p5.p5/2-p6.p6/2;
  #call ACCU(Ladder rewrite 5)
#else
#if ( `LATRANS' == 2 )
  #call ACCU2(AB p3.p7 p1.p7 p7.p8 p7.p7,Ladder rewrite 0)
    id  p3.p7 = p1.p7-p7.p7+p7.p8;
  #call ACCU2(AB Q.p3  p3.p3 Q.Q p4.p4,Ladder rewrite 1)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p1  p1.p1 Q.Q p6.p6,Ladder rewrite 2)
    id  Q.p1 = p1.p1/2+Q.Q/2-p6.p6/2;
  #call ACCU2(AB p1.p7 p1.p1 p2.p2 p7.p7,Ladder rewrite 3)
    id  p1.p7 = p1.p1/2-p2.p2/2+p7.p7/2;
  #call ACCU2(AB Q.p7 p1.p1 p2.p2 p5.p5 p6.p6,Ladder rewrite 4)
    id  Q.p7 = p1.p1/2-p2.p2/2+p5.p5/2-p6.p6/2;
  #call ACCU(Ladder rewrite 5)
#else
#if ( `LATRANS' == 3 )
  #call ACCU2(AB Q.p2 p2.p2 Q.Q p5.p5,Ladder rewrite 0)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p2.p7 p1.p1 p2.p2 p7.p7,Ladder rewrite 1)
    id  p2.p7 = p1.p1/2-p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p8 p3.p3 p2.p2 p8.p8,Ladder rewrite 2)
    id  p2.p8 = p3.p3/2-p2.p2/2-p8.p8/2;
  #call ACCU2(AB Q.p7 p1.p1 p2.p2 p5.p5 p6.p6,Ladder rewrite 3)
    id  Q.p7 = p1.p1/2-p2.p2/2+p5.p5/2-p6.p6/2;
  #call ACCU2(AB Q.p8 p3.p3 p2.p2 p5.p5 p4.p4,Ladder rewrite 4)
    id  Q.p8 = p3.p3/2-p2.p2/2+p5.p5/2-p4.p4/2;
  #call ACCU(Ladder rewrite 5)
#else
  #call ACCU2(AB Q.p1 p1.p1 p6.p6 Q.Q,Ladder rewrite 0)
    id  Q.p1 = p1.p1/2-p6.p6/2+Q.Q/2;
  #call ACCU2(AB Q.p3 p3.p3 p4.p4 Q.Q,Ladder rewrite 1)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p2  p2.p2 Q.Q p5.p5,Ladder rewrite 2)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,Ladder rewrite 3)
    id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,Ladder rewrite 4)
    id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
  #call ACCU(Ladder rewrite 5)
#endif
#endif
#endif
#else
  #call ACCU2(AB Q.p1 p1.p1 p6.p6 Q.Q,Ladder rewrite 0)
    id  Q.p1 = p1.p1/2-p6.p6/2+Q.Q/2;
  #call ACCU2(AB Q.p3 p3.p3 p4.p4 Q.Q,Ladder rewrite 1)
    id  Q.p3 = p3.p3/2-p4.p4/2+Q.Q/2;
  #call ACCU2(AB Q.p2  p2.p2 Q.Q p5.p5,Ladder rewrite 2)
    id  Q.p2 = p2.p2/2+Q.Q/2-p5.p5/2;
  #call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,Ladder rewrite 3)
    id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
  #call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,Ladder rewrite 4)
    id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
  #call ACCU(Ladder rewrite 5)
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
#ifndef `BEPATH'
#call ACCU2(AB p1.p3 p1.p1 p3.p3 p8.p8,Benz rewrite 0)
  id  p1.p3 = p1.p1/2+p3.p3/2-p8.p8/2;
#call ACCU2(AB p2.p3 p2.p2 p3.p3 p7.p7,Benz rewrite 1)
  id  p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 3)
  id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p3 p3.p3 Q.Q p4.p4,Benz rewrite 4)
  id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(Benz rewrite 5)
#else
#if ( `BEPATH' == 0 )
#call ACCU2(AB p1.p3 p1.p1 p3.p3 p8.p8,Benz rewrite 0 \(0\))
  id  p1.p3 = p1.p1/2+p3.p3/2-p8.p8/2;
#call ACCU2(AB p2.p3 p2.p2 p3.p3 p7.p7,Benz rewrite 1 \(0\))
  id  p2.p3 = p2.p2/2+p3.p3/2-p7.p7/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz rewrite 2 \(0\))
  id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 3 \(0\))
  id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p3 p3.p3 Q.Q p4.p4,Benz rewrite 4 \(0\))
  id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(Benz rewrite 5 \(0\))
#endif
#if ( `BEPATH' == 1 )
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 0 \(1\))
    id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB p1.p6 p2.p2 p1.p1 p6.p6,Benz rewrite 1 \(1\))
    id  p1.p6 = p2.p2/2-p1.p1/2-p6.p6/2;
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 2 \(1\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB p1.p8 p3.p3 p1.p1 p8.p8,Benz rewrite 3 \(1\))
    id  p1.p8 = p3.p3/2-p1.p1/2-p8.p8/2;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 4 \(1\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 5 \(1\))
#endif
#if ( `BEPATH' == 2 )
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p6.p6,Benz rewrite 0 \(2\))
    id  p1.p2 = p1.p1/2+p2.p2/2-p6.p6/2;
#call ACCU2(AB p2.p7 p2.p2 p7.p7 p3.p3,Benz rewrite 1 \(2\))
    id  p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(2\))
    id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB Q.p7 Q.p2 Q.Q p3.p3 p4.p4,Benz rewrite 3 \(2\))
    id  Q.p7 = Q.p2-Q.Q/2-p3.p3/2+p4.p4/2;
#call ACCU2(AB p1.p7 p2.p2 p6.p6 p3.p3 p8.p8,Benz rewrite 4 \(2\))
    id  p1.p7 = p2.p2/2-p6.p6/2-p3.p3/2+p8.p8/2;
#call ACCU(Benz rewrite 5 \(2\))
#endif
#if ( `BEPATH' == 3 )
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 0 \(3\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB p2.p6 p2.p2 p6.p6 p1.p1,Benz rewrite 1 \(3\))
    id  p2.p6 = p2.p2/2+p6.p6/2-p1.p1/2;
#call ACCU2(AB p2.p8 p3.p3 p1.p1 p7.p7 p6.p6,Benz rewrite 2 \(3\))
    id  p2.p8 = p3.p3/2-p1.p1/2-p7.p7/2+p6.p6/2;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 3 \(3\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 4 \(3\))
    id  Q.p6 = Q.p2-Q.Q/2-p1.p1/2+p5.p5/2;
#call ACCU(Benz rewrite 5 \(3\))
#endif
#if ( `BEPATH' == 4 )
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 0 \(4\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB p4.p8 p4.p4 p8.p8 p5.p5,Benz rewrite 1 \(4\))
    id  p4.p8 = p4.p4/2+p8.p8/2-p5.p5/2;
#call ACCU2(AB Q.p4 p3.p3 Q.Q p4.p4,Benz rewrite 2 \(4\))
    id  Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 3 \(4\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB p4.p6 Q.p6 p1.p1 p2.p2 p7.p7 p8.p8,Benz rewrite 4 \(4\))
    id  p4.p6 = -Q.p6-p1.p1/2+p2.p2/2+p8.p8/2-p7.p7/2;
#call ACCU(Benz rewrite 5 \(4\))
#endif
#if ( `BEPATH' == 5 )
#call ACCU2(AB p1.p6 p2.p2 p1.p1 p6.p6,Benz rewrite 0 \(5\))
    id  p1.p6 = p2.p2/2-p1.p1/2-p6.p6/2;
#call ACCU2(AB p6.p7 p6.p6 p7.p7 p8.p8,Benz rewrite 1 \(5\))
    id  p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
#call ACCU2(AB Q.p1 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(5\))
    id  Q.p1 = p1.p1/2+Q.Q/2-p5.p5/2;
#call ACCU2(AB p1.p7 p2.p2 p6.p6 p3.p3 p8.p8,Benz rewrite 3 \(5\))
    id  p1.p7 = p2.p2/2-p6.p6/2-p3.p3/2+p8.p8/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 4 \(5\))
    id  Q.p6 = Q.p7+p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU(Benz rewrite 5 \(5\))
#endif
#if ( `BEPATH' == 6 )
#call ACCU2(AB p5.p8 p4.p4 p5.p5 p8.p8,Benz rewrite 0 \(6\))
    id  p5.p8 = p4.p4/2-p5.p5/2-p8.p8/2;
#call ACCU2(AB p6.p8 p6.p6 p8.p8 p7.p7,Benz rewrite 1 \(6\))
    id  p6.p8 = p6.p6/2+p8.p8/2-p7.p7/2;
#call ACCU2(AB Q.p5 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(6\))
    id  Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
#call ACCU2(AB p5.p6 p2.p2 p1.p1 p6.p6 Q.p6,Benz rewrite 3 \(6\))
    id  p5.p6 = p2.p2/2-p1.p1/2-p6.p6/2-Q.p6;
#call ACCU2(AB Q.p8 p3.p3 p4.p4 p1.p1 p5.p5,Benz rewrite 4 \(6\))
    id  Q.p8 = p3.p3/2-p4.p4/2-p1.p1/2+p5.p5/2;
#call ACCU(Benz rewrite 5 \(6\))
#endif
#if ( `BEPATH' == 7 )
#call ACCU2(AB p4.p5 p4.p4 p5.p5 p8.p8,Benz rewrite 0 \(7\))
    id  p4.p5 = p4.p4/2+p5.p5/2-p8.p8/2;
#call ACCU2(AB Q.p4 p3.p3 Q.Q p4.p4,Benz rewrite 1 \(7\))
    id  Q.p4 = p3.p3/2-Q.Q/2-p4.p4/2;
#call ACCU2(AB Q.p5 p1.p1 Q.Q p5.p5,Benz rewrite 2 \(7\))
    id  Q.p5 = p1.p1/2-Q.Q/2-p5.p5/2;
#call ACCU2(AB p2.p4 p2.p2 p3.p3 p7.p7 Q.p2,Benz rewrite 3 \(7\))
    id  p2.p4 = p2.p2/2+p3.p3/2-p7.p7/2-Q.p2;
#call ACCU2(AB p2.p5 p2.p2 p1.p1 p6.p6 Q.p2,Benz rewrite 4 \(7\))
    id  p2.p5 = p2.p2/2+p1.p1/2-p6.p6/2-Q.p2;
#call ACCU(Benz rewrite 5 \(7\))
#endif
#if ( `BEPATH' == 8 )
#call ACCU2(AB p2.p6 p2.p2 p1.p1 p6.p6,Benz rewrite 0 \(8\))
    id  p2.p6 = p2.p2/2+p6.p6/2-p1.p1/2;
#call ACCU2(AB p2.p7 p2.p2 p7.p7 p3.p3,Benz rewrite 1 \(8\))
    id  p2.p7 = p2.p2/2+p7.p7/2-p3.p3/2;
#call ACCU2(AB p6.p7 p6.p6 p7.p7 p8.p8,Benz rewrite 2 \(8\))
    id  p6.p7 = p6.p6/2+p7.p7/2-p8.p8/2;
#call ACCU2(AB Q.p6 Q.p2 Q.Q p1.p1 p5.p5,Benz rewrite 3 \(8\))
    id  Q.p6 = Q.p2-Q.Q/2-p1.p1/2+p5.p5/2;
#call ACCU2(AB Q.p7 Q.p2 Q.Q p3.p3 p4.p4,Benz rewrite 4 \(8\))
    id  Q.p7 = Q.p2-Q.Q/2-p3.p3/2+p4.p4/2;
#call ACCU(Benz rewrite 5 \(8\))
#endif
#endif
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifndef `NOSPEC'
#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,no rewrite 0)
  id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;
#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,no rewrite 1)
  id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,no rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
#call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,no rewrite 3)
  id  p3.p2 = p3.p3/2+p2.p2/2-p8.p8/2;
#call ACCU(no rewrite 4)
    id p1.p3 = -p2.Q+p1.p1/2+p2.p2/2+p3.p3/2+p5.p5/2
                 +Q.Q/2-p4.p4/2-p6.p6/2-p7.p7/2-p8.p8/2;
#call ACCU(no rewrite 5)
#else
#if ( `NOSPEC' == 0 )
#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,no rewrite 0)
  id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;
#call ACCU2(AB p3.Q p3.p3 Q.Q p4.p4,no rewrite 1)
  id  p3.Q = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,no rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
#call ACCU2(AB p2.p3 p3.p3 p2.p2 p8.p8,no rewrite 3)
  id  p2.p3 = p3.p3/2+p2.p2/2-p8.p8/2;
#call ACCU(no rewrite 4)
  id p1.p3 = -p2.Q+p1.p1/2+p2.p2/2+p3.p3/2+p5.p5/2
            +Q.Q/2-p4.p4/2-p6.p6/2-p7.p7/2-p8.p8/2;
#call ACCU(no rewrite 5)
#endif
#if ( `NOSPEC' == 1 )
  id  p2.p7 = p2.p2/2+p7.p7/2-p1.p1/2;
#call ACCU2(AB p2.p8 p3.p3 p2.p2 p8.p8,no rewrite 0)
  id  p2.p8 = -p3.p3/2+p2.p2/2+p8.p8/2;
#call ACCU2(AB p7.Q Q.p2 p1.p1 Q.Q p6.p6,no rewrite 2)
  id  p7.Q = Q.p2-p1.p1/2-Q.Q/2+p6.p6/2;
#call ACCU2(AB p8.Q p3.p3 Q.Q p4.p4 Q.p2,no rewrite 3)
  id  p8.Q = Q.p2-p3.p3/2-Q.Q/2+p4.p4/2;
#call ACCU(no rewrite 4)
    id,p1.p3 = -p2.Q+p1.p1/2+p2.p2/2+p3.p3/2+p5.p5/2
                 +Q.Q/2-p4.p4/2-p6.p6/2-p7.p7/2-p8.p8/2;
#call ACCU(no rewrite 5)
#endif
#if ( `NOSPEC' == 2 )
#call ACCU2(AB p1.Q p1.p1 Q.Q p6.p6,no rewrite 0)
  id  p1.Q = p1.p1/2+Q.Q/2-p6.p6/2;
#call ACCU2(AB p8.Q p2.Q p3.p3 Q.Q p4.p4,no rewrite 1)
  id  p8.Q = p2.Q-p3.p3/2-Q.Q/2+p4.p4/2;
#call ACCU2(AB p1.p2 p1.p1 p2.p2 p7.p7,no rewrite 2)
  id  p1.p2 = p1.p1/2+p2.p2/2-p7.p7/2;
#call ACCU2(AB p2.p8 p3.p3 p2.p2 p8.p8,no rewrite 3)
  id  p2.p8 = p8.p8/2+p2.p2/2-p3.p3/2;
#call ACCU2(AB p1.p8 p2.Q p3.p3 p5.p5 Q.Q p4.p4 p6.p6 p8.p8,no rewrite 4)
  id p1.p8 = +p2.Q-p3.p3/2-p5.p5/2
                 -Q.Q/2+p4.p4/2+p6.p6/2+p8.p8/2;
#call ACCU(no rewrite 5)
#endif
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
#ifndef `O1PATH'
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o1 rewite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(o1 rewite 2)
#else
#if ( `O1PATH' == 0 )
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o1 rewite 1\(0\))
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(o1 rewite 2\(0\))
#endif
#if ( `O1PATH' == 1 )
id  p1.p7 = -p1.p6+p1.p1/2+p5.p5/2-p2.p2/2;
id  p6.p7 = p5.p5/2-p6.p6/2-p7.p7/2;
#call ACCU(o1 rewite 1\(1\))
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p7 = -Q.p6+p1.p1/2-p2.p2/2+p3.p3/2-p4.p4/2;
#call ACCU(o1 rewite 2\(1\))
#endif
#if ( `O1PATH' == 2 )
id  p1.p5 = p1.p1/2+p5.p5/2-p2.p2/2;
id  p5.p6 = p5.p5/2+p6.p6/2-p7.p7/2;
#call ACCU(o1 rewite 1\(2\))
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p5 = p1.p1/2-p2.p2/2+p3.p3/2-p4.p4/2;
#call ACCU(o1 rewite 2\(2\))
#endif
#endif
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
id  p4.p6 = p4.p4/2+p6.p6/2-p7.p7/2;
id  p3.p4 = p3.p3/2+p4.p4/2-p5.p5/2;
#call ACCU(o2 rewrite 1)
id  Q.p3 = p2.p2/2-Q.Q/2-p3.p3/2;
id  Q.p4 = p1.p1/2-Q.Q/2-p4.p4/2;
#call ACCU(o2 rewrite 2)
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
id  Q.p6 = p6.p6/2+Q.Q/2-p7.p7/2;
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o3 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(o3 rewrite 2)
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
id  Q.p6 = p6.p6/2+Q.Q/2-p7.p7/2;
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(o4 rewrite 1)
id  p1.p6 = p1.p1/2+p6.p6/2-p4.p4/2;
id  p2.p6 = p2.p2/2+p6.p6/2-p3.p3/2;
#call ACCU(o4 rewrite 2)
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y1 rewrite)
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(y2 rewrite 1)
id  p1.p5 = p1.p1/2+p5.p5/2-p6.p6/2;
#call ACCU(y2 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y2 rewrite 3)
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(y3 rewrite 1)
id  p3.p5 = p3.p3/2+p5.p5/2-p6.p6/2;
#call ACCU(y3 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y3 rewrite 3)
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
id  Q.p5 = p5.p5/2+Q.Q/2-p6.p6/2;
#call ACCU(y4 rewrite 1)
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(y4 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y4 rewrite 3)
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
id  Q.p5 = p5.p5/2+Q.Q/2-p6.p6/2;
#call ACCU(y5 rewrite 1)
id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(y5 rewrite 2)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(y5 rewrite 3)
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
id  p1.p2 = p1.p1/2+p2.p2/2-p5.p5/2;
#call ACCU(t1 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p4.p4/2;
#call ACCU(t1 rewrite 2)
id  Q.p2 = p2.p2/2+Q.Q/2-p3.p3/2;
#call ACCU(t1 rewrite 3)
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
id  p1.p3 = p1.p1/2+p3.p3/2-p4.p4/2;
#call ACCU(t2 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(t2 rewrite 2)
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
id  Q.p3 = p3.p3/2+Q.Q/2-p4.p4/2;
#call ACCU(t3 rewrite 1)
id  Q.p1 = p1.p1/2+Q.Q/2-p2.p2/2;
#call ACCU(t3 rewrite 2)
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure
*--#] scalars : 
*--#[ simplify :
#procedure simplify
*
*	Note: The acc'mncs are leftovers when the gamma'mncs are normalized.
*	In that case two gamma'mncs had to be reduced down, so that the
*	first part is one. Actually the first acc can be cancelled
*	against the factors in the definition of the exp'mncs.
*
if ( match(mncG(?a,0,0)) );
id	mncG(mncx1?,0,mncy1?,0,0,0) = mncaccm(mncT00(mncx1,mncy1));
id	mncG(mncx1?,1,mncy1?,0,0,0) = mncexp10*mncaccm(mncT10(mncx1,mncy1));
id	mncG(mncx1?,0,mncy1?,1,0,0) = mncexp10*mncaccm(mncT10(mncy1,mncx1));
id	mncG(mncx1?,2,mncy1?,0,0,0) = mncexp20*mncaccm(mncT20(mncx1,mncy1));
id	mncG(mncx1?,0,mncy1?,2,0,0) = mncexp20*mncaccm(mncT20(mncy1,mncx1));
id	mncG(mncx1?,1,mncy1?,1,0,0) = mncexp11*mncaccm(mncT11(mncx1,mncy1));
id	mncaccm(mncT00(mncx?,mncy?)) = mncG(mncx,0,mncy,0,0,0);
id	mncaccm(mncT10(mncx?,mncy?)) = mncG(mncx,1,mncy,0,0,0)/mncexp10;
id	mncaccm(mncT20(mncx?,mncy?)) = mncG(mncx,2,mncy,0,0,0)/mncexp20;
id	mncaccm(mncT11(mncx?,mncy?)) = mncG(mncx,1,mncy,1,0,0)/mncexp11;
id	mncaccm(mncx?) = acc(mncx);
endif;
if ( count(mncG,1) );
id	mncG(mncx1?,mncy1?,mncx2?,mncy2?,D?,mncs?) = mncpo(mncx1+mncx2-mncs-2,1+mncy1+mncy2)
	*mncpo(2-mncx1+D-mncs,-1-mncy1)*mncpo(2-mncx2+mncs,-1-mncy2)
		*acc(1-2*ep-ep*mncy1-ep*mncy2)
	*mncpoinv(mncx1,mncy1)*mncpoinv(mncx2,mncy2)*mncpoinv(4-mncx1-mncx2+D,-2-mncy1-mncy2)
	*mncG(1,mncy1,1,mncy2,0,0);
id  mncG(1,0,1,0,0,0) = 1;
id  mncG(1,1,1,1,0,0) = mncexp11; *1/3
id  mncG(1,0,1,1,0,0) = mncexp10; *1/2
id  mncG(1,1,1,0,0,0) = mncexp10; *1/2
id  mncG(1,0,1,2,0,0) = mncexp20; *1/3
id  mncG(1,2,1,0,0,0) = mncexp20; *1/3

id mncpo(1,?a) = 1;
id mncpoinv(1,?a) = 1;
id mncpo(mncx1?pos_,0) = fac_(mncx1-1);
id mncpoinv(mncx1?pos_,0) = invfac_(mncx1-1);

id,many,mncpo(mncx1?neg0_,mncx2?) = acc(mncPO(mncx1,mncx2))/mncx2/ep;
id,many,mncpo(mncx1?,mncx2?) = acc(mncPO(mncx1,mncx2));
id,many,mncpoinv(mncx1?neg0_,mncx2?) = acc(mncPOINV(mncx1,mncx2))*mncx2*ep;
id,many,mncpoinv(mncx1?,mncx2?) = acc(mncPOINV(mncx1,mncx2));

endif;
id  mncexp10*mncexp20 = mncexp11*acc(1+ep+3*ep^2+9*ep^3+27*ep^4+81*ep^5+243*ep^6);

multiply ep;

#endprocedure

*--#] simplify : 
*--#[ special :
#procedure special(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
#define LATRANS "0"
if ( ( count(mncx5,1) > 0 ) && ( count(mncx2,1) == 0 ) );
	multiply,replace_(
	 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
	,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
	,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
	,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3);
endif;
if ( ( count(mncx2,1) > 0 ) && ( count(mncx6,1) > 0 ) );
	multiply,replace_(
	 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
	,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
	,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
	,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
	,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
	,[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
	multiply,replace_(mncx1,mncx3,mncx3,mncx1,mncx4,mncx6,mncx6,mncx4,mncx7,mncx8,mncx8,mncx7);
endif;
if ( match(mncx2*mncx8*mncx4) );
	if ( match(mncDg(?a,[P-p2])) || match(mncDg(?a,-[P-p2]))
	|| match(mncfp(?a,[P-p2])) || match(mncfp(?a,-[P-p2]))
	|| match(mncDgh(?a,[P-p2])) || match(mncDgh(?a,-[P-p2])) );
		multiply,replace_([P+p8],p8,[P+p4],p4,p4,-[P-p4],p3,-[P-p3],mncx8,mncx3,mncx3,mncx8);
	else;
		multiply,replace_([P-p8],-p8,[P-p4],-p4,p4,[P+p4],p3,[P+p3],mncx8,mncx3,mncx3,mncx8);
	endif;
endif;
if ( count(mncx7,1,mncx8,1) > 0 );
  if ( match(mncx7*mncx8) > 0 );
    redefine LATRANS "3";
	if ( count(mncx5,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  elseif ( (match(mncx7*mncx1) > 0) || (match(mncx7*mncx6) > 0) );
    redefine LATRANS "2";
	if ( count(mncx6,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  elseif ( (match(mncx8*mncx3) > 0) || (match(mncx8*mncx4) > 0) );
    redefine LATRANS "2";
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
	if ( count(mncx6,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  else;
    redefine LATRANS "1";
	if ( count(mncx8,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
	if ( count(mncx5,1) > 0 )
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
  endif;
elseif ( count(mncx4,1,mncx5,1,mncx6,1) > count(mncx1,1,mncx2,1,mncx3,1) );
		multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,-p7,p8,-p8,
		[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] la : 
*--#[ be :
#case be
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
#define BEPATH "0"
if ( match(mncx4*mncx5) );
	redefine BEPATH "7";*  1,5,4 or 3,4,5 or 4,5
	if ( count(mncx3,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx4*mncx6*mncx8) || match(mncx5*mncx7*mncx8) );
	redefine BEPATH "4";*  4,8,6 or 5,8,7 or 4,8 or 5,8
	if ( count(mncx5,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( ( count(mncx4,1,mncx5,1) > 0 ) && ( count(mncx1,1,mncx3,1) == 0 ) );
label 6;
	redefine BEPATH "6";*  4,8,7,or 5,8,6 or 4,8 or 5,8
	if ( count(mncx4,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx1*mncx6*mncx7) || match(mncx3*mncx6*mncx7) );
	redefine BEPATH "5";*  1,6,7 or 3,7,6
	if ( count(mncx3,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx6*mncx7) );
	redefine BEPATH "8";*  6,7
elseif ( match(mncx2*mncx8) );
	redefine BEPATH "3";*  2,6,8 or 2,7,8
	if ( count(mncx7,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx2*mncx7) || match(mncx2*mncx6) );
	redefine BEPATH "2";*  1,2,7 or 3,2,6
	if ( count(mncx6,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
elseif ( match(mncx6) || match(mncx7) || match(mncx8) );
	if ( match(mncx1*mncx5*mncx6) || match(mncx3*mncx4*mncx7) );
		if ( count(mncx3,1) )
			multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
			,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
			,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
			,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
			,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q]
			,mncx3,mncx1,mncx1,mncx3,mncx4,mncx5,mncx5,mncx4,mncx6,mncx7,mncx7,mncx6)*mncsgn3;
		if ( match(mncDg(?a,[P-p6])) || match(mncDg(?a,-[P-p6]))
		|| match(mncfp(?a,[P-p6])) || match(mncfp(?a,-[P-p6]))
		|| match(mncDgh(?a,[P-p6])) || match(mncDgh(?a,-[P-p6])) );
			multiply,replace_([P+p5],p5,[P+p1],p1,[P-p6],-p6,
			p6,[P+p6],p8,[P+p8],p5,-[P-p5],[P-p5],-p5,[P-p1],-p1,[P+p6],p6,
			mncx1,mncx8,mncx8,mncx1);
		else;
*
*			This one still needs correcting in some databases
*
			multiply,replace_([P+p5],p5,[P+p1],p1,[P-p6],-p6,
			p6,-[P-p6],p8,-[P-p8],p5,[P+p5],[P-p5],-p5,[P-p1],-p1,[P+p6],p6,
			mncx1,mncx8,mncx8,mncx1);
		endif;
		goto 6;
	endif;
	if ( match(mncx3*mncx4*mncx8) || match(mncx1*mncx5*mncx8) );
		if ( count(mncx3,1) )
			multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
			,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
			,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
			,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
			,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q]
			,mncx3,mncx1,mncx1,mncx3,mncx4,mncx5,mncx5,mncx4,mncx6,mncx7,mncx7,mncx6)*mncsgn3;
		if ( match(mncDg(?a,[P+p1])) || match(mncDg(?a,-[P+p1]))
		|| match(mncfp(?a,[P+p1])) || match(mncfp(?a,-[P+p1]))
		|| match(mncDgh(?a,[P+p1])) || match(mncDgh(?a,-[P+p1])) );
			multiply,replace_(p1,-[P-p1],p6,[P+p6],p8,[P+p8]
			,[P+p1],p1,[P+p5],p5,[P-p8],-p8
			,[P-p1],-p1,[P-p5],-p5,[P+p8],p8
			,mncx5,mncx6,mncx6,mncx5);
		else;
*
*			This one still needs correcting in some databases
*
			multiply,replace_(p1,[P+p1],p6,-[P-p6],p8,-[P-p8]
			,[P+p1],p1,[P+p5],p5,[P-p8],-p8
			,[P-p1],-p1,[P-p5],-p5,[P+p8],p8
			,mncx5,mncx6,mncx6,mncx5);
		endif;
	endif;
	redefine BEPATH "1";*  1,6,8 or 1,6 or 6,8 or 5,1,6 or vv
	if ( count(mncx7,1) > 0 )
		multiply,replace_(p1,-p3,p3,-p1,p2,-p2,p6,-p7,p7,-p6,p4,-p5,p5,-p4,Q,-Q
		,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1]
		,[P+p4],[P-p5],[P+p5],[P-p4],[P-p4],[P+p5],[P-p5],[P+p4]
		,[P+p6],[P-p7],[P+p7],[P-p6],[P-p6],[P+p7],[P-p7],[P+p6]
		,[P+p2],[P-p2],[P-p2],[P+p2],[P+Q],[P-Q],[P-Q],[P+Q])*mncsgn3;
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] be : 
*--#[ no :
#case no
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
#define NOSPEC "0"
repeat id mncx?[mncx18]^2 = mncx;
if ( match(mncx2*mncx7*mncx8) || match(mncx5*mncx7*mncx8) || match(mncx2*mncx5*mncx7) || match(mncx2*mncx5*mncx8) );
    redefine NOSPEC "1";
	if ( count(mncx2,1) == 0 );
		multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
		multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
		multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3,mncx7,mncx8,mncx8,mncx7);
	elseif ( count(mncx7,1) == 0 );
		multiply,replace_(
			p1,-p6,p6,-p1,[P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1],
			p7,p5,p5,p7,[P+p7],[P+p5],[P+p5],[P+p7],[P-p7],[P-p5],[P-p5],[P-p7],
			p2,-p8,p8,-p2,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2],
			mncx1,mncx6,mncx6,mncx1,mncx5,mncx7,mncx7,mncx5,mncx2,mncx8,mncx8,mncx2);
	elseif ( count(mncx8,1) == 0 );
		multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
		multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
		multiply,replace_(mncx2,mncx7,mncx7,mncx2,mncx8,mncx5,mncx5,mncx8,mncx3,mncx4,mncx4,mncx3);
	endif;
*
*	We have now a configuration with 7,2,8
*	Now minimize the number of fermions
*
	id  mncfp(?a, mncp?mncPcenter,?b) = mncfp(?a, mncp,?b)*mncx;
	id  mncfp(?a,-mncp?mncPcenter,?b) = mncfp(?a,-mncp,?b)*mncx;
	id	mncfp(?a, mncp?mncpcenter,?b ) = mncfp(?a, mncp,?b)/mncx;
	id	mncfp(?a,-mncp?mncpcenter,?b ) = mncfp(?a,-mncp,?b)/mncx;
	if ( count(mncx,1) > 0 );
		if ( match(mncDg(?a,[P-p7])) || match(mncDg(?a,-[P-p7]))
		|| match(mncfp(?a,[P-p7])) || match(mncfp(?a,-[P-p7]))
		|| match(mncDgh(?a,[P-p7])) || match(mncDgh(?a,-[P-p7])) );
			multiply,replace_([P-p7],-p7,[P-p2],-p2,[P-p8],-p8,
			p7,[P+p7],p5,-[P-p5],p8,[P+p8],mncx2,mncx5,mncx5,mncx2);
		else;
			multiply,replace_([P+p7],p7,[P+p2],p2,[P+p8],p8,
			p7,-[P-p7],p5,[P+p5],p8,-[P-p8],mncx2,mncx5,mncx5,mncx2);
		endif;
		multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
		multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
		multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3,mncx7,mncx8,mncx8,mncx7);
	endif;
	id	mncx = 1;
	id	1/mncx = 1;
else;
if ( ( count(mncx3,1) > 0 ) && ( count(mncx1,1,mncx4,1,mncx6,1) == 0 ) );
	multiply,replace_(
		p1,-p3,p3,-p1,[P+p1],[P-p3],[P+p3],[P-p1],[P-p1],[P+p3],[P-p3],[P+p1],
		p4,-p6,p6,-p4,[P+p4],[P-p6],[P+p6],[P-p4],[P-p4],[P+p6],[P-p6],[P+p4],
		p2,-p2,[P+p2],[P-p2],[P-p2],[P+p2],
		p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5],
		p7,-p8,p8,-p7,[P+p7],[P-p8],[P+p8],[P-p7],[P-p7],[P+p8],[P-p8],[P+p7],
		Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q],
		mncx1,mncx3,mncx3,mncx1,mncx4,mncx6,mncx6,mncx4,mncx7,mncx8,mncx8,mncx7)*mncsgn3;
endif;
if ( ( count(mncx4,1) > 0 ) && ( count(mncx1,1,mncx3,1,mncx6,1) == 0 ) );
	multiply,replace_(
		p1,p4,p4,p1,[P+p1],[P+p4],[P+p4],[P+p1],[P-p1],[P-p4],[P-p4],[P-p1],
		p2,p5,p5,p2,[P+p2],[P+p5],[P+p5],[P+p2],[P-p2],[P-p5],[P-p5],[P-p2],
		p3,p6,p6,p3,[P+p3],[P+p6],[P+p6],[P+p3],[P-p3],[P-p6],[P-p6],[P-p3],
		p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7],
		p8,-p8,[P+p8],[P-p8],[P-p8],[P+p8],
		Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q],
		mncx1,mncx4,mncx4,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx6,mncx6,mncx3)*mncsgn3;
endif;
if ( ( count(mncx6,1) > 0 ) && ( count(mncx1,1) == 0 ) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
	multiply,replace_(mncx1,mncx6,mncx6,mncx1,mncx2,mncx5,mncx5,mncx2,mncx3,mncx4,mncx4,mncx3,mncx7,mncx8,mncx8,mncx7);
endif;
if ( match(mncx1*mncx7) > 0 );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
	multiply,replace_(mncx2,mncx7,mncx7,mncx2,mncx8,mncx5,mncx5,mncx8,mncx3,mncx4,mncx4,mncx3);
endif;
if ( match(mncx1*mncx2*mncx8) > 0 );
    redefine NOSPEC "2";
endif;
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
#define O1PATH "0"
if ( match(mncx6*mncx7) > 0 );
	redefine O1PATH "1";
elseif ( ( count(mncx6,1,mncx7,1) > 0 ) && ( count(mncx3,1,mncx4,1) > 0 ) );
	multiply replace_(
		p1,-p4,p4,-p1,[P+p1],[P-p4],[P-p1],[P+p4],[P+p4],[P-p1],[P-p4],[P+p1],
		p2,-p3,p3,-p2,[P+p2],[P-p3],[P-p2],[P+p3],[P+p3],[P-p2],[P-p3],[P+p2],
		p5,-p5,[P-p5],[P+p5],[P+p5],[P-p5],
		p6,-p6,[P-p6],[P+p6],[P+p6],[P-p6],
		p7,-p7,[P-p7],[P+p7],[P+p7],[P-p7],
		mncx1,mncx4,mncx4,mncx1,mncx2,mncx3,mncx3,mncx2);
endif;
if ( count(mncx3,1,mncx4,1) > count(mncx1,1,mncx2,1) );
	multiply replace_(
		p1,-p4,p4,-p1,[P+p1],[P-p4],[P-p1],[P+p4],[P+p4],[P-p1],[P-p4],[P+p1],
		p2,-p3,p3,-p2,[P+p2],[P-p3],[P-p2],[P+p3],[P+p3],[P-p2],[P-p3],[P+p2],
		p5,-p5,[P-p5],[P+p5],[P+p5],[P-p5],
		p6,-p6,[P-p6],[P+p6],[P+p6],[P-p6],
		p7,-p7,[P-p7],[P+p7],[P+p7],[P-p7],
		mncx1,mncx4,mncx4,mncx1,mncx2,mncx3,mncx3,mncx2);
endif;
if ( ( count(mncx7,1) > 0 ) && ( count(mncx6,1) == 0 ) );
	multiply replace_(p6,p7,p7,p6,[P+p6],[P+p7],[P+p7],[P+p6],
		[P-p6],[P-p7],[P-p7],[P-p6],mncx6,mncx7,mncx7,mncx6);
endif;
if ( ( count(mncx2,1) > 0 ) && ( count(mncx1,1) == 0 ) );
	multiply replace_(
		p1,-p2,p2,-p1,[P+p1],[P-p2],[P-p1],[P+p2],[P+p2],[P-p1],[P-p2],[P+p1],
		p4,-p3,p3,-p4,[P+p4],[P-p3],[P-p4],[P+p3],[P+p3],[P-p4],[P-p3],[P+p4],
		Q,-Q,[P-Q],[P+Q],[P+Q],[P-Q],mncx1,mncx2,mncx2,mncx1,mncx4,mncx3,mncx3,mncx4)*mncsgn3;
endif;
if ( count(mncx5,1) > 0 );
	redefine O1PATH "2";
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
id  mncDg(?a,mncp?[mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,mncp?[-mncpp18][mncx]) = mncDg(?a,mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDg(?a,-mncp?[-mncpp18][mncx]) = mncDg(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,mncp?[-mncpp18][mncx]) = mncDgh(?a,mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncDgh(?a,-mncp?[-mncpp18][mncx]) = mncDgh(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,mncp?[-mncpp18][mncx]) = mncfp(?a,mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
id  mncfp(?a,-mncp?[-mncpp18][mncx]) = mncfp(?a,-mncp)*[mncx18][mncx];
if ( ( count(mncx7,1) > 0 ) && ( count(mncx6,1) == 0 ) );
	multiply replace_(
		p6,p7,p7,p6,[P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
		mncx6,mncx7,mncx7,mncx6);
endif;
if ( match(mncx6*mncx2*mncx1) );
	if ( match(mncDg(?a,[P-p2])) || match(mncDg(?a,-[P-p2]))
	|| match(mncfp(?a,[P-p2])) || match(mncfp(?a,-[P-p2]))
	|| match(mncDgh(?a,[P-p2])) || match(mncDgh(?a,-[P-p2])) );
		Multiply,replace_([P-p2],-p2,p2,[P+p2],[P-p1],-p1,[P-p4],-p4
		,[P-p6],-p6,p6,[P+p6],p4,[P+p4],p3,[P+p3],mncx1,mncx3,mncx3,mncx1);
	else;
		Multiply,replace_([P+p2],p2,p2,-[P-p2],[P+p4],p4,p4,-[P-p4],[P+p6],p6,
        p6,-[P-p6],p3,-[P-p3],[P+p1],p1,mncx1,mncx3,mncx3,mncx1);
	endif;	
endif;
repeat,id  mncx?[mncx18] = 1;
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure
*--#] special : 
*--#[ subint :
#procedure subint
id  mncexp20*mncexp10 = 1
       + ep * ( 3 )
       + ep^2 * ( 13 )
       + ep^3 * ( 55 - 22*z3 )
       + ep^4 * ( 229 - 66*z3 - 33*z4 )
       + ep^5 * ( 943 - 286*z3 - 99*z4 - 234*z5 )
       + ep^6 * ( 3853 - 1210*z3 + 242*z3^2 - 429*z4 - 702*z5 - 530*z6 );
id  mncexp11 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 22*z3 )
       + ep^4 * ( 128 - 44*z3 - 33*z4 )
       + ep^5 * ( 512 - 176*z3 - 66*z4 - 234*z5 )
       + ep^6 * ( 2048 - 704*z3 + 242*z3^2 - 264*z4 - 468*z5 - 530*z6 );
id  mncexp20 = 1
       + ep * ( 2 )
       + ep^2 * ( 8 )
       + ep^3 * ( 32 - 16*z3 )
       + ep^4 * ( 128 - 32*z3 - 24*z4 )
       + ep^5 * ( 512 - 128*z3 - 48*z4 - 192*z5 )
       + ep^6 * ( 2048 - 512*z3 + 128*z3^2 - 192*z4 - 384*z5 - 440*z6 );
id  mncexp10 = 1
       + ep * ( 1 )
       + ep^2 * ( 3 )
       + ep^3 * ( 9 - 6*z3 )
       + ep^4 * ( 27 - 6*z3 - 9*z4 )
       + ep^5 * ( 81 - 18*z3 - 9*z4 - 42*z5 )
       + ep^6 * ( 243 - 54*z3 + 18*z3^2 - 27*z4 - 42*z5 - 90*z6 );
*
*   This integral is from the paper, but apparently there is a problem
*   with the relative normalization. We correct that here with the
*   factor 1-2*ep. It makes that all our results are in agreement with
*   the mincer paper. 
*
id  mncG311 = (1-2*ep)*(6*z3+9*z4*ep+102*z5*ep^2);
*
id  mncF321 = 20*z5;
id  ep = 0;
#endprocedure
*--#] subint : 
*--#[ sym1 :
#procedure sym1(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
*#if ( `LATRANS' == 0 )
*if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
*	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
*	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
*	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
*	multiply,replace_(
*		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
*		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
*		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
*	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
*	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
*	id p7 = -p7;
*	id p8 = -p8;
*endif;
*if ( count([P+p1].[P+p1],1,[P+p6].[P+p6],1,
*	[P-p1].[P-p1],1,[P-p6].[P-p6],1) >
*	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
*	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
*	multiply,replace_(
*		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
*		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
*		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
*		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
*		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
*		,[P+Q],[P-Q],[P-Q],[P+Q]);
*endif;
*#endif
#else
#ifdef `LASYM'
#if ( `LASYM' == 1 )
	multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	id p7 = -p7;
	id p8 = -p8;
#else
#if ( `LASYM' == 2 )
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q]);
#else
#if ( `LASYM' == 3 )
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q]);
	multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	id p7 = -p7;
	id p8 = -p8;
#endif
#endif
#endif
#else
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
	multiply,replace_(
		 [P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,
	[P+p7],[P-p7],[P-p7],[P+p7],[P+p8],[P-p8],[P-p8],[P+p8]);
	id p7 = -p7;
	id p8 = -p8;
endif;
if ( count([P+p1].[P+p1],1,[P+p6].[P+p6],1,
	[P-p1].[P-p1],1,[P-p6].[P-p6],1) >
	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
	multiply,replace_(
		 [P-p1],[P+p3],[P+p1],[P-p3],[P-p4],[P+p6],[P+p4],[P-p6]
		,[P-p3],[P+p1],[P+p3],[P-p1],[P-p6],[P+p4],[P+p6],[P-p4]
		,[P-p2],[P+p2],[P+p2],[P-p2],[P-p5],[P+p5],[P+p5],[P-p5]
		,[P-p7],[P+p8],[P+p7],[P-p8],[P-p8],[P+p7],[P+p8],[P-p7]
		,p1,-p3,p3,-p1,p4,-p6,p6,-p4,p2,-p2,p5,-p5,p7,-p8,p8,-p7,Q,-Q
		,[P+Q],[P-Q],[P-Q],[P+Q]);
endif;
#endif
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifdef `NOSPEC'
#if ( `NOSPEC' == 1 )
if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) == 0 );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
elseif( count([P+p7].[P+p7],1,[P-p7].[P-p7],1) == 0 );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
elseif ( count([P+p8].[P+p8],1,[P-p8].[P-p8],1) == 0 );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
else;
	if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
	endif;
	if ( count([P+p7].[P+p7],1,[P-p7].[P-p7],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
	if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
	endif;
	elseif ( count([P+p8].[P+p8],1,[P-p8].[P-p8],1) > count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
	endif;
endif;
#else
#if ( `NOSPEC' == 0 )
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
endif;
if ( count([P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p7].[P+p7],1,
	[P-p4].[P-p4],1,[P-p7].[P-p7],1) );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
endif;
if ( count([P+p2].[P+p2],1,[P+p1].[P+p1],1,
	[P-p2].[P-p2],1,[P-p1].[P-p1],1) >
	count([P+p6].[P+p6],1,[P+p8].[P+p8],1,
	[P-p6].[P-p6],1,[P-p8].[P-p8],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
endif;
#endif
#endif
#else
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p5].[P+p5],1,[P+p6].[P+p6],1,
	[P-p4].[P-p4],1,[P-p5].[P-p5],1,[P-p6].[P-p6],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p5],[P+p2],[P-p5],[P+p5],[P-p2],[P-p5],[P+p2]
		,[P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]);
	multiply,replace_(p1,-p6,p6,-p1,p2,-p5,p5,-p2,p3,-p4,p4,-p3,p7,p8,p8,p7
		,[P+p8],[P+p7],[P+p7],[P+p8],[P-p8],[P-p7],[P-p7],[P-p8]);
endif;
if ( count([P+p2].[P+p2],1,[P+p3].[P+p3],1,
	[P-p2].[P-p2],1,[P-p3].[P-p3],1) >
	count([P+p4].[P+p4],1,[P+p7].[P+p7],1,
	[P-p4].[P-p4],1,[P-p7].[P-p7],1) );
	multiply,replace_([P-p3],[P+p4],[P+p3],[P-p4],[P+p4],[P-p3],[P-p4],[P+p3]
		,[P-p2],[P+p7],[P+p2],[P-p7],[P+p7],[P-p2],[P-p7],[P+p2]
		,[P+p5],[P+p8],[P-p5],[P-p8],[P+p8],[P+p5],[P-p8],[P-p5]);
	multiply,replace_(p2,-p7,p7,-p2,p8,p5,p5,p8,p3,-p4,p4,-p3);
endif;
if ( count([P+p2].[P+p2],1,[P+p1].[P+p1],1,
	[P-p2].[P-p2],1,[P-p1].[P-p1],1) >
	count([P+p6].[P+p6],1,[P+p8].[P+p8],1,
	[P-p6].[P-p6],1,[P-p8].[P-p8],1) );
	multiply,replace_([P-p1],[P+p6],[P+p1],[P-p6],[P+p6],[P-p1],[P-p6],[P+p1]
		,[P-p2],[P+p8],[P+p2],[P-p8],[P+p8],[P-p2],[P-p8],[P+p2]
		,[P+p5],[P+p7],[P-p5],[P-p7],[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(p2,-p8,p8,-p2,p7,p5,p5,p7,p1,-p6,p6,-p1);
endif;
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
*if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) >
*	count([P+p7].[P+p7],1,[P-p7].[P-p7],1) );
*	multiply,replace_([P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
*	p6,p7,p7,p6);
*endif;
*if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
*	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
*	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
*	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
*	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
*		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
*		,[P-p5],[P+p5],[P+p5],[P-p5],[P-p6],[P+p6],[P+p6],[P-p6]
*		,[P-p7],[P+p7],[P+p7],[P-p7]);
*	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2);
*	id	p5 = -p5;
*	id	p6 = -p6;
*	id	p7 = -p7;
*endif;
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) >
	count([P+p7].[P+p7],1,[P-p7].[P-p7],1) );
	multiply,replace_([P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
	p6,p7,p7,p6);
endif;
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) >
	count([P+p7].[P+p7],1,[P-p7].[P-p7],1) );
	multiply,replace_([P+p6],[P+p7],[P+p7],[P+p6],[P-p6],[P-p7],[P-p7],[P-p6]
	,p6,p7,p7,p6);
endif;
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
	count([P+p3].[P+p3],1,[P+p4].[P+p4],1,
	[P-p3].[P-p3],1,[P-p4].[P-p4],1) );
	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
		,[P-p5],[P+p5],[P+p5],[P-p5]);
	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2);
	id	p5 = -p5;
endif;
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
	count([P+p4].[P+p4],1,[P+p3].[P+p3],1,
	[P-p4].[P-p4],1,[P-p3].[P-p3],1) );
	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
		,[P-p5],[P+p5],[P+p5],[P-p5]);
	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2);
	id	p5 = -p5;
endif;
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
if ( count([P+p6].[P+p6],1,[P-p6].[P-p6],1) <
	count([P+p5].[P+p5],1,[P-p5].[P-p5],1) );
	multiply,replace_([P+p6],[P+p5],[P+p5],[P+p6],[P-p6],[P-p5],[P-p5],[P-p6]
	p6,p5,p5,p6);
endif;
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4);
endif;
if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) <
	count([P+p1].[P+p1],1,[P-p1].[P-p1],1) );
	multiply,replace_([P+p2],[P+p1],[P+p1],[P+p2],[P-p2],[P-p1],[P-p1],[P-p2]
	p2,p1,p1,p2);
endif;
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
if ( count([P+p1].[P+p1],1,[P+p2].[P+p2],1,
	[P-p1].[P-p1],1,[P-p2].[P-p2],1) >
	count([P+p4].[P+p4],1,[P+p3].[P+p3],1,
	[P-p4].[P-p4],1,[P-p3].[P-p3],1) );
	multiply,replace_([P-p1],[P+p4],[P+p1],[P-p4],[P+p4],[P-p1],[P-p4],[P+p1]
		,[P-p2],[P+p3],[P+p2],[P-p3],[P+p3],[P-p2],[P-p3],[P+p2]
		,[P-p5],[P+p5],[P+p5],[P-p5]);
	multiply,replace_(p1,-p4,p4,-p1,p2,-p3,p3,-p2,mnce1,mnce4,mnce4,mnce1,mnce2,mnce3,mnce3,mnce2);
	id	p5 = -p5;
endif;
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4,mnce3,mnce4,mnce4,mnce3);
endif;
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
if ( count([P+p4].[P+p4],1,[P-p4].[P-p4],1) <
	count([P+p3].[P+p3],1,[P-p3].[P-p3],1) );
	multiply,replace_([P+p4],[P+p3],[P+p3],[P+p4],[P-p4],[P-p3],[P-p3],[P-p4]
	p4,p3,p3,p4,mnce3,mnce4,mnce4,mnce3);
endif;
if ( count([P+p2].[P+p2],1,[P-p2].[P-p2],1) <
	count([P+p1].[P+p1],1,[P-p1].[P-p1],1) );
	multiply,replace_([P+p2],[P+p1],[P+p1],[P+p2],[P-p2],[P-p1],[P-p1],[P-p2]
	p2,p1,p1,p2,mnce1,mnce2,mnce2,mnce1);
endif;
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure

*--#] sym1 : 
*--#[ sym2 :
#procedure sym2(TOPO)
#switch `TOPO'
*--#[ la :
#case la
*
#ifdef `LATRANS'
#if ( `LATRANS' != 1 )
#if ( `LATRANS' != 2 )
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p6.p6,1) < count(p4.p4,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p6.p6,1) == count(p4.p4,1) );
	    if ( count(p1.p1,1) < count(p3.p3,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#endif
#endif
#else
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p6.p6,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#endif
*
#break
*--#] la : 
*--#[ be :
#case be
*
#ifndef `BEPATH'
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#else
#if ( `BEPATH' == 0 )
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#endif
#if ( `BEPATH' == 7 )
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#endif
#if ( `BEPATH' == 8 )
if ( count(p6.p6,1) < count(p7.p7,1) );
	multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
elseif ( count(p6.p6,1) == count(p7.p7,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p5.p5,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p5,p5,p4,p6,p7,p7,p6,p8,-p8);
	endif;
endif;
#endif
#endif
*
#break
*--#] be : 
*--#[ no :
#case no
*
#ifndef `NOSPEC'
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p6.p6,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#else
#if ( `NOSPEC' != 2 )
if ( count(p7.p7,1) < count(p8.p8,1) );
	multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
elseif ( count(p7.p7,1) == count(p8.p8,1) );
    if ( count(p1.p1,1) < count(p3.p3,1) );
		multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	elseif ( count(p1.p1,1) == count(p3.p3,1) );
	    if ( count(p6.p6,1) < count(p4.p4,1) )
			multiply replace_(p1,p3,p3,p1,p4,p6,p6,p4,p7,p8,p8,p7);
	endif;
endif;
#endif
#endif
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure

*--#] sym2 : 
*--#[ tabtwo :
#procedure tabtwo(n)
Ctable,check,strict,mncTabTwo(-10:12);
*
#if ( `n' > 10 )
fill mncTabTwo(-10) =
     + 1/33*ep^-2*mncexp11 - 22129/914760*ep^-1*mncexp11 - 216938023/1014285888*mncexp11
	 - 5997222836107/6694286860800*ep*mncexp11
	 - 4249965245766403333/1298959422469632000*ep^2*mncexp11
	 - 2047223673498737416560637/180035775954290995200000*ep^3*mncexp11
	 + 2/11*ep*mncG311 + 88751/152460*ep^2*mncG311 + 2314681471/1408730400*ep^3*mncG311;
fill mncTabTwo(-9) =
     - 1/30*ep^-2*mncexp11 + 439/15120*ep^-1*mncexp11 + 44567623/190512000*mncexp11
	 + 22148701837/22861440000*ep*mncexp11
	 + 1422368328652361/403275801600000*ep^2*mncexp11
	 + 12441442444649011943/1016255020032000000*ep^3*mncexp11
	 - 1/5*ep*mncG311 - 1577/2520*ep^2*mncG311 - 18605911/10584000*ep^3*mncG311;
#endif
#if ( `n' > 8 )
fill mncTabTwo(-8) =
     + 1/27*ep^-2*mncexp11 - 797/22680*ep^-1*mncexp11 - 44217371/171460800*mncexp11
	 - 65104918307/61725888000*ep*mncexp11
	 - 4166135527435991/1088844664320000*ep^2*mncexp11
	 - 36393341868100266377/2743888554086400000*ep^3*mncexp11
	 + 2/9*ep*mncG311 + 2563/3780*ep^2*mncG311 + 74297/39200*ep^3*mncG311;
fill mncTabTwo(-7) =
	 - 1/24*ep^-2*mncexp11 + 289/6720*ep^-1*mncexp11 + 4876579/16934400*mncexp11
	 + 2364251101/2032128000*ep*mncexp11
	 + 16751468663557/3982970880000*ep^2*mncexp11
	 + 48704651163860173/3345695539200000*ep^3*mncexp11
	 - 1/4*ep*mncG311 - 831/1120*ep^2*mncG311 - 5823947/2822400*ep^3*mncG311;
#endif
#if ( `n' > 6 )
fill mncTabTwo(-6) =
      1/21*ep^-2*mncexp11 - 157/2940*ep^-1*mncexp11 - 172243/529200*mncexp11
	 - 288228947/222264000*ep*mncexp11 - 113013415303/24202080000*ep^2*mncexp11
	 - 1476575820814739/91483862400000*ep^3*mncexp11
	 + 2/7*ep*mncG311 + 403/490*ep^2*mncG311 + 1404743/617400*ep^3*mncG311;
fill mncTabTwo(-5) =
	 - 1/18*ep^-2*mncexp11 + 73/1080*ep^-1*mncexp11 + 24389/64800*mncexp11
	 + 1917641/1296000*ep*mncexp11 + 15283541/2880000*ep^2*mncexp11
	 + 9491140693/518400000*ep^3*mncexp11
	 - 1/3*ep*mncG311 - 167/180*ep^2*mncG311 - 1021/400*ep^3*mncG311;
#endif
#if ( `n' > 4 )
fill mncTabTwo(-4) =
      1/15*ep^-2*mncexp11 - 79/900*ep^-1*mncexp11 - 24007/54000*mncexp11
	 - 1857983/1080000*ep*mncexp11 - 398148641/64800000*ep^2*mncexp11
	 - 82309007731/3888000000*ep^3*mncexp11
	 + 2/5*ep*mncG311 + 161/150*ep^2*mncG311 + 8807/3000*ep^3*mncG311;
fill mncTabTwo(-3) =
	 - 1/12*ep^-2*mncexp11 + 17/144*ep^-1*mncexp11 + 955/1728*mncexp11
	 + 1619/768*ep*mncexp11 + 621317/82944*ep^2*mncexp11 + 25618703/995328*ep^3*mncexp11
	 - 1/2*ep*mncG311 - 31/24*ep^2*mncG311 - 337/96*ep^3*mncG311;
#endif
fill mncTabTwo(-2) =
      1/9*ep^-2*mncexp11 - 1/6*ep^-1*mncexp11 - 233/324*mncexp11
	 - 5251/1944*ep*mncexp11 - 111641/11664*ep^2*mncexp11 - 2301799/69984*ep^3*mncexp11
	 + 2/3*ep*mncG311 + 5/3*ep^2*mncG311 + 9/2*ep^3*mncG311;
fill mncTabTwo(-1) =
	 - 1/6*ep^-2*mncexp11 + 1/4*ep^-1*mncexp11 + 9/8*mncexp11
	 + 203/48*ep*mncexp11 + 477/32*ep^2*mncexp11 + 3261/64*ep^3*mncexp11
	 - ep*mncG311 - 5/2*ep^2*mncG311 - 27/4*ep^3*mncG311;
fill mncTabTwo(0) =
     + 1/3*ep^-2*mncexp11 - 1/3*ep^-1*mncexp11 - 5/3*mncexp11
	 - 7*ep*mncexp11 - 27*ep^2*mncexp11 - 99*ep^3*mncexp11
	 + 2*ep*mncG311 + 6*ep^2*mncG311 + 18*ep^3*mncG311;
fill mncTabTwo(1) = mncG311;
fill mncTabTwo(2) =
     + 1/3*ep^-2*mncexp11 - 2*ep^-1*mncexp11 + 28*ep*mncexp11
	 - 132*ep^2*mncexp11 + 436*ep^3*mncexp11
	 - 3*ep*mncG311 + 6*ep^2*mncG311 - 12*ep^3*mncG311;
fill mncTabTwo(3) =
	 - 1/6*ep^-2*mncexp11 + 2/3*ep^-1*mncexp11 + 23/6*mncexp11
	 - 373/12*ep*mncexp11 + 2429/24*ep^2*mncexp11 - 10693/48*ep^3*mncexp11
	 + 3/2*ep*mncG311 - 3*ep^3*mncG311;
fill mncTabTwo(4) =
     + 1/9*ep^-2*mncexp11 - 19/54*ep^-1*mncexp11 - 227/81*mncexp11
	 + 8801/486*ep*mncexp11 - 148589/2916*ep^2*mncexp11 + 1631399/17496*ep^3*mncexp11
	 - ep*mncG311 - 5/6*ep^2*mncG311 + 23/9*ep^3*mncG311;
fill mncTabTwo(5) =
	 - 1/12*ep^-2*mncexp11 + 2/9*ep^-1*mncexp11 + 995/432*mncexp11
	 - 65743/5184*ep*mncexp11 + 1861109/62208*ep^2*mncexp11
	 - 33766519/746496*ep^3*mncexp11
	 + 3/4*ep*mncG311 + ep^2*mncG311 - 43/24*ep^3*mncG311;
fill mncTabTwo(6) =
      1/15*ep^-2*mncexp11 - 139/900*ep^-1*mncexp11 - 12799/6750*mncexp11
	 + 7720709/810000*ep*mncexp11 - 999124577/48600000*ep^2*mncexp11
	 + 76898788103/2916000000*ep^3*mncexp11
	 - 3/5*ep*mncG311 - 101/100*ep^2*mncG311 + 464/375*ep^3*mncG311;
#if ( `n' > 6 )
fill mncTabTwo(7) =
	 - 1/18*ep^-2*mncexp11 + 41/360*ep^-1*mncexp11 + 13183/8100*mncexp11
	 - 2437711/324000*ep*mncexp11 + 856633049/58320000*ep^2*mncexp11
	 - 19656659797/1166400000*ep^3*mncexp11
	 + 1/2*ep*mncG311 + 39/40*ep^2*mncG311 - 383/450*ep^3*mncG311;
fill mncTabTwo(8) =
      1/21*ep^-2*mncexp11 - 257/2940*ep^-1*mncexp11 - 2620213/1852200*mncexp11
	 + 266505851/43218000*ep*mncexp11 - 1832447625539/163364040000*ep^2*mncexp11
	 + 254648720594909/22870965600000*ep^3*mncexp11
	 - 3/7*ep*mncG311 - 909/980*ep^2*mncG311 + 118681/205800*ep^3*mncG311;
#endif
#if ( `n' > 8 )
fill mncTabTwo(9) =
	 - 1/24*ep^-2*mncexp11 + 29/420*ep^-1*mncexp11 + 5316251/4233600*mncexp11
	 - 6129986999/1185408000*ep*mncexp11 + 26135084020949/2987228160000*ep^2*mncexp11
	 - 2198751676783421/278807961600000*ep^3*mncexp11
	 + 3/8*ep*mncG311 + 123/140*ep^2*mncG311 - 88531/235200*ep^3*mncG311;
fill mncTabTwo(10) =
      1/27*ep^-2*mncexp11 - 3791/68040*ep^-1*mncexp11 - 6029953/5358150*mncexp11
	 + 478951433329/108020304000*ep*mncexp11
	 - 1922783114144729/272211166080000*ep^2*mncexp11
	 + 3804584745942884587/685972138521600000*ep^3*mncexp11
	 - 1/3*ep*mncG311 - 6289/7560*ep^2*mncG311 + 539599/2381400*ep^3*mncG311;
#endif
#if ( `n' > 10 )
fill mncTabTwo(11) =
	 - 1/30*ep^-2*mncexp11 + 691/15120*ep^-1*mncexp11 + 12161273/11907000*mncexp11
	 - 462440372497/120022560000*ep*mncexp11
	 + 1749242338593257/302456851200000*ep^2*mncexp11
	 - 3135287147784104059/762191265024000000*ep^3*mncexp11
	 + 3/10*ep*mncG311 + 265/336*ep^2*mncG311 - 296629/2646000*ep^3*mncG311;
fill mncTabTwo(12) =
     + 1/33*ep^-2*mncexp11 - 34729/914760*ep^-1*mncexp11 - 1183461847/1267857360*mncexp11
	 + 119387071076071/35145006019200*ep*mncexp11
	 - 188324238814636153/38968782674088960*ep^2*mncexp11
	 + 402330866351205405392621/135026831965718246400000*ep^3*mncexp11
	 - 3/11*ep*mncG311 - 76151/101640*ep^2*mncG311 + 16227353/704365200*ep^3*mncG311;
#endif
#endprocedure
*--#] tabtwo : 
*--#[ transfor :
#procedure transfor(TOPOL)
*
*	This file contains topology transformations.
*	The topology assignments of Paulo (lili or convert) sometimes
*	give a diagram a topology that is too complicated, because he
*	could not take the 4 and 5 point vertices into account properly.
*	This file also makes some diagrams zero of which it can be
*	easily seen that this must be the case.
*
#switch `TOPOL'
*--#[ la :
#case la
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p8,-p5,[P+p8],[P-p5],[P-p8],[P+p5]
	,p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	);
	multiply,replace_(mncx8,mncx5,mncx2,mncx1,mncx3,mncx2,mncx4,mncx3,mncx5,mncx4);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,-p5,[P+p1],[P-p5],[P-p1],[P+p5]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p5,-p2,[P+p5],[P-p2],[P-p5],[P+p2]
	,p6,-p1,[P+p6],[P-p1],[P-p6],[P+p1]
	,p7,p6,[P+p7],[P+p6],[P-p7],[P-p6]
	,p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	);
	multiply,replace_(mncx1,mncx5,mncx3,mncx4,mncx4,mncx3,mncx5,mncx2,mncx6,mncx1,mncx7,mncx6,mncx8,mncx7);
	redefine TOPO "be";
	Print,"Topology changed from la to be";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p1,-p2,[P+p1],[P-p2],[P-p1],[P+p2]
	,p2,-p1,[P+p2],[P-p1],[P-p2],[P+p1]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	,p6,-p3,[P+p6],[P-p3],[P-p6],[P+p3]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	,p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	)*mncsgn3;
	multiply,replace_(mncx1,mncx2,mncx2,mncx1,mncx7,mncx5,mncx5,mncx4,mncx6,mncx3,mncx4,mncx6,mncx8,mncx7);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p2,p4,[P+p2],[P+p4],[P-p2],[P-p4]
	,p5,p1,[P+p5],[P+p1],[P-p5],[P-p1]
	,p6,p2,[P+p6],[P+p2],[P-p6],[P-p2]
	,p3,p6,[P+p3],[P+p6],[P-p3],[P-p6]
	,p8,-p7,[P+p8],[P-p7],[P-p8],[P+p7]
	)*mncsgn3;
	multiply,replace_(mncx7,mncx5,mncx1,mncx3,mncx2,mncx4,mncx5,mncx1,mncx6,mncx2,mncx3,mncx6,mncx8,mncx7);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p7,-p6,[P+p7],[P-p6],[P-p7],[P+p6]
	,p8,-p7,[P+p8],[P-p7],[P-p8],[P+p7]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	);
	multiply,replace_(mncx7,mncx6,mncx8,mncx7,mncx6,mncx5);
	redefine TOPO "be";
	Print,"Topology changed from la to be";
elseif ( count(mncx6,1) == 0 );
	multiply,replace_(
	 p1,-p6,[P+p1],[P-p6],[P-p1],[P+p6]
	,p2,-p4,[P+p2],[P-p4],[P-p2],[P+p4]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p5,-p1,[P+p5],[P-p1],[P-p5],[P+p1]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	);
	multiply,replace_(mncx1,mncx6,mncx2,mncx4,mncx4,mncx2,mncx5,mncx1,mncx8,mncx5);
	redefine TOPO "o2";
	Print,"Topology changed from la to o2";
elseif ( count(mncx7,1) == 0 );
	multiply,replace_(
	 p1,p7,[P+p1],[P+p7],[P-p1],[P-p7]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p8,-p5,[P+p8],[P-p5],[P-p8],[P+p5]
	);
	multiply,replace_(mncx1,mncx7,mncx2,mncx1,mncx3,mncx2,mncx4,mncx3,mncx5,mncx4,mncx8,mncx5);
	redefine TOPO "o3";
	Print,"Topology changed from la to o3";
elseif ( count(mncx8,1) == 0 );
	multiply,replace_(
	 p3,p7,[P+p3],[P+p7],[P-p3],[P-p7]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p6,p4,[P+p6],[P+p4],[P-p6],[P-p4]
	);
	multiply,replace_(mncx3,mncx7,mncx4,mncx6,mncx7,mncx5,mncx5,mncx3,mncx6,mncx4);
	redefine TOPO "o3";
	Print,"Topology changed from la to o3";
endif;
*
#break
*--#] la : 
*--#[ be :
#case be
*
if ( count(mncx1,1,mncx3,1) == 0 );
	multiply,replace_(
	 p2,p7,[P+p2],[P+p7],[P-p2],[P-p7]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p5,-p1,[P+p5],[P-p1],[P-p5],[P+p1]
	,p7,p3,[P+p7],[P+p3],[P-p7],[P-p3]
	,p6,p4,[P+p6],[P+p4],[P-p6],[P-p4]
	);
	multiply,replace_(mncx2,mncx7,mncx8,mncx5,mncx4,mncx2,mncx5,mncx1,mncx7,mncx3,mncx6,mncx4);
	redefine TOPO "o4";
	Print,"Topology changed from be to o4";
elseif ( count(mncx1,1,mncx8,1) == 0 );
	multiply,replace_(
	 p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,p7,[P+p5],[P+p7],[P-p5],[P-p7]
	);
	multiply,replace_(mncx2,mncx1,mncx3,mncx2,mncx4,mncx3,mncx7,mncx5,mncx5,mncx7);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
elseif ( count(mncx3,1,mncx8,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p1,-p2,[P+p1],[P-p2],[P-p1],[P+p2]
	,p2,-p1,[P+p2],[P-p1],[P-p2],[P+p1]
	,p6,-p5,[P+p6],[P-p5],[P-p6],[P+p5]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	,p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7]
	)*mncsgn3;
	multiply,replace_(mncx1,mncx2,mncx2,mncx1,mncx6,mncx5,mncx5,mncx3,mncx4,mncx6);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p4,p3,[P+p4],[P+p3],[P-p4],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p8,-p5,[P+p8],[P-p5],[P-p8],[P+p5]
	);
	multiply,replace_(mncx3,mncx2,mncx4,mncx3,mncx5,mncx4,mncx8,mncx5);
	redefine TOPO "o1";
	Print,"Topology changed from be to o1";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p1,p6,[P+p1],[P+p6],[P-p1],[P-p6]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,p2,[P+p3],[P+p2],[P-p3],[P-p2]
	,p8,p3,[P+p8],[P+p3],[P-p8],[P-p3]
	,p6,p4,[P+p6],[P+p4],[P-p6],[P-p4]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p5,-p7,[P+p5],[P-p7],[P-p5],[P+p7]
	);
	multiply,replace_(mncx1,mncx6,mncx2,mncx1,mncx3,mncx2,mncx8,mncx3,mncx6,mncx4,mncx7,mncx5,mncx5,mncx7);
	redefine TOPO "o4";
	Print,"Topology changed from be to o4";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p8,-p4,[P+p8],[P-p4],[P-p8],[P+p4]
	,p6,-p5,[P+p6],[P-p5],[P-p6],[P+p5]
	,p3,p6,[P+p3],[P+p6],[P-p3],[P-p6]
	,p4,-p7,[P+p4],[P-p7],[P-p4],[P+p7]
	,p7,p3,[P+p7],[P+p3],[P-p7],[P-p3]
	);
	multiply,replace_(mncx8,mncx4,mncx6,mncx5,mncx3,mncx6,mncx4,mncx7,mncx7,mncx3);
	redefine TOPO "o4";
	Print,"Topology changed from be to o4";
elseif ( count(mncx6,1) == 0 );
	multiply,replace_(
	 Q,-Q,[P+Q],[P-Q],[P-Q],[P+Q]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,p1,[P+p4],[P+p1],[P-p4],[P-p1]
	,p5,p2,[P+p5],[P+p2],[P-p5],[P-p2]
	,p3,p4,[P+p3],[P+p4],[P-p3],[P-p4]
	,p2,p6,[P+p2],[P+p6],[P-p2],[P-p6]
	,p7,-p7,[P+p7],[P-p7],[P-p7],[P+p7]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	)*mncsgn3;
	multiply,replace_(mncx1,mncx3,mncx4,mncx1,mncx5,mncx2,mncx3,mncx4,mncx2,mncx6,mncx8,mncx5);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
elseif ( count(mncx7,1) == 0 );
	multiply,replace_(
	 p1,-p4,[P+p1],[P-p4],[P-p1],[P+p4]
	,p2,-p7,[P+p2],[P-p7],[P-p2],[P+p7]
	,p8,p5,[P+p8],[P+p5],[P-p8],[P-p5]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p5,-p1,[P+p5],[P-p1],[P-p5],[P+p1]
	);
	multiply,replace_(mncx1,mncx4,mncx2,mncx7,mncx8,mncx5,mncx4,mncx2,mncx5,mncx1);
	redefine TOPO "o2";
	Print,"Topology changed from be to o2";
endif;
*
#break
*--#] be : 
*--#[ no :
#case no
*
*	If we miss a line, we go to the benz topology
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	,p5,p8,[P+p5],[P+p8],[P-p5],[P-p8]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]);
	multiply,replace_(mncx8,mncx7,mncx5,mncx8,mncx7,mncx5);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,-p5,[P+p1],[P-p5],[P-p1],[P+p5]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p6,-p1,[P+p6],[P-p1],[P-p6],[P+p1]
	,p5,-p2,[P+p5],[P-p2],[P-p5],[P+p2]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p8,p6,[P+p8],[P+p6],[P-p8],[P-p6]
	);
	multiply,replace_(mncx1,mncx5,mncx3,mncx4,mncx6,mncx1,mncx5,mncx2,mncx4,mncx3,mncx8,mncx6);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p8,p4,[P+p8],[P+p4],[P-p8],[P-p4]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	,p7,p6,[P+p7],[P+p6],[P-p7],[P-p6]
	,p4,p7,[P+p4],[P+p7],[P-p4],[P-p7]
	,p5,-p8,[P+p5],[P-p8],[P-p5],[P+p8]
	);
	multiply,replace_(mncx8,mncx4,mncx6,mncx5,mncx7,mncx6,mncx4,mncx7,mncx5,mncx8);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p7,-p2,[P+p7],[P-p2],[P-p7],[P+p2]
	,p2,-p6,[P+p2],[P-p6],[P-p2],[P+p6]
	,p3,-p7,[P+p3],[P-p7],[P-p3],[P+p7]
	,p8,-p8,[P+p8],[P-p8],[P-p8],[P+p8]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	);
	multiply,replace_(mncx7,mncx2,mncx2,mncx6,mncx3,mncx7,mncx6,mncx5,mncx5,mncx4);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p7,p6,[P+p7],[P+p6],[P-p7],[P-p6]
	,p8,p7,[P+p8],[P+p7],[P-p8],[P-p7]
	,p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	);
	multiply,replace_(mncx7,mncx6,mncx8,mncx7,mncx6,mncx5);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx6,1) == 0 );
	multiply,replace_(
	 p8,-p2,[P+p8],[P-p2],[P-p8],[P+p2]
	,p1,-p6,[P+p1],[P-p6],[P-p1],[P+p6]
	,p2,-p7,[P+p2],[P-p7],[P-p2],[P+p7]
	,p7,p8,[P+p7],[P+p8],[P-p7],[P-p8]
	);
	multiply,replace_(mncx8,mncx2,mncx1,mncx6,mncx2,mncx7,mncx7,mncx8);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx7,1) == 0 );
	multiply,replace_(
	 p6,-p1,[P+p6],[P-p1],[P-p6],[P+p1]
	,p1,-p5,[P+p1],[P-p5],[P-p1],[P+p5]
	,p8,-p2,[P+p8],[P-p2],[P-p8],[P+p2]
	,p5,p6,[P+p5],[P+p6],[P-p5],[P-p6]
	,p2,-p7,[P+p2],[P-p7],[P-p2],[P+p7]
	);
	multiply,replace_(mncx6,mncx1,mncx1,mncx5,mncx8,mncx2,mncx5,mncx6,mncx2,mncx7);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
elseif ( count(mncx8,1) == 0 );
	multiply,replace_(
	 p6,p5,[P+p6],[P+p5],[P-p6],[P-p5]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p7,-p2,[P+p7],[P-p2],[P-p7],[P+p2]
	,p2,-p6,[P+p2],[P-p6],[P-p2],[P+p6]
	,p5,p7,[P+p5],[P+p7],[P-p5],[P-p7]
	);
	multiply,replace_(mncx6,mncx5,mncx3,mncx4,mncx4,mncx3,mncx7,mncx2,mncx2,mncx6,mncx5,mncx7);
	redefine TOPO "be";
	Print,"Topology changed from no to be";
endif;
*
#break
*--#] no : 
*--#[ fa :
#case fa
*
*
#break
*--#] fa : 
*--#[ bu :
#case bu
*
*
#break
*--#] bu : 
*--#[ o1 :
#case o1
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	);
	multiply,replace_(mncx3,mncx1,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	);
	multiply,replace_(mncx1,mncx2,mncx4,mncx1,mncx3,mncx4,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p2,p4,[P+p2],[P+p4],[P-p2],[P-p4]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	);
	multiply,replace_(mncx4,mncx2,mncx2,mncx4,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]
	,p1,p4,[P+p1],[P+p4],[P-p1],[P-p4]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	);
	multiply,replace_(mncx2,mncx1,mncx3,mncx2,mncx1,mncx4,mncx5,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o1 to y3";
elseif ( ( count(mncx6,1) == 0 ) || ( count(mncx7,1) == 0 ) );
	Discard;
endif;
*
#break
*--#] o1 : 
*--#[ o2 :
#case o2
*
if ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	);
	multiply,replace_(mncx3,mncx1,mncx5,mncx4,mncx4,mncx3,mncx7,mncx5);
	redefine TOPO "y3";
	Print,"Topology changed from o2 to y3";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	,p6,-p3,[P+p6],[P-p3],[P-p6],[P+p3]
	,p7,-p4,[P+p7],[P-p4],[P-p7],[P+p4]
	);
	multiply,replace_(mncx1,mncx2,mncx4,mncx1,mncx3,mncx6,mncx6,mncx3,mncx7,mncx4);
	redefine TOPO "y2";
	Print,"Topology changed from o2 to y2";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p6,-p6,[P+p6],[P-p6],[P-p6],[P+p6]
	,p7,-p5,[P+p7],[P-p5],[P-p7],[P+p5]
	);
	multiply,replace_(mncx2,mncx3,mncx5,mncx4,mncx4,mncx2,mncx7,mncx5);
	redefine TOPO "y1";
	Print,"Topology changed from o2 to y1";
elseif ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p2,p5,[P+p2],[P+p5],[P-p2],[P-p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p6,-p3,[P+p6],[P-p3],[P-p6],[P+p3]
	,p7,-p4,[P+p7],[P-p4],[P-p7],[P+p4]
	);
	multiply,replace_(mncx2,mncx5,mncx3,mncx6,mncx4,mncx1,mncx1,mncx2,mncx6,mncx3,mncx7,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o2 to y4";
elseif ( ( count(mncx6,1) == 0 ) || ( count(mncx7,1) == 0 ) );
	Discard;
endif;
*
#break
*--#] o2 : 
*--#[ o3 :
#case o3
*
if ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]
	);
	multiply,replace_(mncx7,mncx5,mncx1,mncx3,mncx2,mncx1,mncx3,mncx2);
	redefine TOPO "y5";
	Print,"Topology changed from o3 to y5";
elseif ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	);
	multiply,replace_(mncx7,mncx5,mncx3,mncx1,mncx5,mncx3);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	);
	multiply,replace_(mncx7,mncx5,mncx4,mncx1,mncx1,mncx2,mncx5,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	);
	multiply,replace_(mncx7,mncx5,mncx4,mncx2,mncx2,mncx3,mncx5,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p7,p5,[P+p7],[P+p5],[P-p7],[P-p5]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	,p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	);
	multiply,replace_(mncx7,mncx5,mncx2,mncx1,mncx3,mncx2,mncx1,mncx3,mncx5,mncx4);
	redefine TOPO "y4";
	Print,"Topology changed from o3 to y4";
elseif ( ( count(mncx6,1) == 0 ) || ( count(mncx7,1) == 0 ) );
	Discard;
endif;
*
#break
*--#] o3 : 
*--#[ o4 :
#case o4
*
if ( count(mncx5,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p2,p5,[P+p2],[P+p5],[P-p2],[P-p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx3,mncx2,mncx5,mncx3,mncx6);
	redefine TOPO "y2";
	Print,"Topology changed from o4 to y2";
elseif ( count(mncx1,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p2,p4,[P+p2],[P+p4],[P-p2],[P-p4]
	,p3,-p3,[P+p3],[P-p3],[P-p3],[P+p3]
	,p4,-p6,[P+p4],[P-p6],[P-p4],[P+p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx2,mncx4,mncx4,mncx6);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p4,[P+p1],[P+p4],[P-p1],[P-p4]
	,p4,-p3,[P+p4],[P-p3],[P-p4],[P+p3]
	,p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5]
	,p3,-p6,[P+p3],[P-p6],[P-p3],[P+p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx4,mncx4,mncx3,mncx3,mncx6);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p2,p6,[P+p2],[P+p6],[P-p2],[P-p6]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx3,mncx2,mncx6);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(
	 p6,p1,[P+p6],[P+p1],[P-p6],[P-p1]
	,p7,p2,[P+p7],[P+p2],[P-p7],[P-p2]
	,p1,p6,[P+p1],[P+p6],[P-p1],[P-p6]
	,p5,-p5,[P+p5],[P-p5],[P-p5],[P+p5]
	,p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]
	);
	multiply,replace_(mncx6,mncx1,mncx7,mncx2,mncx1,mncx6,mncx2,mncx3,mncx3,mncx4);
	redefine TOPO "y3";
	Print,"Topology changed from o4 to y3";
elseif ( count(mncx7,1) == 0 );
	discard;
endif;
*
#break
*--#] o4 : 
*--#[ y1 :
#case y1
*
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y1 : 
*--#[ y2 :
#case y2
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y2 : 
*--#[ y3 :
#case y3
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y3 : 
*--#[ y4 :
#case y4
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y4 : 
*--#[ y5 :
#case y5
*
if ( count(mncx1,1) == 0 ) discard;
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
if ( count(mncx5,1) == 0 ) discard;
if ( count(mncx6,1) == 0 ) discard;
*
#break
*--#] y5 : 
*--#[ t1 :
#case t1
*
*	If 5 is missing we have t3, if 1,2,3,4 is missing, we have t2.
*
if ( count(mncx5,1) == 0 );
	multiply,replace_(p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]
	,p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]);
	multiply,replace_(mncx4,mncx2,mncx2,mncx3,mncx3,mncx4);
	redefine TOPO "t3";
	Print,"Topology changed from t1 to t3";
elseif ( count(mncx1,1) == 0 );
	multiply,replace_(p5,p3,[P+p5],[P+p3],[P-p5],[P-p3]
	,p4,-p4,[P+p4],[P-p4],[P-p4],[P+p4]
	,p3,-p1,[P+p3],[P-p1],[P-p3],[P+p1]);
	multiply,replace_(mncx5,mncx3,mncx3,mncx1);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
elseif ( count(mncx2,1) == 0 );
	multiply,replace_(p1,p2,[P+p1],[P+p2],[P-p1],[P-p2]
	,p4,-p1,[P+p4],[P-p1],[P-p4],[P+p1]
	,p5,-p3,[P+p5],[P-p3],[P-p5],[P+p3]
	,p3,-p4,[P+p3],[P-p4],[P-p3],[P+p4]);
	multiply,replace_(mncx1,mncx2,mncx4,mncx1,mncx5,mncx3,mncx3,mncx4);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
elseif ( count(mncx3,1) == 0 );
	multiply,replace_(p2,p3,[P+p2],[P+p3],[P-p2],[P-p3]
	,p5,p4,[P+p5],[P+p4],[P-p5],[P-p4]
	,p4,-p2,[P+p4],[P-p2],[P-p4],[P+p2]);
	multiply,replace_(mncx2,mncx3,mncx5,mncx4,mncx4,mncx2);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
elseif ( count(mncx4,1) == 0 );
	multiply,replace_(p1,p3,[P+p1],[P+p3],[P-p1],[P-p3]
	,p5,-p4,[P+p5],[P-p4],[P-p5],[P+p4]
	,p2,p1,[P+p2],[P+p1],[P-p2],[P-p1]
	p3,-p2,[P+p3],[P-p2],[P-p3],[P+p2]);
	multiply,replace_(mncx1,mncx3,mncx5,mncx4,mncx2,mncx1,mncx3,mncx2);
	redefine TOPO "t2";
	Print,"Topology changed from t1 to t2";
endif;
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
if ( count(mncx1,1) == 0 ) discard;
if ( count(mncx2,1) == 0 ) discard;
if ( count(mncx3,1) == 0 ) discard;
if ( count(mncx4,1) == 0 ) discard;
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
*
#break
*--#] tr : 
#endswitch
#endprocedure

*--#] transfor : 
*--#[ triangl2 :
#procedure triangl2(P,PA,PB,P1,P3,EA,EB)
*
*   Routine solves the triangle recursion
*                     P
*      N1 -------------------------- N3
*          P1    \    N2    /    P3
*                 \        /
*                A \      / B
*                PA \    / PB
*                    \  /
*                     \/
*
*   mncA,mncB,mncN1,mncN2,mncN3 are the powers of the denominators
*   mncA and mncB don't have to be integers here.
*   EA and EB are 1/PA.PA^ep and 1/PB.PB^ep
*   P is the momentum in mncN2. We need it here to determine the extra
*   momenta in the numerator.
*
*   This routine differs from the routine triangle in that the final 
*   substitution of mncftri involves gamma functions rather than factorials.
*
id  `P' = mncx*`P';
if ( count(`P1'.`P1',1,`P3'.`P3',1,`P'.`P',1) < -4 );
id  mncx^mncm?/`P1'.`P1'^mncN1?/`P'.`P'^mncN2?/`P3'.`P3'^mncN3?/`PA'.`PA'^mncA?/`PB'.`PB'^mncB?
        *`EA'^mncx1?*`EB'^mncx2? =
        mncftri(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm)*mncpoinv(mncA,mncx1)*mncpoinv(mncB,mncx2)*`EA'^mncx1*`EB'^mncx2;
id  mncpoinv(1,mncx1?) = 1;
id  mncpoinv(mncx1?,0) = invfac_(mncx1-1);
id  mncpoinv(mncx1?neg0_,mncx2?) = mncx2*acc(mncPOINV(mncx1,mncx2))*ep;
id  mncpoinv(mncx1?,mncx2?) = acc(mncPOINV(mncx1,mncx2));

id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?) =
        +sum_(mnck4,0,mncN3-1,sign_(mncN1+mnck4)*mncpo(5+mncm-2*mncN2-mncA-mncB-mncN1-mnck4,-2-mncx1-mncx2)
            *mncsumm1(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm,mnck4)*invfac_(mnck4))*invfac_(mncN1-1)
        +mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm)*mncN2*mncpoinv(4+mncm-2*mncN2-mncA-mncB+mncN2,-2-mncx1-mncx2)
        +sum_(mnck2,0,mncN1-1,sign_(mnck2+mncN3)*mncpo(5+mncm-2*mncN2-mncA-mncB-mnck2-mncN3,-2-mncx1-mncx2)
            *mncsumm3(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm,mnck2)*invfac_(mnck2))*invfac_(mncN3-1)
    ;
*
*   Evaluate the gamma functions.
*   We multiply numerator and denominator with gamma(1-2*ep)
*   Then mncpo(mncx,-2) represents a normalized gamma function.
*   The following identities can then be applied:
*   (the table has overal factors ep taken out)
*
if ( count(mncsumm2,1) );
    id  mncpoinv(1,mncy1?) = 1;
    id  mncpoinv(mncx1?neg0_,mncy1?) = mncy1*acc(mncPOINV(mncx1,mncy1))*ep;
    id  mncpoinv(mncx1?,mncy1?) = acc(mncPOINV(mncx1,mncy1));
    id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?) =
        +sum_(mnck2,0,mncN1-1,sum_(mnck4,0,mncN3-1,sign_(mnck2+mnck4)*fac_(mnck2+mncN2+mnck4-1)
            *mncpo(4+mncm-2*mncN2-mncA-mncB-mnck2-mnck4,-2-mncx1-mncx2)
            *mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncx1,mncx2,mncm,mnck2,mnck4)
         *invfac_(mnck4))*invfac_(mnck2));
    id  mncpo(mncx1?,0) = fac_(mncx1-1);
    id  mncpo(1,mncy1?) = 1;
    id  mncpo(mncx1?neg0_,mncy1?) = acc(mncPO(mncx1,mncy1))/mncy1/ep;
    id  mncpo(mncx1?,mncy1?) = acc(mncPO(mncx1,mncy1));
    id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?,mnck2?,mnck4?) =
             sum_(mnck1,0,mncN2,invfac_(mnck1)*invfac_(mncN2-mnck1)
            *mncftri(mncN1-mnck2,0,mncN3-mnck4,mncA+mnck1+mnck2,mncB+mncN2-mnck1+mnck4,mncx1,mncx2));
else;
    id  mncpo(mncx1?,0) = fac_(mncx1-1);
    id  mncpo(1,mncy1?) = 1;
    id  mncpo(mncx1?neg0_,mncy1?) = acc(mncPO(mncx1,mncy1))/mncy1/ep;
    id  mncpo(mncx1?,mncy1?) = acc(mncPO(mncx1,mncy1));
    id  mncsumm1(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?,mnck4?) =
            sum_(mnck1,0,mncN2-1,sum_(mnck3,0,mncN2-mnck1-1,
            fac_(mnck1+mncN1+mnck3+mnck4-1)*invfac_(mnck3)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2-mncx1-mncx2)
            *mncftri(0,mncN2-mnck1-mnck3,mncN3-mnck4,mncA+mnck1+mncN1,mncB+mnck3+mnck4,mncx1,mncx2)
         )*invfac_(mnck1));
    id  mncsumm3(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?,mncm?,mnck2?) =
            sum_(mnck3,0,mncN2-1,sum_(mnck1,0,mncN2-mnck3-1,
            fac_(mnck1+mnck2+mnck3+mncN3-1)*invfac_(mnck1)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2-mncx1-mncx2)
            *mncftri(mncN1-mnck2,mncN2-mnck1-mnck3,0,mncA+mnck1+mnck2,mncB+mnck3+mncN3,mncx1,mncx2)
         )*invfac_(mnck3));
    id  mncpoinv(1,mncy1?) = 1;
    id  mncpoinv(mncx1?neg0_,mncy1?) = mncy1*acc(mncPOINV(mncx1,mncy1))*ep;
    id  mncpoinv(mncx1?,mncy1?) = acc(mncPOINV(mncx1,mncy1));
endif;

id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncx1?,mncx2?) = mncpo(mncA,mncx1)*mncpo(mncB,mncx2)
    /`P1'.`P1'^mncN1/`P'.`P'^mncN2/`P3'.`P3'^mncN3/`PA'.`PA'^mncA/`PB'.`PB'^mncB;
id  mncpo(mncx1?,0) = fac_(mncx1-1);
id  mncpo(1,mncy1?) = 1;
id  mncpo(mncx1?neg0_,mncy1?) = acc(mncPO(mncx1,mncy1))/mncy1/ep;
id  mncpo(mncx1?,mncy1?) = acc(mncPO(mncx1,mncy1));

else;

  repeat;
    if ( match(1/`P'.`P'/`P1'.`P1'/`P3'.`P3') > 0 );
      id  mncx^mncx4?/`PA'.`PA'^mncx1?/`PB'.`PB'^mncx2?/`P'.`P'^mncx3?*`EA'^mncy1?*`EB'^mncy2? =
          mncx^mncx4 /`PA'.`PA'^mncx1 /`PB'.`PB'^mncx2 /`P'.`P'^mncx3 *`EA'^mncy1*`EB'^mncy2*(
            +acc(mncx2+mncy2*ep)*`P'.`P'/`PB'.`PB'-acc(mncx2+mncy2*ep)*`P3'.`P3'/`PB'.`PB'
            +acc(mncx1+mncy1*ep)*`P'.`P'/`PA'.`PA'-acc(mncx1+mncy1*ep)*`P1'.`P1'/`PA'.`PA'
          )*mncdeno(4+mncx4-mncx1-mncx2-2*mncx3,-2-mncy1-mncy2);
      id,many,mncdeno(0,mncy1?) = 1/mncy1/ep;
      id,mncdeno(mncx1?,mncy1?) = acc(1-mncy1*ep/mncx1+mncy1^2*ep^2/mncx1^2-mncy1^3*ep^3/mncx1^3
                      +mncy1^4*ep^4/mncx1^4-mncy1^5*ep^5/mncx1^5+mncy1^6*ep^6/mncx1^6)/mncx1;
    endif;
  endrepeat;
  id  mncx = 1;

endif;

#endprocedure

*--#] triangl2 : 
*--#[ triangle :
#procedure triangle(P,PA,PB,P1,P3)
*
*   Routine solves the triangle recursion
*                     P
*      N1 -------------------------- N3
*          P1    \    N2    /    P3
*                 \        /
*                A \      / B
*                PA \    / PB
*                    \  /
*                     \/
*
*   mncA,mncB,mncN1,mncN2,mncN3 are the powers of the denominators
*   We assume that mncA and mncB are integers here. Otherwise see triangl2.
*   P is the momentum in mncN2. We need it here to determine the extra
*   momenta in the numerator.
*
*   We follow the algorithm of F.V.Tkachov Theor. Mat. Fiz. 56(1983)350.
*
*   There are three sums:
*   One in which the power of 1 becomes zero, one for 2 and one for 3.
*   Each sum has 4 constants to sum over, except that for each
*   one of them has its maximal value:
*   mnck1 = (a-mncA)-mnck2
*   mnck2 = mncN1-n1          sum1: mncN1
*   mnck3 = (b-mncB)-mnck4
*   mnck4 = mncN3-n3          sum3: mncN3
*   mnck1+mnck3 = mncN2-n2       sum2: mncN2
*   The gamma functions are evaluated using the tables in pochtabl.prc
*
*   It turns out that the easy cases are faster when the regular recursion
*   is used. We do that here is there are fewer than 6 powers in P,P1 and P3
*   combined. Test timings don't use these special cases.
*
*   Programmed by J.mncA.M.Vermaseren 28-oct-1990 + 13-nov-1990
*
*   Test versus benzbar:
*       1/p1.p1^3/mncp.mncp/p3.p3/pa.pa/pb.pb -> 0.96 sec versus 0.80 sec
*       1/p1.p1^3/mncp.mncp^3/p3.p3/pa.pa/pb.pb -> 3.07 sec versus 20.34 sec
*       1/p1.p1^3/mncp.mncp^3/p3.p3^3/pa.pa/pb.pb -> 6.21 sec versus 547.11 sec
*   triangle generates exactly the right number of terms
*   (times on Atari TT)
*
*   For the easy cases we take the original recursion, because this is much
*   faster. This is done for the combined powers of P1,P2,P3 at most 4
*   in the denominator. IT IS VERY DANGEROUS TO INCREASE THIS NUMBER!
*   In principle each two steps in the recursion can generate one
*   extra pole that has to be cancelled between the terms. This can
*   cause problems with the truncation of the powers of ep. We can
*   tolerate only one such pole here.
*
id  `P' = mncx*`P';
if ( count(`P1'.`P1',1,`P3'.`P3',1,`P'.`P',1) < -4 );
id  mncx^mncm?/`P1'.`P1'^mncN1?/`P'.`P'^mncN2?/`P3'.`P3'^mncN3?/`PA'.`PA'^mncA?/`PB'.`PB'^mncB? =
        mncftri(mncN1,mncN2,mncN3,mncA,mncB,mncm)*invfac_(mncA-1)*invfac_(mncB-1);
id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?) =
        +sum_(mnck4,0,mncN3-1,sign_(mncN1+mnck4)*mncpo(5+mncm-2*mncN2-mncA-mncB-mncN1-mnck4,-2)
            *mncsumm1(mncN1,mncN2,mncN3,mncA,mncB,mncm,mnck4)*invfac_(mnck4))*invfac_(mncN1-1)
        +mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncm)*mncN2*mncpoinv(4+mncm-2*mncN2-mncA-mncB+mncN2,-2)
        +sum_(mnck2,0,mncN1-1,sign_(mnck2+mncN3)*mncpo(5+mncm-2*mncN2-mncA-mncB-mnck2-mncN3,-2)
            *mncsumm3(mncN1,mncN2,mncN3,mncA,mncB,mncm,mnck2)*invfac_(mnck2))*invfac_(mncN3-1)
    ;
*
*   Evaluate the gamma functions.
*   We multiply numerator and denominator with gamma(1-2*ep)
*   Then mncpo(mncx,-2) represents a normalized gamma function.
*   The following identities can then be applied:
*   (the table has overal factors ep taken out)
*
if ( count(mncsumm2,1) );
	id  mncpoinv(1,-2) = 1;
	id  mncpoinv(mncx1?neg0_,-2) = -2*acc(mncPOINV(mncx1,-2))*ep;
	id  mncpoinv(mncx1?,-2) = acc(mncPOINV(mncx1,-2));
	id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?) =
    	    +sum_(mnck2,0,mncN1-1,sum_(mnck4,0,mncN3-1,sign_(mnck2+mnck4)*fac_(mnck2+mncN2+mnck4-1)
        	    *mncpo(4+mncm-2*mncN2-mncA-mncB-mnck2-mnck4,-2)*mncsumm2(mncN1,mncN2,mncN3,mncA,mncB,mncm,mnck2,mnck4)
	         *invfac_(mnck4))*invfac_(mnck2));
	id  mncpo(1,-2) = 1;
	id  mncpo(mncx1?neg0_,-2) = -acc(mncPO(mncx1,-2))/2/ep;
	id  mncpo(mncx1?,-2) = acc(mncPO(mncx1,-2));
	id  mncsumm2(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?,mnck2?,mnck4?) =
            +sum_(mnck1,0,mncN2,invfac_(mnck1)*invfac_(mncN2-mnck1)
            *mncftri(mncN1-mnck2,0,mncN3-mnck4,mncA+mnck1+mnck2,mncB+mncN2-mnck1+mnck4));
else;
	id  mncpo(1,-2) = 1;
	id  mncpo(mncx1?neg0_,-2) = -acc(mncPO(mncx1,-2))/2/ep;
	id  mncpo(mncx1?,-2) = acc(mncPO(mncx1,-2));
	id  mncsumm1(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?,mnck4?) =
            sum_(mnck1,0,mncN2-1,sum_(mnck3,0,mncN2-mnck1-1,
            fac_(mnck1+mncN1+mnck3+mnck4-1)*invfac_(mnck3)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2)
            *mncftri(0,mncN2-mnck1-mnck3,mncN3-mnck4,mncA+mnck1+mncN1,mncB+mnck3+mnck4)
         )*invfac_(mnck1));
	id  mncsumm3(mncN1?,mncN2?,mncN3?,mncA?,mncB?,mncm?,mnck2?) =
            sum_(mnck3,0,mncN2-1,sum_(mnck1,0,mncN2-mnck3-1,
            fac_(mnck1+mnck2+mnck3+mncN3-1)*invfac_(mnck1)
            *mncpoinv(5+mncm-2*mncN2-mncA-mncB+mnck1+mnck3,-2)
            *mncftri(mncN1-mnck2,mncN2-mnck1-mnck3,0,mncA+mnck1+mnck2,mncB+mnck3+mncN3)
         )*invfac_(mnck3));
	id  mncpoinv(1,-2) = 1;
	id  mncpoinv(mncx1?neg0_,-2) = -2*acc(mncPOINV(mncx1,-2))*ep;
	id  mncpoinv(mncx1?,-2) = acc(mncPOINV(mncx1,-2));
endif;
id  mncftri(mncN1?,mncN2?,mncN3?,mncA?,mncB?) = fac_(mncA-1)*fac_(mncB-1)
    /`P1'.`P1'^mncN1/`P'.`P'^mncN2/`P3'.`P3'^mncN3/`PA'.`PA'^mncA/`PB'.`PB'^mncB;

else;
  repeat;
    if ( match(1/`P'.`P'/`P1'.`P1'/`P3'.`P3') > 0 );
      id  mncx^mncx4?/`PA'.`PA'^mncx1?/`PB'.`PB'^mncx2?/`P'.`P'^mncx3? =
          mncx^mncx4 /`PA'.`PA'^mncx1 /`PB'.`PB'^mncx2 /`P'.`P'^mncx3 *(
            +mncx2*`P'.`P'/`PB'.`PB'-mncx2*`P3'.`P3'/`PB'.`PB'
            +mncx1*`P'.`P'/`PA'.`PA'-mncx1*`P1'.`P1'/`PA'.`PA'
          )*mncdeno(4+mncx4-mncx1-mncx2-2*mncx3,-2);
      id,many,mncdeno(0,-2)   = -1/2/ep;
      id,mncdeno(mncx1?,-2) = acc(1+2*ep/mncx1+4*ep^2/mncx1^2+8*ep^3/mncx1^3
                      +16*ep^4/mncx1^4+32*ep^5/mncx1^5+64*ep^6/mncx1^6)/mncx1;
    endif;
  endrepeat;
  id  mncx = 1;

endif;
#endprocedure
*--#] triangle : 
*--#[ trim :
#procedure trim(TOPO)
#switch `TOPO'
*--#[ la :
*
*
*--#] la : 
*--#[ be :
*
*
*--#] be : 
*--#[ no :
*
*
*--#] no : 
*--#[ fa :
*
*
*--#] fa : 
*--#[ bu :
*
*
*--#] bu : 
*--#[ o1 :
*
*
*--#] o1 : 
*--#[ o2 :
*
*
*--#] o2 : 
*--#[ o3 :
*
*
*--#] o3 : 
*--#[ o4 :
*
*
*--#] o4 : 
*--#[ y1 :
*
*
*--#] y1 : 
*--#[ y2 :
*
*
*--#] y2 : 
*--#[ y3 :
*
*
*--#] y3 : 
*--#[ y4 :
*
*
*--#] y4 : 
*--#[ y5 :
*
*
*--#] y5 : 
*--#[ t1 :
#case t1
*
#if 'TRIM' > 0
	id ep = 0;
#endif
*
#break
*--#] t1 : 
*--#[ t2 :
#case t2
*
#if 'TRIM' > 0
	id ep = 0;
#endif
*
#break
*--#] t2 : 
*--#[ t3 :
#case t3
*
#if 'TRIM' > 0
	id ep = 0;
#endif
*
#break
*--#] t3 : 
*--#[ l1 :
#case l1
*
#if 'TRIM' > 0
	id ep^{3-'TRIM'} = 0;
#endif
*
#break
*--#] l1 : 
*--#[ l2 :
#case l2
*
*
#break
*--#] l2 : 
*--#[ l3 :
#case l3
*
*
#break
*--#] l3 : 
*--#[ tr :
#case tr
*
#if 'TRIM' > 0
	id ep^{4-'TRIM'} = 0;
#endif
*
#break
*--#] tr : 
#endswitch
#endprocedure
*--#] trim : 
*--#[ two :
#procedure two(P1,E1,P2,E2,P3,E3,P4,E4,P5,E5,Q,EQ,REDUCTION,INTS)
*
*   Routine for the reduction of two loop diagrams.
*   All particles are massless and it treats only two point functions.
*   For the algorithm, see "Mincer:...." S.G.Gorishny, S.A.Larin,
*   L.R.Surguladze and F.V.Tkachov, Comp. Phys. Comm. 55(1989)381.
*   The core of this routine consists of the equations (3.8)-(3.11).
*   Note that equation 3.10 isn't right, but the equation 4.29 in
*   K.G.Chetyrkin and F.V.Tkachov, Nucl.Phys. B192(1981)159 is correct.
*   The odd parameters are the vectors and the even parameters
*   are symbols for 1/(p.p^ep). The last parameter indicates whether
*   there should be a tensor reduction first.
*
*	This routine is (mostly) superceeded by the routine newtwo. Only when
*	we have to calculate extra elements in the table tabtwo we need this
*	routine.
*
#if ( `REDUCTION' > 0 )
  id  `P4' = `P1'-`Q';
  id  `P3' = `P2'-`Q';
  id  `P5' = `P1'-`P2';
  .sort: Two loop momenta;
  id  `P1'.`Q' = `P1'.`P1'/2+`Q'.`Q'/2-`P4'.`P4'/2;
  id  `P2'.`Q' = `P2'.`P2'/2+`Q'.`Q'/2-`P3'.`P3'/2;
  id  `P1'.`P2' = `P1'.`P1'/2+`P2'.`P2'/2-`P5'.`P5'/2;
  .sort: Two loop scalars;
#endif
repeat;
  if ( ( ( count(`P1'.`P1',1) < 0 ) || ( count(`E1',1) > 0 ) ) &&
       ( ( count(`P2'.`P2',1) < 0 ) || ( count(`E2',1) > 0 ) ) &&
       ( ( count(`P3'.`P3',1) < 0 ) || ( count(`E3',1) > 0 ) ) &&
       ( ( count(`P4'.`P4',1) < 0 ) || ( count(`E4',1) > 0 ) ) &&
       ( ( count(`P5'.`P5',1) < 0 ) || ( count(`E5',1) > 0 ) ) );
    if ( count(`E5',1) == 0 );
      if ( count(`E2',1,`E3',1) == 0 );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?/`P2'.`P2'^mncx2?/`P3'.`P3'^mncx3?*
            `E4'^mncy4?/`P4'.`P4'^mncx4?/`P5'.`P5'^mncx5?*`E5'^mncy5? =
              `E1'^mncy1/`P1'.`P1'^mncx1/`P2'.`P2'^mncx2/`P3'.`P3'^mncx3*
              `E4'^mncy4/`P4'.`P4'^mncx4/`P5'.`P5'^mncx5*`E5'^mncy5*(
                + acc(mncx1,mncy1)*`P5'.`P5'/`P1'.`P1'
                + acc(mncx4,mncy4)*`P5'.`P5'/`P4'.`P4'
                - acc(mncx1,mncy1)*`P2'.`P2'/`P1'.`P1'
                - acc(mncx4,mncy4)*`P3'.`P3'/`P4'.`P4'
              )*mncdeno(4-mncx1-mncx4-2*mncx5,-mncy1-mncy4-2*mncy5-2);
      else;
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                + acc(mncx3,mncy3)*`P5'.`P5'/`P3'.`P3'
                + acc(mncx2,mncy2)*`P5'.`P5'/`P2'.`P2'
                - acc(mncx3,mncy3)*`P4'.`P4'/`P3'.`P3'
                - acc(mncx2,mncy2)*`P1'.`P1'/`P2'.`P2'
              )*mncdeno(4-mncx2-mncx3-2*mncx5,-mncy2-mncy3-2*mncy5-2);
      endif;
    else;
      if ( ( count(`P1'.`P1',1) < -1 ) && ( count(`E1',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx4+mncx1+mncx5-5,+2*mncy4+mncy1+mncy5+2)*`P1'.`P1'*mncdeno(mncx1-1,mncy1)
                +`P4'.`P4'
                +acc(mncx5,mncy5)*`P4'.`P4'*`P1'.`P1'/`P5'.`P5'*mncdeno(mncx1-1,mncy1)
                -acc(mncx5,mncy5)*`P3'.`P3'*`P1'.`P1'/`P5'.`P5'*mncdeno(mncx1-1,mncy1)
              )/`Q'.`Q';
      else;
      if ( ( count(`P2'.`P2',1) < -1 ) && ( count(`E2',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx3+mncx2+mncx5-5,+2*mncy3+mncy2+mncy5+2)*`P2'.`P2'*mncdeno(mncx2-1,mncy2)
                +`P3'.`P3'
                +acc(mncx5,mncy5)*`P3'.`P3'*`P2'.`P2'/`P5'.`P5'*mncdeno(mncx2-1,mncy2)
                -acc(mncx5,mncy5)*`P4'.`P4'*`P2'.`P2'/`P5'.`P5'*mncdeno(mncx2-1,mncy2)
              )/`Q'.`Q';
      else;
      if ( ( count(`P3'.`P3',1) < -1 ) && ( count(`E3',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx2+mncx3+mncx5-5,+2*mncy2+mncy3+mncy5+2)*`P3'.`P3'*mncdeno(mncx3-1,mncy3)
                +`P2'.`P2'
                +acc(mncx5,mncy5)*`P2'.`P2'*`P3'.`P3'/`P5'.`P5'*mncdeno(mncx3-1,mncy3)
                -acc(mncx5,mncy5)*`P1'.`P1'*`P3'.`P3'/`P5'.`P5'*mncdeno(mncx3-1,mncy3)
              )/`Q'.`Q';
      else;
      if ( ( count(`P4'.`P4',1) < -1 ) && ( count(`E4',1) == 0 ) );
        id  `E1'^mncy1?/`P1'.`P1'^mncx1?*`E2'^mncy2?/`P2'.`P2'^mncx2?*
            `E3'^mncy3?/`P3'.`P3'^mncx3?*`E4'^mncy4?/`P4'.`P4'^mncx4?*
            `E5'^mncy5?/`P5'.`P5'^mncx5? =
              `E1'^mncy1/`P1'.`P1'^mncx1*`E2'^mncy2/`P2'.`P2'^mncx2*
              `E3'^mncy3/`P3'.`P3'^mncx3*`E4'^mncy4/`P4'.`P4'^mncx4*
              `E5'^mncy5/`P5'.`P5'^mncx5*(
                +acc(2*mncx1+mncx4+mncx5-5,+2*mncy1+mncy4+mncy5+2)*`P4'.`P4'*mncdeno(mncx4-1,mncy4)
                +`P1'.`P1'
                +acc(mncx5,mncy5)*`P1'.`P1'*`P4'.`P4'/`P5'.`P5'*mncdeno(mncx4-1,mncy4)
                -acc(mncx5,mncy5)*`P2'.`P2'*`P4'.`P4'/`P5'.`P5'*mncdeno(mncx4-1,mncy4)
              )/`Q'.`Q';
      else;
      if ( count(`E1',1,`E2',1,`E3',1,`E4',1) == 0 );
        if ( count(`P5'.`P5',1) < -1 );
*
*         Note: The equation 3.10 in the Mincer paper is wrong!
*
          id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
              /`P4'.`P4'/`P5'.`P5'^mncx5?*`E5'^mncy5? =
                -acc(mncx5-2,2+mncy5)*mncdeno(mncx5-1,1+mncy5)*`P5'.`P5'/`Q'.`Q'
                /`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'^mncx5*`E5'^mncy5
                -mncG(1,0,mncx5,mncy5,0,0)*mncG(1,0,mncx5,mncy5+1,0,0)*mncdeno(mncx5-1,1+mncy5)
                *acc(3-2*mncx5-3*ep-2*mncy5*ep)*2*`EQ'^mncy5*`EQ'^2/`Q'.`Q'^mncx5/(`INTS');
        else;
        if ( count(`P5'.`P5',1) >= 0 );
          id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
              /`P4'.`P4'/`P5'.`P5'^mncx5?*`E5'^mncy5? =
                -mncdeno(mncx5-1,2+mncy5)*acc(mncx5,1+mncy5)*`Q'.`Q'/`P5'.`P5'
                /`P1'.`P1'/`P2'.`P2'/`P3'.`P3'/`P4'.`P4'/`P5'.`P5'^mncx5*`E5'^mncy5
                -mncG(1,0,mncx5+1,mncy5,0,0)*mncG(1,0,mncx5+1,mncy5+1,0,0)*mncdeno(mncx5-1,2+mncy5)
                *acc(1-2*mncx5-3*ep-2*mncy5*ep)*2*`EQ'^mncy5*`EQ'^2/`Q'.`Q'^mncx5/(`INTS');
        else;
          id  1/`P1'.`P1'/`P2'.`P2'/`P3'.`P3'
              /`P4'.`P4'/`P5'.`P5'*`E5'^mncy5? = mncG311/`Q'.`Q'*`EQ'^2*`EQ'^mncy5
                /(`INTS');
*
*         mncG311 = 6*z3+9*z4*ep+102*z5*ep^2+order_(ep,3);
*           There seems to be also a normalization problem
*           The above expansion may not be enough!
*
        endif;
        endif;
*      else;
*        goto 1;
      endif;
      endif;
      endif;
      endif;
      endif;
    endif;
  endif;
endrepeat;
label 1;
id  mncdeno(0,mncy1?) = 1/mncy1/ep;
id	acc(0,mncx1?) = mncx1*ep;
id	acc(mncx1?,mncy1?) = acc(mncx1+mncy1*ep);
id  mncdeno(mncx1?,mncy1?) = mncaccm(1+ep*mncy1/mncx1)/mncx1;
repeat id mncaccm(mncx1?)*mncaccm(mncx2?) = mncaccm(mncx1*mncx2);
id  mncaccm(mncx1?) = mncaccm(mncx1-1);
id  mncaccm(mncx1?) = mncaccm(mncx1-mncx1^2,mncx1^3);
id  mncaccm(mncx1?,mncx2?) = acc(1-mncx1-mncx2+mncx2*mncx1+mncx2^2);
repeat id acc(mncx?)*acc(mncy?) = acc(mncx*mncy);
id	acc(mncx1?) = mncx1;
#endprocedure
*--#] two : 
*--#[ vertsub :
#procedure vertsub
#if 'GAUGE' == 0
	id	mncDg(mnci1?,mnci2?,mncp?) = d_(mnci1,mnci2)*mncDs(mncp);
#else
	repeat;
		id,once,mncDg(mnci1?,mnci2?,mncp?)*mncV3G(?a,mnci1?,mncp?,?b) =
			mncV3G(?a,mnci2,mncp,?b)*mncDs(mncp)
			-mncxi*mncp(mnci2)*mncV3G(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

		id,once,mncDg(mnci1?,mnci2?,mncp?)*mncV3G(?a,mnci1?,-mncp?,?b) =
			mncV3G(?a,mnci2,-mncp,?b)*mncDs(mncp)
			+mncxi*mncp(mnci2)*mncV3G(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

		id,once,mncDg(mnci2?,mnci1?,mncp?)*mncV3G(?a,mnci1?,mncp?,?b) =
			mncV3G(?a,mnci2,mncp,?b)*mncDs(mncp)
			-mncxi*mncp(mnci2)*mncV3G(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

		id,once,mncDg(mnci2?,mnci1?,mncp?)*mncV3G(?a,mnci1?,-mncp?,?b) =
			mncV3G(?a,mnci2,-mncp,?b)*mncDs(mncp)
			+mncxi*mncp(mnci2)*mncV3G(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);
	endrepeat;
	id	mncDg(mnci1?,mnci2?,mncp?) = (d_(mnci1,mnci2)-mncxi*mncp(mnci1)*mncp(mnci2)*mncDs(mncp))*mncDs(mncp);
#endif

id	mncDs(p1?) = 1/p1.p1;
id	mncDL(mnci1?,mncj1?,p1?) = d_(mnci1,mncj1)/p1.p1-p1(mnci1)*p1(mncj1)/p1.p1^2;

.sort

repeat;
repeat;
	repeat;
		id,mncV3G(p1?,p1?,p2?,p2?,p3?,p3?) = 0;
		id,once,mncV3G(p1?,p1?,p2?,p2?,mnci3?,p3?) =
			p3.p3*p2(mnci3)-p2.p3*p3(mnci3);
		id,once,mncV3G(mnci3?,p3?,p1?,p1?,p2?,p2?) =
			p3.p3*p2(mnci3)-p2.p3*p3(mnci3);
		id,once,mncV3G(p2?,p2?,mnci3?,p3?,p1?,p1?) =
			p3.p3*p2(mnci3)-p2.p3*p3(mnci3);
	endrepeat;
	id,once,mncV3G(p1?,p1?,mnci2?,p2?,mnci3?,p3?) =
		p2(mnci2)*p2(mnci3)-p3(mnci2)*p3(mnci3)+p3.p3*d_(mnci2,mnci3)-p2.p2*d_(mnci2,mnci3);
	id,once,mncV3G(mnci3?,p3?,p1?,p1?,mnci2?,p2?) =
		p2(mnci2)*p2(mnci3)-p3(mnci2)*p3(mnci3)+p3.p3*d_(mnci2,mnci3)-p2.p2*d_(mnci2,mnci3);
	id,once,mncV3G(mnci2?,p2?,mnci3?,p3?,p1?,p1?) =
		p2(mnci2)*p2(mnci3)-p3(mnci2)*p3(mnci3)+p3.p3*d_(mnci2,mnci3)-p2.p2*d_(mnci2,mnci3);
endrepeat;

id,once,mncV3G(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = 2*p1(mnci3)*d_(mnci1,mnci2)+p3(mnci3)*d_(mnci1,mnci2)
	                              +2*p2(mnci1)*d_(mnci2,mnci3)+p1(mnci1)*d_(mnci2,mnci3)
	                              +2*p3(mnci2)*d_(mnci3,mnci1)+p2(mnci2)*d_(mnci3,mnci1);
endrepeat;
id	mncV4G(mnci1?,mnci2?,mnci3?,mnci4?,mncx1?,mncx2?,mncx3?) =
	+mncx1*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
	+mncx2*(d_(mnci1,mnci2)*d_(mnci3,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
	+mncx3*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci2)*d_(mnci3,mnci4));

id	D = acc(4-2*ep);
#endprocedure

*--#] vertsub : 
*--#[ vertsubm :
#procedure vertsubm
multiply,replace_(mncv4gi,mncv4g);
id	mncv4gp(?a) = mncx18*mncv4g(?a);

#if ( `GAUGE' == 0 )
    id  mncDg(mnci1?,mnci2?,mncp?) = -i_*d_(mnci1,mnci2)*mncDs(mncp);
#else
    repeat;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gi(mnci1?,p1?,?a) = -i_*mncv2gi(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gi(?a,mnci1?,p1?) = -i_*mncv2gi(?a,mnci2,p1)/p1.p1;
	endrepeat;
	repeat;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gp(mnci1?,p1?,?a) = -i_*mncv2gp(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gp(?a,mnci1?,p1?) = -i_*mncv2gp(?a,mnci2,p1)/p1.p1;
	endrepeat;
	repeat;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gc(mnci1?,p1?,?a) = -i_*mncv2gc(mnci2,p1,?a)/p1.p1;
        id  mncDg(mnci1?,mnci2?,-p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
        id  mncDg(mnci2?,mnci1?,-p1?)*mncv2gc(?a,mnci1?,p1?) = -i_*mncv2gc(?a,mnci2,p1)/p1.p1;
    endrepeat;
    repeat;
        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3g(?a,mnci1?,mncp?,?b) =
            -i_*mncv3g(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3g(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3g(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3g(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3g(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3g(?a,mnci1?,mncp?,?b) =
            -i_*mncv3g(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3g(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3g(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3g(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3g(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3gp(?a,mnci1?,mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3gp(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci1?,mnci2?,mncp?)*mncv3gp(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3gp(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3gp(?a,mnci1?,mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,mncp,?b)*mncDs(mncp)
            +i_*mncxi*mncp(mnci2)*mncv3gp(?a,mncp,mncp,?b)*mncDs(mncp)*mncDs(mncp);

        id,once,mncDg(mnci2?,mnci1?,mncp?)*mncv3gp(?a,mnci1?,-mncp?,?b) =
            -i_*mncv3gp(?a,mnci2,-mncp,?b)*mncDs(mncp)
            -i_*mncxi*mncp(mnci2)*mncv3gp(?a,-mncp,-mncp,?b)*mncDs(mncp)*mncDs(mncp);
    endrepeat;
#endif
#if ( `GAUGE' > 0 )
    if ( count(mncxi,1) > `GAUGE' ) discard;
#endif
id  mncDs(p1?) = 1/p1.p1;
id  mncDL(mnci1?,mncj1?,p1?) = -i_*d_(mnci1,mncj1)/p1.p1+i_*p1(mnci1)*p1(mncj1)/p1.p1^2;
id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);

.sort:Gluon Propagators;

repeat;
  repeat;
    repeat;
      repeat;
        repeat;
          repeat;
            repeat;
              id,mncv3g(p1?,p1?,p2?,p2?,p3?,p3?) = 0;
              id,mncv2gi(p1?,p1?,?a) = 0;
              id,mncv2gi(p1?,-p1?,?a) = 0;
              id,mncv2gi(?a,p1?,p1?) = 0;
              id,mncv2gi(?a,p1?,-p1?) = 0;
              id,mncv2gp(p1?,p1?,?a) = 0;
              id,mncv2gp(p1?,-p1?,?a) = 0;
              id,mncv2gp(?a,p1?,p1?) = 0;
              id,mncv2gp(?a,p1?,-p1?) = 0;
              id,mncv2gc(p1?,p1?,?a) = 0;
              id,mncv2gc(p1?,-p1?,?a) = 0;
              id,mncv2gc(?a,p1?,p1?) = 0;
              id,mncv2gc(?a,p1?,-p1?) = 0;
              id,once,mncv3g(p1?,p1?,p2?,p2?,mnci3?,p3?) =
                    -i_*p3.p3*p2(mnci3)+i_*p2.p3*p3(mnci3);
              id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
              id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
              id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
              id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
            endrepeat;
            id,once,mncv3g(mnci3?,p3?,p1?,p1?,p2?,p2?) =
                -i_*p3.p3*p2(mnci3)+i_*p2.p3*p3(mnci3);
            id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
            id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
            id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
            id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
          endrepeat;
          id,once,mncv3g(p2?,p2?,mnci3?,p3?,p1?,p1?) =
                -i_*p3.p3*p2(mnci3)+i_*p2.p3*p3(mnci3);
          id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
          id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
          id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
          id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
        endrepeat;
        id,once,mncv3g(p1?,p1?,mnci2?,p2?,mnci3?,p3?) =
            -i_*p2(mnci2)*p2(mnci3)+i_*p3(mnci2)*p3(mnci3)-i_*p3.p3*d_(mnci2,mnci3)+i_*p2.p2*d_(mnci2,mnci3);
        id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
        id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
        id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
        id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
      endrepeat;
      id,once,mncv3g(mnci3?,p3?,p1?,p1?,mnci2?,p2?) =
        -i_*p2(mnci2)*p2(mnci3)+i_*p3(mnci2)*p3(mnci3)-i_*p3.p3*d_(mnci2,mnci3)+i_*p2.p2*d_(mnci2,mnci3);
      id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
      id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
      id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
      id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
    endrepeat;
    id,once,mncv3g(mnci2?,p2?,mnci3?,p3?,p1?,p1?) =
        -i_*p2(mnci2)*p2(mnci3)+i_*p3(mnci2)*p3(mnci3)-i_*p3.p3*d_(mnci2,mnci3)+i_*p2.p2*d_(mnci2,mnci3);
    id  mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
    id  mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
    id  mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
    id  mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
  endrepeat;
  id,once,mncv3g(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) =
             -2*i_*p1(mnci3)*d_(mnci1,mnci2)-i_*p3(mnci3)*d_(mnci1,mnci2)
             -2*i_*p2(mnci1)*d_(mnci2,mnci3)-i_*p1(mnci1)*d_(mnci2,mnci3)
             -2*i_*p3(mnci2)*d_(mnci3,mnci1)-i_*p2(mnci2)*d_(mnci3,mnci1);
  id    mncv3g(?a,p3?,-p3?) = -mncv3g(?a,-p3,-p3);
  id    mncv3g(mnci1?index_,p1?,p2?,-p2?,?a) = -mncv3g(mnci1,p1,-p2,-p2,?a);
  id    mncv3g(p3?,p1?,p2?,-p2?,?a) = -mncv3g(p3,p1,-p2,-p2,?a);
  id    mncv3g(p1?,-p1?,?a) = -mncv3g(-p1,-p1,?a);
endrepeat;
id  mncv4g(mnci1?,mnci2?,mnci3?,mnci4?) = -i_*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3));

id  mncV4G(mnci1?,mnci2?,mnci3?,mnci4?,mncx1?,mncx2?,mncx3?) =
    -i_*mncx1*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
    -i_*mncx2*(d_(mnci1,mnci2)*d_(mnci3,mnci4)-d_(mnci1,mnci4)*d_(mnci2,mnci3))
    -i_*mncx3*(d_(mnci1,mnci3)*d_(mnci2,mnci4)-d_(mnci1,mnci2)*d_(mnci3,mnci4));

#if ( `GAUGE' != 0 )
    id  mncDg(mnci1?,mnci2?,mncp?) = -i_*(d_(mnci1,mnci2)-mncxi*mncp(mnci1)*mncp(mnci2)/mncp.mncp)/mncp.mncp;
#endif

id  D = acc(4-2*ep);

id	P.P = 0;

id  mncv2gi(mnci1?,p1?,mnci2?,p2?) = -i_*(d_(mnci1,mnci2)*p1.p2-p1(mnci2)*p2(mnci1));
id  mncv3gi(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = i_*(
        d_(mnci1,mnci2)*(p1(mnci3)-p2(mnci3))+d_(mnci2,mnci3)*(p2(mnci1)-p3(mnci1))
        +d_(mnci3,mnci1)*(p3(mnci2)-p1(mnci2)));


id  mncv2gp(mnci1?,p1?,mnci2?,p2?) = -i_*(d_(mnci1,mnci2)*p1.p2-p1(mnci2)*p2(mnci1));
id  mncv3gp(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = i_*(
        d_(mnci1,mnci2)*(p1(mnci3)-p2(mnci3))+d_(mnci2,mnci3)*(p2(mnci1)-p3(mnci1))
        +d_(mnci3,mnci1)*(p3(mnci2)-p1(mnci2)));

id	P.P = 0;

id	mncv2gc(mnci1?,p1?,mnci2?,p2?) = -i_*e_(mnci1,p1,mnci2,p2);
id	mncv3gc(mnci1?,p1?,mnci2?,p2?,mnci3?,p3?) = i_*(
			e_(mnci1,mnci2,mnci3,p1)+e_(mnci1,mnci2,mnci3,p2)+e_(mnci1,mnci2,mnci3,p3));
id	mncv3gc(mnci1?,mnci2?,mnci3?,mncp?) = -i_*e_(mnci1,mnci2,mnci3,mncp);
id	mncv4gc(mnci1?,mnci2?,mnci3?,mnci4?) = -i_*e_(mnci1,mnci2,mnci3,mnci4);

Contract;
id	P.P = 0;

#endprocedure
*--#] vertsubm : 
*--#[ ACCU :
#procedure ACCU(TEXT)
if ( count(ep,1) );
	if ( count(acc,1) == 1 );
		id	ep^mncx?*acc(mncy?) = acc(ep^mncx*mncy);
	else;
		id	ep^mncx? = acc(ep^mncx);
	endif;
endif;
.sort(PolyFun = acc):`TEXT';
#endprocedure
*--#] ACCU : 
*--#[ ACCU2 :
#procedure ACCU2(BRA,TEXT)
if ( count(ep,1) );
	if ( count(acc,1) == 1 );
		id	ep^mncx?*acc(mncy?) = acc(ep^mncx*mncy);
	else;
		id	ep^mncx? = acc(ep^mncx);
	endif;
endif;
`BRA';
.sort(PolyFun = acc):`TEXT';
#endprocedure
*--#] ACCU2 : 
*--#[ ACCUP :
#procedure ACCUP(TEXT)
id	acc(mncx?) = mncx;
.sort:`TEXT';
#endprocedure
*--#] ACCUP : 
*--#] Procedures :
*--#[ Tables :
*#ifdef `POW'
*#if ( `POW' >= 8 )
*#call pochtabl(24)
*#else
*#call pochtabl(20)
*#endif
*#else
*#call pochtabl(20)
*#endif
#call pochtabl(24)
#call tabtwo(12)
*--#[ notabl.h :
CTable sparse mncnoptab(4);
#define INNOTABL "11"
*Fill mncnoptab(3,3,3,3) =
*       - 18474865276279/324000 - 147056/3*ep^-3 - 9668041/30*ep^-2 + 85171103/
*      1800*ep^-1 - 484428616/3*z3 + 246960000*z5;
*Fill mncnoptab(4,2,2,4) =
*       - 6586797294014227/250047000 - 269984/27*ep^-3 - 57006874/945*ep^-2 + 
*      955059143/22050*ep^-1 - 1942771744/27*z3 + 109760000*z5;
*Fill mncnoptab(4,3,1,4) =
*       - 3041096169814853/357210000 - 291704/135*ep^-3 - 993209/75*ep^-2 + 
*      158917319/18900*ep^-1 - 3110543296/135*z3 + 35123200*z5;
*Fill mncnoptab(4,3,2,3) =
*       - 91660413154999/2976750 - 193760/9*ep^-3 - 6413092/45*ep^-2 + 27103277/
*      1890*ep^-1 - 775759936/9*z3 + 131712000*z5;
*Fill mncnoptab(4,3,3,2) =
*       - 357433853456101/14883750 - 1156064/45*ep^-3 - 4163404/25*ep^-2 + 
*      64087288/1575*ep^-1 - 3094354816/45*z3 + 105369600*z5;
*Fill mncnoptab(4,4,2,2) =
*       - 86747864238209/8930250 - 417088/27*ep^-3 - 38521988/405*ep^-2 + 
*      264311666/4725*ep^-1 - 769912640/27*z3 + 43904000*z5;
*Fill mncnoptab(4,4,3,1) =
*       - 1515457055404949/357210000 - 82712/135*ep^-3 - 18631369/2025*ep^-2 - 
*      89285363/2835*ep^-1 - 1559578048/135*z3 + 17561600*z5;
*Fill mncnoptab(5,1,1,5) =
*       - 54699046462671221/32006016000 + 39923/216*ep^-3 + 65445179/60480*
*      ep^-2 - 453971069/313600*ep^-1 - 121886869/27*z3 + 6860000*z5;
*Fill mncnoptab(5,2,1,4) =
*       - 10775201906664373/2000376000 + 860/27*ep^-3 - 1053382/945*ep^-2 - 
*      266829113/35280*ep^-1 - 390135008/27*z3 + 21952000*z5;
*Fill mncnoptab(5,2,2,3) =
*       - 2654032230525247/208372500 - 108592/45*ep^-3 - 35031746/1575*ep^-2 - 
*      1264086542/33075*ep^-1 - 1558464128/45*z3 + 52684800*z5;
*Fill mncnoptab(5,3,1,3) =
*       - 1553281109396459/381024000 + 6559/9*ep^-3 + 172871/540*ep^-2 - 
*      2946557347/100800*ep^-1 - 97752760/9*z3 + 16464000*z5;
*Fill mncnoptab(5,3,2,2) =
*       - 349190112856271/59535000 - 381136/45*ep^-3 - 36449102/675*ep^-2 + 
*      193339331/9450*ep^-1 - 770935424/45*z3 + 26342400*z5;
*Fill mncnoptab(5,3,3,1) =
*       - 495589548067253/317520000 - 19369/45*ep^-3 - 12264643/1800*ep^-2 - 
*      745482991/30240*ep^-1 - 195095096/45*z3 + 6585600*z5;
*Fill mncnoptab(5,4,1,2) =
*       - 1404687254200169/2000376000 - 22196/27*ep^-3 - 18341056/2835*ep^-2 - 
*      7901872933/1587600*ep^-1 - 55213792/27*z3 + 3136000*z5;
*Fill mncnoptab(5,4,2,1) =
*       - 2703599746937443/5000940000 - 141956/135*ep^-3 - 206700143/28350*
*      ep^-2 - 395097751/264600*ep^-1 - 219587104/135*z3 + 2508800*z5;
*Fill mncnoptab(5,5,1,1) =
*       - 2629892605029463/128024064000 - 9421/108*ep^-3 - 169868023/362880*
*      ep^-2 - 170678409/627200*ep^-1 - 1745339/27*z3 + 98000*z5;
*Fill mncnoptab(6,1,1,4) =
*       - 21394537161736301/25004700000 - 204262/675*ep^-3 - 11650321/10500*
*      ep^-2 + 954399088/165375*ep^-1 - 1550442608/675*z3 + 3512320*z5;
*Fill mncnoptab(6,2,1,3) =
*       - 1355689314527311/1041862500 + 9944/225*ep^-3 + 4198591/23625*ep^-2 - 
*      576422233/330750*ep^-1 - 780778304/225*z3 + 5268480*z5;
*Fill mncnoptab(6,2,2,2) =
*       - 102264570285053/86821875 - 377056/225*ep^-3 - 27899296/2625*ep^-2 + 
*      791190703/165375*ep^-1 - 770079104/225*z3 + 5268480*z5;
*Fill mncnoptab(6,3,1,2) =
*       - 712078941266617/2083725000 - 88616/225*ep^-3 - 65364799/23625*ep^-2
*       - 76182557/220500*ep^-1 - 220289344/225*z3 + 1505280*z5;
*Fill mncnoptab(6,3,2,1) =
*       - 71933674894463/463050000 - 88408/225*ep^-3 - 22366649/7875*ep^-2 - 
*      83726576/55125*ep^-1 - 109791872/225*z3 + 752640*z5;
*Fill mncnoptab(6,4,1,1) =
*       - 2549268572811643/200037600000 - 39952/675*ep^-3 - 181234189/567000*
*      ep^-2 - 659982313/3969000*ep^-1 - 27943568/675*z3 + 62720*z5;
*Fill mncnoptab(7,1,1,3) =
*       - 3723627858464321/33339600000 + 46897/1350*ep^-3 + 73683103/378000*
*      ep^-2 - 3880010633/15876000*ep^-1 - 195059276/675*z3 + 439040*z5;
*Fill mncnoptab(7,2,1,2) =
*       - 122256120796157/2083725000 - 8008/675*ep^-3 - 230717/875*ep^-2 - 
*      984557027/992250*ep^-1 - 111467072/675*z3 + 250880*z5;
*Fill mncnoptab(7,2,2,1) =
*       - 374471233554053/29172150000 - 352616/4725*ep^-3 - 77449193/165375*
*      ep^-2 + 1455586687/13891500*ep^-1 - 215345344/4725*z3 + 71680*z5;
*Fill mncnoptab(7,3,1,1) =
*       - 886148642962981/266716800000 - 8938/675*ep^-3 - 56364883/756000*ep^-2
*       - 1845718393/31752000*ep^-1 - 6977492/675*z3 + 15680*z5;
*Fill mncnoptab(8,1,1,2) =
*       - 952067717329531/408410100000 - 305366/33075*ep^-3 - 157911017/4630500
*      *ep^-2 + 15496117051/97240500*ep^-1 - 208616944/33075*z3 + 10240*z5;
*Fill mncnoptab(8,2,1,1) =
*       - 716689569830281/3267280800000 - 51952/33075*ep^-3 - 25922261/3087000*
*      ep^-2 - 18220093/24310125*ep^-1 - 28039568/33075*z3 + 1280*z5;
*Fill mncnoptab(9,1,1,1) =
*       - 1896551334050581/209105971200000 + 73249/1058400*ep^-3 + 51235081/
*      296352000*ep^-2 - 54957379097/49787136000*ep^-1 - 413312/33075*z3 + 20*
*      z5;
Fill mncnoptab(3,3,3,2) =
      427977441983/103680 - 52955/12*ep^-3 - 3917279/144*ep^-2 + 44625631/2880
      *ep^-1 + 10894318111/72*ep*z3 + 15370495*ep*z4 - 99078000*ep*z5 - 
      452482708047761/10368000*ep + 30740990/3*z3 - 15435000*z5;
Fill mncnoptab(4,2,1,4) =
      492417147546743/571536000 - 22771/54*ep^-3 - 1974617/1080*ep^-2 + 
      915359519/151200*ep^-1 + 6081755963/180*ep*z3 + 30675106/9*ep*z4 - 
      67110400/3*ep*z5 - 2327268549647543977/240045120000*ep + 61350212/27*z3
       - 3430000*z5;
Fill mncnoptab(4,2,2,3) =
      10310508922643/3888000 - 29239/18*ep^-3 - 410057/40*ep^-2 + 29037853/
      7200*ep^-1 + 18176277881/180*ep*z3 + 30621724/3*ep*z4 - 66463600*ep*z5
       - 6775865580736891/233280000*ep + 61243448/9*z3 - 10290000*z5;
Fill mncnoptab(4,3,1,3) =
      98209093589899/127008000 - 847/12*ep^-3 - 21579/16*ep^-2 - 513470983/
      100800*ep^-1 + 1219050631/40*ep*z3 + 3045119*ep*z4 - 20286000*ep*z5 - 
      152753095200805831/17781120000*ep + 6090238/3*z3 - 3087000*z5;
Fill mncnoptab(4,3,2,2) =
      746549351657/432000 - 18823/6*ep^-3 - 2095397/120*ep^-2 + 476289437/
      21600*ep^-1 + 3674812061/60*ep*z3 + 6207586*ep*z4 - 40454400*ep*z5 - 
      449125235438929/25920000*ep + 12415172/3*z3 - 6174000*z5;
Fill mncnoptab(4,3,3,1) =
      33417478515833/70560000 - 1981/60*ep^-3 - 6027293/3600*ep^-2 - 
      2496913651/302400*ep^-1 + 33147300541/1800*ep*z3 + 9111137/5*ep*z4 - 
      12359760*ep*z5 - 1343694916819313567/266716800000*ep + 18222274/15*z3 - 
      1852200*z5;
Fill mncnoptab(4,4,2,1) =
      111808019020979/571536000 - 20419/54*ep^-3 - 7607927/3240*ep^-2 + 
      618574609/453600*ep^-1 + 11269028347/1620*ep*z3 + 6219724/9*ep*z4 - 
      14131600/3*ep*z5 - 445250532042081389/240045120000*ep + 12439448/27*z3
       - 686000*z5;
Fill mncnoptab(5,1,1,4) =
      3404545910519813/16003008000 + 11537/216*ep^-3 + 2265673/30240*ep^-2 - 
      6664583011/4233600*ep^-1 + 6125595259/720*ep*z3 + 7568332/9*ep*z4 - 
      17149300/3*ep*z5 - 15988216912889349067/6721263360000*ep + 15136664/27*
      z3 - 857500*z5;
Fill mncnoptab(5,2,1,3) =
      94217706529879/254016000 + 1407/8*ep^-3 + 784633/1440*ep^-2 - 794391811/
      201600*ep^-1 + 11025810727/720*ep*z3 + 1515276*ep*z4 - 10304700*ep*z5 - 
      151196680058747123/35562240000*ep + 1010184*z3 - 1543500*z5;
Fill mncnoptab(5,2,2,2) =
      6657499764253/12960000 - 48041/60*ep^-3 - 17309333/3600*ep^-2 + 1298841/
      320*ep^-1 + 33499700221/1800*ep*z3 + 9286732/5*ep*z4 - 12506760*ep*z5 - 
      439852636788781/86400000*ep + 18573464/15*z3 - 1852200*z5;
Fill mncnoptab(5,3,1,2) =
      15299981746757/108864000 - 10171/72*ep^-3 - 4960199/4320*ep^-2 - 
      67110217/86400*ep^-1 + 2256184967/432*ep*z3 + 1537060/3*ep*z4 - 3562300*
      ep*z5 - 12594448880199007/9144576000*ep + 3074120/9*z3 - 514500*z5;
Fill mncnoptab(5,3,2,1) =
      115620267808099/1270080000 - 23387/120*ep^-3 - 1040799/800*ep^-2 + 
      1988123/120960*ep^-1 + 3798914129/1200*ep*z3 + 1550612/5*ep*z4 - 2172660
      *ep*z5 - 433205664999625789/533433600000*ep + 3101224/15*z3 - 308700*z5;
Fill mncnoptab(5,4,1,1) =
      116607543852899/16003008000 - 6157/216*ep^-3 - 12443447/90720*ep^-2 + 
      33603169/12700800*ep^-1 + 11782494547/45360*ep*z3 + 216868/9*ep*z4 - 
      567700/3*ep*z5 - 56108643614351387/960180480000*ep + 433736/27*z3 - 
      24500*z5;
Fill mncnoptab(6,1,1,3) =
      2037883590668579/44452800000 + 733/200*ep^-3 + 7183069/252000*ep^-2 - 
      1717712057/21168000*ep^-1 + 33824122981/18000*ep*z3 + 4538676/25*ep*z4
       - 1299396*ep*z5 - 9366902119661172109/18670176000000*ep + 3025784/25*z3
       - 185220*z5;
Fill mncnoptab(6,2,1,2) =
      35390275843033/1058400000 - 16667/300*ep^-3 - 1822397/6000*ep^-2 + 
      682534127/1512000*ep^-1 + 1280879763/1000*ep*z3 + 3119284/25*ep*z4 - 
      892584*ep*z5 - 434777012367296309/1333584000000*ep + 6238568/75*z3 - 
      123480*z5;
Fill mncnoptab(6,2,2,1) =
      43705933939733/3175200000 - 51667/900*ep^-3 - 643293/2000*ep^-2 + 
      164162507/504000*ep^-1 + 3941599109/9000*ep*z3 + 3185084/75*ep*z4 - 
      309288*ep*z5 - 139189622958910043/1333584000000*ep + 6370168/225*z3 - 
      41160*z5;
Fill mncnoptab(6,3,1,1) =
      4402290724537/1646400000 - 2127/200*ep^-3 - 13081511/252000*ep^-2 + 
      85049863/21168000*ep^-1 + 11976922627/126000*ep*z3 + 216756/25*ep*z4 - 
      70476*ep*z5 - 54838846552119547/2667168000000*ep + 144504/25*z3 - 8820*
      z5;
Fill mncnoptab(7,1,1,2) =
      238117911919931/133358400000 + 29933/5400*ep^-3 + 4181741/756000*ep^-2
       - 10958786353/63504000*ep^-1 + 3961449709/54000*ep*z3 + 1424992/225*ep*
      z4 - 54348*ep*z5 - 883201342630552501/56010528000000*ep + 2849984/675*z3
       - 6860*z5;
Fill mncnoptab(7,2,1,1) =
      37694309069933/133358400000 - 4981/5400*ep^-3 - 3848197/756000*ep^-2 - 
      229928551/63504000*ep^-1 + 4150542589/378000*ep*z3 + 217456/225*ep*z4 - 
      8484*ep*z5 - 16503907631292229/8001504000000*ep + 434912/675*z3 - 980*z5
      ;
Fill mncnoptab(8,1,1,1) =
      61242264325133/6534561600000 - 26581/264600*ep^-3 - 8290837/37044000*
      ep^-2 + 4495302041/3111696000*ep^-1 + 641079787/2646000*ep*z3 + 206656/
      11025*ep*z4 - 1452/7*ep*z5 - 152139085793242243/2744515872000000*ep + 
      413312/33075*z3 - 20*z5;
Fill mncnoptab(3,2,2,3) =
       - 13078015423/40500 - 1166/3*ep^-3 - 219653/90*ep^-2 + 179359/150*ep^-1
       - 621784364/45*ep*z3 - 1410728*ep*z4 + 8943600*ep*z5 + 565882214657/
      135000*ep - 2821456/3*z3 + 1440000*z5;
Fill mncnoptab(3,3,2,2) =
       - 931159283/4320 - 800*ep^-3 - 48001/12*ep^-2 + 1417247/180*ep^-1 - 
      62078545/6*ep*z3 - 1038120*ep*z4 + 6768000*ep*z5 + 4000067937751/1296000
      *ep - 692080*z3 + 1080000*z5;
Fill mncnoptab(3,3,3,1) =
       - 5573732533/57600 + 175/4*ep^-3 - 9581/48*ep^-2 - 7492889/2880*ep^-1
       - 94545971/24*ep*z3 - 403305*ep*z4 + 2574000*ep*z5 + 12321204871351/
      10368000*ep - 268870*z3 + 405000*z5;
Fill mncnoptab(4,1,1,4) =
       - 2807827829/72900 - 1630/27*ep^-3 - 3245/18*ep^-2 + 34576/27*ep^-1 - 
      42000568/27*ep*z3 - 1383640/9*ep*z4 + 3082000/3*ep*z5 + 979385889611/
      2187000*ep - 2767280/27*z3 + 160000*z5;
Fill mncnoptab(4,2,1,3) =
       - 28221879029/324000 + 4/3*ep^-3 - 1799/20*ep^-2 - 44113/75*ep^-1 - 
      35012467/10*ep*z3 - 356408*ep*z4 + 2289600*ep*z5 + 6698633885851/6480000
      *ep - 712816/3*z3 + 360000*z5;
Fill mncnoptab(4,2,2,2) =
       - 23078731723/216000 - 461*ep^-3 - 130721/60*ep^-2 + 19017283/3600*
      ep^-1 - 156219263/30*ep*z3 - 514644*ep*z4 + 3448800*ep*z5 + 
      19670240647171/12960000*ep - 343096*z3 + 540000*z5;
Fill mncnoptab(4,3,1,2) =
       - 9262246349/324000 - 338/3*ep^-3 - 11801/20*ep^-2 + 26071/25*ep^-1 - 
      14061799/10*ep*z3 - 137384*ep*z4 + 946800*ep*z5 + 869340324673/2160000*
      ep - 274768/3*z3 + 144000*z5;
Fill mncnoptab(4,3,2,1) =
       - 4269941147/216000 - 251/3*ep^-3 - 93673/180*ep^-2 + 3333209/10800*
      ep^-1 - 95416027/90*ep*z3 - 104348*ep*z4 + 717600*ep*z5 + 11837431004993/
      38880000*ep - 208696/3*z3 + 108000*z5;
Fill mncnoptab(4,4,1,1) =
       - 3869903417/2916000 - 364/27*ep^-3 - 89387/1620*ep^-2 + 432743/8100*
      ep^-1 - 67431383/810*ep*z3 - 71512/9*ep*z4 + 176800/3*ep*z5 + 
      3785470839041/174960000*ep - 143024/27*z3 + 8000*z5;
Fill mncnoptab(5,1,1,3) =
       - 94014346831/5184000 + 121/8*ep^-3 + 106063/1440*ep^-2 - 16207369/
      86400*ep^-1 - 482890991/720*ep*z3 - 66732*ep*z4 + 447900*ep*z5 + 
      59566361995607/311040000*ep - 44488*z3 + 67500*z5;
Fill mncnoptab(5,2,1,2) =
       - 1631016859/144000 - 15/2*ep^-3 - 14459/120*ep^-2 - 80399/288*ep^-1 - 
      32279897/60*ep*z3 - 53352*ep*z4 + 367200*ep*z5 + 1309588517171/8640000*
      ep - 35568*z3 + 54000*z5;
Fill mncnoptab(5,2,2,1) =
       - 1703250341/540000 - 201/5*ep^-3 - 28709/150*ep^-2 + 179513/450*ep^-1
       - 32408209/150*ep*z3 - 99576/5*ep*z4 + 152280*ep*z5 + 1861089308173/
      32400000*ep - 66384/5*z3 + 21600*z5;
Fill mncnoptab(5,3,1,1) =
       - 1507518839/1728000 - 49/8*ep^-3 - 37471/1440*ep^-2 + 1281373/86400*
      ep^-1 - 34159189/720*ep*z3 - 4452*ep*z4 + 33900*ep*z5 + 3821093000941/
      311040000*ep - 2968*z3 + 4500*z5;
Fill mncnoptab(6,1,1,2) =
       - 8071460023/8100000 - 181/25*ep^-3 - 24496/1125*ep^-2 + 1915223/13500*
      ep^-1 - 99509497/2250*ep*z3 - 94056/25*ep*z4 + 32136*ep*z5 + 
      5141063764979/486000000*ep - 62704/25*z3 + 4320*z5;
Fill mncnoptab(6,2,1,1) =
       - 35661097/400000 - 77/50*ep^-3 - 55603/9000*ep^-2 + 967589/108000*
      ep^-1 - 35320249/4500*ep*z3 - 17976/25*ep*z4 + 5856*ep*z5 + 
      3353461354561/1944000000*ep - 11984/25*z3 + 720*z5;
Fill mncnoptab(7,1,1,1) =
       - 3387368219/388800000 + 469/5400*ep^-3 + 14099/108000*ep^-2 - 1960937/
      1296000*ep^-1 - 4305961/18000*ep*z3 - 4144/225*ep*z4 + 196*ep*z5 + 
      1489128179587/23328000000*ep - 8288/675*z3 + 20*z5;
Fill mncnoptab(3,2,1,3) =
      2831372533/194400 + 455/18*ep^-3 + 6319/216*ep^-2 - 4589599/6480*ep^-1
       + 15385216/27*ep*z3 + 173950/3*ep*z4 - 363500*ep*z5 - 981631156921/
      5832000*ep + 347900/9*z3 - 60000*z5;
Fill mncnoptab(3,2,2,2) =
      145969549/3888 - 1435/9*ep^-3 - 70691/108*ep^-2 + 1431199/648*ep^-1 + 
      31188362/27*ep*z3 + 372740/3*ep*z4 - 721000*ep*z5 - 8538217571/23328*ep
       + 745480/9*z3 - 120000*z5;
Fill mncnoptab(3,3,2,1) =
      7510602449/777600 - 235/9*ep^-3 - 67391/432*ep^-2 + 2082899/12960*ep^-1
       + 63188269/216*ep*z3 + 90710/3*ep*z4 - 187000*ep*z5 - 4047664683001/
      46656000*ep + 181420/9*z3 - 30000*z5;
Fill mncnoptab(4,1,1,3) =
      15081744101/2916000 + 203/54*ep^-3 + 19823/3240*ep^-2 - 11583047/97200*
      ep^-1 + 77945816/405*ep*z3 + 172582/9*ep*z4 - 374300/3*ep*z5 - 
      5068206135881/87480000*ep + 345164/27*z3 - 20000*z5;
Fill mncnoptab(4,2,1,2) =
      1399378579/233280 - 740/27*ep^-3 - 70421/648*ep^-2 + 1649821/3888*ep^-1
       + 63915859/324*ep*z3 + 190060/9*ep*z4 - 380000/3*ep*z5 - 830598308171/
      13996800*ep + 380120/27*z3 - 20000*z5;
Fill mncnoptab(4,2,2,1) =
      8626579097/2332800 - 1505/54*ep^-3 - 70453/648*ep^-2 + 15165647/38880*
      ep^-1 + 32636837/324*ep*z3 + 97820/9*ep*z4 - 196000/3*ep*z5 - 
      4214387793553/139968000*ep + 195640/27*z3 - 10000*z5;
Fill mncnoptab(4,3,1,1) =
      7805797697/11664000 - 119/27*ep^-3 - 93743/6480*ep^-2 + 5998307/194400*
      ep^-1 + 65653693/3240*ep*z3 + 17638/9*ep*z4 - 42200/3*ep*z5 - 
      3678149914921/699840000*ep + 35276/27*z3 - 2000*z5;
Fill mncnoptab(5,1,1,2) =
      38410091629/46656000 + 763/216*ep^-3 - 13217/12960*ep^-2 - 88538189/
      777600*ep^-1 + 162821989/6480*ep*z3 + 19568/9*ep*z4 - 51700/3*ep*z5 - 
      17384289807653/2799360000*ep + 39136/27*z3 - 2500*z5;
Fill mncnoptab(5,2,1,1) =
      7464164057/46656000 - 193/216*ep^-3 - 42829/12960*ep^-2 + 3267047/777600
      *ep^-1 + 33840689/6480*ep*z3 + 4432/9*ep*z4 - 11300/3*ep*z5 - 
      3355464483121/2799360000*ep + 8864/27*z3 - 500*z5;
Fill mncnoptab(6,1,1,1) =
      9848776457/1166400000 - 769/5400*ep^-3 - 49837/324000*ep^-2 + 8517547/
      3888000*ep^-1 + 36299969/162000*ep*z3 + 4144/225*ep*z4 - 548/3*ep*z5 - 
      4938159875041/69984000000*ep + 8288/675*z3 - 20*z5;
Fill mncnoptab(2,2,2,2) =
       - 79897/27 - 64*ep^-3 - 500/3*ep^-2 + 10846/9*ep^-1 - 466976/3*ep*z3 - 
      14352*ep*z4 + 97440*ep*z5 + 2415263/54*ep - 9568*z3 + 17280*z5;
Fill mncnoptab(3,1,1,3) =
       - 1209925/864 + 9/2*ep^-3 + 123/8*ep^-2 - 4087/48*ep^-1 - 123208/3*ep*
      z3 - 4314*ep*z4 + 25260*ep*z5 + 74575541/5184*ep - 2876*z3 + 4320*z5;
Fill mncnoptab(3,2,1,2) =
       - 466685/648 - 4*ep^-3 - 310/9*ep^-2 + 473/108*ep^-1 - 478994/9*ep*z3
       - 5712*ep*z4 + 33600*ep*z5 + 65128439/3888*ep - 3808*z3 + 5760*z5;
Fill mncnoptab(3,2,2,1) =
       - 582479/972 - 148/9*ep^-3 - 1217/27*ep^-2 + 47689/162*ep^-1 - 955180/
      27*ep*z3 - 9328/3*ep*z4 + 22880*ep*z5 + 57290287/5832*ep - 18656/9*z3 + 
      3840*z5;
Fill mncnoptab(3,3,1,1) =
       - 1518557/10368 - 5/3*ep^-3 - 565/144*ep^-2 + 11917/864*ep^-1 - 514753/
      72*ep*z3 - 710*ep*z4 + 4680*ep*z5 + 273452161/124416*ep - 1420/3*z3 + 
      720*z5;
Fill mncnoptab(4,1,1,2) =
       - 1072745/2916 - 142/27*ep^-3 - 1705/162*ep^-2 + 56761/486*ep^-1 - 
      974044/81*ep*z3 - 8152/9*ep*z4 + 24080/3*ep*z5 + 7103453/2187*ep - 16304/
      27*z3 + 1280*z5;
Fill mncnoptab(4,2,1,1) =
       - 471157/23328 - 40/27*ep^-3 - 1019/324*ep^-2 + 16361/972*ep^-1 - 
      519899/162*ep*z3 - 2920/9*ep*z4 + 6560/3*ep*z5 + 204421561/279936*ep - 
      5840/27*z3 + 320*z5;
Fill mncnoptab(5,1,1,1) =
       - 2696245/373248 + 25/216*ep^-3 + 17/2592*ep^-2 - 63191/31104*ep^-1 - 
      286261/1296*ep*z3 - 160/9*ep*z4 + 500/3*ep*z5 + 369093769/4478976*ep - 
      320/27*z3 + 20*z5;
Fill mncnoptab(2,2,2,1) =
      50881/216 - 9*ep^-3 - 85/6*ep^-2 + 6803/36*ep^-1 + 30293/3*ep*z3 + 1476*
      ep*z4 - 5760*ep*z5 - 5699221/1296*ep + 984*z3 - 1080*z5;
Fill mncnoptab(3,1,1,2) =
      144325/432 + 3/2*ep^-3 - 15/4*ep^-2 - 377/8*ep^-1 + 30517/6*ep*z3 + 384*
      ep*z4 - 3000*ep*z5 - 4415225/2592*ep + 256*z3 - 540*z5;
Fill mncnoptab(3,2,1,1) =
      73417/1296 - 5/6*ep^-3 - 29/36*ep^-2 + 2027/216*ep^-1 + 30409/18*ep*z3
       + 176*ep*z4 - 1080*ep*z5 - 4203133/7776*ep + 352/3*z3 - 180*z5;
Fill mncnoptab(4,1,1,1) =
      44165/11664 - 13/54*ep^-3 + 59/324*ep^-2 + 6575/1944*ep^-1 + 31733/162*
      ep*z3 + 160/9*ep*z4 - 440/3*ep*z5 - 6225337/69984*ep + 320/27*z3 - 20*z5
      ;
Fill mncnoptab(2,1,1,2) =
       - 677/3 - 10/3*ep^-3 + 1/3*ep^-2 + 233/3*ep^-1 - 4480/3*ep*z3 + 56*ep*
      z4 + 760*ep*z5 + 1567/3*ep + 112/3*z3 + 160*z5;
Fill mncnoptab(2,2,1,1) =
       - 85/4 - 4/3*ep^-3 + 3/2*ep^-2 + 31/2*ep^-1 - 697*ep*z3 - 88*ep*z4 + 
      400*ep*z5 + 571/8*ep - 176/3*z3 + 80*z5;
Fill mncnoptab(3,1,1,1) =
       - 53/16 + 1/6*ep^-3 - 5/12*ep^-2 - 47/24*ep^-1 - 1151/6*ep*z3 - 16*ep*
      z4 + 120*ep*z5 + 3427/32*ep - 32/3*z3 + 20*z5;
Fill mncnoptab(2,1,1,1) =
       - 10 - 2/3*ep^-3 + 10/3*ep^-2 - 2*ep^-1 + 404/3*ep*z3 + 16*ep*z4 - 80*
      ep*z5 - 42*ep + 32/3*z3 - 20*z5;
Fill mncnoptab(1,1,1,1) =
      20*z5;
*--#] notabl.h : 
*--#[ gtabls.h :
Ctable,relax,mncT00(1:10,1:10);
Ctable,relax,mncT10(-6:10,1:10);
Ctable,relax,mncT20(-6:10,1:10);
Ctable,relax,mncT11(-6:10,-6:10);
fill mncT00(1,1) =
  ep^-1;
fill mncT00(1,2) =
  2-ep^-1;
fill mncT00(1,3) =
  -1+2*ep;
fill mncT00(1,4) =
  -1/3+4/3*ep^2;
fill mncT00(1,5) =
  -1/6-1/6*ep+2/3*ep^2+2/3*ep^3;
fill mncT00(1,6) =
  -1/10-1/6*ep+1/3*ep^2+2/3*ep^3+4/15*ep^4;
fill mncT00(1,7) =
  -1/15-13/90*ep+1/6*ep^2+5/9*ep^3+2/5*ep^4+4/45*ep^5;
fill mncT00(1,8) =
  -1/21-11/90*ep+7/90*ep^2+4/9*ep^3+4/9*ep^4+8/45*ep^5;
fill mncT00(1,9) =
  -1/28-29/280*ep+1/36*ep^2+127/360*ep^3+4/9*ep^4+11/45*ep^5;
fill mncT00(1,10) =
  -1/36-223/2520*ep-4/2835*ep^2+101/360*ep^3+229/540*ep^4+13/
  45*ep^5;
fill mncT00(2,1) =
  2-ep^-1;
fill mncT00(2,2) =
  2-2*ep^-1+4*ep;
fill mncT00(2,3) =
  -1-2*ep^-1+8*ep+4*ep^2;
fill mncT00(2,4) =
  -8/3-2*ep^-1+22/3*ep+32/3*ep^2+8/3*ep^3;
fill mncT00(2,5) =
  -23/6-2*ep^-1+35/6*ep+15*ep^2+26/3*ep^3+4/3*ep^4;
fill mncT00(2,6) =
  -71/15-2*ep^-1+62/15*ep+53/3*ep^2+46/3*ep^3+76/15*ep^4+8/
  15*ep^5;
fill mncT00(2,7) =
  -82/15-2*ep^-1+217/90*ep+1729/90*ep^2+196/9*ep^3+476/45*ep^4
  +104/45*ep^5;
fill mncT00(2,8) =
  -213/35-2*ep^-1+229/315*ep+899/45*ep^2+1247/45*ep^3+776/45*
  ep^4+248/45*ep^5;
fill mncT00(2,9) =
  -927/140-2*ep^-1-2263/2520*ep+6359/315*ep^2+3967/120*ep^3+
  1477/60*ep^4+151/15*ep^5;
fill mncT00(2,10) =
  -4469/630-2*ep^-1-3097/1260*ep+45329/2268*ep^2+85787/2268*ep^3
  +17489/540*ep^4+4273/270*ep^5;
fill mncT00(3,1) =
  -1+2*ep;
fill mncT00(3,2) =
  -1-2*ep^-1+8*ep+4*ep^2;
fill mncT00(3,3) =
  -5-6*ep^-1+23*ep+20*ep^2+4*ep^3;
fill mncT00(3,4) =
  -15-12*ep^-1+127/3*ep+178/3*ep^2+68/3*ep^3+8/3*ep^4;
fill mncT00(3,5) =
  -97/3-20*ep^-1+371/6*ep+751/6*ep^2+217/3*ep^3+50/3*ep^4+4/
  3*ep^5;
fill mncT00(3,6) =
  -58-30*ep^-1+2333/30*ep+6529/30*ep^2+500/3*ep^3+172/3*ep^4
  +136/15*ep^5;
fill mncT00(3,7) =
  -464/5-42*ep^-1+2603/30*ep+15089/45*ep^2+28489/90*ep^3+6416/
  45*ep^4+1508/45*ep^5;
fill mncT00(3,8) =
  -687/5-56*ep^-1+10807/126*ep+149903/315*ep^2+1061/2*ep^3+291
  *ep^4+268/3*ep^5;
fill mncT00(3,9) =
  -6733/35-72*ep^-1+2015/28*ep+1603937/2520*ep^2+513547/630*ep^3
  +62519/120*ep^4+11669/60*ep^5;
fill mncT00(3,10) =
  -3615/14-90*ep^-1+13466/315*ep+2051033/2520*ep^2+6665453/5670*
  ep^3+19284803/22680*ep^4+49856/135*ep^5;
fill mncT00(4,1) =
  -1/3+4/3*ep^2;
fill mncT00(4,2) =
  -8/3-2*ep^-1+22/3*ep+32/3*ep^2+8/3*ep^3;
fill mncT00(4,3) =
  -15-12*ep^-1+127/3*ep+178/3*ep^2+68/3*ep^3+8/3*ep^4;
fill mncT00(4,4) =
  -58-40*ep^-1+1180/9*ep+226*ep^2+1036/9*ep^3+24*ep^4+16/9*
  ep^5;
fill mncT00(4,5) =
  -505/3-100*ep^-1+5311/18*ep+11569/18*ep^2+3740/9*ep^3+1100/9
  *ep^4+152/9*ep^5;
fill mncT00(4,6) =
  -401-210*ep^-1+8123/15*ep+13433/9*ep^2+52729/45*ep^3+3992/9*
  ep^4+3976/45*ep^5;
fill mncT00(4,7) =
  -12467/15-392*ep^-1+77009/90*ep+405461/135*ep^2+249029/90*ep^3
  +57259/45*ep^4+14788/45*ep^5;
fill mncT00(4,8) =
  -23332/15-672*ep^-1+25051/21*ep+734401/135*ep^2+5421223/945*
  ep^3+138649/45*ep^4+43618/45*ep^5;
fill mncT00(4,9) =
  -18855/7-1080*ep^-1+618431/420*ep+1527913/168*ep^2+40749427/
  3780*ep^3+49720691/7560*ep^4+108841/45*ep^5;
fill mncT00(4,10) =
  -61445/14-1650*ep^-1+1187719/756*ep+13492646/945*ep^2+
  319245677/17010*ep^3+1605965/126*ep^4+36227755/6804*ep^5;
fill mncT00(5,1) =
  -1/6-1/6*ep+2/3*ep^2+2/3*ep^3;
fill mncT00(5,2) =
  -23/6-2*ep^-1+35/6*ep+15*ep^2+26/3*ep^3+4/3*ep^4;
fill mncT00(5,3) =
  -97/3-20*ep^-1+371/6*ep+751/6*ep^2+217/3*ep^3+50/3*ep^4+4/
  3*ep^5;
fill mncT00(5,4) =
  -505/3-100*ep^-1+5311/18*ep+11569/18*ep^2+3740/9*ep^3+1100/9
  *ep^4+152/9*ep^5;
fill mncT00(5,5) =
  -3835/6-350*ep^-1+34147/36*ep+43147/18*ep^2+63929/36*ep^3+
  5720/9*ep^4+1082/9*ep^5;
fill mncT00(5,6) =
  -11683/6-980*ep^-1+427073/180*ep+321547/45*ep^2+120747/20*ep^3
  +25521/10*ep^4+9106/15*ep^5;
fill mncT00(5,7) =
  -75782/15-2352*ep^-1+445667/90*ep+1953209/108*ep^2+465035/27*
  ep^3+1510033/180*ep^4+215411/90*ep^5;
fill mncT00(5,8) =
  -11610-5040*ep^-1+5635817/630*ep+152869817/3780*ep^2+81063041/
  1890*ep^3+89139203/3780*ep^4+351502/45*ep^5;
fill mncT00(5,9) =
  -339795/14-9900*ep^-1+7169401/504*ep+177345113/2160*ep^2+
  1450750099/15120*ep^3+177108377/3024*ep^4+66478591/3024*ep^5;
fill mncT00(5,10) =
  -329285/7-18150*ep^-1+30067363/1512*ep+333243523/2160*ep^2+
  26798048483/136080*ep^3+2559867239/19440*ep^4+1496306639/27216*ep^5;
fill mncT00(6,1) =
  -1/10-1/6*ep+1/3*ep^2+2/3*ep^3+4/15*ep^4;
fill mncT00(6,2) =
  -71/15-2*ep^-1+62/15*ep+53/3*ep^2+46/3*ep^3+76/15*ep^4+8/
  15*ep^5;
fill mncT00(6,3) =
  -58-30*ep^-1+2333/30*ep+6529/30*ep^2+500/3*ep^3+172/3*ep^4
  +136/15*ep^5;
fill mncT00(6,4) =
  -401-210*ep^-1+8123/15*ep+13433/9*ep^2+52729/45*ep^3+3992/9*
  ep^4+3976/45*ep^5;
fill mncT00(6,5) =
  -11683/6-980*ep^-1+427073/180*ep+321547/45*ep^2+120747/20*ep^3
  +25521/10*ep^4+9106/15*ep^5;
fill mncT00(6,6) =
  -37009/5-3528*ep^-1+1164389/150*ep+2400553/90*ep^2+2213339/90*
  ep^3+23205/2*ep^4+80157/25*ep^5;
fill mncT00(6,7) =
  -23499-10584*ep^-1+1544798/75*ep+74618423/900*ep^2+11272138/
  135*ep^3+23575927/540*ep^4+3092012/225*ep^5;
fill mncT00(6,8) =
  -64989-27720*ep^-1+29212361/630*ep+1058350894/4725*ep^2+
  1159995587/4725*ep^3+133238803/945*ep^4+93995227/1890*ep^5;
fill mncT00(6,9) =
  -2256507/14-65340*ep^-1+76200941/840*ep+4550075377/8400*ep^2+
  9721402571/15120*ep^3+30385900253/75600*ep^4+2369271799/15120*ep^5;
fill mncT00(6,10) =
  -5124141/14-141570*ep^-1+97914331/630*ep+45269411767/37800*ep^2
  +43425450739/28350*ep^3+43960605211/42525*ep^4+74891892349/170100*
  ep^5;
fill mncT00(7,1) =
  -1/15-13/90*ep+1/6*ep^2+5/9*ep^3+2/5*ep^4+4/45*ep^5;
fill mncT00(7,2) =
  -82/15-2*ep^-1+217/90*ep+1729/90*ep^2+196/9*ep^3+476/45*ep^4
  +104/45*ep^5;
fill mncT00(7,3) =
  -464/5-42*ep^-1+2603/30*ep+15089/45*ep^2+28489/90*ep^3+6416/
  45*ep^4+1508/45*ep^5;
fill mncT00(7,4) =
  -12467/15-392*ep^-1+77009/90*ep+405461/135*ep^2+249029/90*ep^3
  +57259/45*ep^4+14788/45*ep^5;
fill mncT00(7,5) =
  -75782/15-2352*ep^-1+445667/90*ep+1953209/108*ep^2+465035/27*
  ep^3+1510033/180*ep^4+215411/90*ep^5;
fill mncT00(7,6) =
  -23499-10584*ep^-1+1544798/75*ep+74618423/900*ep^2+11272138/
  135*ep^3+23575927/540*ep^4+3092012/225*ep^5;
fill mncT00(7,7) =
  -89691-38808*ep^-1+15230353/225*ep+839340229/2700*ep^2+
  2703725629/8100*ep^3+33824861/180*ep^4+526025219/8100*ep^5;
fill mncT00(7,8) =
  -293898-121968*ep^-1+583171907/3150*ep+6289238647/6300*ep^2+
  64919324111/56700*ep^3+39277798103/56700*ep^4+14806523023/56700*ep^5
  ;
fill mncT00(7,9) =
  -5970591/7-339768*ep^-1+910963763/2100*ep+1275352103/450*ep^2+
  37461814447/10800*ep^3+72796743971/32400*ep^4+5945016637/6480*ep^5;
fill mncT00(7,10) =
  -4484337/2-858858*ep^-1+16663386827/18900*ep+825227119253/113400
  *ep^2+1290630089159/136080*ep^3+2673094441009/408240*ep^4+
  1957097729129/680400*ep^5;
fill mncT00(8,1) =
  -1/21-11/90*ep+7/90*ep^2+4/9*ep^3+4/9*ep^4+8/45*ep^5;
fill mncT00(8,2) =
  -213/35-2*ep^-1+229/315*ep+899/45*ep^2+1247/45*ep^3+776/45*
  ep^4+248/45*ep^5;
fill mncT00(8,3) =
  -687/5-56*ep^-1+10807/126*ep+149903/315*ep^2+1061/2*ep^3+291
  *ep^4+268/3*ep^5;
fill mncT00(8,4) =
  -23332/15-672*ep^-1+25051/21*ep+734401/135*ep^2+5421223/945*
  ep^3+138649/45*ep^4+43618/45*ep^5;
fill mncT00(8,5) =
  -11610-5040*ep^-1+5635817/630*ep+152869817/3780*ep^2+81063041/
  1890*ep^3+89139203/3780*ep^4+351502/45*ep^5;
fill mncT00(8,6) =
  -64989-27720*ep^-1+29212361/630*ep+1058350894/4725*ep^2+
  1159995587/4725*ep^3+133238803/945*ep^4+93995227/1890*ep^5;
fill mncT00(8,7) =
  -293898-121968*ep^-1+583171907/3150*ep+6289238647/6300*ep^2+
  64919324111/56700*ep^3+39277798103/56700*ep^4+14806523023/56700*ep^5
  ;
fill mncT00(8,8) =
  -7885284/7-453024*ep^-1+6655456091/11025*ep+473865407/126*ep^2
  +9189330217/2025*ep^3+1644373427/567*ep^4+5518157081/4725*ep^5;
fill mncT00(8,9) =
  -26476593/7-1472328*ep^-1+73265477633/44100*ep+54627219331/4410*
  ep^2+3572949997297/226800*ep^3+2411251880873/226800*ep^4+
  206938354943/45360*ep^5;
fill mncT00(8,10) =
  -22789767/2-4294290*ep^-1+528877919/135*ep+29013083864323/793800
  *ep^2+116678567813779/2381400*ep^3+17786915424493/510300*ep^4+
  8105581054537/510300*ep^5;
fill mncT00(9,1) =
  -1/28-29/280*ep+1/36*ep^2+127/360*ep^3+4/9*ep^4+11/45*ep^5;
fill mncT00(9,2) =
  -927/140-2*ep^-1-2263/2520*ep+6359/315*ep^2+3967/120*ep^3+
  1477/60*ep^4+151/15*ep^5;
fill mncT00(9,3) =
  -6733/35-72*ep^-1+2015/28*ep+1603937/2520*ep^2+513547/630*ep^3
  +62519/120*ep^4+11669/60*ep^5;
fill mncT00(9,4) =
  -18855/7-1080*ep^-1+618431/420*ep+1527913/168*ep^2+40749427/
  3780*ep^3+49720691/7560*ep^4+108841/45*ep^5;
fill mncT00(9,5) =
  -339795/14-9900*ep^-1+7169401/504*ep+177345113/2160*ep^2+
  1450750099/15120*ep^3+177108377/3024*ep^4+66478591/3024*ep^5;
fill mncT00(9,6) =
  -2256507/14-65340*ep^-1+76200941/840*ep+4550075377/8400*ep^2+
  9721402571/15120*ep^3+30385900253/75600*ep^4+2369271799/15120*ep^5;
fill mncT00(9,7) =
  -5970591/7-339768*ep^-1+910963763/2100*ep+1275352103/450*ep^2+
  37461814447/10800*ep^3+72796743971/32400*ep^4+5945016637/6480*ep^5;
fill mncT00(9,8) =
  -26476593/7-1472328*ep^-1+73265477633/44100*ep+54627219331/4410*
  ep^2+3572949997297/226800*ep^3+2411251880873/226800*ep^4+
  206938354943/45360*ep^5;
fill mncT00(9,9) =
  -407455191/28-5521230*ep^-1+62145308573/11760*ep+8267348377283/
  176400*ep^2+26321703245023/423360*ep^3+4967716026299/113400*ep^4+
  1280830607257/64800*ep^5;
fill mncT00(9,10) =
  -1394685435/28-18404100*ep^-1+100114668349/7056*ep+1852144738247/
  11760*ep^2+1386280258914223/6350400*ep^3+510011325931501/3175200*
  ep^4+62160020883013/816480*ep^5;
fill mncT00(10,1) =
  -1/36-223/2520*ep-4/2835*ep^2+101/360*ep^3+229/540*ep^4+13/
  45*ep^5;
fill mncT00(10,2) =
  -4469/630-2*ep^-1-3097/1260*ep+45329/2268*ep^2+85787/2268*ep^3
  +17489/540*ep^4+4273/270*ep^5;
fill mncT00(10,3) =
  -3615/14-90*ep^-1+13466/315*ep+2051033/2520*ep^2+6665453/5670*
  ep^3+19284803/22680*ep^4+49856/135*ep^5;
fill mncT00(10,4) =
  -61445/14-1650*ep^-1+1187719/756*ep+13492646/945*ep^2+
  319245677/17010*ep^3+1605965/126*ep^4+36227755/6804*ep^5;
fill mncT00(10,5) =
  -329285/7-18150*ep^-1+30067363/1512*ep+333243523/2160*ep^2+
  26798048483/136080*ep^3+2559867239/19440*ep^4+1496306639/27216*ep^5;
fill mncT00(10,6) =
  -5124141/14-141570*ep^-1+97914331/630*ep+45269411767/37800*ep^2
  +43425450739/28350*ep^3+43960605211/42525*ep^4+74891892349/170100*
  ep^5;
fill mncT00(10,7) =
  -4484337/2-858858*ep^-1+16663386827/18900*ep+825227119253/113400
  *ep^2+1290630089159/136080*ep^3+2673094441009/408240*ep^4+
  1957097729129/680400*ep^5;
fill mncT00(10,8) =
  -22789767/2-4294290*ep^-1+528877919/135*ep+29013083864323/793800
  *ep^2+116678567813779/2381400*ep^3+17786915424493/510300*ep^4+
  8105581054537/510300*ep^5;
fill mncT00(10,9) =
  -1394685435/28-18404100*ep^-1+100114668349/7056*ep+1852144738247/
  11760*ep^2+1386280258914223/6350400*ep^3+510011325931501/3175200*
  ep^4+62160020883013/816480*ep^5;
fill mncT00(10,10) =
  -8074989065/42-69526600*ep^-1+1350488632313/31752*ep+
  47479977496171/79380*ep^2+24566922560195171/28576800*ep^3+
  18726665340585257/28576800*ep^4+10393828589694061/32148900*ep^5;
fill mncT10(-6,1) =
  -1/112-757/31360*ep-3727229/79027200*ep^2-596248999/7375872000*
  ep^3-805517926621/6195732480000*ep^4-116996591020151/578268364800000
  *ep^5;
fill mncT10(-6,2) =
  -143/140-1/2*ep^-1-317803/176400*ep-72277427/24696000*ep^2-
  15809639243/3457440000*ep^3-3390537990787/484041600000*ep^4-
  79974824548387/7529536000000*ep^5;
fill mncT10(-6,3) =
  -59/20-21/2*ep^-1-24049/1200*ep-1127389/72000*ep^2-6231227/
  160000*ep^3-1260578141/28800000*ep^4-15537540689/192000000*ep^5;
fill mncT10(-6,4) =
  235/4-105/2*ep^-1-30433/240*ep+1041767/14400*ep^2-51977471/
  288000*ep^3+178464223/5760000*ep^4-30193341199/115200000*ep^5;
fill mncT10(-6,5) =
  670/3-175/2*ep^-1-60443/144*ep+100289/192*ep^2-4637557/6912*ep^3
  +53277763/82944*ep^4-794249701/995328*ep^5;
fill mncT10(-6,6) =
  443/2-105/2*ep^-1-125593/240*ep+2499871/2880*ep^2-13702799/11520
  *ep^3+7218039/5120*ep^4-174569129/110592*ep^5;
fill mncT10(-6,7) =
  337/5-21/2*ep^-1-260689/1200*ep+33888383/72000*ep^2-376269769/
  480000*ep^3+31338072103/28800000*ep^4-2307104628361/1728000000*ep^5;
fill mncT10(-6,8) =
  353/70-1/2*ep^-1-86107/3600*ep+5200903/72000*ep^2-228739987/
  1440000*ep^3+23861797469/86400000*ep^4-696292338001/1728000000*ep^5;
fill mncT10(-6,9) =
  1/56-463/1960*ep+7054603/4939200*ep^2-1232361283/230496000*ep^3+
  1372388471947/96808320000*ep^4-1175386471449923/40659494400000*ep^5;
fill mncT10(-6,10) =
  1/1344*ep-3179/376320*ep^2+38770049/948326400*ep^3-9635223953/
  88510464000*ep^4+11802258330329/74348789760000*ep^5;
fill mncT10(-5,1) =
  -1/84-131/4410*ep-45907/823200*ep^2-32325739/345744000*ep^3-
  798737439/5378240000*ep^4-172809886751/752953600000*ep^5;
fill mncT10(-5,2) =
  -13/15-1/2*ep^-1-5267/3600*ep-55693/24000*ep^2-5155573/1440000
  *ep^3-52300417/9600000*ep^4-526842293/64000000*ep^5;
fill mncT10(-5,3) =
  5/4-15/2*ep^-1-3119/240*ep-22373/4800*ep^2-2122051/96000*ep^3-
  35026237/1920000*ep^4-543093073/12800000*ep^5;
fill mncT10(-5,4) =
  265/6-25*ep^-1-5579/72*ep+20767/288*ep^2-121699/1152*ep^3+
  315191/4608*ep^4-267971/2048*ep^5;
fill mncT10(-5,5) =
  1055/12-25*ep^-1-6547/36*ep+3175/12*ep^2-36151/108*ep^3+473935/
  1296*ep^4-391195/972*ep^5;
fill mncT10(-5,6) =
  173/4-15/2*ep^-1-30149/240*ep+78807/320*ep^2-4323407/11520*ep^3
  +66872909/138240*ep^4-186295291/331776*ep^5;
fill mncT10(-5,7) =
  71/15-1/2*ep^-1-75287/3600*ep+4216483/72000*ep^2-515461421/
  4320000*ep^3+50009271427/259200000*ep^4-4105017792749/15552000000*
  ep^5;
fill mncT10(-5,8) =
  1/42-379/1260*ep+43399/25200*ep^2-9167693/1512000*ep^3+
  1366105291/90720000*ep^4-156453380117/5443200000*ep^5;
fill mncT10(-5,9) =
  1/784*ep-2263/164640*ep^2+1428971/23049600*ep^3-1443954119/
  9680832000*ep^4+725260343671/4065949440000*ep^5;
fill mncT10(-5,10) =
  1/28224*ep-5797/23708160*ep^2+2202023/6638284800*ep^3+8689170961/
  5576159232000*ep^4-31132238888473/4683973754880000*ep^5;
fill mncT10(-4,1) =
  -1/60-17/450*ep-2441/36000*ep^2-26639/240000*ep^3-278431/
  1600000*ep^4-8544297/32000000*ep^5;
fill mncT10(-4,2) =
  -41/60-1/2*ep^-1-1337/1200*ep-41419/24000*ep^2-1262653/480000*
  ep^3-12728737/3200000*ep^4-383416719/64000000*ep^5;
fill mncT10(-4,3) =
  11/3-5*ep^-1-211/24*ep+167/96*ep^2-4763/384*ep^3-1851/512*ep^4
  -41841/2048*ep^5;
fill mncT10(-4,4) =
  53/2-10*ep^-1-416/9*ep+331/6*ep^2-595/9*ep^3+1505/24*ep^4-
  595/8*ep^5;
fill mncT10(-4,5) =
  299/12-5*ep^-1-755/12*ep+3889/36*ep^2-15913/108*ep^3+225715/
  1296*ep^4-371315/1944*ep^5;
fill mncT10(-4,6) =
  131/30-1/2*ep^-1-845/48*ep+25747/576*ep^2-570889/6912*ep^3+
  50613671/414720*ep^4-154047985/995328*ep^5;
fill mncT10(-4,7) =
  1/30-179/450*ep+4253/2000*ep^2-7480199/1080000*ep^3+1025875513/
  64800000*ep^4-108169063031/3888000000*ep^5;
fill mncT10(-4,8) =
  1/420*ep-101/4200*ep^2+24967/252000*ep^3-1045543/5040000*ep^4+
  159617923/907200000*ep^5;
fill mncT10(-4,9) =
  1/11760*ep-437/823200*ep^2+150043/345744000*ep^3+198757571/
  48404160000*ep^4-812570541017/60989241600000*ep^5;
fill mncT10(-4,10) =
  1/141120*ep-3529/118540800*ep^2-540767/11063808000*ep^3+
  10661942293/27880796160000*ep^4-8911337124349/23419868774400000*ep^5;
fill mncT10(-3,1) =
  -1/40-121/2400*ep-4127/48000*ep^2-43883/320000*ep^3-1357221/
  6400000*ep^4-41346027/128000000*ep^5;
fill mncT10(-3,2) =
  -11/24-1/2*ep^-1-73/96*ep-443/384*ep^2-891/512*ep^3-5361/
  2048*ep^4-32211/8192*ep^5;
fill mncT10(-3,3) =
  9/2-3*ep^-1-20/3*ep+29/6*ep^2-31/4*ep^3+27/8*ep^4-159/16*
  ep^5;
fill mncT10(-3,4) =
  12-3*ep^-1-74/3*ep+35*ep^2-499/12*ep^3+89/2*ep^4-747/16*ep^5
  ;
fill mncT10(-3,5) =
  47/12-1/2*ep^-1-167/12*ep+1111/36*ep^2-10793/216*ep^3+85315/
  1296*ep^4-594665/7776*ep^5;
fill mncT10(-3,6) =
  1/20-133/240*ep+2597/960*ep^2-91439/11520*ep^3+2244941/138240*
  ep^4-8504443/331776*ep^5;
fill mncT10(-3,7) =
  1/200*ep-557/12000*ep^2+40553/240000*ep^3-4125511/14400000*ep^4+
  81009257/864000000*ep^5;
fill mncT10(-3,8) =
  1/4200*ep-109/84000*ep^2+683/5040000*ep^3+171199/14400000*ep^4-
  507092773/18144000000*ep^5;
fill mncT10(-3,9) =
  1/39200*ep-1439/16464000*ep^2-573283/2304960000*ep^3+1163405147/
  968083200000*ep^4-159267256723/406594944000000*ep^5;
fill mncT10(-3,10) =
  1/235200*ep-1723/197568000*ep^2-3323987/55319040000*ep^3+
  6428460691/46467993600000*ep^4+7694842432037/39033114624000000*ep^5;
fill mncT10(-2,1) =
  -1/24-7/96*ep-15/128*ep^2-93/512*ep^3-567/2048*ep^4-3429/
  8192*ep^5;
fill mncT10(-2,2) =
  -1/6-1/2*ep^-1-5/12*ep-5/8*ep^2-15/16*ep^3-45/32*ep^4-135/
  64*ep^5;
fill mncT10(-2,3) =
  4-3/2*ep^-1-23/4*ep+47/8*ep^2-99/16*ep^3+183/32*ep^4-411/64*
  ep^5;
fill mncT10(-2,4) =
  10/3-1/2*ep^-1-39/4*ep+421/24*ep^2-375/16*ep^3+855/32*ep^4-
  1815/64*ep^5;
fill mncT10(-2,5) =
  1/12-5/6*ep+257/72*ep^2-3883/432*ep^3+40625/2592*ep^4-332755/
  15552*ep^5;
fill mncT10(-2,6) =
  1/80*ep-33/320*ep^2+239/768*ep^3-16369/46080*ep^4-28393/110592*
  ep^5;
fill mncT10(-2,7) =
  1/1200*ep-89/24000*ep^2-5057/1440000*ep^3+3402559/86400000*ep^4-
  297978833/5184000000*ep^5;
fill mncT10(-2,8) =
  1/8400*ep-7/24000*ep^2-4979/3360000*ep^3+2574119/604800000*ep^4+
  1593769/576000000*ep^5;
fill mncT10(-2,9) =
  1/39200*ep-153/5488000*ep^2-303141/768320000*ep^3+446130407/
  968083200000*ep^4+235332367979/135531648000000*ep^5;
fill mncT10(-2,10) =
  1/141120*ep-19/39513600*ep^2-1286911/11063808000*ep^3+395635669/
  27880796160000*ep^4+4644027020161/7806622924800000*ep^5;
fill mncT10(-1,1) =
  -1/12-1/8*ep-3/16*ep^2-9/32*ep^3-27/64*ep^4-81/128*ep^5;
fill mncT10(-1,2) =
  1/4-1/2*ep^-1-1/8*ep-3/16*ep^2-9/32*ep^3-27/64*ep^4-81/128*
  ep^5;
fill mncT10(-1,3) =
  5/2-1/2*ep^-1-5*ep+6*ep^2-6*ep^3+6*ep^4-6*ep^5;
fill mncT10(-1,4) =
  1/6-17/12*ep+39/8*ep^2-151/16*ep^3+407/32*ep^4-919/64*ep^5;
fill mncT10(-1,5) =
  1/24*ep-41/144*ep^2+523/864*ep^3-641/5184*ep^4-46589/31104*ep^5;
fill mncT10(-1,6) =
  1/240*ep-37/2880*ep^2-1301/34560*ep^3+63767/414720*ep^4-55825/
  995328*ep^5;
fill mncT10(-1,7) =
  1/1200*ep-67/72000*ep^2-52171/4320000*ep^3+3702677/259200000*ep^4
  +700238501/15552000000*ep^5;
fill mncT10(-1,8) =
  1/4200*ep+13/252000*ep^2-56531/15120000*ep^3-548003/907200000*ep^4
  +945051661/54432000000*ep^5;
fill mncT10(-1,9) =
  1/11760*ep+257/2469600*ep^2-1351993/1037232000*ep^3-679414663/
  435637440000*ep^4+1056611141567/182967724800000*ep^5;
fill mncT10(-1,10) =
  1/28224*ep+569/7902720*ep^2-3349369/6638284800*ep^3-6050070703/
  5576159232000*ep^4+8556135083879/4683973754880000*ep^5;
fill mncT10(0,1) =
  -1/4-3/8*ep-9/16*ep^2-27/32*ep^3-81/64*ep^4-243/128*ep^5;
fill mncT10(0,2) =
  1-1/2*ep^-1;
fill mncT10(0,3) =
  1/2-3*ep+6*ep^2-6*ep^3+6*ep^4-6*ep^5;
fill mncT10(0,4) =
  1/4*ep-9/8*ep^2+9/16*ep^3+87/32*ep^4-279/64*ep^5;
fill mncT10(0,5) =
  1/24*ep-5/144*ep^2-449/864*ep^3+2275/5184*ep^4+37975/31104*ep^5;
fill mncT10(0,6) =
  1/80*ep+13/960*ep^2-1951/11520*ep^3-24083/138240*ep^4+178885/
  331776*ep^5;
fill mncT10(0,7) =
  1/200*ep+143/12000*ep^2-42841/720000*ep^3-6769033/43200000*ep^4+
  281515271/2592000000*ep^5;
fill mncT10(0,8) =
  1/420*ep+101/12600*ep^2-16957/756000*ep^3-4615741/45360000*ep^4-
  69750733/2721600000*ep^5;
fill mncT10(0,9) =
  1/784*ep+291/54880*ep^2-196163/23049600*ep^3-616218973/9680832000*
  ep^4-235493357243/4065949440000*ep^5;
fill mncT10(0,10) =
  1/1344*ep+1349/376320*ep^2-909109/316108800*ep^3-10682456563/
  265531392000*ep^4-13079587690741/223046369280000*ep^5;
fill mncT10(1,1) =
  1/2*ep^-1;
fill mncT10(1,2) =
  3-ep^-1;
fill mncT10(1,3) =
  -3/2+3*ep+6*ep^2-6*ep^3+6*ep^4-6*ep^5;
fill mncT10(1,4) =
  -1/2-3/4*ep+39/8*ep^2+105/16*ep^3-105/32*ep^4+105/64*ep^5;
fill mncT10(1,5) =
  -1/4-5/6*ep+119/72*ep^2+3299/432*ep^3+13895/2592*ep^4-19285/
  15552*ep^5;
fill mncT10(1,6) =
  -3/20-11/16*ep+65/192*ep^2+13213/2304*ep^3+1265101/138240*ep^4
  +1354885/331776*ep^5;
fill mncT10(1,7) =
  -1/10-83/150*ep-3973/18000*ep^2+4308551/1080000*ep^3+632934263/
  64800000*ep^4+34727955719/3888000000*ep^5;
fill mncT10(1,8) =
  -1/14-9/20*ep-559/1200*ep^2+194473/72000*ep^3+39548249/4320000
  *ep^4+3093776137/259200000*ep^5;
fill mncT10(1,9) =
  -3/56-729/1960*ep-312307/548800*ep^2+411281683/230496000*ep^3+
  789265539653/96808320000*ep^4+547737213033523/40659494400000*ep^5;
fill mncT10(1,10) =
  -1/24-2099/6720*ep-3411341/5644800*ep^2+5367611413/4741632000*
  ep^3+28254903745891/3982970880000*ep^4+46982106507854437/
  3345695539200000*ep^5;
fill mncT10(2,1) =
  2-1/2*ep^-1-2*ep+2*ep^2-2*ep^3+2*ep^4-2*ep^5;
fill mncT10(2,2) =
  3-3/2*ep^-1+6*ep-6*ep^2+6*ep^3-6*ep^4+6*ep^5;
fill mncT10(2,3) =
  -3/2-3/2*ep^-1+15*ep+12*ep^2-12*ep^3+12*ep^4-12*ep^5;
fill mncT10(2,4) =
  -4-3/2*ep^-1+49/4*ep+295/8*ep^2+169/16*ep^3-233/32*ep^4+
  361/64*ep^5;
fill mncT10(2,5) =
  -23/4-3/2*ep^-1+89/12*ep+457/9*ep^2+1487/27*ep^3+700/81*ep^4
  -700/243*ep^5;
fill mncT10(2,6) =
  -71/10-3/2*ep^-1+511/240*ep+164303/2880*ep^2+3505459/34560*
  ep^3+25651559/414720*ep^4+8078735/995328*ep^5;
fill mncT10(2,7) =
  -41/5-3/2*ep^-1-1263/400*ep+465987/8000*ep^2+22952577/160000*
  ep^3+445571067/3200000*ep^4+3730168857/64000000*ep^5;
fill mncT10(2,8) =
  -639/70-3/2*ep^-1-23221/2800*ep+9404347/168000*ep^2+1808749211/
  10080000*ep^3+139327252843/604800000*ep^4+5435434915259/36288000000*
  ep^5;
fill mncT10(2,9) =
  -2781/280-3/2*ep^-1-259297/19600*ep+52749191/1029000*ep^2+
  45208808453/216090000*ep^3+3723811897181/11344725000*ep^4+
  663357839735273/2382392250000*ep^5;
fill mncT10(2,10) =
  -4469/420-3/2*ep^-1-4223269/235200*ep+8846797177/197568000*ep^2
  +38689293302239/165957120000*ep^3+59709391783310473/139403980800000*
  ep^4+51332799820998824911/117099343872000000*ep^5;
fill mncT10(3,1) =
  -3/4+27/8*ep-75/16*ep^2+171/32*ep^3-363/64*ep^4+747/128*ep^5
  ;
fill mncT10(3,2) =
  3/4-3/2*ep^-1+105/8*ep-105/16*ep^2+105/32*ep^3-105/64*ep^4+
  105/128*ep^5;
fill mncT10(3,3) =
  -3-9/2*ep^-1+171/4*ep+201/8*ep^2-297/16*ep^3+489/32*ep^4-
  873/64*ep^5;
fill mncT10(3,4) =
  -15-9*ep^-1+159/2*ep+543/4*ep^2+105/8*ep^3-105/16*ep^4+105/
  32*ep^5;
fill mncT10(3,5) =
  -149/4-15*ep^-1+335/3*ep+24041/72*ep^2+90941/432*ep^3+30905/
  2592*ep^4-70315/15552*ep^5;
fill mncT10(3,6) =
  -285/4-45/2*ep^-1+10293/80*ep+196431/320*ep^2+169797/256*ep^3
  +1264407/5120*ep^4+46389/4096*ep^5;
fill mncT10(3,7) =
  -591/5-63/2*ep^-1+48357/400*ep+7699887/8000*ep^2+229927077/
  160000*ep^3+2914218567/3200000*ep^4+15233331357/64000000*ep^5;
fill mncT10(3,8) =
  -1791/10-42*ep^-1+27859/350*ep+7153343/5250*ep^2+101471723/
  39375*ep^3+5250487699/2362500*ep^4+69188808181/70875000*ep^5;
fill mncT10(3,9) =
  -35673/140-54*ep^-1-64347/19600*ep+153855913/85750*ep^2+
  296173542391/72030000*ep^3+33238587150539/7563150000*ep^4+
  4145231326795487/1588261500000*ep^5;
fill mncT10(3,10) =
  -4845/14-135/2*ep^-1-2120191/15680*ep+392726021/175616*ep^2+
  893381947379/147517440*ep^3+189024874192657/24782929920*ep^4+
  23238823471233947/4163532226560*ep^5;
fill mncT10(4,1) =
  -1/4+11/24*ep+239/144*ep^2-2989/864*ep^3+23879/5184*ep^4-
  163669/31104*ep^5;
fill mncT10(4,2) =
  -1/2-3/2*ep^-1+173/12*ep+257/72*ep^2-3187/432*ep^3+19577/
  2592*ep^4-109867/15552*ep^5;
fill mncT10(4,3) =
  -15/2-9*ep^-1+85*ep+194/3*ep^2-302/9*ep^3+626/27*ep^4-1598/
  81*ep^5;
fill mncT10(4,4) =
  -89/2-30*ep^-1+1607/6*ep+14399/36*ep^2+4547/216*ep^3+3623/
  1296*ep^4-92053/7776*ep^5;
fill mncT10(4,5) =
  -625/4-75*ep^-1+3617/6*ep+100921/72*ep^2+281917/432*ep^3+
  99961/2592*ep^4-395051/15552*ep^5;
fill mncT10(4,6) =
  -825/2-315/2*ep^-1+87101/80*ep+3474373/960*ep^2+34090769/11520
  *ep^3+115905997/138240*ep^4-1176443/331776*ep^5;
fill mncT10(4,7) =
  -9107/10-294*ep^-1+498149/300*ep+34741013/4500*ep^2+296389693/
  33750*ep^3+1083612773/253125*ep^4+3003598556/3796875*ep^5;
fill mncT10(4,8) =
  -8891/5-504*ep^-1+4553953/2100*ep+454960141/31500*ep^2+
  4911347351/236250*ep^3+14142455467/1012500*ep^4+992017228511/
  212625000*ep^5;
fill mncT10(4,9) =
  -88875/28-810*ep^-1+9252927/3920*ep+168366909/6860*ep^2+
  8166579979/192080*ep^3+144167672767/4033680*ep^4+562192184635/
  33882912*ep^5;
fill mncT10(4,10) =
  -148145/28-2475/2*ep^-1+5844233/3136*ep+102041943371/2634240*
  ep^2+34685940027097/442552320*ep^3+5810307829273907/74348789760*ep^4
  +567484189539766993/12490596679680*ep^5;
fill mncT10(5,1) =
  -1/8+7/96*ep+1331/1152*ep^2-10697/13824*ep^3-16261/165888*ep^4
  +1688527/1990656*ep^5;
fill mncT10(5,2) =
  -11/8-3/2*ep^-1+1385/96*ep+13765/1152*ep^2-112975/13824*ep^3
  +625645/165888*ep^4-3023815/1990656*ep^5;
fill mncT10(5,3) =
  -16-15*ep^-1+3359/24*ep+40699/288*ep^2-146353/3456*ep^3+
  909331/41472*ep^4-9088057/497664*ep^5;
fill mncT10(5,4) =
  -225/2-75*ep^-1+5331/8*ep+32337/32*ep^2+10551/128*ep^3+6201/
  512*ep^4-76569/2048*ep^5;
fill mncT10(5,5) =
  -1025/2-525/2*ep^-1+103501/48*ep+2646365/576*ep^2+12919849/
  6912*ep^3+12547205/82944*ep^4-106259855/995328*ep^5;
fill mncT10(5,6) =
  -1750-735*ep^-1+650707/120*ep+22250591/1440*ep^2+185708083/
  17280*ep^3+552944999/207360*ep^4-58423921/497664*ep^5;
fill mncT10(5,7) =
  -49007/10-1764*ep^-1+850421/75*ep+760299527/18000*ep^2+
  43823276051/1080000*ep^3+1087265701763/64800000*ep^4+9074623643219/
  3888000000*ep^5;
fill mncT10(5,8) =
  -23775/2-3780*ep^-1+2859667/140*ep+23847883/240*ep^2+
  2424900241/20160*ep^3+16526858893/241920*ep^4+7708831711/414720*ep^5
  ;
fill mncT10(5,9) =
  -1448565/56-7425*ep^-1+12607711/392*ep+68703347107/329280*ep^2
  +8372383405609/27659520*ep^3+500539948415827/2323399680*ep^4+
  16253187395221297/195165573120*ep^5;
fill mncT10(5,10) =
  -2895365/56-27225/2*ep^-1+137893873/3136*ep+351913867217/878080*
  ep^2+6644184374413/9834496*ep^3+1574369597037737/2753658880*ep^4+
  8634850111386637/30840979456*ep^5;
fill mncT10(6,1) =
  -3/40-13/800*ep+35531/48000*ep^2+233003/2880000*ep^3-93186661/
  172800000*ep^4+5785099307/10368000000*ep^5;
fill mncT10(6,2) =
  -41/20-3/2*ep^-1+16777/1200*ep+1335301/72000*ep^2-19367987/
  4320000*ep^3-196568531/259200000*ep^4+20928087997/15552000000*ep^5;
fill mncT10(6,3) =
  -117/4-45/2*ep^-1+16461/80*ep+419211/1600*ep^2-885519/32000*
  ep^3+5867451/640000*ep^4-167036679/12800000*ep^5;
fill mncT10(6,4) =
  -999/4-315/2*ep^-1+110547/80*ep+3592917/1600*ep^2+10569807/
  32000*ep^3+5651397/640000*ep^4-934558713/12800000*ep^5;
fill mncT10(6,5) =
  -5677/4-735*ep^-1+181561/30*ep+22883293/1800*ep^2+275706917/
  54000*ep^3+823074373/1620000*ep^4-15404524363/48600000*ep^5;
fill mncT10(6,6) =
  -120561/20-2646*ep^-1+4004489/200*ep+640164857/12000*ep^2+
  24618330341/720000*ep^3+348715791533/43200000*ep^4-1386850102771/
  2592000000*ep^5;
fill mncT10(6,7) =
  -414603/20-7938*ep^-1+10807857/200*ep+720254637/4000*ep^2+
  12473875827/80000*ep^3+93453599817/1600000*ep^4+206943175107/
  32000000*ep^5;
fill mncT10(6,8) =
  -243381/4-20790*ep^-1+34826081/280*ep+8670420679/16800*ep^2+
  561756327107/1008000*ep^3+17090170665691/60480000*ep^4+
  238855334385083/3628800000*ep^5;
fill mncT10(6,9) =
  -8845353/56-49005*ep^-1+61371918/245*ep+715102622253/548800*ep^2
  +128719613722761/76832000*ep^3+11393633670678117/10756480000*ep^4+
  536420721540120849/1505907200000*ep^5;
fill mncT10(6,10) =
  -10411467/28-212355/2*ep^-1+7007897301/15680*ep+13054357748157/
  4390400*ep^2+5432640205465833/1229312000*ep^3+1141773110158691877/
  344207360000*ep^4+137203192797278262513/96378060800000*ep^5;
fill mncT10(7,1) =
  -1/20-1/25*ep+17713/36000*ep^2+82091/240000*ep^3-48738953/
  129600000*ep^4+427746437/2592000000*ep^5;
fill mncT10(7,2) =
  -13/5-3/2*ep^-1+16009/1200*ep+1713467/72000*ep^2+5388271/
  4320000*ep^3-914192377/259200000*ep^4+25764655399/15552000000*ep^5;
fill mncT10(7,3) =
  -957/20-63/2*ep^-1+112243/400*ep+10355459/24000*ep^2+39466867/
  1440000*ep^3-820748029/86400000*ep^4-52688239277/5184000000*ep^5;
fill mncT10(7,4) =
  -4991/10-294*ep^-1+760201/300*ep+40405069/9000*ep^2+276581461/
  270000*ep^3+34098109/8100000*ep^4-31522116779/243000000*ep^5;
fill mncT10(7,5) =
  -34601/10-1764*ep^-1+2884389/200*ep+557280473/18000*ep^2+
  2372481179/180000*ep^3+25064318153/16200000*ep^4-124218058181/
  162000000*ep^5;
fill mncT10(7,6) =
  -356391/20-7938*ep^-1+302601/5*ep+25242353/160*ep^2+189122879/
  1920*ep^3+535864919/23040*ep^4-88343129/55296*ep^5;
fill mncT10(7,7) =
  -1470819/20-29106*ep^-1+40709357/200*ep+7693396111/12000*ep^2+
  377114820443/720000*ep^3+8039414975059/43200000*ep^4+45909374983667/
  2592000000*ep^5;
fill mncT10(7,8) =
  -2560767/10-91476*ep^-1+403678357/700*ep+91955041481/42000*ep^2
  +5533074324853/2520000*ep^3+156314232405389/151200000*ep^4+
  1952097820330957/9072000000*ep^5;
fill mncT10(7,9) =
  -109180863/140-254826*ep^-1+27831938271/19600*ep+4471028447173/
  686000*ep^2+1110743856904309/144060000*ep^3+135627586834713397/
  30252600000*ep^4+8622826680259950451/6353046000000*ep^5;
fill mncT10(7,10) =
  -10657361/5-1288287/2*ep^-1+104096074001/33600*ep+70010581183721/
  4032000*ep^2+11415336636644921/483840000*ep^3+941071217126100521/
  58060800000*ep^4+43764869471914228121/6967296000000*ep^5;
fill mncT10(8,1) =
  -1/28-11/245*ep+841441/2469600*ep^2+140549527/345744000*ep^3-
  78460581929/435637440000*ep^4-119057887957/6776582400000*ep^5;
fill mncT10(8,2) =
  -429/140-3/2*ep^-1+741721/58800*ep+76963479/2744000*ep^2+
  81887763001/10372320000*ep^3-6160336923403/1452124800000*ep^4+
  1295154979900681/1829677248000000*ep^5;
fill mncT10(8,3) =
  -723/10-42*ep^-1+190459/525*ep+3999879/6125*ep^2+1606404113/
  11576250*ep^3-18966571957/810337500*ep^4-6990546924043/510512625000*
  ep^5;
fill mncT10(8,4) =
  -4583/5-504*ep^-1+2976049/700*ep+3633118901/441000*ep^2+
  26640129587/10290000*ep^3+1404226137989/19448100000*ep^4-
  312289819072471/1361367000000*ep^5;
fill mncT10(8,5) =
  -15261/2-3780*ep^-1+1708635/56*ep+160324043/2352*ep^2+
  1046272427/32928*ep^3+18358712195/4148928*ep^4-10404645445/6453888*
  ep^5;
fill mncT10(8,6) =
  -187149/4-20790*ep^-1+44283219/280*ep+9735744713/23520*ep^2+
  34385651633/131712*ep^3+10575190295741/165957120*ep^4-1096338717877/
  309786624*ep^5;
fill mncT10(8,7) =
  -2277627/10-91476*ep^-1+226386421/350*ep+584576884757/294000*
  ep^2+195459943419287/123480000*ep^3+28591792133478017/51861600000*
  ep^4+1079869635250403447/21781872000000*ep^5;
fill mncT10(8,8) =
  -32429661/35-339768*ep^-1+10790696937/4900*ep+2046677027189/
  257250*ep^2+91578785899761/12005000*ep^3+77932951717863967/
  22689450000*ep^4+1055840020003157587/1588261500000*ep^5;
fill mncT10(8,9) =
  -457261233/140-1104246*ep^-1+126658602561/19600*ep+
  56612672242069/2058000*ep^2+1477059000503353/48020000*ep^3+
  1532380088383876441/90757800000*ep^4+30091840120792481701/
  6353046000000*ep^5;
fill mncT10(8,10) =
  -40973075/4-6441435/2*ep^-1+22478238109/1344*ep+476548217134259/
  5644800*ep^2+510156069130971413/4741632000*ep^3+
  275923509539915048291/3982970880000*ep^4+83099258828924445467237/
  3345695539200000*ep^5;
fill mncT10(9,1) =
  -3/112-1371/31360*ep+6431963/26342400*ep^2+2966087647/7375872000
  *ep^3-611577766213/18587197440000*ep^4-132891842895899/
  1734805094400000*ep^5;
fill mncT10(9,2) =
  -1941/560-3/2*ep^-1+5574893/470400*ep+1384537139/43904000*ep^2
  +4946688512957/331914240000*ep^3-290639078154967/92935987200000*ep^4
  -134149663854043507/234198687744000000*ep^5;
fill mncT10(9,3) =
  -3606/35-54*ep^-1+8832897/19600*ep+15295528679/16464000*ep^2+
  1480090671851/4609920000*ep^3-216275657823529/11616998400000*ep^4-
  79790911767110501/3252759552000000*ep^5;
fill mncT10(9,4) =
  -11007/7-810*ep^-1+5227599/784*ep+619210523/43904*ep^2+
  41651662777/7375872*ep^3+489208925459/1239146496*ep^4-81859576744847/
  208176611328*ep^5;
fill mncT10(9,5) =
  -108615/7-7425*ep^-1+92424603/1568*ep+36431450201/263424*ep^2+
  1051649748017/14751744*ep^3+88092329320049/7434878976*ep^4-
  414528826232413/138784407552*ep^5;
fill mncT10(9,6) =
  -3127311/28-49005*ep^-1+2898678549/7840*ep+433169530321/439040*
  ep^2+47397954971827/73758720*ep^3+2054240925109729/12391464960*ep^4
  -2252571502338001/416353222656*ep^5;
fill mncT10(9,7) =
  -22145607/35-254826*ep^-1+35373882351/19600*ep+30313548935039/
  5488000*ep^2+20203931885697673/4609920000*ep^3+5933616533636271311/
  3872332800000*ep^4+462091977884877380377/3252759552000000*ep^5;
fill mncT10(9,8) =
  -103963002/35-1104246*ep^-1+20313977223/2800*ep+8587525177223/
  336000*ep^2+107219196240447/4480000*ep^3+50977876717066823/
  4838400000*ep^4+380601667803088541/193536000000*ep^5;
fill mncT10(9,9) =
  -47947185/4-8281845/2*ep^-1+78174883767/3136*ep+445278263627459/
  4390400*ep^2+403289285860381253/3687936000*ep^3+
  179134080933423547571/3097866240000*ep^4+40107079404902794050197/
  2602207641600000*ep^5;
fill mncT10(9,10) =
  -85433205/2-13803075*ep^-1+117761275265/1568*ep+467167231082219/
  1317120*ep^2+95619206829958873/221276160*ep^3+9875467238318703923/
  37174394880*ep^4+561612840013743600337/6245298339840*ep^5;
fill mncT10(10,1) =
  -1/48-4913/120960*ep+54821267/304819200*ep^2+287421825007/
  768144384000*ep^3+129457437294347/1935723847680000*ep^4-
  380383365844061513/4878024096153600000*ep^5;
fill mncT10(10,2) =
  -3209/840-3/2*ep^-1+23449001/2116800*ep+183663936121/5334336000*
  ep^2+295519349213141/13442526720000*ep^3-16723146461182439/
  33875167334400000*ep^4-139225311874684347619/85365421682688000000*ep^5
  ;
fill mncT10(10,3) =
  -7863/56-135/2*ep^-1+5105869/9408*ep+5979475273/4741632*ep^2+
  1404672849793/2389782528*ep^3+25182200308273/1204450394112*ep^4-
  24400676646773807/607042998632448*ep^5;
fill mncT10(10,4) =
  -142895/56-2475/2*ep^-1+279921139/28224*ep+324527671543/14224896
  *ep^2+79228822515679/7169347584*ep^3+4736815497678319/3613351182336*
  ep^4-1128953117831145521/1821128995897344*ep^5;
fill mncT10(10,5) =
  -1652695/56-27225/2*ep^-1+2991229469/28224*ep+3731016922625/
  14224896*ep^2+1070807836572329/7169347584*ep^3+106428276085837625/
  3613351182336*ep^4-8696857836147578215/1821128995897344*ep^5;
fill mncT10(10,6) =
  -13805781/56-212355/2*ep^-1+37220066537/47040*ep+51518379298877/
  23708160*ep^2+17681366933446277/11948912640*ep^3+2462941888380796757/
  6022251970560*ep^4-1155889915078838159/607042998632448*ep^5;
fill mncT10(10,7) =
  -64298663/40-1288287/2*ep^-1+65399895179/14400*ep+72673731308677/
  5184000*ep^2+21008503589356631/1866240000*ep^3+2699732995940530693/
  671846400000*ep^4+98615194279443444479/241864704000000*ep^5;
fill mncT10(10,8) =
  -68961035/8-6441435/2*ep^-1+85716427777/4032*ep+538624877659483/
  7257600*ep^2+180099386375368169/2612736000*ep^3+28379320048858941307/
  940584960000*ep^4+1897053674504596395521/338610585600000*ep^5;
fill mncT10(10,9) =
  -315660345/8-13803075*ep^-1+99248819645/1176*ep+991879090289449/
  2963520*ep^2+263813554159185809/746807040*ep^3+34403361676341944641/
  188195374080*ep^4+2243502897931080551873/47425234268160*ep^5;
fill mncT10(10,10) =
  -3802934135/24-52144950*ep^-1+12362003265215/42336*ep+
  141030167154691039/106686720*ep^2+16799338215122256935/10754021376*
  ep^3+25215345288750461743819/27100133867520*ep^4+
  826552886737401492355103/2731693493846016*ep^5;
fill mncT20(-6,1) =
  -1/84-23/980*ep-5843/154350*ep^2-453806/8103375*ep^3-67430704/
  850854375*ep^4-9775819136/89339709375*ep^5;
fill mncT20(-6,2) =
  -73/105-2/3*ep^-1-11492/11025*ep-1677703/1157625*ep^2-
  240693302/121550625*ep^3-34187537368/12762815625*ep^4-4827576638912/
  1340095640625*ep^5;
fill mncT20(-6,3) =
  72/5-14*ep^-1-3697/150*ep+30361/2250*ep^2-484709/16875*ep^3+
  2108492/253125*ep^4-135135596/3796875*ep^5;
fill mncT20(-6,4) =
  587/3-70*ep^-1-5104/15*ep+95062/225*ep^2-3304937/6750*ep^3+
  100310887/202500*ep^4-3255229337/6075000*ep^5;
fill mncT20(-6,5) =
  3275/6-350/3*ep^-1-47683/36*ep+79933/36*ep^2-968071/324*ep^3+
  757925/216*ep^4-44696575/11664*ep^5;
fill mncT20(-6,6) =
  485-70*ep^-1-49229/30*ep+439127/120*ep^2-26640239/4320*ep^3+
  49332629/5760*ep^4-1299375595/124416*ep^5;
fill mncT20(-6,7) =
  2092/15-14*ep^-1-16473/25*ep+17887891/9000*ep^2-2354883317/
  540000*ep^3+244404539179/32400000*ep^4-21223511520773/1944000000*
  ep^5;
fill mncT20(-6,8) =
  353/35-2/3*ep^-1-31619/450*ep+303089/1000*ep^2-1489855661/
  1620000*ep^3+68644660769/32400000*ep^4-22832247383309/5832000000*
  ep^5;
fill mncT20(-6,9) =
  1/28-1349/1960*ep+2479361/411600*ep^2-1852848323/57624000*ep^3+
  8626260284921/72606240000*ep^4-3329436346797163/10164873600000*ep^5;
fill mncT20(-6,10) =
  1/504*ep-4591/141120*ep^2+26553911/118540800*ep^3-26897921381/
  33191424000*ep^4+112312437169799/83642388480000*ep^5;
fill mncT20(-5,1) =
  -1/63-379/13230*ep-30823/694575*ep^2-4683932/72930375*ep^3-
  687208288/7657689375*ep^4-98880776192/804057384375*ep^5;
fill mncT20(-5,2) =
  -22/45-2/3*ep^-1-1033/1350*ep-10573/10125*ep^2-214376/151875*
  ep^3-4322512/2278125*ep^4-86870144/34171875*ep^5;
fill mncT20(-5,3) =
  46/3-10*ep^-1-1937/90*ep+11788/675*ep^2-236794/10125*ep^3+
  2350972/151875*ep^4-59300836/2278125*ep^5;
fill mncT20(-5,4) =
  1075/9-100/3*ep^-1-12457/54*ep+25549/81*ep^2-179305/486*ep^3+
  1142575/2916*ep^4-7163485/17496*ep^5;
fill mncT20(-5,5) =
  1775/9-100/3*ep^-1-30707/54*ep+175897/162*ep^2-773903/486*ep^3
  +5761805/2916*ep^4-38852975/17496*ep^5;
fill mncT20(-5,6) =
  90-10*ep^-1-5711/15*ep+368137/360*ep^2-8629087/4320*ep^3+
  160556317/51840*ep^4-507053099/124416*ep^5;
fill mncT20(-5,7) =
  142/15-2/3*ep^-1-13787/225*ep+6570173/27000*ep^2-1093489951/
  1620000*ep^3+137668367537/97200000*ep^4-13917130212319/5832000000*
  ep^5;
fill mncT20(-5,8) =
  1/21-551/630*ep+136597/18900*ep^2-40929769/1134000*ep^3+
  8420292103/68040000*ep^4-1284520788361/4082400000*ep^5;
fill mncT20(-5,9) =
  1/294*ep-3257/61740*ep^2+4361053/12965400*ep^3-5867075167/
  5445468000*ep^4+2880118282903/2287096560000*ep^5;
fill mncT20(-5,10) =
  1/10584*ep-8513/8890560*ep^2+14714953/7468070400*ep^3+77922221551/
  6273179136000*ep^4-395835392153543/5269470474240000*ep^5;
fill mncT20(-4,1) =
  -1/45-49/1350*ep-544/10125*ep^2-11528/151875*ep^3-238336/
  2278125*ep^4-4860032/34171875*ep^5;
fill mncT20(-4,2) =
  -11/45-2/3*ep^-1-337/675*ep-6794/10125*ep^2-136528/151875*ep^3
  -2738336/2278125*ep^4-54860032/34171875*ep^5;
fill mncT20(-4,3) =
  131/9-20/3*ep^-1-1067/54*ep+1565/81*ep^2-5080/243*ep^3+13700/
  729*ep^4-47260/2187*ep^5;
fill mncT20(-4,4) =
  562/9-40/3*ep^-1-3842/27*ep+17653/81*ep^2-130045/486*ep^3+
  856255/2916*ep^4-5371645/17496*ep^5;
fill mncT20(-4,5) =
  157/3-20/3*ep^-1-3427/18*ep+23569/54*ep^2-59156/81*ep^3+479815/
  486*ep^4-3400565/2916*ep^5;
fill mncT20(-4,6) =
  131/15-2/3*ep^-1-925/18*ep+39547/216*ep^2-1169689/2592*ep^3+
  130416407/155520*ep^4-469580545/373248*ep^5;
fill mncT20(-4,7) =
  1/15-173/150*ep+39883/4500*ep^2-10971971/270000*ep^3+2049129277/
  16200000*ep^4-281553155699/972000000*ep^5;
fill mncT20(-4,8) =
  2/315*ep-62/675*ep^2+75109/141750*ep^3-12130183/8505000*ep^4+
  49117903/72900000*ep^5;
fill mncT20(-4,9) =
  1/4410*ep-1913/926100*ep^2+493441/194481000*ep^3+2703618881/
  81682020000*ep^4-5052527519129/34306448400000*ep^5;
fill mncT20(-4,10) =
  1/52920*ep-5237/44452800*ep^2-9426899/37340352000*ep^3+96602667307/
  31365895680000*ep^4-104343711700451/26347352371200000*ep^5;
fill mncT20(-3,1) =
  -1/30-11/225*ep-232/3375*ep^2-4784/50625*ep^3-97408/759375*
  ep^4-1968896/11390625*ep^5;
fill mncT20(-3,2) =
  1/18-2/3*ep^-1-7/27*ep-28/81*ep^2-112/243*ep^3-448/729*ep^4-
  1792/2187*ep^5;
fill mncT20(-3,3) =
  37/3-4*ep^-1-167/9*ep+538/27*ep^2-1628/81*ep^3+4828/243*ep^4
  -14708/729*ep^5;
fill mncT20(-3,4) =
  77/3-4*ep^-1-223/3*ep+403/3*ep^2-1085/6*ep^3+2485/12*ep^4-
  5285/24*ep^5;
fill mncT20(-3,5) =
  47/6-2/3*ep^-1-727/18*ep+6667/54*ep^2-83453/324*ep^3+788095/
  1944*ep^4-6126365/11664*ep^5;
fill mncT20(-3,6) =
  1/10-8/5*ep+1339/120*ep^2-65581/1440*ep^3+2144431/17280*ep^4-
  10217753/41472*ep^5;
fill mncT20(-3,7) =
  1/75*ep-22/125*ep^2+19867/22500*ep^3-2410529/1350000*ep^4-
  106376777/81000000*ep^5;
fill mncT20(-3,8) =
  1/1575*ep-118/23625*ep^2+841/1417500*ep^3+8151533/85050000*ep^4-
  1499687771/5103000000*ep^5;
fill mncT20(-3,9) =
  1/14700*ep-263/771750*ep^2-879791/648270000*ep^3+2609273819/
  272273400000*ep^4-219838700171/114354828000000*ep^5;
fill mncT20(-3,10) =
  1/88200*ep-2563/74088000*ep^2-20465941/62233920000*ep^3+
  58042373213/52276492800000*ep^4+116022719392091/43912253952000000*ep^5
  ;
fill mncT20(-2,1) =
  -1/18-2/27*ep-8/81*ep^2-32/243*ep^3-128/729*ep^4-512/2187*
  ep^5;
fill mncT20(-2,2) =
  4/9-2/3*ep^-1-2/27*ep-8/81*ep^2-32/243*ep^3-128/729*ep^4-512/
  2187*ep^5;
fill mncT20(-2,3) =
  9-2*ep^-1-17*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(-2,4) =
  20/3-2/3*ep^-1-28*ep+67*ep^2-215/2*ep^3+535/4*ep^4-1175/8*
  ep^5;
fill mncT20(-2,5) =
  1/6-43/18*ep+781/54*ep^2-16061/324*ep^3+214615/1944*ep^4-
  2073125/11664*ep^5;
fill mncT20(-2,6) =
  1/30*ep-139/360*ep^2+6721/4320*ep^3-84259/51840*ep^4-902827/
  124416*ep^5;
fill mncT20(-2,7) =
  1/450*ep-377/27000*ep^2-35201/1620000*ep^3+30326287/97200000*ep^4
  -3031593569/5832000000*ep^5;
fill mncT20(-2,8) =
  1/3150*ep-23/21000*ep^2-93791/11340000*ep^3+7404539/226800000*ep^4
  +1951554721/40824000000*ep^5;
fill mncT20(-2,9) =
  1/14700*ep-317/3087000*ep^2-2824597/1296540000*ep^3+1840664773/
  544546800000*ep^4+5160486513443/228709656000000*ep^5;
fill mncT20(-2,10) =
  1/52920*ep-29/44452800*ep^2-23874563/37340352000*ep^3+1050578059/
  31365895680000*ep^4+195040341925213/26347352371200000*ep^5;
fill mncT20(-1,1) =
  -1/9-4/27*ep-16/81*ep^2-64/243*ep^3-256/729*ep^4-1024/2187*
  ep^5;
fill mncT20(-1,2) =
  1-2/3*ep^-1;
fill mncT20(-1,3) =
  5-2/3*ep^-1-14*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(-1,4) =
  1/3-4*ep+19*ep^2-95/2*ep^3+295/4*ep^4-695/8*ep^5;
fill mncT20(-1,5) =
  1/9*ep-28/27*ep^2+217/81*ep^3+1105/486*ep^4-69035/2916*ep^5;
fill mncT20(-1,6) =
  1/90*ep-49/1080*ep^2-2909/12960*ep^3+176471/155520*ep^4+77183/
  373248*ep^5;
fill mncT20(-1,7) =
  1/450*ep-77/27000*ep^2-108701/1620000*ep^3+8508787/97200000*ep^4
  +3586068931/5832000000*ep^5;
fill mncT20(-1,8) =
  1/1575*ep+19/47250*ep^2-57553/2835000*ep^3-2102489/170100000*ep^4
  +2150196743/10206000000*ep^5;
fill mncT20(-1,9) =
  1/4410*ep+439/926100*ep^2-2704141/388962000*ep^3-2439933731/
  163364040000*ep^4+4525924032779/68612896800000*ep^5;
fill mncT20(-1,10) =
  1/10584*ep+2743/8890560*ep^2-19721351/7468070400*ep^3-60095960177/
  6273179136000*ep^4+102403388672761/5269470474240000*ep^5;
fill mncT20(0,1) =
  -1/3-2/3*ep-4/3*ep^2-8/3*ep^3-16/3*ep^4-32/3*ep^5;
fill mncT20(0,2) =
  2-2/3*ep^-1;
fill mncT20(0,3) =
  1-8*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(0,4) =
  2/3*ep-11/3*ep^2-5/6*ep^3+325/12*ep^4-965/24*ep^5;
fill mncT20(0,5) =
  1/9*ep-1/27*ep^2-457/162*ep^3+995/972*ep^4+98855/5832*ep^5;
fill mncT20(0,6) =
  1/30*ep+29/360*ep^2-3599/4320*ep^3-106051/51840*ep^4+600341/
  124416*ep^5;
fill mncT20(0,7) =
  1/75*ep+43/750*ep^2-11891/45000*ep^3-3854183/2700000*ep^4+
  28768321/162000000*ep^5;
fill mncT20(0,8) =
  2/315*ep+172/4725*ep^2-23929/283500*ep^3-14469227/17010000*ep^4-
  956061151/1020600000*ep^5;
fill mncT20(0,9) =
  1/294*ep+1447/61740*ep^2-566677/25930800*ep^3-5484186467/
  10890936000*ep^4-4758952611397/4574193120000*ep^5;
fill mncT20(0,10) =
  1/504*ep+2201/141120*ep^2+99943/118540800*ep^3-10086927493/
  33191424000*ep^4-74798499514553/83642388480000*ep^5;
fill mncT20(1,1) =
  1/3*ep^-1;
fill mncT20(1,2) =
  4-ep^-1;
fill mncT20(1,3) =
  -2+4*ep+20*ep^2-20*ep^3+20*ep^4-20*ep^5;
fill mncT20(1,4) =
  -2/3-2*ep+11*ep^2+65/2*ep^3-25/4*ep^4-55/8*ep^5;
fill mncT20(1,5) =
  -1/3-17/9*ep+133/54*ep^2+9697/324*ep^3+90685/1944*ep^4+48265/
  11664*ep^5;
fill mncT20(1,6) =
  -1/5-3/2*ep-17/24*ep^2+5783/288*ep^3+1068911/17280*ep^4+
  2624615/41472*ep^5;
fill mncT20(1,7) =
  -2/15-89/75*ep-8617/4500*ep^2+3351779/270000*ep^3+970238027/
  16200000*ep^4+101308463051/972000000*ep^5;
fill mncT20(1,8) =
  -2/21-43/45*ep-6341/2700*ep^2+1156907/162000*ep^3+510974491/
  9720000*ep^4+72810365483/583200000*ep^5;
fill mncT20(1,9) =
  -1/14-769/980*ep-1010321/411600*ep^2+205879523/57624000*ep^3+
  3214970899279/72606240000*ep^4+1341980656664563/10164873600000*ep^5;
fill mncT20(1,10) =
  -1/18-551/840*ep-5115629/2116800*ep^2+75291971/65856000*ep^3+
  54543220808719/1493614080000*ep^4+54914876768924611/418211942400000*
  ep^5;
fill mncT20(2,1) =
  2-1/3*ep^-1-4*ep+8*ep^2-16*ep^3+32*ep^4-64*ep^5;
fill mncT20(2,2) =
  4-4/3*ep^-1+8*ep-16*ep^2+32*ep^3-64*ep^4+128*ep^5;
fill mncT20(2,3) =
  -2-4/3*ep^-1+24*ep+28*ep^2-36*ep^3+52*ep^4-84*ep^5;
fill mncT20(2,4) =
  -16/3-4/3*ep^-1+18*ep+87*ep^2+105/2*ep^3-105/4*ep^4+105/8*
  ep^5;
fill mncT20(2,5) =
  -23/3-4/3*ep^-1+73/9*ep+6289/54*ep^2+68989/324*ep^3+192745/
  1944*ep^4-257915/11664*ep^5;
fill mncT20(2,6) =
  -142/15-4/3*ep^-1-233/90*ep+135527/1080*ep^2+4831027/12960*
  ep^3+64777463/155520*ep^4+59776703/373248*ep^5;
fill mncT20(2,7) =
  -164/15-4/3*ep^-1-5959/450*ep+3266573/27000*ep^2+827279549/
  1620000*ep^3+82540045037/97200000*ep^4+3971016625181/5832000000*ep^5
  ;
fill mncT20(2,8) =
  -426/35-4/3*ep^-1-74243/3150*ep+2252989/21000*ep^2+7047906613/
  11340000*ep^3+303789722423/226800000*ep^4+62608258173397/40824000000
  *ep^5;
fill mncT20(2,9) =
  -927/70-4/3*ep^-1-1476577/44100*ep+179362247/2058000*ep^2+
  5488605605993/7779240000*ep^3+2014683523898821/1089093600000*ep^4+
  3664245722376390233/1372257936000000*ep^5;
fill mncT20(2,10) =
  -4469/315-4/3*ep^-1-3789689/88200*ep+4624227637/74088000*ep^2+
  47595938660059/62233920000*ep^3+123202774990297213/52276492800000*ep^4
  +177176618299181880091/43912253952000000*ep^5;
fill mncT20(3,1) =
  -2/3+14/3*ep-38/3*ep^2+86/3*ep^3-182/3*ep^4+374/3*ep^5;
fill mncT20(3,2) =
  2-4/3*ep^-1+18*ep-26*ep^2+42*ep^3-74*ep^4+138*ep^5;
fill mncT20(3,3) =
  -2-4*ep^-1+66*ep+30*ep^2-30*ep^3+30*ep^4-30*ep^5;
fill mncT20(3,4) =
  -50/3-8*ep^-1+124*ep+269*ep^2+125/2*ep^3-145/4*ep^4+185/8*
  ep^5;
fill mncT20(3,5) =
  -134/3-40/3*ep^-1+1522/9*ep+19061/27*ep^2+115049/162*ep^3+
  134645/972*ep^4-243775/5832*ep^5;
fill mncT20(3,6) =
  -88-20*ep^-1+5417/30*ep+474037/360*ep^2+9565217/4320*ep^3+
  75824797/51840*ep^4+33326293/124416*ep^5;
fill mncT20(3,7) =
  -2224/15-28*ep^-1+20927/150*ep+18515191/9000*ep^2+2581018183/
  540000*ep^3+162439806679/32400000*ep^4+4861399866727/1944000000*ep^5
  ;
fill mncT20(3,8) =
  -1134/5-112/3*ep^-1+45233/1575*ep+4307843/1500*ep^2+
  48365901917/5670000*ep^3+1347457264207/113400000*ep^4+26378646127739/
  2916000000*ep^5;
fill mncT20(3,9) =
  -11366/35-48*ep^-1-205412/1225*ep+1902910333/514500*ep^2+
  2921999991203/216090000*ep^3+2096541650905573/90757800000*ep^4+
  872516058420356243/38118276000000*ep^5;
fill mncT20(3,10) =
  -9305/21-60*ep^-1-1638433/3528*ep+7361205209/1646400*ep^2+
  81972708321109/4148928000*ep^3+138028550387269363/3485099520000*ep^4
  +138795980231409673141/2927483596800000*ep^5;
fill mncT20(4,1) =
  -2/9+22/27*ep+118/81*ep^2-2018/243*ep^3+17158/729*ep^4-
  120338/2187*ep^5;
fill mncT20(4,2) =
  8/9-4/3*ep^-1+560/27*ep-1120/81*ep^2+2240/243*ep^3-4480/729*
  ep^4+8960/2187*ep^5;
fill mncT20(4,3) =
  -10/3-8*ep^-1+1178/9*ep+1370/27*ep^2-3550/81*ep^3+9530/243*
  ep^4-26350/729*ep^5;
fill mncT20(4,4) =
  -364/9-80/3*ep^-1+11414/27*ep+52583/81*ep^2+29995/486*ep^3-
  94465/2916*ep^4+301315/17496*ep^5;
fill mncT20(4,5) =
  -1490/9-200/3*ep^-1+25756/27*ep+213712/81*ep^2+439192/243*ep^3
  +121240/729*ep^4-122360/2187*ep^5;
fill mncT20(4,6) =
  -466-140*ep^-1+50969/30*ep+2595829/360*ep^2+37296929/4320*ep^3
  +203776669/51840*ep^4+45626581/124416*ep^5;
fill mncT20(4,7) =
  -15974/15-784/3*ep^-1+563653/225*ep+212948149/13500*ep^2+
  21367432837/810000*ep^3+981651206581/48600000*ep^4+20536825751653/
  2916000000*ep^5;
fill mncT20(4,8) =
  -31864/15-448*ep^-1+4807756/1575*ep+704184707/23625*ep^2+
  90017249191/1417500*ep^3+5633202721583/85050000*ep^4+190987510132879/
  5103000000*ep^5;
fill mncT20(4,9) =
  -26930/7-720*ep^-1+414236/147*ep+15650506589/308700*ep^2+
  17001990837739/129654000*ep^3+9261629868042749/54454680000*ep^4+
  2943607325873278459/22870965600000*ep^5;
fill mncT20(4,10) =
  -408245/63-1100*ep^-1+11019805/10584*ep+707513577751/8890560*
  ep^2+1814527882945273/7468070400*ep^3+2338002817201507471/
  6273179136000*ep^4+1826951548514338306297/5269470474240000*ep^5;
fill mncT20(5,1) =
  -1/9+13/54*ep+461/324*ep^2-6623/1944*ep^3+60269/11664*ep^4-
  459047/69984*ep^5;
fill mncT20(5,2) =
  1/9-4/3*ep^-1+1175/54*ep-785/324*ep^2-11845/1944*ep^3+111775/
  11664*ep^4-756925/69984*ep^5;
fill mncT20(5,3) =
  -62/9-40/3*ep^-1+5893/27*ep+17225/162*ep^2-73355/972*ep^3+
  345665/5832*ep^4-1772675/34992*ep^5;
fill mncT20(5,4) =
  -790/9-200/3*ep^-1+28721/27*ep+227557/162*ep^2+46625/972*ep^3
  -32195/5832*ep^4-567415/34992*ep^5;
fill mncT20(5,5) =
  -485-700/3*ep^-1+62669/18*ep+836537/108*ep^2+2614229/648*ep^3
  +872705/3888*ep^4-2444035/23328*ep^5;
fill mncT20(5,6) =
  -1813-1960/3*ep^-1+394943/45*ep+30703469/1080*ep^2+347378191/
  12960*ep^3+1441025999/155520*ep^4+151385327/373248*ep^5;
fill mncT20(5,7) =
  -80164/15-1568*ep^-1+1368386/75*ep+20352181/250*ep^2+542082151/
  5000*ep^3+6553417021/100000*ep^4+34239683791/2000000*ep^5;
fill mncT20(5,8) =
  -40180/3-3360*ep^-1+2038402/63*ep+1858182677/9450*ep^2+
  189734040541/567000*ep^3+9555153067133/34020000*ep^4+255951484910029/
  2041200000*ep^5;
fill mncT20(5,9) =
  -625915/21-6600*ep^-1+43566575/882*ep+155241292369/370440*ep^2
  +134457514968671/155584800*ep^3+59632498889714041/65345616000*ep^4
  +15336180514258890431/27445158720000*ep^5;
fill mncT20(5,10) =
  -3815020/63-12100*ep^-1+672043865/10584*ep+7209932656511/8890560
  *ep^2+14657572049878313/7468070400*ep^3+15493420641913630511/
  6273179136000*ep^4+9940372453388210088377/5269470474240000*ep^5;
fill mncT20(6,1) =
  -1/15+37/450*ep+13681/13500*ep^2-531047/405000*ep^3+10925689/
  12150000*ep^4-58905143/364500000*ep^5;
fill mncT20(6,2) =
  -22/45-4/3*ep^-1+14917/675*ep+145621/20250*ep^2-7176827/607500
  *ep^3+178762549/18225000*ep^4-3758759963/546750000*ep^5;
fill mncT20(6,3) =
  -40/3-20*ep^-1+14728/45*ep+140792/675*ep^2-1143752/10125*ep^3
  +11067512/151875*ep^4-126680072/2278125*ep^5;
fill mncT20(6,4) =
  -530/3-140*ep^-1+33557/15*ep+423607/150*ep^2+76397/1500*ep^3
  +536287/15000*ep^4-11154523/150000*ep^5;
fill mncT20(6,5) =
  -1225-1960/3*ep^-1+893521/90*ep+52848593/2700*ep^2+682276609/
  81000*ep^3+991720817/2430000*ep^4-19991371679/72900000*ep^5;
fill mncT20(6,6) =
  -5782-2352*ep^-1+1655967/50*ep+91233989/1000*ep^2+1443847463/
  20000*ep^3+8173903421/400000*ep^4+1458637007/8000000*ep^5;
fill mncT20(6,7) =
  -105938/5-7056*ep^-1+13461241/150*ep+196444423/600*ep^2+
  22085957393/60000*ep^3+222489175979/1200000*ep^4+911520869801/
  24000000*ep^5;
fill mncT20(6,8) =
  -194530/3-18480*ep^-1+26018777/126*ep+36860355869/37800*ep^2+
  3184378641517/2268000*ep^3+135220583203421/136080000*ep^4+
  2985861528034573/8164800000*ep^5;
fill mncT20(6,9) =
  -1213465/7-43560*ep^-1+60822598/147*ep+194807431393/77175*ep^2
  +71368977411709/16206750*ep^3+13453624222021897/3403417500*ep^4+
  1454776080000749701/714717675000*ep^5;
fill mncT20(6,10) =
  -8757815/21-94380*ep^-1+285953499/392*ep+86753994798313/14817600
  *ep^2+148907578338425071/12446784000*ep^3+134583634360736251897/
  10455298560000*ep^4+73478148911479794387679/8782450790400000*ep^5;
fill mncT20(7,1) =
  -2/45+17/675*ep+14621/20250*ep^2-266827/607500*ep^3-2337451/
  18225000*ep^4+292240037/546750000*ep^5;
fill mncT20(7,2) =
  -44/45-4/3*ep^-1+14924/675*ep+154756/10125*ep^2-1870036/151875
  *ep^3+13127716/2278125*ep^4-60303796/34171875*ep^5;
fill mncT20(7,3) =
  -116/5-28*ep^-1+34276/75*ep+412444/1125*ep^2-2379164/16875*
  ep^3+17847484/253125*ep^4-185697404/3796875*ep^5;
fill mncT20(7,4) =
  -1666/5-784/3*ep^-1+938503/225*ep+35955539/6750*ep^2+35076907/
  202500*ep^3+360336491/6075000*ep^4-26477428517/182250000*ep^5;
fill mncT20(7,5) =
  -13916/5-1568*ep^-1+1802036/75*ep+50033084/1125*ep^2+287204996/
  16875*ep^3+221622524/253125*ep^4-2634047644/3796875*ep^5;
fill mncT20(7,6) =
  -80066/5-7056*ep^-1+5093047/50*ep+760464367/3000*ep^2+
  31791539167/180000*ep^3+469636512367/10800000*ep^4-549658402433/
  648000000*ep^5;
fill mncT20(7,7) =
  -1064182/15-25872*ep^-1+17267879/50*ep+9947129741/9000*ep^2+
  589989515933/540000*ep^3+15486776900429/32400000*ep^4+
  153970495460477/1944000000*ep^5;
fill mncT20(7,8) =
  -3889732/15-81312*ep^-1+1550451076/1575*ep+93444165512/23625*
  ep^2+1773570582514/354375*ep^3+16430603243333/5315625*ep^4+
  154326257660627/159468750*ep^5;
fill mncT20(7,9) =
  -28622858/35-226512*ep^-1+8945694844/3675*ep+4693005624746/
  385875*ep^2+754866033770809/40516875*ep^3+124746450400539397/
  8508543750*ep^4+11669819549415577201/1786794187500*ep^5;
fill mncT20(7,10) =
  -103252721/45-572572*ep^-1+201215003399/37800*ep+
  1052670739682273/31752000*ep^2+1584389477988125111/26671680000*ep^3+
  1260115013745961428977/22404211200000*ep^4+600882741173995469811239/
  18819537408000000*ep^5;
fill mncT20(8,1) =
  -2/63+11/6615*ep+735761/1389150*ep^2-15307249/291721500*ep^3-
  20069423959/61261515000*ep^4+5172990804431/12864918150000*ep^5;
fill mncT20(8,2) =
  -146/105-4/3*ep^-1+241897/11025*ep+51352127/2315250*ep^2-
  4773167543/486202500*ep^3+121383985487/102102525000*ep^4+
  32097376872217/21441530250000*ep^5;
fill mncT20(8,3) =
  -554/15-112/3*ep^-1+955123/1575*ep+194381393/330750*ep^2-
  9944115137/69457500*ep^3+720242324633/14586075000*ep^4-
  106786845347297/3063075750000*ep^5;
fill mncT20(8,4) =
  -8888/15-448*ep^-1+1247644/175*ep+58053334/6125*ep^2+135651199/
  214375*ep^3+298200803/15006250*ep^4-231974825609/1050437500*ep^5;
fill mncT20(8,5) =
  -17476/3-3360*ep^-1+5423872/105*ep+1026210586/11025*ep^2+
  39090448813/1157625*ep^3+462912373583/243101250*ep^4-78990538402847/
  51051262500*ep^5;
fill mncT20(8,6) =
  -119554/3-18480*ep^-1+56805143/210*ep+11147568661/17640*ep^2+
  597336826967/1481760*ep^3+11261910805309/124467840*ep^4-
  7996110736781/2091059712*ep^5;
fill mncT20(8,7) =
  -3134692/15-81312*ep^-1+586429352/525*ep+180345975898/55125*ep^2
  +16981787031817/5788125*ep^3+1400937773650811/1215506250*ep^4+
  40384500100087813/255256312500*ep^5;
fill mncT20(8,8) =
  -94105352/105-302016*ep^-1+42304774636/11025*ep+15966836211554/
  1157625*ep^2+1917150465063091/121550625*ep^3+222944364852849553/
  25525631250*ep^4+12784984115109386899/5360382562500*ep^5;
fill mncT20(8,9) =
  -344915714/105-981552*ep^-1+125188224652/11025*ep+57327608405708/
  1157625*ep^2+169691073788368/2480625*ep^3+616775730790589453/
  12762815625*ep^4+25521414100086000862/1340095640625*ep^5;
fill mncT20(8,10) =
  -95522999/9-2862860*ep^-1+223988205851/7560*ep+198479962759177/
  1270080*ep^2+53777209618419011/213373440*ep^3+7693053960436534657/
  35846737920*ep^4+653914768896638272619/6022251970560*ep^5;
fill mncT20(9,1) =
  -1/42-17/1960*ep+988423/2469600*ep^2+130080361/1037232000*ep^3
  -132124778273/435637440000*ep^4+39081330520489/182967724800000*ep^5;
fill mncT20(9,2) =
  -367/210-4/3*ep^-1+1911101/88200*ep+1042101407/37044000*ep^2-
  86110890751/15558480000*ep^3-17042462394457/6534561600000*ep^4+
  7907446988034401/2744515872000000*ep^5;
fill mncT20(9,3) =
  -1922/35-48*ep^-1+1897591/2450*ep+301069579/343000*ep^2-
  4948522049/48020000*ep^3+80071131619/6722800000*ep^4-18482489761289/
  941192000000*ep^5;
fill mncT20(9,4) =
  -6998/7-720*ep^-1+16770571/1470*ep+3293023879/205800*ep^2+
  51986235451/28812000*ep^3-478953480881/4033680000*ep^4-
  174098181323789/564715200000*ep^5;
fill mncT20(9,5) =
  -239485/21-6600*ep^-1+59678963/588*ep+8999125993/49392*ep^2+
  273368291219/4148928*ep^3+1420652321425/348509952*ep^4-
  91124037255205/29274835968*ep^5;
fill mncT20(9,6) =
  -637747/7-43560*ep^-1+629646273/980*ep+119042517491/82320*ep^2
  +6030757537057/6914880*ep^3+107478921385259/580849920*ep^4-
  105005045961691/9758278656*ep^5;
fill mncT20(9,7) =
  -19467998/35-226512*ep^-1+23281533403/7350*ep+2995897232957/
  343000*ep^2+349928274306329/48020000*ep^3+17758196394663413/
  6722800000*ep^4+289303778474762561/941192000000*ep^5;
fill mncT20(9,8) =
  -41386202/15-981552*ep^-1+283630630979/22050*ep+395546421637189/
  9261000*ep^2+175501506642798899/3889620000*ep^3+37418073001064553109/
  1633640400000*ep^4+3822672350863462613219/686128968000000*ep^5;
fill mncT20(9,9) =
  -162519643/14-3680820*ep^-1+262595305811/5880*ep+87238249360337/
  493920*ep^2+9315219944358107/41489280*ep^3+101175453391617973/
  697019904*ep^4+15089495884566992579/292748359680*ep^5;
fill mncT20(9,10) =
  -1794820885/42-12269400*ep^-1+239935332475/1764*ep+
  629668364238581/987840*ep^2+156590334768924257/165957120*ep^3+
  20499084628777351687/27880796160*ep^4+315771825523270174417/
  936794750976*ep^5;
fill mncT20(10,1) =
  -1/54-899/68040*ep+26608661/85730400*ep^2+22301027281/
  108020304000*ep^3-30764322105499/136105583040000*ep^4+
  13987748932332121/171493034630400000*ep^5;
fill mncT20(10,2) =
  -1949/945-4/3*ep^-1+25400111/1190700*ep+50002245931/1500282000*
  ep^2-307591759849/1890355320000*ep^3-12413937459889229/
  2381847703200000*ep^4+8738028774226905791/3001128106032000000*ep^5;
fill mncT20(10,3) =
  -1627/21-60*ep^-1+25410289/26460*ep+41398021589/33339600*ep^2-
  190296782231/42007896000*ep^3-1878209166342451/52929948960000*ep^4-
  604812037282539071/66691735689600000*ep^5;
fill mncT20(10,4) =
  -101455/63-1100*ep^-1+275221241/15876*ep+103162952009/4000752*
  ep^2+4293929585705/1008189504*ep^3-89566560900055/254063755008*ep^4
  -27959241939151255/64024066262016*ep^5;
fill mncT20(10,5) =
  -1329680/63-12100*ep^-1+737272054/3969*ep+84298599661/250047*
  ep^2+3965429329817/31505922*ep^3+34545751893985/3969746172*ep^4-
  2913598743696175/500188017672*ep^5;
fill mncT20(10,6) =
  -4079713/21-94380*ep^-1+36973908163/26460*ep+20570227539667/
  6667920*ep^2+3033514159050163/1680315840*ep^3+157783074769647667/
  423439591680*ep^4-528901375770096745/21341355420672*ep^5;
fill mncT20(10,7) =
  -61332271/45-572572*ep^-1+459094453861/56700*ep+1531948229048633/
  71442000*ep^2+1529532469520022109/90016920000*ep^3+
  659328793858498496657/113421319200000*ep^4+84193338407945687943061/
  142910862192000000*ep^5;
fill mncT20(10,8) =
  -69552769/9-2862860*ep^-1+434310052219/11340*ep+7004672898859/
  58320*ep^2+350749945127471/2939328*ep^3+5985907366175321/105815808*
  ep^4+33984285466122253/2720977920*ep^5;
fill mncT20(10,9) =
  -1551477785/42-12269400*ep^-1+1627394154415/10584*ep+
  7543699807403531/13335840*ep^2+2260333080623120459/3360631680*ep^3+
  68488673475056100559/169375836672*ep^4+5610227992150949456143/
  42682710841344*ep^5;
fill mncT20(10,10) =
  -29016110695/189-139053200/3*ep^-1+51295527403105/95256*ep+
  554800602494906533/240045120*ep^2+385811958544034384741/120982740480*
  ep^3+140661160501409433770533/60975301201920*ep^4+
  5972748132827112581530465/6146310361153536*ep^5;
fill mncT11(-6,-6) =
  1/25971865920*ep+54143/374368864117248*ep^2+1461092694913/
  3372689096832287232000*ep^3+1521012295134409487/
  1215382242934483026923520000*ep^4+144702912918207566541491/
  39815922278533663962014515200000*ep^5;
fill mncT11(-6,-5) =
  1/5194373184*ep+191897/267406331512320*ep^2+1446714588313/
  674537819366457446400*ep^3+215051810762400977/
  34725206940985229340672000*ep^4+143219674905396635366459/
  7963184455706732792402903040000*ep^5;
fill mncT11(-6,-4) =
  1/856215360*ep+1349351/308545767129600*ep^2+291188566637/
  22237510528564531200*ep^3+1515740361197464559/
  40067546470367572316160000*ep^4+144212179045019487639827/
  1312612822369241669077401600000*ep^5;
fill mncT11(-6,-3) =
  1/109771200*ep+21271/608571532800*ep^2+1781801717/16869602889216000*
  ep^3+715217051621027/2338126960445337600000*ep^4+5235259582269107603/
  5892079940322250752000000*ep^5;
fill mncT11(-6,-2) =
  1/9979200*ep+22531/55324684800*ep^2+1933272617/1533600262656000*ep^3
  +781840739076527/212556996404121600000*ep^4+63017127138305883733/
  5892079940322250752000000*ep^5;
fill mncT11(-6,-1) =
  1/544320*ep+11509/1371686400*ep^2+19034489/691329945600*ep^3+
  716347562557/8710757314560000*ep^4+5281738326720781/
  21951108432691200000*ep^5;
fill mncT11(-6,0) =
  1/12096*ep+14701/30481920*ep^2+142493173/76814438400*ep^3+
  1175022146197/193572384768000*ep^4+362229416590381/19512096384614400*
  ep^5;
fill mncT11(-6,1) =
  -1/168-491/11760*ep-2809459/14817600*ep^2-164251523/230496000*
  ep^3-9394096633/3872332800*ep^4-953372760821057/121978483200000*ep^5
  ;
fill mncT11(-6,2) =
  -89/105-1/6*ep^-1-1805329/529200*ep-97649753/8232000*ep^2-
  2971437071/76832000*ep^3-528741075088307/4356374400000*ep^4-
  683016375960851521/1829677248000000*ep^5;
fill mncT11(-6,3) =
  -53/10-7/2*ep^-1-132547/3600*ep-5766373/72000*ep^2-94663519/
  288000*ep^3-73265935007/86400000*ep^4-14991092330803/5184000000*ep^5
  ;
fill mncT11(-6,4) =
  19-35/2*ep^-1-127459/720*ep+746551/14400*ep^2-117119053/96000*
  ep^3-12251704507/17280000*ep^4-2900897885237/345600000*ep^5;
fill mncT11(-6,5) =
  1865/18-175/6*ep^-1-65051/144*ep+552703/576*ep^2-21762941/6912*
  ep^3+393823703/82944*ep^4-17125296709/995328*ep^5;
fill mncT11(-6,6) =
  1313/12-35/2*ep^-1-117053/240*ep+7250177/4800*ep^2-1244217599/
  288000*ep^3+174112515313/17280000*ep^4-25434137985631/1036800000*
  ep^5;
fill mncT11(-6,7) =
  2027/60-7/2*ep^-1-74183/400*ep+5800583/8000*ep^2-222102029/96000
  *ep^3+546926396573/86400000*ep^4-81787562480723/5184000000*ep^5;
fill mncT11(-6,8) =
  353/140-1/6*ep^-1-373727/19600*ep+800940667/8232000*ep^2-
  29289691863/76832000*ep^3+5385992171933273/4356374400000*ep^4-
  709521618026979929/203297472000000*ep^5;
fill mncT11(-6,9) =
  1/112-5471/31360*ep+14340133/8780800*ep^2-24494628927/2458624000*
  ep^3+6237727760217/137682944000*ep^4-864838163864034797/
  5204415283200000*ep^5;
fill mncT11(-6,10) =
  1/2016*ep-42589/5080320*ep^2+827883523/12802406400*ep^3-
  9821121950233/32262064128000*ep^4+15684812553506807/16260080320512000*
  ep^5;
fill mncT11(-5,-6) =
  1/5194373184*ep+191897/267406331512320*ep^2+1446714588313/
  674537819366457446400*ep^3+215051810762400977/
  34725206940985229340672000*ep^4+143219674905396635366459/
  7963184455706732792402903040000*ep^5;
fill mncT11(-5,-5) =
  1/1198701504*ep+188597/61709153425920*ep^2+1414297457413/
  155662573699951718400*ep^3+209999513637846077/
  8013509294073514463232000*ep^4+139865314491088852726559/
  1837657951316938336708362240000*ep^5;
fill mncT11(-5,-4) =
  1/230519520*ep+14411/912857299200*ep^2+1659590243/35426166067353600*
  ep^3+94747430653571/701438088133601280000*ep^4+4854449588337788357/
  12373367874676726579200000*ep^5;
fill mncT11(-5,-3) =
  1/34927200*ep+2917/27662342400*ep^2+1687155977/5367600919296000*ep^3
  +96432007853561/106278498202060800000*ep^4+54350675476108434613/
  20622279791127877632000000*ep^5;
fill mncT11(-5,-2) =
  1/3810240*ep+1387/1371686400*ep^2+14843729/4839309619200*ep^3+
  77510868451/8710757314560000*ep^4+3973230536370181/
  153657759028838400000*ep^5;
fill mncT11(-5,-1) =
  1/254016*ep+1543/91445760*ep^2+86761273/1613103206400*ep^3+
  92265059071/580717154304000*ep^4+189942040247089/409754024076902400*
  ep^5;
fill mncT11(-5,0) =
  1/7056*ep+41/52920*ep^2+198451/69148800*ep^3+38167517/4148928000*
  ep^4+13589568749/487913932800*ep^5;
fill mncT11(-5,1) =
  -1/126-1373/26460*ep-278951/1234800*ep^2-428917169/518616000*
  ep^3-24133350683/8712748800*ep^4-808252068538657/91483862400000*ep^5
  ;
fill mncT11(-5,2) =
  -67/90-1/6*ep^-1-10367/3600*ep-699593/72000*ep^2-26955169/
  864000*ep^3-25135874401/259200000*ep^4-4614144435149/15552000000*
  ep^5;
fill mncT11(-5,3) =
  -7/4-5/2*ep^-1-16687/720*ep-515657/14400*ep^2-54125287/288000*
  ep^3-7162742651/17280000*ep^4-1628632766623/1036800000*ep^5;
fill mncT11(-5,4) =
  655/36-25/3*ep^-1-3409/36*ep+3161/27*ep^2-49598/81*ep^3+
  1147271/3888*ep^4-2667887/729*ep^5;
fill mncT11(-5,5) =
  85/2-25/3*ep^-1-12743/72*ep+414557/864*ep^2-14012279/10368*ep^3
  +347829317/124416*ep^4-10748954831/1492992*ep^5;
fill mncT11(-5,6) =
  259/12-5/2*ep^-1-26179/240*ep+5674733/14400*ep^2-1023344371/
  864000*ep^3+158892462077/51840000*ep^4-22936759409299/3110400000*
  ep^5;
fill mncT11(-5,7) =
  71/30-1/6*ep^-1-60467/3600*ep+17415031/216000*ep^2-773765929/
  2592000*ep^3+715830606667/777600000*ep^4-116118457957877/46656000000
  *ep^5;
fill mncT11(-5,8) =
  1/84-1961/8820*ep+14678609/7408800*ep^2-35755774219/3111696000*
  ep^3+13000149370291/261382464000*ep^4-95609558172939007/
  548903174400000*ep^5;
fill mncT11(-5,9) =
  1/1176*ep-13513/987840*ep^2+11790271/118540800*ep^3-304304606929/
  697019904000*ep^4+148251273664517/117099343872000*ep^5;
fill mncT11(-5,10) =
  1/42336*ep-27589/106686720*ep^2+34849789/38407219200*ep^3+
  317044794767/677503346688000*ep^4-5172935456652193/341461686730752000*
  ep^5;
fill mncT11(-4,-6) =
  1/856215360*ep+1349351/308545767129600*ep^2+291188566637/
  22237510528564531200*ep^3+1515740361197464559/
  40067546470367572316160000*ep^4+144212179045019487639827/
  1312612822369241669077401600000*ep^5;
fill mncT11(-4,-5) =
  1/230519520*ep+14411/912857299200*ep^2+1659590243/35426166067353600*
  ep^3+94747430653571/701438088133601280000*ep^4+4854449588337788357/
  12373367874676726579200000*ep^5;
fill mncT11(-4,-4) =
  1/52390800*ep+14123/207467568000*ep^2+8083406479/40257006894720000*
  ep^3+92187701272739/159417747303091200000*ep^4+51962531752521149719/
  30933419686691816448000000*ep^5;
fill mncT11(-4,-3) =
  1/9525600*ep+1279/3429216000*ep^2+66497617/60491370240000*ep^3+
  2757573631/871075731456000*ep^4+3532802670886561/384144397572096000000
  *ep^5;
fill mncT11(-4,-2) =
  1/1270080*ep+263/91445760*ep^2+69071293/8065516032000*ep^3+
  71796516667/2903585771520000*ep^4+3679611959381101/
  51219253009612800000*ep^5;
fill mncT11(-4,-1) =
  1/105840*ep+1/26460*ep^2+364073/3111696000*ep^3+63883327/
  186701760000*ep^4+546850483751/548903174400000*ep^5;
fill mncT11(-4,0) =
  1/3780*ep+71/52920*ep^2+529973/111132000*ep^3+698334139/
  46675440000*ep^4+879324400001/19603684800000*ep^5;
fill mncT11(-4,1) =
  -1/90-1/15*ep-14927/54000*ep^2-3184063/3240000*ep^3-628561811/
  194400000*ep^4-23803415627/2332800000*ep^5;
fill mncT11(-4,2) =
  -28/45-1/6*ep^-1-2789/1200*ep-1633991/216000*ep^2-310028443/
  12960000*ep^3-57229724639/777600000*ep^4-10450629954547/46656000000*
  ep^5;
fill mncT11(-4,3) =
  19/36-5/3*ep^-1-57/4*ep-223/27*ep^2-8182/81*ep^3-582373/3888*
  ep^4-2237203/2916*ep^5;
fill mncT11(-4,4) =
  73/6-10/3*ep^-1-883/18*ep+926/9*ep^2-25784/81*ep^3+103267/216*
  ep^4-4865789/2916*ep^5;
fill mncT11(-4,5) =
  37/3-5/3*ep^-1-449/8*ep+157679/864*ep^2-1769167/3456*ep^3+
  153246119/124416*ep^4-476712269/165888*ep^5;
fill mncT11(-4,6) =
  131/60-1/6*ep^-1-17149/1200*ep+13715489/216000*ep^2-946662581/
  4320000*ep^3+494298681041/777600000*ep^4-8467731288263/5184000000*
  ep^5;
fill mncT11(-4,7) =
  1/60-53/180*ep+266561/108000*ep^2-87124181/6480000*ep^3+
  21293362823/388800000*ep^4-6769202801/37324800*ep^5;
fill mncT11(-4,8) =
  1/630*ep-53/2205*ep^2+9018689/55566000*ep^3-5067714581/7779240000*
  ep^4+16436907354443/9801842400000*ep^5;
fill mncT11(-4,9) =
  1/17640*ep-563/987840*ep^2+2929291/1778112000*ep^3+9789209929/
  3485099520000*ep^4-303031735346099/8782450790400000*ep^5;
fill mncT11(-4,10) =
  1/211680*ep-3737/106686720*ep^2+3220069/192036096000*ep^3+
  1849098148199/3387516733440000*ep^4-17893832061607469/
  8536542168268800000*ep^5;
fill mncT11(-3,-6) =
  1/109771200*ep+21271/608571532800*ep^2+1781801717/16869602889216000*
  ep^3+715217051621027/2338126960445337600000*ep^4+5235259582269107603/
  5892079940322250752000000*ep^5;
fill mncT11(-3,-5) =
  1/34927200*ep+2917/27662342400*ep^2+1687155977/5367600919296000*ep^3
  +96432007853561/106278498202060800000*ep^4+54350675476108434613/
  20622279791127877632000000*ep^5;
fill mncT11(-3,-4) =
  1/9525600*ep+1279/3429216000*ep^2+66497617/60491370240000*ep^3+
  2757573631/871075731456000*ep^4+3532802670886561/384144397572096000000
  *ep^5;
fill mncT11(-3,-3) =
  1/2116800*ep+1249/762048000*ep^2+64485187/13442526720000*ep^3+
  13352658713/967861923840000*ep^4+3421865471751211/85365421682688000000
  *ep^5;
fill mncT11(-3,-2) =
  1/352800*ep+209/21168000*ep^2+600599/20744640000*ep^3+829559/
  9957427200*ep^4+885842668847/3659354496000000*ep^5;
fill mncT11(-3,-1) =
  1/37800*ep+521/5292000*ep^2+658699/2222640000*ep^3+32087681/
  37340352000*ep^4+979800893347/392073696000000*ep^5;
fill mncT11(-3,0) =
  1/1800*ep+31/12000*ep^2+18961/2160000*ep^3+698329/25920000*ep^4+
  622296697/7776000000*ep^5;
fill mncT11(-3,1) =
  -1/60-323/3600*ep-8431/24000*ep^2-5219689/4320000*ep^3-
  1010598197/259200000*ep^4-189197104081/15552000000*ep^5;
fill mncT11(-3,2) =
  -17/36-1/6*ep^-1-7/4*ep-293/54*ep^2-10979/648*ep^3-200341/
  3888*ep^4-3640769/23328*ep^5;
fill mncT11(-3,3) =
  5/3-ep^-1-9*ep+58/9*ep^2-5849/108*ep^3-3065/324*ep^4-1329407/
  3888*ep^5;
fill mncT11(-3,4) =
  35/6-ep^-1-139/6*ep+578/9*ep^2-18179/108*ep^3+233215/648*ep^4
  -3293897/3888*ep^5;
fill mncT11(-3,5) =
  47/24-1/6*ep^-1-1103/96*ep+159143/3456*ep^2-2004967/13824*ep^3
  +193964447/497664*ep^4-625422901/663552*ep^5;
fill mncT11(-3,6) =
  1/40-329/800*ep+50941/16000*ep^2-46047001/2880000*ep^3+
  3470853629/57600000*ep^4-1929124683769/10368000000*ep^5;
fill mncT11(-3,7) =
  1/300*ep-841/18000*ep^2+309163/1080000*ep^3-13185257/12960000*ep^4
  +8539596691/3888000000*ep^5;
fill mncT11(-3,8) =
  1/6300*ep-1259/882000*ep^2+3355417/1111320000*ep^3+367419121/
  31116960000*ep^4-16828556763959/196036848000000*ep^5;
fill mncT11(-3,9) =
  1/58800*ep-1793/16464000*ep^2-338951/5927040000*ep^3+1515706901/
  774466560000*ep^4-162680266832969/29274835968000000*ep^5;
fill mncT11(-3,10) =
  1/352800*ep-11797/889056000*ep^2-12737699/320060160000*ep^3+
  342043914019/1129172244480000*ep^4-5184963405893189/
  14227570280448000000*ep^5;
fill mncT11(-2,-6) =
  1/9979200*ep+22531/55324684800*ep^2+1933272617/1533600262656000*ep^3
  +781840739076527/212556996404121600000*ep^4+63017127138305883733/
  5892079940322250752000000*ep^5;
fill mncT11(-2,-5) =
  1/3810240*ep+1387/1371686400*ep^2+14843729/4839309619200*ep^3+
  77510868451/8710757314560000*ep^4+3973230536370181/
  153657759028838400000*ep^5;
fill mncT11(-2,-4) =
  1/1270080*ep+263/91445760*ep^2+69071293/8065516032000*ep^3+
  71796516667/2903585771520000*ep^4+3679611959381101/
  51219253009612800000*ep^5;
fill mncT11(-2,-3) =
  1/352800*ep+209/21168000*ep^2+600599/20744640000*ep^3+829559/
  9957427200*ep^4+885842668847/3659354496000000*ep^5;
fill mncT11(-2,-2) =
  1/75600*ep+1423/31752000*ep^2+1737677/13335840000*ep^3+419308739/
  1120210560000*ep^4+2559077496341/2352442176000000*ep^5;
fill mncT11(-2,-1) =
  1/10800*ep+209/648000*ep^2+36853/38880000*ep^3+10193/3732480*ep^4
  +1111096141/139968000000*ep^5;
fill mncT11(-2,0) =
  1/720*ep+253/43200*ep^2+49169/2592000*ep^3+8860237/155520000*ep^4
  +1566217001/9331200000*ep^5;
fill mncT11(-2,1) =
  -1/36-7/54*ep-307/648*ep^2-6101/3888*ep^3-115633/23328*ep^4-
  2138849/139968*ep^5;
fill mncT11(-2,2) =
  -5/18-1/6*ep^-1-127/108*ep-2159/648*ep^2-40519/3888*ep^3-
  727775/23328*ep^4-13187287/139968*ep^5;
fill mncT11(-2,3) =
  11/6-1/2*ep^-1-25/4*ep+97/8*ep^2-545/16*ep^3+1537/32*ep^4-
  10625/64*ep^5;
fill mncT11(-2,4) =
  5/3-1/6*ep^-1-299/36*ep+6187/216*ep^2-103013/1296*ep^3+1504375/
  7776*ep^4-20294069/46656*ep^5;
fill mncT11(-2,5) =
  1/24-179/288*ep+14881/3456*ep^2-800819/41472*ep^3+32595961/
  497664*ep^4-1102859819/5971968*ep^5;
fill mncT11(-2,6) =
  1/120*ep-757/7200*ep^2+242359/432000*ep^3-43044433/25920000*ep^4
  +4074665071/1555200000*ep^5;
fill mncT11(-2,7) =
  1/1800*ep-461/108000*ep^2+3287/720000*ep^3+3937531/77760000*ep^4
  -5571523609/23328000000*ep^5;
fill mncT11(-2,8) =
  1/12600*ep-2167/5292000*ep^2-1838653/2222640000*ep^3+1565353577/
  186701760000*ep^4-1969039700503/130691232000000*ep^5;
fill mncT11(-2,9) =
  1/58800*ep-2929/49392000*ep^2-210289/658560000*ep^3+10265988779/
  6970199040000*ep^4-7503545288719/29274835968000000*ep^5;
fill mncT11(-2,10) =
  1/211680*ep-1133/106686720*ep^2-20839151/192036096000*ep^3+
  1005421668539/3387516733440000*ep^4+3636684674926231/
  8536542168268800000*ep^5;
fill mncT11(-1,-6) =
  1/544320*ep+11509/1371686400*ep^2+19034489/691329945600*ep^3+
  716347562557/8710757314560000*ep^4+5281738326720781/
  21951108432691200000*ep^5;
fill mncT11(-1,-5) =
  1/254016*ep+1543/91445760*ep^2+86761273/1613103206400*ep^3+
  92265059071/580717154304000*ep^4+189942040247089/409754024076902400*
  ep^5;
fill mncT11(-1,-4) =
  1/105840*ep+1/26460*ep^2+364073/3111696000*ep^3+63883327/
  186701760000*ep^4+546850483751/548903174400000*ep^5;
fill mncT11(-1,-3) =
  1/37800*ep+521/5292000*ep^2+658699/2222640000*ep^3+32087681/
  37340352000*ep^4+979800893347/392073696000000*ep^5;
fill mncT11(-1,-2) =
  1/10800*ep+209/648000*ep^2+36853/38880000*ep^3+10193/3732480*ep^4
  +1111096141/139968000000*ep^5;
fill mncT11(-1,-1) =
  1/2160*ep+203/129600*ep^2+35419/7776000*ep^3+6106487/466560000*
  ep^4+1064948251/27993600000*ep^5;
fill mncT11(-1,0) =
  1/216*ep+23/1296*ep^2+427/7776*ep^3+7547/46656*ep^4+132547/
  279936*ep^5;
fill mncT11(-1,1) =
  -1/18-23/108*ep-463/648*ep^2-8807/3888*ep^3-163039/23328*ep^4
  -2977367/139968*ep^5;
fill mncT11(-1,2) =
  -1/6*ep^-1-2/3*ep-4/3*ep^2-14/3*ep^3-40/3*ep^4-122/3*ep^5;
fill mncT11(-1,3) =
  5/4-1/6*ep^-1-37/8*ep+197/16*ep^2-901/32*ep^3+3845/64*ep^4-
  15877/128*ep^5;
fill mncT11(-1,4) =
  1/12-77/72*ep+2683/432*ep^2-60473/2592*ep^3+1053499/15552*ep^4
  -15759953/93312*ep^5;
fill mncT11(-1,5) =
  1/36*ep-43/144*ep^2+6583/5184*ep^3-55583/20736*ep^4+1116007/
  746496*ep^5;
fill mncT11(-1,6) =
  1/360*ep-119/7200*ep^2-12041/1296000*ep^3+6722789/25920000*ep^4-
  3468808529/4665600000*ep^5;
fill mncT11(-1,7) =
  1/1800*ep-211/108000*ep^2-62167/6480000*ep^3+3518981/77760000*ep^4
  -169501453/7776000000*ep^5;
fill mncT11(-1,8) =
  1/6300*ep-401/1323000*ep^2-2005079/555660000*ep^3+391786789/
  46675440000*ep^4+154028720287/10890936000000*ep^5;
fill mncT11(-1,9) =
  1/17640*ep-121/2963520*ep^2-2512789/1778112000*ep^3+15188895707/
  10455298560000*ep^4+2773974518263/325275955200000*ep^5;
fill mncT11(-1,10) =
  1/42336*ep+551/106686720*ep^2-23198471/38407219200*ep^3+
  34557361427/677503346688000*ep^4+1401049384583171/341461686730752000*
  ep^5;
fill mncT11(0,-6) =
  1/12096*ep+14701/30481920*ep^2+142493173/76814438400*ep^3+
  1175022146197/193572384768000*ep^4+362229416590381/19512096384614400*
  ep^5;
fill mncT11(0,-5) =
  1/7056*ep+41/52920*ep^2+198451/69148800*ep^3+38167517/4148928000*
  ep^4+13589568749/487913932800*ep^5;
fill mncT11(0,-4) =
  1/3780*ep+71/52920*ep^2+529973/111132000*ep^3+698334139/
  46675440000*ep^4+879324400001/19603684800000*ep^5;
fill mncT11(0,-3) =
  1/1800*ep+31/12000*ep^2+18961/2160000*ep^3+698329/25920000*ep^4+
  622296697/7776000000*ep^5;
fill mncT11(0,-2) =
  1/720*ep+253/43200*ep^2+49169/2592000*ep^3+8860237/155520000*ep^4
  +1566217001/9331200000*ep^5;
fill mncT11(0,-1) =
  1/216*ep+23/1296*ep^2+427/7776*ep^3+7547/46656*ep^4+132547/
  279936*ep^5;
fill mncT11(0,0) =
  1/36*ep+23/216*ep^2+427/1296*ep^3+7547/7776*ep^4+132547/46656*
  ep^5;
fill mncT11(0,1) =
  -1/6-1/2*ep-3/2*ep^2-9/2*ep^3-27/2*ep^4-81/2*ep^5;
fill mncT11(0,2) =
  1/2-1/6*ep^-1-1/2*ep+1/2*ep^2-1/2*ep^3+1/2*ep^4-1/2*ep^5;
fill mncT11(0,3) =
  1/4-19/8*ep+151/16*ep^2-799/32*ep^3+3631/64*ep^4-15439/128*
  ep^5;
fill mncT11(0,4) =
  1/6*ep-47/36*ep^2+697/216*ep^3-2123/1296*ep^4-85583/7776*ep^5;
fill mncT11(0,5) =
  1/36*ep-13/144*ep^2-2147/5184*ep^3+36787/20736*ep^4-1243883/
  746496*ep^5;
fill mncT11(0,6) =
  1/120*ep-19/2400*ep^2-79541/432000*ep^3+676763/2880000*ep^4+
  1092053971/1555200000*ep^5;
fill mncT11(0,7) =
  1/300*ep+17/9000*ep^2-14077/180000*ep^3-119341/6480000*ep^4+
  813955783/1944000000*ep^5;
fill mncT11(0,8) =
  1/630*ep+71/26460*ep^2-2011631/55566000*ep^3-1183313023/
  23337720000*ep^4+68567159309/363031200000*ep^5;
fill mncT11(0,9) =
  1/1176*ep+2167/987840*ep^2-2147569/118540800*ep^3-30974065249/
  697019904000*ep^4+1001999162669/13011038208000*ep^5;
fill mncT11(0,10) =
  1/2016*ep+1193/725760*ep^2-123315497/12802406400*ep^3-
  1087179659173/32262064128000*ep^4+60277238568413/2322868617216000*ep^5
  ;
fill mncT11(1,-6) =
  -1/168-491/11760*ep-2809459/14817600*ep^2-164251523/230496000*
  ep^3-9394096633/3872332800*ep^4-953372760821057/121978483200000*ep^5
  ;
fill mncT11(1,-5) =
  -1/126-1373/26460*ep-278951/1234800*ep^2-428917169/518616000*
  ep^3-24133350683/8712748800*ep^4-808252068538657/91483862400000*ep^5
  ;
fill mncT11(1,-4) =
  -1/90-1/15*ep-14927/54000*ep^2-3184063/3240000*ep^3-628561811/
  194400000*ep^4-23803415627/2332800000*ep^5;
fill mncT11(1,-3) =
  -1/60-323/3600*ep-8431/24000*ep^2-5219689/4320000*ep^3-
  1010598197/259200000*ep^4-189197104081/15552000000*ep^5;
fill mncT11(1,-2) =
  -1/36-7/54*ep-307/648*ep^2-6101/3888*ep^3-115633/23328*ep^4-
  2138849/139968*ep^5;
fill mncT11(1,-1) =
  -1/18-23/108*ep-463/648*ep^2-8807/3888*ep^3-163039/23328*ep^4
  -2977367/139968*ep^5;
fill mncT11(1,0) =
  -1/6-1/2*ep-3/2*ep^2-9/2*ep^3-27/2*ep^4-81/2*ep^5;
fill mncT11(1,1) =
  1/3*ep^-1;
fill mncT11(1,2) =
  5/2-1/2*ep^-1-5/2*ep+5/2*ep^2-5/2*ep^3+5/2*ep^4-5/2*ep^5;
fill mncT11(1,3) =
  -1+9/2*ep-1/4*ep^2-111/8*ep^3+719/16*ep^4-3471/32*ep^5;
fill mncT11(1,4) =
  -1/3+1/9*ep+331/54*ep^2-1391/324*ep^3-14147/1944*ep^4+345409/
  11664*ep^5;
fill mncT11(1,5) =
  -1/6-7/24*ep+2759/864*ep^2+4931/1152*ep^3-1045681/124416*ep^4
  +3278833/497664*ep^5;
fill mncT11(1,6) =
  -1/10-47/150*ep+30253/18000*ep^2+5658839/1080000*ep^3-
  104471693/64800000*ep^4-13141480309/3888000000*ep^5;
fill mncT11(1,7) =
  -1/15-5/18*ep+8173/9000*ep^2+7556441/1620000*ep^3+241319777/
  97200000*ep^4-1397739257/388800000*ep^5;
fill mncT11(1,8) =
  -1/21-524/2205*ep+902201/1852200*ep^2+3014463589/777924000*ep^3
  +1208942969/268912000*ep^4-57410968341421/45741931200000*ep^5;
fill mncT11(1,9) =
  -1/28-227/1120*ep+4829183/19756800*ep^2+17493523283/5531904000*
  ep^3+2131548126517/398297088000*ep^4+1653666696353377/
  1301103820800000*ep^5;
fill mncT11(1,10) =
  -1/36-493/2835*ep+11263261/114307200*ep^2+741728374799/
  288054144000*ep^3+812764988352467/145179288576000*ep^4+
  6149677687096924787/1829259036057600000*ep^5;
fill mncT11(2,-6) =
  -89/105-1/6*ep^-1-1805329/529200*ep-97649753/8232000*ep^2-
  2971437071/76832000*ep^3-528741075088307/4356374400000*ep^4-
  683016375960851521/1829677248000000*ep^5;
fill mncT11(2,-5) =
  -67/90-1/6*ep^-1-10367/3600*ep-699593/72000*ep^2-26955169/
  864000*ep^3-25135874401/259200000*ep^4-4614144435149/15552000000*
  ep^5;
fill mncT11(2,-4) =
  -28/45-1/6*ep^-1-2789/1200*ep-1633991/216000*ep^2-310028443/
  12960000*ep^3-57229724639/777600000*ep^4-10450629954547/46656000000*
  ep^5;
fill mncT11(2,-3) =
  -17/36-1/6*ep^-1-7/4*ep-293/54*ep^2-10979/648*ep^3-200341/
  3888*ep^4-3640769/23328*ep^5;
fill mncT11(2,-2) =
  -5/18-1/6*ep^-1-127/108*ep-2159/648*ep^2-40519/3888*ep^3-
  727775/23328*ep^4-13187287/139968*ep^5;
fill mncT11(2,-1) =
  -1/6*ep^-1-2/3*ep-4/3*ep^2-14/3*ep^3-40/3*ep^4-122/3*ep^5;
fill mncT11(2,0) =
  1/2-1/6*ep^-1-1/2*ep+1/2*ep^2-1/2*ep^3+1/2*ep^4-1/2*ep^5;
fill mncT11(2,1) =
  5/2-1/2*ep^-1-5/2*ep+5/2*ep^2-5/2*ep^3+5/2*ep^4-5/2*ep^5;
fill mncT11(2,2) =
  3-ep^-1+7*ep-17*ep^2+27*ep^3-37*ep^4+47*ep^5;
fill mncT11(2,3) =
  -ep^-1+37/2*ep-27/4*ep^2-209/8*ep^3+1305/16*ep^4-5513/32*
  ep^5;
fill mncT11(2,4) =
  -5/3-ep^-1+343/18*ep+2581/108*ep^2-30839/648*ep^3+175645/
  3888*ep^4-564887/23328*ep^5;
fill mncT11(2,5) =
  -17/6-ep^-1+1249/72*ep+40177/864*ep^2-251579/10368*ep^3-
  1938527/124416*ep^4+60671869/1492992*ep^5;
fill mncT11(2,6) =
  -56/15-ep^-1+26869/1800*ep+6747947/108000*ep^2+99246511/
  6480000*ep^3-16902461257/388800000*ep^4+700982831959/23328000000*
  ep^5;
fill mncT11(2,7) =
  -67/15-ep^-1+7363/600*ep+7963583/108000*ep^2+77642911/1296000*
  ep^3-4851581503/129600000*ep^4-72804350141/23328000000*ep^5;
fill mncT11(2,8) =
  -178/35-ep^-1+843481/88200*ep+1007464943/12348000*ep^2+
  326316812099/3111696000*ep^3-3321224463607/726062400000*ep^4-
  81840394319902889/2744515872000000*ep^5;
fill mncT11(2,9) =
  -787/140-ep^-1+2427349/352800*ep+8586842269/98784000*ep^2+
  7377872489189/49787136000*ep^3+373227039620317/7744665600000*ep^4-
  6457306438212806471/175649015808000000*ep^5;
fill mncT11(2,10) =
  -3839/630-ep^-1+13517821/3175200*ep+722967654779/8001504000*ep^2
  +762299414847911/4032758016000*ep^3+5863782749601411287/
  50812751001600000*ep^4-2410867506661744804829/128048132524032000000*
  ep^5;
fill mncT11(3,-6) =
  -53/10-7/2*ep^-1-132547/3600*ep-5766373/72000*ep^2-94663519/
  288000*ep^3-73265935007/86400000*ep^4-14991092330803/5184000000*ep^5
  ;
fill mncT11(3,-5) =
  -7/4-5/2*ep^-1-16687/720*ep-515657/14400*ep^2-54125287/288000*
  ep^3-7162742651/17280000*ep^4-1628632766623/1036800000*ep^5;
fill mncT11(3,-4) =
  19/36-5/3*ep^-1-57/4*ep-223/27*ep^2-8182/81*ep^3-582373/3888*
  ep^4-2237203/2916*ep^5;
fill mncT11(3,-3) =
  5/3-ep^-1-9*ep+58/9*ep^2-5849/108*ep^3-3065/324*ep^4-1329407/
  3888*ep^5;
fill mncT11(3,-2) =
  11/6-1/2*ep^-1-25/4*ep+97/8*ep^2-545/16*ep^3+1537/32*ep^4-
  10625/64*ep^5;
fill mncT11(3,-1) =
  5/4-1/6*ep^-1-37/8*ep+197/16*ep^2-901/32*ep^3+3845/64*ep^4-
  15877/128*ep^5;
fill mncT11(3,0) =
  1/4-19/8*ep+151/16*ep^2-799/32*ep^3+3631/64*ep^4-15439/128*
  ep^5;
fill mncT11(3,1) =
  -1+9/2*ep-1/4*ep^2-111/8*ep^3+719/16*ep^4-3471/32*ep^5;
fill mncT11(3,2) =
  -ep^-1+37/2*ep-27/4*ep^2-209/8*ep^3+1305/16*ep^4-5513/32*
  ep^5;
fill mncT11(3,3) =
  -3/2-3*ep^-1+225/4*ep+57/8*ep^2-1635/16*ep^3+6957/32*ep^4-
  24375/64*ep^5;
fill mncT11(3,4) =
  -15/2-6*ep^-1+449/4*ep+2363/24*ep^2-33247/144*ep^3+257735/
  864*ep^4-1975171/5184*ep^5;
fill mncT11(3,5) =
  -58/3-10*ep^-1+6497/36*ep+126887/432*ep^2-1603513/5184*ep^3+
  13345907/62208*ep^4-160892713/746496*ep^5;
fill mncT11(3,6) =
  -38-15*ep^-1+30613/120*ep+4364099/7200*ep^2-100543913/432000*
  ep^3-73359169/25920000*ep^4-101532208097/1555200000*ep^5;
fill mncT11(3,7) =
  -643/10-21*ep^-1+198433/600*ep+37491071/36000*ep^2+40354283/
  432000*ep^3-31200286513/129600000*ep^4-456002246177/7776000000*ep^5;
fill mncT11(3,8) =
  -989/10-28*ep^-1+2534177/6300*ep+1411806601/882000*ep^2+
  167103911539/222264000*ep^3-5874194518813/17287200000*ep^4-
  44948630072541313/196036848000000*ep^5;
fill mncT11(3,9) =
  -4983/35-36*ep^-1+4556749/9800*ep+18784846207/8232000*ep^2+
  2508753664829/1382976000*ep^3-667379229950441/5808499200000*ep^4-
  2514512912366469071/4879139328000000*ep^5;
fill mncT11(3,10) =
  -2733/14-45*ep^-1+12100511/23520*ep+36522506621/11854080*ep^2+
  499108024384793/149361408000*ep^3+238057627322242549/376390748160000*
  ep^4-730345405419777932839/948504685363200000*ep^5;
fill mncT11(4,-6) =
  19-35/2*ep^-1-127459/720*ep+746551/14400*ep^2-117119053/96000*
  ep^3-12251704507/17280000*ep^4-2900897885237/345600000*ep^5;
fill mncT11(4,-5) =
  655/36-25/3*ep^-1-3409/36*ep+3161/27*ep^2-49598/81*ep^3+
  1147271/3888*ep^4-2667887/729*ep^5;
fill mncT11(4,-4) =
  73/6-10/3*ep^-1-883/18*ep+926/9*ep^2-25784/81*ep^3+103267/216*
  ep^4-4865789/2916*ep^5;
fill mncT11(4,-3) =
  35/6-ep^-1-139/6*ep+578/9*ep^2-18179/108*ep^3+233215/648*ep^4
  -3293897/3888*ep^5;
fill mncT11(4,-2) =
  5/3-1/6*ep^-1-299/36*ep+6187/216*ep^2-103013/1296*ep^3+1504375/
  7776*ep^4-20294069/46656*ep^5;
fill mncT11(4,-1) =
  1/12-77/72*ep+2683/432*ep^2-60473/2592*ep^3+1053499/15552*ep^4
  -15759953/93312*ep^5;
fill mncT11(4,0) =
  1/6*ep-47/36*ep^2+697/216*ep^3-2123/1296*ep^4-85583/7776*ep^5;
fill mncT11(4,1) =
  -1/3+1/9*ep+331/54*ep^2-1391/324*ep^3-14147/1944*ep^4+345409/
  11664*ep^5;
fill mncT11(4,2) =
  -5/3-ep^-1+343/18*ep+2581/108*ep^2-30839/648*ep^3+175645/
  3888*ep^4-564887/23328*ep^5;
fill mncT11(4,3) =
  -15/2-6*ep^-1+449/4*ep+2363/24*ep^2-33247/144*ep^3+257735/
  864*ep^4-1975171/5184*ep^5;
fill mncT11(4,4) =
  -91/3-20*ep^-1+6647/18*ep+46397/108*ep^2-463897/648*ep^3+
  2998481/3888*ep^4-21706837/23328*ep^5;
fill mncT11(4,5) =
  -95-50*ep^-1+32401/36*ep+206587/144*ep^2-7720667/5184*ep^3+
  23993707/20736*ep^4-1006400483/746496*ep^5;
fill mncT11(4,6) =
  -241-105*ep^-1+218491/120*ep+27182593/7200*ep^2-912704891/
  432000*ep^3+25055078317/25920000*ep^4-2377547244179/1555200000*ep^5;
fill mncT11(4,7) =
  -5243/10-196*ep^-1+2917037/900*ep+150586423/18000*ep^2-
  973581653/648000*ep^3-2685625673/21600000*ep^4-21233987539753/
  11664000000*ep^5;
fill mncT11(4,8) =
  -5094/5-336*ep^-1+2757512/525*ep+1203147311/73500*ep^2+
  41798420893/18522000*ep^3-23640276255767/12965400000*ep^4-
  48468564911944603/16336404000000*ep^5;
fill mncT11(4,9) =
  -12723/7-540*ep^-1+15515811/1960*ep+9610794797/329280*ep^2+
  5562667894709/460992000*ep^3-3161052127785863/1161699840000*ep^4-
  1879943028022084523/325275955200000*ep^5;
fill mncT11(4,10) =
  -42475/14-825*ep^-1+158826085/14112*ep+1722812465123/35562240*
  ep^2+2862905548098763/89616844800*ep^3+51383427764068223/
  225834448896000*ep^4-6023904889151281594517/569102811217920000*ep^5;
fill mncT11(5,-6) =
  1865/18-175/6*ep^-1-65051/144*ep+552703/576*ep^2-21762941/6912*
  ep^3+393823703/82944*ep^4-17125296709/995328*ep^5;
fill mncT11(5,-5) =
  85/2-25/3*ep^-1-12743/72*ep+414557/864*ep^2-14012279/10368*ep^3
  +347829317/124416*ep^4-10748954831/1492992*ep^5;
fill mncT11(5,-4) =
  37/3-5/3*ep^-1-449/8*ep+157679/864*ep^2-1769167/3456*ep^3+
  153246119/124416*ep^4-476712269/165888*ep^5;
fill mncT11(5,-3) =
  47/24-1/6*ep^-1-1103/96*ep+159143/3456*ep^2-2004967/13824*ep^3
  +193964447/497664*ep^4-625422901/663552*ep^5;
fill mncT11(5,-2) =
  1/24-179/288*ep+14881/3456*ep^2-800819/41472*ep^3+32595961/
  497664*ep^4-1102859819/5971968*ep^5;
fill mncT11(5,-1) =
  1/36*ep-43/144*ep^2+6583/5184*ep^3-55583/20736*ep^4+1116007/
  746496*ep^5;
fill mncT11(5,0) =
  1/36*ep-13/144*ep^2-2147/5184*ep^3+36787/20736*ep^4-1243883/
  746496*ep^5;
fill mncT11(5,1) =
  -1/6-7/24*ep+2759/864*ep^2+4931/1152*ep^3-1045681/124416*ep^4
  +3278833/497664*ep^5;
fill mncT11(5,2) =
  -17/6-ep^-1+1249/72*ep+40177/864*ep^2-251579/10368*ep^3-
  1938527/124416*ep^4+60671869/1492992*ep^5;
fill mncT11(5,3) =
  -58/3-10*ep^-1+6497/36*ep+126887/432*ep^2-1603513/5184*ep^3+
  13345907/62208*ep^4-160892713/746496*ep^5;
fill mncT11(5,4) =
  -95-50*ep^-1+32401/36*ep+206587/144*ep^2-7720667/5184*ep^3+
  23993707/20736*ep^4-1006400483/746496*ep^5;
fill mncT11(5,5) =
  -1455/4-175*ep^-1+446189/144*ep+1074551/192*ep^2-92479423/
  20736*ep^3+81031771/27648*ep^4-11094823867/2985984*ep^5;
fill mncT11(5,6) =
  -4557/4-490*ep^-1+6086473/720*ep+28575877/1600*ep^2-
  23703069623/2592000*ep^3+75358338539/17280000*ep^4-69528709761587/
  9331200000*ep^5;
fill mncT11(5,7) =
  -15239/5-1176*ep^-1+1961923/100*ep+871210943/18000*ep^2-
  2501501699/216000*ep^3+57388478537/21600000*ep^4-52691121964811/
  3888000000*ep^5;
fill mncT11(5,8) =
  -7207-2520*ep^-1+16965961/420*ep+4066003721/35280*ep^2+
  88549370213/74088000*ep^3-51961797853837/10372320000*ep^4-
  112317791140034653/4356374400000*ep^5;
fill mncT11(5,9) =
  -108175/7-4950*ep^-1+178300085/2352*ep+489246542041/1975680*ep^2
  +97721162938507/1659571200*ep^3-7710456819734617/464679936000*ep^4
  -20412668993201052719/390331146240000*ep^5;
fill mncT11(5,10) =
  -428725/14-9075*ep^-1+1863930935/14112*ep+17420500082353/
  35562240*ep^2+19591470539173193/89616844800*ep^3-3490364875570682747/
  225834448896000*ep^4-59881195837843542836887/569102811217920000*ep^5;
fill mncT11(6,-6) =
  1313/12-35/2*ep^-1-117053/240*ep+7250177/4800*ep^2-1244217599/
  288000*ep^3+174112515313/17280000*ep^4-25434137985631/1036800000*
  ep^5;
fill mncT11(6,-5) =
  259/12-5/2*ep^-1-26179/240*ep+5674733/14400*ep^2-1023344371/
  864000*ep^3+158892462077/51840000*ep^4-22936759409299/3110400000*
  ep^5;
fill mncT11(6,-4) =
  131/60-1/6*ep^-1-17149/1200*ep+13715489/216000*ep^2-946662581/
  4320000*ep^3+494298681041/777600000*ep^4-8467731288263/5184000000*
  ep^5;
fill mncT11(6,-3) =
  1/40-329/800*ep+50941/16000*ep^2-46047001/2880000*ep^3+
  3470853629/57600000*ep^4-1929124683769/10368000000*ep^5;
fill mncT11(6,-2) =
  1/120*ep-757/7200*ep^2+242359/432000*ep^3-43044433/25920000*ep^4
  +4074665071/1555200000*ep^5;
fill mncT11(6,-1) =
  1/360*ep-119/7200*ep^2-12041/1296000*ep^3+6722789/25920000*ep^4-
  3468808529/4665600000*ep^5;
fill mncT11(6,0) =
  1/120*ep-19/2400*ep^2-79541/432000*ep^3+676763/2880000*ep^4+
  1092053971/1555200000*ep^5;
fill mncT11(6,1) =
  -1/10-47/150*ep+30253/18000*ep^2+5658839/1080000*ep^3-
  104471693/64800000*ep^4-13141480309/3888000000*ep^5;
fill mncT11(6,2) =
  -56/15-ep^-1+26869/1800*ep+6747947/108000*ep^2+99246511/
  6480000*ep^3-16902461257/388800000*ep^4+700982831959/23328000000*
  ep^5;
fill mncT11(6,3) =
  -38-15*ep^-1+30613/120*ep+4364099/7200*ep^2-100543913/432000*
  ep^3-73359169/25920000*ep^4-101532208097/1555200000*ep^5;
fill mncT11(6,4) =
  -241-105*ep^-1+218491/120*ep+27182593/7200*ep^2-912704891/
  432000*ep^3+25055078317/25920000*ep^4-2377547244179/1555200000*ep^5;
fill mncT11(6,5) =
  -4557/4-490*ep^-1+6086473/720*ep+28575877/1600*ep^2-
  23703069623/2592000*ep^3+75358338539/17280000*ep^4-69528709761587/
  9331200000*ep^5;
fill mncT11(6,6) =
  -8673/2-1764*ep^-1+5986513/200*ep+821439983/12000*ep^2-
  18129375839/720000*ep^3+421716164459/43200000*ep^4-2440992111923/
  103680000*ep^5;
fill mncT11(6,7) =
  -139503/10-5292*ep^-1+17533043/200*ep+886911423/4000*ep^2-
  30367486541/720000*ep^3+82520804861/8640000*ep^4-17712342624601/
  288000000*ep^5;
fill mncT11(6,8) =
  -78521/2-13860*ep^-1+187205549/840*ep+221181512717/352800*ep^2
  -115715020399/29635200*ep^3-289203450863189/20744640000*ep^4-
  1302317090554369133/8712748800000*ep^5;
fill mncT11(6,9) =
  -1388409/14-32670*ep^-1+1989252439/3920*ep+5225117077949/3292800
  *ep^2+152407746348439/553190400*ep^3-57305585470090057/774466560000*
  ep^4-229501098284133484783/650551910400000*ep^5;
fill mncT11(6,10) =
  -1604691/7-70785*ep^-1+24874620107/23520*ep+217302808748161/
  59270400*ep^2+37867626431250733/29872281600*ep^3-
  44685664886587404371/376390748160000*ep^4-759955588865113975328047/
  948504685363200000*ep^5;
fill mncT11(7,-6) =
  2027/60-7/2*ep^-1-74183/400*ep+5800583/8000*ep^2-222102029/96000
  *ep^3+546926396573/86400000*ep^4-81787562480723/5184000000*ep^5;
fill mncT11(7,-5) =
  71/30-1/6*ep^-1-60467/3600*ep+17415031/216000*ep^2-773765929/
  2592000*ep^3+715830606667/777600000*ep^4-116118457957877/46656000000
  *ep^5;
fill mncT11(7,-4) =
  1/60-53/180*ep+266561/108000*ep^2-87124181/6480000*ep^3+
  21293362823/388800000*ep^4-6769202801/37324800*ep^5;
fill mncT11(7,-3) =
  1/300*ep-841/18000*ep^2+309163/1080000*ep^3-13185257/12960000*ep^4
  +8539596691/3888000000*ep^5;
fill mncT11(7,-2) =
  1/1800*ep-461/108000*ep^2+3287/720000*ep^3+3937531/77760000*ep^4
  -5571523609/23328000000*ep^5;
fill mncT11(7,-1) =
  1/1800*ep-211/108000*ep^2-62167/6480000*ep^3+3518981/77760000*ep^4
  -169501453/7776000000*ep^5;
fill mncT11(7,0) =
  1/300*ep+17/9000*ep^2-14077/180000*ep^3-119341/6480000*ep^4+
  813955783/1944000000*ep^5;
fill mncT11(7,1) =
  -1/15-5/18*ep+8173/9000*ep^2+7556441/1620000*ep^3+241319777/
  97200000*ep^4-1397739257/388800000*ep^5;
fill mncT11(7,2) =
  -67/15-ep^-1+7363/600*ep+7963583/108000*ep^2+77642911/1296000*
  ep^3-4851581503/129600000*ep^4-72804350141/23328000000*ep^5;
fill mncT11(7,3) =
  -643/10-21*ep^-1+198433/600*ep+37491071/36000*ep^2+40354283/
  432000*ep^3-31200286513/129600000*ep^4-456002246177/7776000000*ep^5;
fill mncT11(7,4) =
  -5243/10-196*ep^-1+2917037/900*ep+150586423/18000*ep^2-
  973581653/648000*ep^3-2685625673/21600000*ep^4-21233987539753/
  11664000000*ep^5;
fill mncT11(7,5) =
  -15239/5-1176*ep^-1+1961923/100*ep+871210943/18000*ep^2-
  2501501699/216000*ep^3+57388478537/21600000*ep^4-52691121964811/
  3888000000*ep^5;
fill mncT11(7,6) =
  -139503/10-5292*ep^-1+17533043/200*ep+886911423/4000*ep^2-
  30367486541/720000*ep^3+82520804861/8640000*ep^4-17712342624601/
  288000000*ep^5;
fill mncT11(7,7) =
  -532091/10-19404*ep^-1+63271401/200*ep+3391764741/4000*ep^2-
  160369010221/2160000*ep^3+45079119479/8640000*ep^4-562005021127483/
  2592000000*ep^5;
fill mncT11(7,8) =
  -878053/5-60984*ep^-1+1021262989/1050*ep+1237038993709/441000*
  ep^2+6809609127931/61740000*ep^3-366227813869447/5186160000*ep^4-
  2411323300828693423/3630312000000*ep^5;
fill mncT11(7,9) =
  -18034071/35-169884*ep^-1+25853745639/9800*ep+22610051516631/
  2744000*ep^2+9993527473165147/6914880000*ep^3-120104412190290221/
  387233280000*ep^4-3028135184250064568279/1626379776000000*ep^5;
fill mncT11(7,10) =
  -6857708/5-429429*ep^-1+325970190527/50400*ep+2784773997117157/
  127008000*ep^2+314001610292351747/45722880000*ep^3-
  95626190195515256131/161310320640000*ep^4-9860721257991817665174811/
  2032510040064000000*ep^5;
fill mncT11(8,-6) =
  353/140-1/6*ep^-1-373727/19600*ep+800940667/8232000*ep^2-
  29289691863/76832000*ep^3+5385992171933273/4356374400000*ep^4-
  709521618026979929/203297472000000*ep^5;
fill mncT11(8,-5) =
  1/84-1961/8820*ep+14678609/7408800*ep^2-35755774219/3111696000*
  ep^3+13000149370291/261382464000*ep^4-95609558172939007/
  548903174400000*ep^5;
fill mncT11(8,-4) =
  1/630*ep-53/2205*ep^2+9018689/55566000*ep^3-5067714581/7779240000*
  ep^4+16436907354443/9801842400000*ep^5;
fill mncT11(8,-3) =
  1/6300*ep-1259/882000*ep^2+3355417/1111320000*ep^3+367419121/
  31116960000*ep^4-16828556763959/196036848000000*ep^5;
fill mncT11(8,-2) =
  1/12600*ep-2167/5292000*ep^2-1838653/2222640000*ep^3+1565353577/
  186701760000*ep^4-1969039700503/130691232000000*ep^5;
fill mncT11(8,-1) =
  1/6300*ep-401/1323000*ep^2-2005079/555660000*ep^3+391786789/
  46675440000*ep^4+154028720287/10890936000000*ep^5;
fill mncT11(8,0) =
  1/630*ep+71/26460*ep^2-2011631/55566000*ep^3-1183313023/
  23337720000*ep^4+68567159309/363031200000*ep^5;
fill mncT11(8,1) =
  -1/21-524/2205*ep+902201/1852200*ep^2+3014463589/777924000*ep^3
  +1208942969/268912000*ep^4-57410968341421/45741931200000*ep^5;
fill mncT11(8,2) =
  -178/35-ep^-1+843481/88200*ep+1007464943/12348000*ep^2+
  326316812099/3111696000*ep^3-3321224463607/726062400000*ep^4-
  81840394319902889/2744515872000000*ep^5;
fill mncT11(8,3) =
  -989/10-28*ep^-1+2534177/6300*ep+1411806601/882000*ep^2+
  167103911539/222264000*ep^3-5874194518813/17287200000*ep^4-
  44948630072541313/196036848000000*ep^5;
fill mncT11(8,4) =
  -5094/5-336*ep^-1+2757512/525*ep+1203147311/73500*ep^2+
  41798420893/18522000*ep^3-23640276255767/12965400000*ep^4-
  48468564911944603/16336404000000*ep^5;
fill mncT11(8,5) =
  -7207-2520*ep^-1+16965961/420*ep+4066003721/35280*ep^2+
  88549370213/74088000*ep^3-51961797853837/10372320000*ep^4-
  112317791140034653/4356374400000*ep^5;
fill mncT11(8,6) =
  -78521/2-13860*ep^-1+187205549/840*ep+221181512717/352800*ep^2
  -115715020399/29635200*ep^3-289203450863189/20744640000*ep^4-
  1302317090554369133/8712748800000*ep^5;
fill mncT11(8,7) =
  -878053/5-60984*ep^-1+1021262989/1050*ep+1237038993709/441000*
  ep^2+6809609127931/61740000*ep^3-366227813869447/5186160000*ep^4-
  2411323300828693423/3630312000000*ep^5;
fill mncT11(8,8) =
  -23526338/35-226512*ep^-1+13076140537/3675*ep+2369104264591/
  220500*ep^2+276406698978143/216090000*ep^3-1272364093560383/
  3630312000*ep^4-10493366424372887233/4235364000000*ep^5;
fill mncT11(8,9) =
  -79327391/35-736164*ep^-1+333168518807/29400*ep+894920683392109/
  24696000*ep^2+54340449286415137/6914880000*ep^3-1380763360930866373/
  1161699840000*ep^4-4426483375360648100903/542126592000000*ep^5;
fill mncT11(8,10) =
  -6878157-2147145*ep^-1+325203879839/10080*ep+558376514581289/
  5080320*ep^2+2276261966505252557/64012032000*ep^3-
  353006015772044616599/161310320640000*ep^4-1416153373047555093193573/
  58071715430400000*ep^5;
fill mncT11(9,-6) =
  1/112-5471/31360*ep+14340133/8780800*ep^2-24494628927/2458624000*
  ep^3+6237727760217/137682944000*ep^4-864838163864034797/
  5204415283200000*ep^5;
fill mncT11(9,-5) =
  1/1176*ep-13513/987840*ep^2+11790271/118540800*ep^3-304304606929/
  697019904000*ep^4+148251273664517/117099343872000*ep^5;
fill mncT11(9,-4) =
  1/17640*ep-563/987840*ep^2+2929291/1778112000*ep^3+9789209929/
  3485099520000*ep^4-303031735346099/8782450790400000*ep^5;
fill mncT11(9,-3) =
  1/58800*ep-1793/16464000*ep^2-338951/5927040000*ep^3+1515706901/
  774466560000*ep^4-162680266832969/29274835968000000*ep^5;
fill mncT11(9,-2) =
  1/58800*ep-2929/49392000*ep^2-210289/658560000*ep^3+10265988779/
  6970199040000*ep^4-7503545288719/29274835968000000*ep^5;
fill mncT11(9,-1) =
  1/17640*ep-121/2963520*ep^2-2512789/1778112000*ep^3+15188895707/
  10455298560000*ep^4+2773974518263/325275955200000*ep^5;
fill mncT11(9,0) =
  1/1176*ep+2167/987840*ep^2-2147569/118540800*ep^3-30974065249/
  697019904000*ep^4+1001999162669/13011038208000*ep^5;
fill mncT11(9,1) =
  -1/28-227/1120*ep+4829183/19756800*ep^2+17493523283/5531904000*
  ep^3+2131548126517/398297088000*ep^4+1653666696353377/
  1301103820800000*ep^5;
fill mncT11(9,2) =
  -787/140-ep^-1+2427349/352800*ep+8586842269/98784000*ep^2+
  7377872489189/49787136000*ep^3+373227039620317/7744665600000*ep^4-
  6457306438212806471/175649015808000000*ep^5;
fill mncT11(9,3) =
  -4983/35-36*ep^-1+4556749/9800*ep+18784846207/8232000*ep^2+
  2508753664829/1382976000*ep^3-667379229950441/5808499200000*ep^4-
  2514512912366469071/4879139328000000*ep^5;
fill mncT11(9,4) =
  -12723/7-540*ep^-1+15515811/1960*ep+9610794797/329280*ep^2+
  5562667894709/460992000*ep^3-3161052127785863/1161699840000*ep^4-
  1879943028022084523/325275955200000*ep^5;
fill mncT11(9,5) =
  -108175/7-4950*ep^-1+178300085/2352*ep+489246542041/1975680*ep^2
  +97721162938507/1659571200*ep^3-7710456819734617/464679936000*ep^4
  -20412668993201052719/390331146240000*ep^5;
fill mncT11(9,6) =
  -1388409/14-32670*ep^-1+1989252439/3920*ep+5225117077949/3292800
  *ep^2+152407746348439/553190400*ep^3-57305585470090057/774466560000*
  ep^4-229501098284133484783/650551910400000*ep^5;
fill mncT11(9,7) =
  -18034071/35-169884*ep^-1+25853745639/9800*ep+22610051516631/
  2744000*ep^2+9993527473165147/6914880000*ep^3-120104412190290221/
  387233280000*ep^4-3028135184250064568279/1626379776000000*ep^5;
fill mncT11(9,8) =
  -79327391/35-736164*ep^-1+333168518807/29400*ep+894920683392109/
  24696000*ep^2+54340449286415137/6914880000*ep^3-1380763360930866373/
  1161699840000*ep^4-4426483375360648100903/542126592000000*ep^5;
fill mncT11(9,9) =
  -487558929/56-2760615*ep^-1+656747596753/15680*ep+
  366565498288861/2634240*ep^2+144763052912195807/3687936000*ep^3-
  10749363204853737433/3097866240000*ep^4-8985300007371764321381/
  289134182400000*ep^5;
fill mncT11(9,10) =
  -1673149335/56-9202050*ep^-1+1289073256967/9408*ep+
  11312477611942837/23708160*ep^2+10298545085451680663/59744563200*ep^3
  -134009329612247902531/30111259852800*ep^4-
  40019532931754029975386181/379401874145280000*ep^5;
fill mncT11(10,-6) =
  1/2016*ep-42589/5080320*ep^2+827883523/12802406400*ep^3-
  9821121950233/32262064128000*ep^4+15684812553506807/16260080320512000*
  ep^5;
fill mncT11(10,-5) =
  1/42336*ep-27589/106686720*ep^2+34849789/38407219200*ep^3+
  317044794767/677503346688000*ep^4-5172935456652193/341461686730752000*
  ep^5;
fill mncT11(10,-4) =
  1/211680*ep-3737/106686720*ep^2+3220069/192036096000*ep^3+
  1849098148199/3387516733440000*ep^4-17893832061607469/
  8536542168268800000*ep^5;
fill mncT11(10,-3) =
  1/352800*ep-11797/889056000*ep^2-12737699/320060160000*ep^3+
  342043914019/1129172244480000*ep^4-5184963405893189/
  14227570280448000000*ep^5;
fill mncT11(10,-2) =
  1/211680*ep-1133/106686720*ep^2-20839151/192036096000*ep^3+
  1005421668539/3387516733440000*ep^4+3636684674926231/
  8536542168268800000*ep^5;
fill mncT11(10,-1) =
  1/42336*ep+551/106686720*ep^2-23198471/38407219200*ep^3+
  34557361427/677503346688000*ep^4+1401049384583171/341461686730752000*
  ep^5;
fill mncT11(10,0) =
  1/2016*ep+1193/725760*ep^2-123315497/12802406400*ep^3-
  1087179659173/32262064128000*ep^4+60277238568413/2322868617216000*ep^5
  ;
fill mncT11(10,1) =
  -1/36-493/2835*ep+11263261/114307200*ep^2+741728374799/
  288054144000*ep^3+812764988352467/145179288576000*ep^4+
  6149677687096924787/1829259036057600000*ep^5;
fill mncT11(10,2) =
  -3839/630-ep^-1+13517821/3175200*ep+722967654779/8001504000*ep^2
  +762299414847911/4032758016000*ep^3+5863782749601411287/
  50812751001600000*ep^4-2410867506661744804829/128048132524032000000*
  ep^5;
fill mncT11(10,3) =
  -2733/14-45*ep^-1+12100511/23520*ep+36522506621/11854080*ep^2+
  499108024384793/149361408000*ep^3+238057627322242549/376390748160000*
  ep^4-730345405419777932839/948504685363200000*ep^5;
fill mncT11(10,4) =
  -42475/14-825*ep^-1+158826085/14112*ep+1722812465123/35562240*
  ep^2+2862905548098763/89616844800*ep^3+51383427764068223/
  225834448896000*ep^4-6023904889151281594517/569102811217920000*ep^5;
fill mncT11(10,5) =
  -428725/14-9075*ep^-1+1863930935/14112*ep+17420500082353/
  35562240*ep^2+19591470539173193/89616844800*ep^3-3490364875570682747/
  225834448896000*ep^4-59881195837843542836887/569102811217920000*ep^5;
fill mncT11(10,6) =
  -1604691/7-70785*ep^-1+24874620107/23520*ep+217302808748161/
  59270400*ep^2+37867626431250733/29872281600*ep^3-
  44685664886587404371/376390748160000*ep^4-759955588865113975328047/
  948504685363200000*ep^5;
fill mncT11(10,7) =
  -6857708/5-429429*ep^-1+325970190527/50400*ep+2784773997117157/
  127008000*ep^2+314001610292351747/45722880000*ep^3-
  95626190195515256131/161310320640000*ep^4-9860721257991817665174811/
  2032510040064000000*ep^5;
fill mncT11(10,8) =
  -6878157-2147145*ep^-1+325203879839/10080*ep+558376514581289/
  5080320*ep^2+2276261966505252557/64012032000*ep^3-
  353006015772044616599/161310320640000*ep^4-1416153373047555093193573/
  58071715430400000*ep^5;
fill mncT11(10,9) =
  -1673149335/56-9202050*ep^-1+1289073256967/9408*ep+
  11312477611942837/23708160*ep^2+10298545085451680663/59744563200*ep^3
  -134009329612247902531/30111259852800*ep^4-
  40019532931754029975386181/379401874145280000*ep^5;
fill mncT11(10,10) =
  -29016110695/252-34763300*ep^-1+64837836509717/127008*ep+
  588017945454375487/320060160*ep^2+617147766869674120613/806551603200*
  ep^3+5319449752682429703959/406502008012800*ep^4-
  2063640067151239842477253231/5121925300961280000*ep^5;
*--#] gtabls.h : 
*--#[ poch.h :
CTable,relax,mncpoch(0:15,0:10);
Fill mncpoch(0,0) = 1;
Fill mncpoch(1,0) = 1;
Fill mncpoch(2,0) = 1;
Fill mncpoch(3,0) = 1;
Fill mncpoch(3,1) =
  1/2+1/4*ep+1/8*ep^2+1/16*ep^3+1/32*ep^4+1/64*ep^5+1/128*ep^6
  ;
Fill mncpoch(4,0) = 1;
Fill mncpoch(4,1) =
  1/3+1/9*ep+1/27*ep^2+1/81*ep^3+1/243*ep^4+1/729*ep^5+1/2187*
  ep^6;
Fill mncpoch(4,2) =
  1/12+5/72*ep+19/432*ep^2+65/2592*ep^3+211/15552*ep^4+665/93312
  *ep^5+2059/559872*ep^6;
Fill mncpoch(5,0) = 1;
Fill mncpoch(5,1) =
  1/4+1/16*ep+1/64*ep^2+1/256*ep^3+1/1024*ep^4+1/4096*ep^5+1/
  16384*ep^6;
Fill mncpoch(5,2) =
  1/24+7/288*ep+37/3456*ep^2+175/41472*ep^3+781/497664*ep^4+3367/
  5971968*ep^5+14197/71663616*ep^6;
Fill mncpoch(5,3) =
  1/144+13/1728*ep+115/20736*ep^2+865/248832*ep^3+5971/2985984*
  ep^4+39193/35831808*ep^5+249355/429981696*ep^6;
Fill mncpoch(6,0) = 1;
Fill mncpoch(6,1) =
  1/5+1/25*ep+1/125*ep^2+1/625*ep^3+1/3125*ep^4+1/15625*ep^5+1/
  78125*ep^6;
Fill mncpoch(6,2) =
  1/40+9/800*ep+61/16000*ep^2+369/320000*ep^3+2101/6400000*ep^4+
  11529/128000000*ep^5+61741/2560000000*ep^6;
Fill mncpoch(6,3) =
  1/360+47/21600*ep+1489/1296000*ep^2+39743/77760000*ep^3+965041/
  4665600000*ep^4+22102367/279936000000*ep^5+487056529/16796160000000*
  ep^6;
Fill mncpoch(6,4) =
  1/2880+77/172800*ep+3799/10368000*ep^2+153713/622080000*ep^3+
  5576431/37324800000*ep^4+189395297/2239488000000*ep^5+6168915439/
  134369280000000*ep^6;
Fill mncpoch(7,0) = 1;
Fill mncpoch(7,1) =
  1/6+1/36*ep+1/216*ep^2+1/1296*ep^3+1/7776*ep^4+1/46656*ep^5+
  1/279936*ep^6;
Fill mncpoch(7,2) =
  1/60+11/1800*ep+91/54000*ep^2+671/1620000*ep^3+4651/48600000*
  ep^4+31031/1458000000*ep^5+201811/43740000000*ep^6;
Fill mncpoch(7,3) =
  1/720+37/43200*ep+919/2592000*ep^2+19153/155520000*ep^3+361711/
  9331200000*ep^4+6418657/559872000000*ep^5+109195759/33592320000000*
  ep^6;
Fill mncpoch(7,4) =
  1/8640+19/172800*ep+2059/31104000*ep^2+20111/622080000*ep^3+
  1568371/111974400000*ep^4+4198453/746496000000*ep^5+864917299/
  403107840000000*ep^6;
Fill mncpoch(7,5) =
  1/86400+29/1728000*ep+4669/311040000*ep^2+22267/2073600000*ep^3+
  7580461/1119744000000*ep^4+88399969/22394880000000*ep^5+8820914509/
  4031078400000000*ep^6;
Fill mncpoch(8,0) = 1;
Fill mncpoch(8,1) =
  1/7+1/49*ep+1/343*ep^2+1/2401*ep^3+1/16807*ep^4+1/117649*ep^5
  +1/823543*ep^6;
Fill mncpoch(8,2) =
  1/84+13/3528*ep+127/148176*ep^2+1105/6223392*ep^3+9031/261382464
  *ep^4+70993/10978063488*ep^5+543607/461078666496*ep^6;
Fill mncpoch(8,3) =
  1/1260+107/264600*ep+7669/55566000*ep^2+460223/11668860000*ep^3+
  24973741/2450460600000*ep^4+1270750247/514596726000000*ep^5+
  61865369749/108065312460000000*ep^6;
Fill mncpoch(8,4) =
  1/20160+319/8467200*ep+64171/3556224000*ep^2+10419739/
  1493614080000*ep^3+1493652451/627317913600000*ep^4+197497515259/
  263473523712000000*ep^5+24696622766131/110658879959040000000*ep^6;
Fill mncpoch(8,5) =
  1/302400+17/4704000*ep+128431/53343360000*ep^2+9466693/
  7468070400000*ep^3+5469663511/9409768704000000*ep^4+321083468933/
  1317367618560000000*ep^5+159551679717991/1659883199385600000000*ep^6;
Fill mncpoch(8,6) =
  1/3628800+223/508032000*ep+268921/640120320000*ep^2+28291163/
  89616844800000*ep^3+23293096201/112917224448000000*ep^4+650533401001/
  5269470474240000000*ep^5+1389059807609881/19918598392627200000000*ep^6;
Fill mncpoch(9,0) = 1;
Fill mncpoch(9,1) =
  1/8+1/64*ep+1/512*ep^2+1/4096*ep^3+1/32768*ep^4+1/262144*ep^5
  +1/2097152*ep^6;
Fill mncpoch(9,2) =
  1/112+15/6272*ep+169/351232*ep^2+1695/19668992*ep^3+15961/
  1101463552*ep^4+144495/61681958912*ep^5+1273609/3454189699072*ep^6;
Fill mncpoch(9,3) =
  1/2016+73/338688*ep+3565/56899584*ep^2+145585/9559130112*ep^3+
  5369221/1605933858816*ep^4+185450473/269796888281088*ep^5+6121074205/
  45325877231222784*ep^6;
Fill mncpoch(9,4) =
  1/40320+533/33868800*ep+178669/28449792000*ep^2+48214517/
  23897825280000*ep^3+11455801981/20074173235200000*ep^4+2504107460933/
  16862305517568000000*ep^5+516331837889869/14164336634757120000000*ep^6;
Fill mncpoch(9,5) =
  1/806400+743/677376000*ep+334699/568995840000*ep^2+118501307/
  477956505600000*ep^3+36341076451/401483464704000000*ep^4+
  10135733515643/337246110351360000000*ep^5+2644835876174899/
  283286732695142400000000*ep^6;
Fill mncpoch(9,6) =
  1/14515200+341/4064256000*ep+621139/10241925120000*ep^2+97473409/
  2867739033600000*ep^3+118218740011/7226702364672000000*ep^4+
  1601369656249/224830740234240000000*ep^5+14751190477417339/
  5099161188512563200000000*ep^6;
Fill mncpoch(9,7) =
  1/203212800+481/56899584000*ep+1227199/143386951680000*ep^2+
  29920141/4460927385600000*ep^3+457513138951/101173833105408000000*ep^4
  +78464166359381/28328673269514240000000*ep^5+113616040090237399/
  71388256639175884800000000*ep^6;
Fill mncpoch(10,0) = 1;
Fill mncpoch(10,1) =
  1/9+1/81*ep+1/729*ep^2+1/6561*ep^3+1/59049*ep^4+1/531441*ep^5
  +1/4782969*ep^6;
Fill mncpoch(10,2) =
  1/144+17/10368*ep+217/746496*ep^2+2465/53747712*ep^3+26281/
  3869835264*ep^4+269297/278628139008*ep^5+2685817/20061226008576*ep^6;
Fill mncpoch(10,3) =
  1/3024+191/1524096*ep+24385/768144384*ep^2+2601215/387144769536*
  ep^3+250388161/195120963846144*ep^4+22554022271/98340965778456576*
  ep^5+1939873287745/49563846752342114304*ep^6;
Fill mncpoch(10,4) =
  1/72576+275/36578304*ep+47485/18435465216*ep^2+6589955/
  9291474468864*ep^3+803944381/4682903132307456*ep^4+90085350275/
  2360183178682957824*ep^5+9507042710845/1189532322056210743296*ep^6;
Fill mncpoch(10,5) =
  1/1814400+1879/4572288000*ep+2134141/11522165760000*ep^2+
  1899351439/29035857715200000*ep^3+1459738363381/73170361442304000000*
  ep^4+1017224854753399/184389310834606080000000*ep^5+
  661228869152666221/464661063303207321600000000*ep^6;
Fill mncpoch(10,6) =
  1/43545600+2509/109734912000*ep+3714811/276531978240000*ep^2+
  4239682369/696860585164800000*ep^3+4130738255851/
  1756088674615296000000*ep^4+3619589955939529/4425343460030545920000000
  *ep^5+2941570541394569491/11151865519276975718400000000*ep^6;
Fill mncpoch(10,7) =
  1/914457600+3349/2304433152000*ep+6527971/5807171543040000*ep^2+
  9723178009/14634072288460800000*ep^3+12298207783411/
  36877862166921216000000*ep^4+13950084494004769/
  92932212660641464320000000*ep^5+14659641516358575451/
  234189175904816490086400000000*ep^6;
Fill mncpoch(10,8) =
  1/14631321600+4609/36870930432000*ep+12335311/92914744688640000*ep^2
  +25265669869/234145156615372800000*ep^3+44132951818351/
  590045794670739456000000*ep^4+69557603785127029/
  1486915402570263429120000000*ep^5+102302222285618631991/
  3747026814477063841382400000000*ep^6;
Fill mncpoch(11,0) = 1;
Fill mncpoch(11,1) =
  1/10+1/100*ep+1/1000*ep^2+1/10000*ep^3+1/100000*ep^4+1/1000000
  *ep^5+1/10000000*ep^6;
Fill mncpoch(11,2) =
  1/180+19/16200*ep+271/1458000*ep^2+3439/131220000*ep^3+40951/
  11809800000*ep^4+468559/1062882000000*ep^5+5217031/95659380000000*
  ep^6;
Fill mncpoch(11,3) =
  1/4320+121/1555200*ep+9781/559872000*ep^2+660241/201553920000*ep^3
  +40194301/72559411200000*ep^4+2288547961/26121388032000000*ep^5+
  124353617221/9403699691520000000*ep^6;
Fill mncpoch(11,4) =
  1/120960+1207/304819200*ep+913789/768144384000*ep^2+555426703/
  1935723847680000*ep^3+296460129781/4878024096153600000*ep^4+
  145189272301687/12292620722307072000000*ep^5+66898216741040749/
  30977404220213821440000000*ep^6;
Fill mncpoch(11,5) =
  1/3628800+1627/9144576000*ep+1597129/23044331520000*ep^2+
  1226220883/58071715430400000*ep^3+811472900641/146340722884608000000*
  ep^4+486007890570907/368778621669212160000000*ep^5+
  271021530780821689/929322126606414643200000000*ep^6;
Fill mncpoch(11,6) =
  1/108864000+2131/274337280000*ep+2671153/691329945600000*ep^2+
  514496399/348430292582400000*ep^3+2108003826121/4390221686538240000000
  *ep^4+1548441818935891/11063358650076364800000000*ep^5+
  1051436207524510753/27879663798192439296000000000*ep^6;
Fill mncpoch(11,7) =
  1/3048192000+2761/7681443840000*ep+4410583/19357238476800000*ep^2+
  1070229857/9756048192307200000*ep^3+5479227875671/
  122926207223070720000000*ep^4+5000355380608621/
  309774042202138214400000000*ep^5+4201660097307941983/
  780630586349388300288000000000*ep^6;
Fill mncpoch(11,8) =
  1/73156608000+3601/184354652160000*ep+7435423/464573723443200000*
  ep^2+2319380921/234145156615372800000*ep^3+15220627743871/
  2950228973353697280000000*ep^4+17785682685460261/
  7434577012851317145600000000*ep^5+19141633553094561223/
  18735134072385319206912000000000*ep^6;
Fill mncpoch(11,9) =
  1/1316818944000+4861/3318383738880000*ep+13560283/
  8362327021977600000*ep^2+5736572237/4214612819076710400000*ep^3+
  51361032836971/53104121520366551040000000*ep^4+82500584060043721/
  133822386231323708620800000000*ep^5+123092369468749649683/
  337232413302935745724416000000000*ep^6;
Fill mncpoch(12,0) = 1;
Fill mncpoch(12,1) =
  1/11+1/121*ep+1/1331*ep^2+1/14641*ep^3+1/161051*ep^4+1/1771561
  *ep^5+1/19487171*ep^6;
Fill mncpoch(12,2) =
  1/220+21/24200*ep+331/2662000*ep^2+4641/292820000*ep^3+61051/
  32210200000*ep^4+771561/3543122000000*ep^5+9487171/389743420000000*
  ep^6;
Fill mncpoch(12,3) =
  1/5940+299/5880600*ep+59701/5821794000*ep^2+9950399/5763576060000*
  ep^3+1495099501/5705940299400000*ep^4+210020850599/
  5648880896406000000*ep^5+28144165209301/5592392087441940000000*ep^6;
Fill mncpoch(12,4) =
  1/190080+1691/752716800*ep+1792261/2980758528000*ep^2+1523994731/
  11803803770880000*ep^3+1137122864101/46743062932684800000*ep^4+
  777937168743371/185102529213431808000000*ep^5+500357399225265541/
  733006015685189959680000000*ep^6;
Fill mncpoch(12,5) =
  1/6652800+15797/184415616000*ep+150376909/5112000875520000*ep^2+
  1118222752373/141704664269414400000*ep^3+7158394096103581/
  3928053293548167168000000*ep^4+41422030615640017157/
  108885637297155193896960000000*ep^5+222897788899387733574829/
  3018309865877141974823731200000000*ep^6;
Fill mncpoch(12,6) =
  1/239500800+20417/6638962176000*ep+244703449/184032031518720000*ep^2
  +2248752686753/5101367913698918400000*ep^3+17547631508902441/
  141409918567734018048000000*ep^4+122492088186769294577/
  3919882942697586980290560000000*ep^5+788811236322261874520569/
  108659155171577111093654323200000000*ep^6;
Fill mncpoch(12,7) =
  1/8382528000+25961/232363676160000*ep+388631233/6441121103155200000*
  ep^2+880664848501/35709575395892428800000*ep^3+41959661109350161/
  4949347149870690631680000000*ep^4+355116449377006587161/
  137195902994415544310169600000000*ep^5+2757576831668386393741153/
  3803070431005198888277901312000000000*ep^6;
Fill mncpoch(12,8) =
  1/268240896000+32891/7435637637120000*ep+616565863/
  206115875300966400000*ep^2+1735225134619/1142706412668557721600000*
  ep^3+102085212023898511/158379108795862100213760000000*ep^4+
  1062566968702623268391/4390268895821297417925427200000000*ep^5+
  10121165924777565643690783/121698253792166364424892841984000000000*ep^6;
Fill mncpoch(12,9) =
  1/7242504192000+42131/200762216202240000*ep+1005856303/
  5565128633126092800000*ep^2+3594047582563/30853073142051058483200000*
  ep^3+268130210338309111/4276235937488276705771520000000*ep^4+
  3540090112228599454031/118537260187175030283986534400000000*ep^5+
  42831598561769824598937223/3285852852388491839472106733568000000000*ep^6;
Fill mncpoch(12,10) =
  1/144850083840000+55991/4015244324044800000*ep+1781891563/
  111302572662521856000000*ep^2+8533450995199/
  617061462841021169664000000*ep^3+859498364305599811/
  85524718749765534115430400000000*ep^4+15452737441504212834491/
  2370745203743500605679730688000000000*ep^5+257006539501018214484982483/
  65717057047769836789442134671360000000000*ep^6;
Fill mncpoch(13,0) = 1;
Fill mncpoch(13,1) = 1/12+1/144*ep+1/1728*ep^2+1/20736*ep^3+1/248832*ep^4
  +1/2985984*ep^5+1/35831808*ep^6;
Fill mncpoch(13,2) = 1/264+23/34848*ep+397/4599936*ep^2+6095/607191552*ep^3
  +87781/80149284864*ep^4+1214423/10579705602048*ep^5+16344637/
  1396521139470336*ep^6;
Fill mncpoch(13,3) = 1/7920+181/5227200*ep+21871/3449952000*ep^2
  +2205361/2276968320000*ep^3+200416951/1502799091200000*ep^4
  +17022590641/991847400192000000*ep^5+1378875935431/654619284126720000000*ep^6;
Fill mncpoch(13,4) = 1/285120+763/564537600*ep+364699/1117784448000*ep^2
  +139778527/2213213207040000*ep^3+46985048971/4382162149939200000*ep^4
  +14473200299383/8676681056879616000000*ep^5+4189304622793459/
  17179828492621639680000000*ep^6;
Fill mncpoch(13,5) =
      1/11404800 + 2021/45163008000*ep + 2459191/178845511680000*ep^2 + 
      2335527761/708228226252800000*ep^3 + 1907847025231/
      2804583775961088000000*ep^4 + 1407526687069601/
      11106151752805908480000000*ep^5 + 964841205958233871/
      43980360941111397580800000000*ep^6;
Fill mncpoch(13,6) =
      1/479001600 + 18107/13277924352000*ep + 192204079/368064063037440000*
      ep^2 + 1562214174863/10202735827397836800000*ep^3 + 10767108840037111/
      282819837135468036096000000*ep^4 + 66294052036125743567/
      7839765885395173960581120000000*ep^5 + 376037049102838201214599/21731831\
      0343154222187308646400000000*ep^6;
Fill mncpoch(13,7) =
      1/20118067200 + 22727/557672822784000*ep + 297202819/
      15458690647572480000*ep^2 + 2935291198643/428514904750709145600000*ep^3
       + 24328154177767771/11878433159689657516032000000*ep^4 + 
      178690124337412845587/329270167186597306344407040000000*ep^5 + 
      1201585423541685547826539/9127369034412477331866963148800000000*ep^6;
Fill mncpoch(13,8) =
      1/804722688000 + 28271/22306912911360000*ep + 453937243/
      618347625902899200000*ep^2 + 1090383854767/3428119238005673164800000*
      ep^3 + 54553594631909011/475137326387586300641280000000*ep^4 + 
      481135252976716402571/13170806687463892253776281600000000*ep^5 + 
      3868999266044601283680163/365094761376499093274678525952000000000*ep^6;
Fill mncpoch(14,0) = 1;
Fill mncpoch(14,1) =
      1/13 + 1/169*ep + 1/2197*ep^2 + 1/28561*ep^3 + 1/371293*ep^4 + 1/4826809
      *ep^5 + 1/62748517*ep^6;
Fill mncpoch(14,2) =
      1/312 + 25/48672*ep + 469/7592832*ep^2 + 7825/1184481792*ep^3 + 122461/
      184779159552*ep^4 + 1840825/28825548890112*ep^5 + 26916709/
      4496785626857472*ep^6;
Fill mncpoch(14,3) =
      1/10296 + 431/17667936*ep + 123985/30318178176*ep^2 + 29756735/
      52025993750016*ep^3 + 6435002161/89276605275027456*ep^4 + 1300327044191/
      153198654651947114496*ep^5 + 250535610806545/262888891382741248475136*
      ep^6;
Fill mncpoch(14,4) =
      1/411840 + 3013/3533587200*ep + 5684779/30318178176000*ep^2 + 8597132257/
      260129968750080000*ep^3 + 11398215827131/2231915131875686400000*ep^4 + 
      13843191192775273/19149831831493389312000000*ep^5 + 15792076962253449859/
      164305557114213280296960000000*ep^6;
Fill mncpoch(14,5) =
      1/18532800 + 11899/477034272000*ep + 85194151/12278862161280000*ep^2 + 
      475777842799/316057912031347200000*ep^3 + 2283980112402751/
      8135330655686876928000000*ep^4 + 9896078581316259199/
      209403411077380212126720000000*ep^5 + 39815208848047266256351/
      5390043801131766660141772800000000*ep^6;
Fill mncpoch(14,6) =
      1/889574400 + 30233/45795290112000*ep + 535325959/2357541534965760000*
      ep^2 + 7251045288557/121366238220037324800000*ep^3 + 83204158230308311/
      6247933943567521480704000000*ep^4 + 852093272814154275653/
      321643639414856005826641920000000*ep^5 + 8031393576834107804233519/
      16558214557076787179955526041600000000*ep^6;
Fill mncpoch(15,0) = 1;
*--#] poch.h : 
*--#] Tables : 
#endif
